
################################################################################
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
##
##    Contact help@edautils.com you need more informattion/support
################################################################################


## This file has been maintained in order to maintain the
## backward compatibility. In the earlier release of Baya,
## the commands did not have the prefix 'baya_' . The 'baya_'
## has been prepended with the commands in order differentate
## the Baya commands from the 'ipxact' and 'brigid'  Tcl comands.
##

package require java
set edautilsroot  [ java::call System getenv "EDAUTILS_ROOT" ]

source $edautilsroot/bin/init.baya.tcl

global baya
set baya [java::call BayaBackBone instance ]

set msgInst [java::call LogMessages instance]
$msgInst setToolprefix "Baya"

$baya setFile "undefined.v"
$baya setLine 0

proc get_current_module {args} {
    set ret [ baya_get_current_module $args]
	return $ret
}

proc get_file {args} {
    set ret [ baya_get_file $args]
    return $ret
}

proc get_line {args} {
    set ret [baya_get_line $args]
    return $ret
}

proc get_root {args} {
    set ret [baya_get_root $args]
    return $ret
}

proc set_current_module {args} {
	set ret [baya_set_current_module $args ]
    return $ret
}

proc set_file {args} {
    set ret [baya_set_file $args]
    return $ret
}

proc set_line {args} {
    set ret [baya_set_line $args]
    return $ret
}


proc add_connection {args} {
    set ret [baya_add_connection $args]
    return $ret
}

proc create_hierarchy {args} {
	set ret [baya_create_hierarchy $args]
    return $ret
}

proc create_instance {args} {
    set ret [baya_create_instance $args]
    return $ret
}

proc create_module {args} {
    set ret [baya_create_module $args]
    return $ret
}

proc create_parameter {args} {
    set ret [baya_create_parameter $args]
    return $ret
}

proc create_parameter_map {args} {
    set ret [baya_create_parameter_map $args]
    return $ret
}

proc create_port {args} {
    set ret [baya_create_port $args]
    return $ret
}

proc elaborate {args} {
    set ret [baya_elaborate $args]
    return $ret
}

proc elaborate_root {args} {
    set ret [baya_elaborate_root $args]
    return $ret
}

proc find_all_gate_instances {args} {
    set ret [baya_find_all_gate_instances $args]
    return $ret
}

proc find_all_module_instances {args} {
    set ret [baya_find_all_module_instances $args]
    return $ret
}


proc find_all_udp_instances {args} {
    set ret [baya_find_all_udp_instances $args]
    return $ret
}

proc find_all_modules {args} {
    set ret [baya_find_all_modules $args]
    return $ret
}

proc find_all_nets {args} {
    set ret [baya_find_all_nets $args]
    return $ret
}

proc find_all_ports {args} {
    set ret [baya_find_all_ports $args]
    return $ret
}

proc find_gate_instances {args} {
    set ret [baya_find_gate_instances $args ]
    return $ret
}

proc find_hier_gate_instances {args} {
    set ret [baya_find_hier_gate_instances $args]
    return $ret
}

proc find_hier_module_instances {args} {
    set ret [baya_find_hier_module_instances $args]
    return $ret
}


proc find_hier_nets {args} {
    set ret [baya_find_hier_nets $args]
    return $ret
}

proc find_hier_ports {args} {
    set ret [baya_find_hier_ports $args]
    return $ret
}

proc find_hier_udp_instances {args} {
    set ret [baya_find_hier_udp_instances $args]
    return $ret
}

proc find_gate_instances {args} {
    set ret [baya_find_gate_instances $args]
    return $ret
}

proc find_module_instances {args} {
    set ret [baya_find_module_instances $args]
    return $ret
}


proc find_nets {args} {
    set ret [baya_find_nets $args]
    return $ret
}

proc find_ports {args} {
    set ret [baya_find_ports $args]
    return $ret
}

proc find_udp_instances {args} {
    set ret [baya_find_udp_instances $args]
    return $ret
}

proc import_ipxact {args} {
    set ret [baya_import_ipxact $args]
    return $ret
}

proc import_verilog {args} {
    set ret [baya_import_verilog $args]
    return $ret
}

proc import_verilog_file_list {args} {
    set ret [baya_import_verilog_file_list $args]
    return  $ret 
}

proc import_vhdl {args} {
    set ret [baya_import_vhdl $args]
    return $ret
}

proc print_verilog {args} {
    set ret [baya_print_verilog $args]
    return $ret
}

proc print_verilog_file {args} {
    set ret [baya_print_verilog_file $args]
    return $ret
}

proc print_vhdl {args} {
    set ret [baya_print_vhdl $args]
    return $ret
}

proc print_vhdl_file {args} {
    set ret [baya_print_vhdl_file $args]
    return $ret
}

proc remove_connection {args} {
    set ret [baya_remove_connection $args]
    return $ret
}

proc remove_hierarchy {args} {
    set ret [baya_remove_hierarchy $args]
    return $ret
}

proc remove_instance {args} {
    set ret [baya_remove_instance $args]
    return $ret
}



