

### Import verilog module
puts "######### Reading the verilog file ./top.v"
$baya importVerilogModule "./top.v" null "top" "./" $null false false $null $null $null $null $null $null
## Set top as current design
puts "######### Setting the current design to 'top'"
$baya setCurrentModule "top"
## All the commands will be executed on the module 'top'

## Elaborate the design
puts "######### Elaborating the the design"
$baya elaborate

puts "#################################################"
puts "#########  Find all the modules and print their names "
### Find all the modules and print those their names
set mods {}
lappend mods [ $baya findAllModules ]

if { $mods != $null } {
    set len1 [$mods length]
    for {set i 0} {$i < $len1} {incr i} {
        set arr [lindex $mods $i]
        if { $arr != "" } {
            set len2 [$arr length]
            for {set j 0} {$j < $len2} {incr j} {
                    set ele [ $arr get $j ]
                    if { $ele != "" } {
                    set str [ $ele getName ]
                    puts "The module name is: $str"
                }
            }
        }
     }
}
puts "#########  completed printing of all the module names "
puts "#######################################################"
puts "#################################################"
puts "#########  Find all the modules whose names contains bott* and print their names "
### Find all the modules whose name matches with the pattern and print those their names
set mods {}
lappend mods [ $baya findModules "bott*"]

if { $mods != $null } {
    set len1 [$mods length]
    for {set i 0} {$i < $len1} {incr i} {
        set arr [lindex $mods $i]
        if { $arr != "" } {
            set len2 [$arr length]
            for {set j 0} {$j < $len2} {incr j} {
                    set ele [ $arr get $j ]
                    if { $ele != "" } {
                    set str [ $ele getName ]
                    puts "The module name is: $str"
                }
            }
        }
     }
}
puts "#########  completed printing of all the module names matching with 'bott*'"
puts "###########################################################################"


puts "#################################################"
puts "#########  Printing all the nets "
### Find all the nets and print those nets
set nets {}
lappend nets [ $baya findAllNets ]

if { $nets != $null } {
    set len1 [$nets length]
    for {set i 0} {$i < $len1} {incr i} {
        set arr [lindex $nets $i]
        if { $arr != "" } {
            set len2 [$arr length]
            for {set j 0} {$j < $len2} {incr j} {
                    set ele [ $arr get $j ]
                    if { $ele != "" } {
                    set str [ $ele print ]
                    puts "The net name is: $str"
                }
            }
        }
     }
}
puts "#########  completed printing of all the nets "
puts "#################################################"

### Find all the ports and print those 
puts "#################################################"
puts "#########  Printing all the ports "
set ports {}
lappend ports [ $baya findAllPorts ]
if { $ports != $null } {
    set len1 [$ports length]

    for {set i 0} {$i < $len1} {incr i} {
        set arr [lindex $ports $i]
        if { $arr != "" } {
            set len2 [$arr length]
            for {set j 0} {$j < $len2} {incr j} {
                    set ele [ $arr get $j ]
                    if { $ele != "" } {
                    set str [ $ele print ]
                    puts "The Port name is: $str"
                }
            }
        }
     }
}
puts "#########  completed printing of all the ports "
puts "#################################################"

puts "#################################################"
puts "#########  Printing all the module instances "
set insts {}
lappend insts [ $baya findAllModuleInstances ]
if { $insts != $null } {
    set len1 [$insts length]

    for {set i 0} {$i < $len1} {incr i} {
        set arr [lindex $insts $i]
        if { $arr != "" } {
            set len2 [$arr length]
            for {set j 0} {$j < $len2} {incr j} {
                    set ele [ $arr get $j ]
                    if { $ele != "" } {
                    set str [ $ele getName ]
                    puts "The Inst name is: $str"
                }
            }
        }
     }
}
puts "#########  completed printing of all the Module instances "
puts "#################################################"

puts "#################################################"
puts "#########  Printing all the Gate instances "
set insts {}
lappend insts [ $baya findAllGateInstances ]

if { $insts != $null } {
    set len1 [$insts length]
    for {set i 0} {$i < $len1} {incr i} {
        set arr [lindex $insts $i]
        if { $arr != "" } {
            set len2 [$arr length]
            for {set j 0} {$j < $len2} {incr j} {
                    set ele [ $arr get $j ]
                    if { $ele != "" } {
                    set str [ $ele getName ]
                    puts "The Inst name is: $str"
                }
            }
        }
     }
}
puts "#########  completed printing of all the Gate instances "
puts "#################################################"

puts "#################################################"
puts "#########  Printing all the UDP instances "
set insts {}
lappend insts [ $baya findAllUDPInstances ]
if { $insts != $null } {
    set len1 [$insts length]
    for {set i 0} {$i < $len1} {incr i} {
        set arr [lindex $insts $i]
        if { $arr != "" } {
            set len2 [$arr length]
            for {set j 0} {$j < $len2} {incr j} {
                    set ele [ $arr get $j ]
                    if { $ele != "" } {
                    set str [ $ele getName ]
                    puts "The Inst name is: $str"
                }
            }
        }
     }
}
puts "#########  completed printing of all the UDP instances "
puts "#################################################"

### Now lets find some selective objects and print them

puts "#################################################"
puts "#########  Printing all the nets in the current module whose name contains 'in*' "
set nets {}
lappend nets [ $baya findNets "in*" ]

if { $nets != $null } {
    set len1 [$nets length]
    for {set i 0} {$i < $len1} {incr i} {
        set arr [lindex $nets $i]
        if { $arr != "" } {
            set len2 [$arr length]
            for {set j 0} {$j < $len2} {incr j} {
                    set ele [ $arr get $j ]
                    if { $ele != "" } {
                    set str [ $ele print ]
                    puts "The net name is: $str"
                }
            }
        }
     }
}

puts "#################################################"
puts "#########  Printing all the hierarchical nets from the current module whose name contains 'in*' "
set nets {}
lappend nets [ $baya findHierNets "in*" ]

if { $nets != $null } {
    set len1 [$nets length]
    for {set i 0} {$i < $len1} {incr i} {
        set arr [lindex $nets $i]
        if { $arr != "" } {
            set len2 [$arr length]
            for {set j 0} {$j < $len2} {incr j} {
                    set ele [ $arr get $j ]
                    if { $ele != "" } {
                    set str [ $ele getHierName ]
                    puts "The net name is: $str"
                }
            }
        }
     }
}
puts "#########  completed printing of all the nets with pattern matching "
puts "#################################################"

puts "#################################################"
puts "#########  Printing all the hierarchical module instances where the inst name contains '2'"
set insts {}
lappend insts [ $baya findHierModuleInstances "/*2"]
if { $insts != $null } {
    set len1 [$insts length]

    for {set i 0} {$i < $len1} {incr i} {
        set arr [lindex $insts $i]
        if { $arr != "" } {
            set len2 [$arr length]
            for {set j 0} {$j < $len2} {incr j} {
                    set ele [ $arr get $j ]
                    if { $ele != "" } {
                    set str [ $ele getHierName ]
                    puts "The Inst name is: $str"
                }
            }
        }
     }
}
puts "#########  completed printing of all the Module instances with pattern matching"
puts "#################################################"

exit

