
-------------------------------------------------------------------
-- Simple DFF
-------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity DFF_SIMPLE_POSEDGE is
	port(Q : out std_logic; CLK, D : in std_logic );
end;

architecture RTL of DFF_SIMPLE_POSEDGE is
begin
	process( CLK )
	begin
		if ( CLK'event and CLK = '1' ) then
			Q <= D;
		end if;
	end process;
end;


library ieee;
use ieee.std_logic_1164.all;

entity DFF_SIMPLE_NEGEDGE is
	port(Q : out std_logic; CLK, D : in std_logic );
end;

architecture RTL of DFF_SIMPLE_NEGEDGE is
begin
	process( CLK )
	begin
		if ( CLK'event and CLK = '0' ) then
			Q <= D;
		end if;
	end process;
end;


-------------------------------------------------------------------
-- DFF ASYNC RST 
-------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity DFF_ASYNC_NEGEDGE_RST_NEGEDGE_CLK is
	port(Q : out std_logic; CLK, RST, RSTVAL, D : in std_logic );
end;

architecture RTL of DFF_ASYNC_NEGEDGE_RST_NEGEDGE_CLK is
begin
	process( CLK, RST )
	begin
		if ( RST = '0' ) then
			Q <= RSTVAL;
		elsif ( CLK'event and CLK = '0' ) then
			Q <= D;
		end if;
	end process;
end;

library ieee;
use ieee.std_logic_1164.all;

entity DFF_ASYNC_NEGEDGE_RST_POSEDGE_CLK is
	port(Q : out std_logic; CLK, RST, RSTVAL, D : in std_logic );
end;

architecture RTL of DFF_ASYNC_NEGEDGE_RST_POSEDGE_CLK is
begin
	process( CLK, RST )
	begin
		if ( RST = '0' ) then
			Q <= RSTVAL;
		elsif ( CLK'event and CLK = '1' ) then
			Q <= D;
		end if;
	end process;
end;


library ieee;
use ieee.std_logic_1164.all;

entity DFF_ASYNC_POSEDGE_RST_NEGEDGE_CLK is
	port(Q : out std_logic; CLK, RST, RSTVAL, D : in std_logic );
end;

architecture RTL of DFF_ASYNC_POSEDGE_RST_NEGEDGE_CLK is
begin
	process( CLK, RST )
	begin
		if ( RST = '1' ) then
			Q <= RSTVAL;
		elsif ( CLK'event and CLK = '0' ) then
			Q <= D;
		end if;
	end process;
end;

library ieee;
use ieee.std_logic_1164.all;

entity DFF_ASYNC_POSEDGE_RST_POSEDGE_CLK is
	port(Q : out std_logic; CLK, RST, RSTVAL, D : in std_logic );
end;

architecture RTL of DFF_ASYNC_POSEDGE_RST_POSEDGE_CLK is
begin
	process( CLK, RST )
	begin
		if ( RST = '1' ) then
			Q <= RSTVAL;
		elsif ( CLK'event and CLK = '1' ) then
			Q <= D;
		end if;
	end process;
end;

