// TJC implementation of procedure compileproc_command_cache_epoch_check
package tjc;
import tcl.lang.*;

public class CompileprocCommandCacheEpochCheckCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "symbol");
        }
        setVarScalar(interp, "symbol", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: append buffer "((" $symbol "_cmdEpoch == " $symbol ...
            TclObject[] objv0 = TJC.grabObjv(interp, 5);
            TclObject tmp1;
            try {
                // Arg 2 constant: "(("
                objv0[0] = const1;
                // Arg 3 variable: $symbol
                tmp1 = getVarScalar(interp, "symbol", compiledLocals, 0);
                tmp1.preserve();
                objv0[1] = tmp1;
                // Arg 4 constant: "_cmdEpoch == "
                objv0[2] = const2;
                // Arg 5 variable: $symbol
                tmp1 = getVarScalar(interp, "symbol", compiledLocals, 0);
                tmp1.preserve();
                objv0[3] = tmp1;
                // Arg 6 constant: ...
                objv0[4] = const3;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv0, compiledLocals, 1);
            } finally {
                tmp1 = objv0[1];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                tmp1 = objv0[3];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                TJC.releaseObjv(interp, objv0, 5);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv2 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv2[0] = const4;
                // Arg 1 constant: +1
                objv2[1] = const5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv2, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv2, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] "? " $symbol ".cmd : null)"
            TclObject[] objv3 = TJC.grabObjv(interp, 4);
            TclObject tmp4;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv5 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv5[0] = const6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv5, 1);
                    }
                } // End Invoke: emitter_indent
                tmp4 = interp.getResult();
                tmp4.preserve();
                objv3[0] = tmp4;
                // Arg 3 constant: "? "
                objv3[1] = const7;
                // Arg 4 variable: $symbol
                tmp4 = getVarScalar(interp, "symbol", compiledLocals, 0);
                tmp4.preserve();
                objv3[2] = tmp4;
                // Arg 5 constant: ".cmd : null)"
                objv3[3] = const8;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv3, compiledLocals, 1);
            } finally {
                tmp4 = objv3[0];
                if ( tmp4 != null ) {
                    tmp4.release();
                }
                tmp4 = objv3[2];
                if ( tmp4 != null ) {
                    tmp4.release();
                }
                TJC.releaseObjv(interp, objv3, 4);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv6 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv6[0] = const4;
                // Arg 1 constant: -1
                objv6[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv6, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv6, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: return $buffer
            TclObject tmp7 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp7);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_command_cache_epoch_check");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("((");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_cmdEpoch == ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance(".cmdEpoch)\n");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent_level");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("+1");
        TclInteger.get(interp, const5);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_indent");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("? ");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(".cmd : null)");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(-1);
        const9.preserve(); const9.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "symbol",
        "buffer"
    };
} // end class CompileprocCommandCacheEpochCheckCmd

