// TJC implementation of procedure compileproc_command_finish_callback
package tjc;
import tcl.lang.*;

public class CompileprocCommandFinishCallbackCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_command_finish_callback");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "key"
    };
} // end class CompileprocCommandFinishCallbackCmd

