// TJC implementation of procedure compileproc_constant_cache_add
package tjc;
import tcl.lang.*;

public class CompileprocConstantCacheAddCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "tstr");
        }
        setVarScalar(interp, "tstr", objv[1], compiledLocals, 0);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_constant_cache", "_compileproc_constant_cache", 1);
        } // End Invoke: global
        { // Invoke: set key const,$tstr
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            sbtmp1.append("const,");
            tmp0 = getVarScalar(interp, "tstr", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            tmp0 = TclString.newInstance(sbtmp1);
            setVarScalar(interp, "key", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists "..."
                TclObject[] objv2 = TJC.grabObjv(interp, 3);
                TclObject tmp3;
                try {
                    // Arg 0 constant: info
                    objv2[0] = const0;
                    // Arg 1 constant: exists
                    objv2[1] = const1;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp4 = new StringBuffer(64);
                    sbtmp4.append("_compileproc_constant_cache(");
                    tmp3 = getVarScalar(interp, "key", compiledLocals, 2);
                    sbtmp4.append(tmp3.toString());
                    sbtmp4.append(")");
                    tmp3 = TclString.newInstance(sbtmp4);
                    tmp3.preserve();
                    objv2[2] = tmp3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv2, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp3 = objv2[2];
                    if ( tmp3 != null ) {
                        tmp3.release();
                    }
                    TJC.releaseObjv(interp, objv2, 3);
                }
            } // End Invoke: info
            TclObject tmp5 = interp.getResult();
            ExprValue tmp6 = evs0;
            if ( tmp5.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp6, tmp5);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp6, tmp5);
            }
            // End Unary operator: !
            boolean tmp7 = ( tmp6.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: set ident {}
                    setVarScalar(interp, "ident", const2, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set type [...]
                    TclObject tmp8;
                    { // Invoke: ... $tstr
                        TclObject[] objv9 = TJC.grabObjv(interp, 2);
                        TclObject tmp10;
                        try {
                            // Arg 0 constant: ...
                            objv9[0] = const3;
                            // Arg 1 variable: $tstr
                            tmp10 = getVarScalar(interp, "tstr", compiledLocals, 0);
                            tmp10.preserve();
                            objv9[1] = tmp10;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv9, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp10 = objv9[1];
                            if ( tmp10 != null ) {
                                tmp10.release();
                            }
                            TJC.releaseObjv(interp, objv9, 2);
                        }
                    } // End Invoke: ...
                    tmp8 = interp.getResult();
                    setVarScalar(interp, "type", tmp8, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set tuple [...]
                    TclObject tmp11;
                    { // Invoke: list $ident $type $tstr
                        TclObject tmp12 = TclList.newInstance();
                        TclObject tmp13;
                        try {
                            tmp13 = getVarScalar(interp, "ident", compiledLocals, 3);
                            TclList.append(interp, tmp12, tmp13);
                            tmp13 = getVarScalar(interp, "type", compiledLocals, 4);
                            TclList.append(interp, tmp12, tmp13);
                            tmp13 = getVarScalar(interp, "tstr", compiledLocals, 0);
                            TclList.append(interp, tmp12, tmp13);
                        } catch (TclException ex) {
                            tmp12.release();
                            throw ex;
                        }
                        interp.setResult(tmp12);
                    } // End Invoke: list
                    tmp11 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp11, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set "..." $tuple
                    TclObject tmp14;
                    tmp14 = getVarScalar(interp, "key", compiledLocals, 2);
                    String tmp15 = tmp14.toString();
                    tmp14 = getVarScalar(interp, "tuple", compiledLocals, 5);
                    tmp14 = setVarArray(interp, "_compileproc_constant_cache", tmp15, tmp14, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_constant_cache_add");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_constant_cache_type");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "compileproc_constant_cache_type";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tstr",
        "_compileproc_constant_cache",
        "key",
        "ident",
        "type",
        "tuple"
    };
} // end class CompileprocConstantCacheAddCmd

