// TJC implementation of procedure compileproc_emit_inline_command_incr
package tjc;
import tcl.lang.*;

public class CompileprocEmitInlineCommandIncrCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 35, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: if ... ... else ...
            TclObject tmp0 = getVarArray(interp, "_compileproc", "options,cache_variables", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            TJC.exprInitValue(interp, tmp1, tmp0);
            boolean tmp2 = tmp1.getBooleanValue(interp);
            if ( tmp2 ) {
                { // Invoke: set cache_variables 1
                    setVarScalar(interp, "cache_variables", const0, compiledLocals, 2);
                } // End Invoke: set
            } else {
                { // Invoke: set cache_variables 0
                    setVarScalar(interp, "cache_variables", const1, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const2, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set incr_value_buffer ""
            setVarScalar(interp, "incr_value_buffer", const2, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set incr_buffer ""
            setVarScalar(interp, "incr_buffer", const2, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp3;
            { // Invoke: ... $key 1
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: ...
                    objv4[0] = const3;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: 1
                    objv4[2] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: ...
            tmp3 = interp.getResult();
            setVarScalar(interp, "tuple", tmp3, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp6;
            { // Invoke: lindex $tuple 0
                TclObject tmp7 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp7 = TclList.index(interp, tmp7, 0);
                if ( tmp7 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp7);
                }
            } // End Invoke: lindex
            tmp6 = interp.getResult();
            setVarScalar(interp, "type", tmp6, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: $type == "constant"
            TclObject tmp8 = getVarScalar(interp, "type", compiledLocals, 7);
            boolean tmp9 = tmp8.toString().equals("constant");
            ExprValue tmp10 = evs0;
            tmp10.setIntValue(tmp9);
            // End Binary operator: ==
            boolean tmp11 = ( tmp10.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: set constant_varname 1
                    setVarScalar(interp, "constant_varname", const0, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set varname [...]
                    TclObject tmp12;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp13 = getVarScalar(interp, "tuple", compiledLocals, 6);
                        tmp13 = TclList.index(interp, tmp13, 1);
                        if ( tmp13 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp13);
                        }
                    } // End Invoke: lindex
                    tmp12 = interp.getResult();
                    setVarScalar(interp, "varname", tmp12, compiledLocals, 9);
                } // End Invoke: set
            } else {
                { // Invoke: set constant_varname 0
                    setVarScalar(interp, "constant_varname", const1, compiledLocals, 8);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set tree [...]
            TclObject tmp14;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv15 = TJC.grabObjv(interp, 3);
                TclObject tmp16;
                try {
                    // Arg 0 constant: descend_get_data
                    objv15[0] = const4;
                    // Arg 1 variable: $key
                    tmp16 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp16.preserve();
                    objv15[1] = tmp16;
                    // Arg 2 constant: tree
                    objv15[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv15, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp16 = objv15[1];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    TJC.releaseObjv(interp, objv15, 3);
                }
            } // End Invoke: descend_get_data
            tmp14 = interp.getResult();
            setVarScalar(interp, "tree", tmp14, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp17;
            { // Invoke: llength $tree
                TclObject tmp18 = getVarScalar(interp, "tree", compiledLocals, 10);
                int tmp19 = TclList.getLength(interp, tmp18);
                interp.setResult(tmp19);
            } // End Invoke: llength
            tmp17 = interp.getResult();
            setVarScalar(interp, "num_args", tmp17, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: if {$num_args == 2} ... elseif {$num_args == 3} ... else ...
            // Binary operator: $num_args == 2
            TclObject tmp20 = getVarScalar(interp, "num_args", compiledLocals, 11);
            ExprValue tmp21 = evs0;
            TJC.exprInitValue(interp, tmp21, tmp20);
            ExprValue tmp22 = evs1;
            tmp22.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp21, tmp22);
            // End Binary operator: ==
            boolean tmp23 = ( tmp21.getIntValue() != 0 );
            if ( tmp23 ) {
                { // Invoke: set incr_symbol 1
                    setVarScalar(interp, "incr_symbol", const0, compiledLocals, 12);
                } // End Invoke: set
            } else {
                // Binary operator: $num_args == 3
                TclObject tmp24 = getVarScalar(interp, "num_args", compiledLocals, 11);
                ExprValue tmp25 = evs0;
                TJC.exprInitValue(interp, tmp25, tmp24);
                ExprValue tmp26 = evs1;
                tmp26.setIntValue(3);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp25, tmp26);
                // End Binary operator: ==
                boolean tmp27 = ( tmp25.getIntValue() != 0 );
                if ( tmp27 ) {
                    { // Invoke: set ... 0
                        setVarScalar(interp, "constant_integer_increment", const1, compiledLocals, 13);
                    } // End Invoke: set
                    { // Invoke: set tuple [...]
                        TclObject tmp28;
                        { // Invoke: ... $key 2
                            TclObject[] objv29 = TJC.grabObjv(interp, 3);
                            TclObject tmp30;
                            try {
                                // Arg 0 constant: ...
                                objv29[0] = const3;
                                // Arg 1 variable: $key
                                tmp30 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp30.preserve();
                                objv29[1] = tmp30;
                                // Arg 2 constant: 2
                                objv29[2] = const6;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv29, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp30 = objv29[1];
                                if ( tmp30 != null ) {
                                    tmp30.release();
                                }
                                TJC.releaseObjv(interp, objv29, 3);
                            }
                        } // End Invoke: ...
                        tmp28 = interp.getResult();
                        setVarScalar(interp, "tuple", tmp28, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: set type [...]
                        TclObject tmp31;
                        { // Invoke: lindex $tuple 0
                            TclObject tmp32 = getVarScalar(interp, "tuple", compiledLocals, 6);
                            tmp32 = TclList.index(interp, tmp32, 0);
                            if ( tmp32 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp32);
                            }
                        } // End Invoke: lindex
                        tmp31 = interp.getResult();
                        setVarScalar(interp, "type", tmp31, compiledLocals, 7);
                    } // End Invoke: set
                    { // Invoke: set value [...]
                        TclObject tmp33;
                        { // Invoke: lindex $tuple 1
                            TclObject tmp34 = getVarScalar(interp, "tuple", compiledLocals, 6);
                            tmp34 = TclList.index(interp, tmp34, 1);
                            if ( tmp34 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp34);
                            }
                        } // End Invoke: lindex
                        tmp33 = interp.getResult();
                        setVarScalar(interp, "value", tmp33, compiledLocals, 14);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        // Binary operator: $type == "constant"
                        TclObject tmp35 = getVarScalar(interp, "type", compiledLocals, 7);
                        boolean tmp36 = tmp35.toString().equals("constant");
                        ExprValue tmp37 = evs0;
                        tmp37.setIntValue(tmp36);
                        // End Binary operator: ==
                        boolean tmp38 = ( tmp37.getIntValue() != 0 );
                        if ( tmp38 ) {
                            { // Invoke: set is_integer [...]
                                TclObject tmp39;
                                { // Invoke: ... $value
                                    TclObject[] objv40 = TJC.grabObjv(interp, 2);
                                    TclObject tmp41;
                                    try {
                                        // Arg 0 constant: ...
                                        objv40[0] = const7;
                                        // Arg 1 variable: $value
                                        tmp41 = getVarScalar(interp, "value", compiledLocals, 14);
                                        tmp41.preserve();
                                        objv40[1] = tmp41;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv40, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp41 = objv40[1];
                                        if ( tmp41 != null ) {
                                            tmp41.release();
                                        }
                                        TJC.releaseObjv(interp, objv40, 2);
                                    }
                                } // End Invoke: ...
                                tmp39 = interp.getResult();
                                setVarScalar(interp, "is_integer", tmp39, compiledLocals, 15);
                            } // End Invoke: set
                            { // Invoke: if {$is_integer} ...
                                TclObject tmp42 = getVarScalar(interp, "is_integer", compiledLocals, 15);
                                boolean tmp43 = TJC.getBoolean(interp, tmp42);
                                if ( tmp43 ) {
                                    { // Invoke: set tuple [...]
                                        TclObject tmp44;
                                        { // Invoke: ... $value
                                            TclObject[] objv45 = TJC.grabObjv(interp, 2);
                                            TclObject tmp46;
                                            try {
                                                // Arg 0 constant: ...
                                                objv45[0] = const8;
                                                // Arg 1 variable: $value
                                                tmp46 = getVarScalar(interp, "value", compiledLocals, 14);
                                                tmp46.preserve();
                                                objv45[1] = tmp46;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv45, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                tmp46 = objv45[1];
                                                if ( tmp46 != null ) {
                                                    tmp46.release();
                                                }
                                                TJC.releaseObjv(interp, objv45, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp44 = interp.getResult();
                                        setVarScalar(interp, "tuple", tmp44, compiledLocals, 6);
                                    } // End Invoke: set
                                    { // Invoke: set stringrep_matches [...]
                                        TclObject tmp47;
                                        { // Invoke: lindex $tuple 0
                                            TclObject tmp48 = getVarScalar(interp, "tuple", compiledLocals, 6);
                                            tmp48 = TclList.index(interp, tmp48, 0);
                                            if ( tmp48 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp48);
                                            }
                                        } // End Invoke: lindex
                                        tmp47 = interp.getResult();
                                        setVarScalar(interp, "stringrep_matches", tmp47, compiledLocals, 16);
                                    } // End Invoke: set
                                    { // Invoke: set parsed_number [...]
                                        TclObject tmp49;
                                        { // Invoke: lindex $tuple 1
                                            TclObject tmp50 = getVarScalar(interp, "tuple", compiledLocals, 6);
                                            tmp50 = TclList.index(interp, tmp50, 1);
                                            if ( tmp50 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp50);
                                            }
                                        } // End Invoke: lindex
                                        tmp49 = interp.getResult();
                                        setVarScalar(interp, "parsed_number", tmp49, compiledLocals, 17);
                                    } // End Invoke: set
                                    { // Invoke: if {$stringrep_matches} ...
                                        TclObject tmp51 = getVarScalar(interp, "stringrep_matches", compiledLocals, 16);
                                        boolean tmp52 = TJC.getBoolean(interp, tmp51);
                                        if ( tmp52 ) {
                                            { // Invoke: set ... 1
                                                setVarScalar(interp, "constant_integer_increment", const0, compiledLocals, 13);
                                            } // End Invoke: set
                                            { // Invoke: set incr_symbol $parsed_number
                                                TclObject tmp53;
                                                tmp53 = getVarScalar(interp, "parsed_number", compiledLocals, 17);
                                                setVarScalar(interp, "incr_symbol", tmp53, compiledLocals, 12);
                                            } // End Invoke: set
                                        }
                                    } // End Invoke: if
                                }
                            } // End Invoke: if
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ...
                        // Unary operator: ! $constant_integer_increment
                        TclObject tmp54 = getVarScalar(interp, "constant_integer_increment", compiledLocals, 13);
                        ExprValue tmp55 = evs0;
                        if ( tmp54.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp55, tmp54);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp55, tmp54);
                        }
                        // End Unary operator: !
                        boolean tmp56 = ( tmp55.getIntValue() != 0 );
                        if ( tmp56 ) {
                            { // Invoke: set tuple [...]
                                TclObject tmp57;
                                { // Invoke: ... $key 2 true {}
                                    TclObject[] objv58 = TJC.grabObjv(interp, 5);
                                    TclObject tmp59;
                                    try {
                                        // Arg 0 constant: ...
                                        objv58[0] = const9;
                                        // Arg 1 variable: $key
                                        tmp59 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp59.preserve();
                                        objv58[1] = tmp59;
                                        // Arg 2 constant: 2
                                        objv58[2] = const6;
                                        // Arg 3 constant: true
                                        objv58[3] = const10;
                                        // Arg 4 constant: {}
                                        objv58[4] = const2;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv58, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp59 = objv58[1];
                                        if ( tmp59 != null ) {
                                            tmp59.release();
                                        }
                                        TJC.releaseObjv(interp, objv58, 5);
                                    }
                                } // End Invoke: ...
                                tmp57 = interp.getResult();
                                setVarScalar(interp, "tuple", tmp57, compiledLocals, 6);
                            } // End Invoke: set
                            { // Invoke: set value_type [...]
                                TclObject tmp60;
                                { // Invoke: lindex $tuple 0
                                    TclObject tmp61 = getVarScalar(interp, "tuple", compiledLocals, 6);
                                    tmp61 = TclList.index(interp, tmp61, 0);
                                    if ( tmp61 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp61);
                                    }
                                } // End Invoke: lindex
                                tmp60 = interp.getResult();
                                setVarScalar(interp, "value_type", tmp60, compiledLocals, 18);
                            } // End Invoke: set
                            { // Invoke: set value_symbol [...]
                                TclObject tmp62;
                                { // Invoke: lindex $tuple 1
                                    TclObject tmp63 = getVarScalar(interp, "tuple", compiledLocals, 6);
                                    tmp63 = TclList.index(interp, tmp63, 1);
                                    if ( tmp63 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp63);
                                    }
                                } // End Invoke: lindex
                                tmp62 = interp.getResult();
                                setVarScalar(interp, "value_symbol", tmp62, compiledLocals, 19);
                            } // End Invoke: set
                            { // Invoke: set value_buffer [...]
                                TclObject tmp64;
                                { // Invoke: lindex $tuple 2
                                    TclObject tmp65 = getVarScalar(interp, "tuple", compiledLocals, 6);
                                    tmp65 = TclList.index(interp, tmp65, 2);
                                    if ( tmp65 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp65);
                                    }
                                } // End Invoke: lindex
                                tmp64 = interp.getResult();
                                setVarScalar(interp, "value_buffer", tmp64, compiledLocals, 20);
                            } // End Invoke: set
                            { // Invoke: append incr_value_buffer $value_buffer
                                TclObject[] objv66 = TJC.grabObjv(interp, 1);
                                TclObject tmp67;
                                try {
                                    // Arg 2 variable: $value_buffer
                                    tmp67 = getVarScalar(interp, "value_buffer", compiledLocals, 20);
                                    tmp67.preserve();
                                    objv66[0] = tmp67;
                                    interp.resetResult();
                                    appendVarScalar(interp, "incr_value_buffer", objv66, compiledLocals, 4);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv66, 1);
                                }
                            } // End Invoke: append
                            { // Invoke: set tmpsymbol [...]
                                TclObject tmp68;
                                { // Invoke: ...
                                    TclObject[] objv69 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: ...
                                        objv69[0] = const11;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv69, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv69, 1);
                                    }
                                } // End Invoke: ...
                                tmp68 = interp.getResult();
                                setVarScalar(interp, "tmpsymbol", tmp68, compiledLocals, 21);
                            } // End Invoke: set
                            { // Invoke: append incr_value_buffer [...]
                                TclObject[] objv70 = TJC.grabObjv(interp, 1);
                                TclObject tmp71;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_statement "..."
                                        TclObject[] objv72 = TJC.grabObjv(interp, 2);
                                        TclObject tmp73;
                                        try {
                                            // Arg 0 constant: emitter_statement
                                            objv72[0] = const12;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp74 = new StringBuffer(64);
                                            sbtmp74.append("int ");
                                            tmp73 = getVarScalar(interp, "tmpsymbol", compiledLocals, 21);
                                            sbtmp74.append(tmp73.toString());
                                            sbtmp74.append(" = TclInteger.get(interp, ");
                                            tmp73 = getVarScalar(interp, "value_symbol", compiledLocals, 19);
                                            sbtmp74.append(tmp73.toString());
                                            sbtmp74.append(")");
                                            tmp73 = TclString.newInstance(sbtmp74);
                                            tmp73.preserve();
                                            objv72[1] = tmp73;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                ? cmdcache7.cmd : null), objv72, 0);
                                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                updateCmdCache(interp, 7);
                                            }
                                        } finally {
                                            tmp73 = objv72[1];
                                            if ( tmp73 != null ) {
                                                tmp73.release();
                                            }
                                            TJC.releaseObjv(interp, objv72, 2);
                                        }
                                    } // End Invoke: emitter_statement
                                    tmp71 = interp.getResult();
                                    tmp71.preserve();
                                    objv70[0] = tmp71;
                                    interp.resetResult();
                                    appendVarScalar(interp, "incr_value_buffer", objv70, compiledLocals, 4);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv70, 1);
                                }
                            } // End Invoke: append
                            { // Invoke: set incr_symbol $tmpsymbol
                                TclObject tmp75;
                                tmp75 = getVarScalar(interp, "tmpsymbol", compiledLocals, 21);
                                setVarScalar(interp, "incr_symbol", tmp75, compiledLocals, 12);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                } else {
                    { // Invoke: error ...
                        TclObject[] objv76 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: error
                            objv76[0] = const13;
                            // Arg 1 constant: ...
                            objv76[1] = const14;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv76, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv76, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        { // Invoke: append incr_buffer [...]
            TclObject[] objv77 = TJC.grabObjv(interp, 1);
            TclObject tmp78;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_reset_result
                    TclObject[] objv79 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_reset_result
                        objv79[0] = const15;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                            ? cmdcache9.cmd : null), objv79, 0);
                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                            updateCmdCache(interp, 9);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv79, 1);
                    }
                } // End Invoke: emitter_reset_result
                tmp78 = interp.getResult();
                tmp78.preserve();
                objv77[0] = tmp78;
                interp.resetResult();
                appendVarScalar(interp, "incr_buffer", objv77, compiledLocals, 5);
            } finally {
                TJC.releaseObjvElems(interp, objv77, 1);
            }
        } // End Invoke: append
        { // Invoke: set omit_result 0
            setVarScalar(interp, "omit_result", const1, compiledLocals, 22);
        } // End Invoke: set
        { // Invoke: if {!$cache_variables} ... elseif {$constant_varname} ... else ...
            // Unary operator: ! $cache_variables
            TclObject tmp80 = getVarScalar(interp, "cache_variables", compiledLocals, 2);
            ExprValue tmp81 = evs0;
            if ( tmp80.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp81, tmp80);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp81, tmp80);
            }
            // End Unary operator: !
            boolean tmp82 = ( tmp81.getIntValue() != 0 );
            if ( tmp82 ) {
                { // Invoke: set result_tmpsymbol [...]
                    TclObject tmp83;
                    { // Invoke: ...
                        TclObject[] objv84 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv84[0] = const11;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv84, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv84, 1);
                        }
                    } // End Invoke: ...
                    tmp83 = interp.getResult();
                    setVarScalar(interp, "result_tmpsymbol", tmp83, compiledLocals, 23);
                } // End Invoke: set
                { // Invoke: if {$constant_varname} ... else ...
                    TclObject tmp85 = getVarScalar(interp, "constant_varname", compiledLocals, 8);
                    boolean tmp86 = TJC.getBoolean(interp, tmp85);
                    if ( tmp86 ) {
                        { // Invoke: set qvarname [...]
                            TclObject tmp87;
                            { // Invoke: ... $varname
                                TclObject[] objv88 = TJC.grabObjv(interp, 2);
                                TclObject tmp89;
                                try {
                                    // Arg 0 constant: ...
                                    objv88[0] = const16;
                                    // Arg 1 variable: $varname
                                    tmp89 = getVarScalar(interp, "varname", compiledLocals, 9);
                                    tmp89.preserve();
                                    objv88[1] = tmp89;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                        ? cmdcache10.cmd : null), objv88, 0);
                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                        updateCmdCache(interp, 10);
                                    }
                                } finally {
                                    tmp89 = objv88[1];
                                    if ( tmp89 != null ) {
                                        tmp89.release();
                                    }
                                    TJC.releaseObjv(interp, objv88, 2);
                                }
                            } // End Invoke: ...
                            tmp87 = interp.getResult();
                            setVarScalar(interp, "qvarname", tmp87, compiledLocals, 24);
                        } // End Invoke: set
                        { // Invoke: append buffer $incr_value_buffer $incr_buffer [...] "..." ... $qvarname ", null" ", " $incr_symbol ...
                            TclObject[] objv90 = TJC.grabObjv(interp, 10);
                            TclObject tmp91;
                            try {
                                // Arg 2 variable: $incr_value_buffer
                                tmp91 = getVarScalar(interp, "incr_value_buffer", compiledLocals, 4);
                                tmp91.preserve();
                                objv90[0] = tmp91;
                                // Arg 3 variable: $incr_buffer
                                tmp91 = getVarScalar(interp, "incr_buffer", compiledLocals, 5);
                                tmp91.preserve();
                                objv90[1] = tmp91;
                                // Arg 4 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv92 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv92[0] = const17;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                            ? cmdcache11.cmd : null), objv92, 0);
                                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                            updateCmdCache(interp, 11);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv92, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp91 = interp.getResult();
                                tmp91.preserve();
                                objv90[2] = tmp91;
                                // Arg 5 word: "..."
                                StringBuffer sbtmp93 = new StringBuffer(64);
                                sbtmp93.append("TclObject ");
                                tmp91 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 23);
                                sbtmp93.append(tmp91.toString());
                                sbtmp93.append(" = ");
                                tmp91 = TclString.newInstance(sbtmp93);
                                tmp91.preserve();
                                objv90[3] = tmp91;
                                // Arg 6 constant: ...
                                objv90[4] = const18;
                                // Arg 7 variable: $qvarname
                                tmp91 = getVarScalar(interp, "qvarname", compiledLocals, 24);
                                tmp91.preserve();
                                objv90[5] = tmp91;
                                // Arg 8 constant: ", null"
                                objv90[6] = const19;
                                // Arg 9 constant: ", "
                                objv90[7] = const20;
                                // Arg 10 variable: $incr_symbol
                                tmp91 = getVarScalar(interp, "incr_symbol", compiledLocals, 12);
                                tmp91.preserve();
                                objv90[8] = tmp91;
                                // Arg 11 constant: ...
                                objv90[9] = const21;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv90, compiledLocals, 3);
                            } finally {
                                objv90[4] = null;
                                objv90[6] = null;
                                objv90[7] = null;
                                objv90[9] = null;
                                TJC.releaseObjvElems(interp, objv90, 10);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: append buffer [...] "..."
                            TclObject[] objv94 = TJC.grabObjv(interp, 2);
                            TclObject tmp95;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv96 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv96[0] = const17;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                            ? cmdcache11.cmd : null), objv96, 0);
                                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                            updateCmdCache(interp, 11);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv96, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp95 = interp.getResult();
                                tmp95.preserve();
                                objv94[0] = tmp95;
                                // Arg 3 word: "..."
                                StringBuffer sbtmp97 = new StringBuffer(64);
                                sbtmp97.append("TclObject ");
                                tmp95 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 23);
                                sbtmp97.append(tmp95.toString());
                                sbtmp97.append(";");
                                sbtmp97.append("\n");
                                tmp95 = TclString.newInstance(sbtmp97);
                                tmp95.preserve();
                                objv94[1] = tmp95;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv94, compiledLocals, 3);
                            } finally {
                                TJC.releaseObjvElems(interp, objv94, 2);
                            }
                        } // End Invoke: append
                        { // Invoke: set tuple [...]
                            TclObject tmp98;
                            { // Invoke: ... $key 1 false $result_tmpsymbol
                                TclObject[] objv99 = TJC.grabObjv(interp, 5);
                                TclObject tmp100;
                                try {
                                    // Arg 0 constant: ...
                                    objv99[0] = const9;
                                    // Arg 1 variable: $key
                                    tmp100 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp100.preserve();
                                    objv99[1] = tmp100;
                                    // Arg 2 constant: 1
                                    objv99[2] = const0;
                                    // Arg 3 constant: false
                                    objv99[3] = const22;
                                    // Arg 4 variable: $result_tmpsymbol
                                    tmp100 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 23);
                                    tmp100.preserve();
                                    objv99[4] = tmp100;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv99, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp100 = objv99[1];
                                    if ( tmp100 != null ) {
                                        tmp100.release();
                                    }
                                    tmp100 = objv99[4];
                                    if ( tmp100 != null ) {
                                        tmp100.release();
                                    }
                                    TJC.releaseObjv(interp, objv99, 5);
                                }
                            } // End Invoke: ...
                            tmp98 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp98, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv101 = TJC.grabObjv(interp, 1);
                            TclObject tmp102;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: lindex $tuple 2
                                    TclObject tmp103 = getVarScalar(interp, "tuple", compiledLocals, 6);
                                    tmp103 = TclList.index(interp, tmp103, 2);
                                    if ( tmp103 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp103);
                                    }
                                } // End Invoke: lindex
                                tmp102 = interp.getResult();
                                tmp102.preserve();
                                objv101[0] = tmp102;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv101, compiledLocals, 3);
                            } finally {
                                TJC.releaseObjvElems(interp, objv101, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set avname_tmpsymbol [...]
                            TclObject tmp104;
                            { // Invoke: ...
                                TclObject[] objv105 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv105[0] = const11;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv105, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv105, 1);
                                }
                            } // End Invoke: ...
                            tmp104 = interp.getResult();
                            setVarScalar(interp, "avname_tmpsymbol", tmp104, compiledLocals, 25);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv106 = TJC.grabObjv(interp, 1);
                            TclObject tmp107;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv108 = TJC.grabObjv(interp, 2);
                                    TclObject tmp109;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv108[0] = const12;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp110 = new StringBuffer(64);
                                        sbtmp110.append("String ");
                                        tmp109 = getVarScalar(interp, "avname_tmpsymbol", compiledLocals, 25);
                                        sbtmp110.append(tmp109.toString());
                                        sbtmp110.append(" = ");
                                        tmp109 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 23);
                                        sbtmp110.append(tmp109.toString());
                                        sbtmp110.append(".toString()");
                                        tmp109 = TclString.newInstance(sbtmp110);
                                        tmp109.preserve();
                                        objv108[1] = tmp109;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv108, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        tmp109 = objv108[1];
                                        if ( tmp109 != null ) {
                                            tmp109.release();
                                        }
                                        TJC.releaseObjv(interp, objv108, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp107 = interp.getResult();
                                tmp107.preserve();
                                objv106[0] = tmp107;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv106, compiledLocals, 3);
                            } finally {
                                TJC.releaseObjvElems(interp, objv106, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: append buffer $incr_value_buffer $incr_buffer [...] "..." ... $avname_tmpsymbol ", null" ", " $incr_symbol ...
                            TclObject[] objv111 = TJC.grabObjv(interp, 10);
                            TclObject tmp112;
                            try {
                                // Arg 2 variable: $incr_value_buffer
                                tmp112 = getVarScalar(interp, "incr_value_buffer", compiledLocals, 4);
                                tmp112.preserve();
                                objv111[0] = tmp112;
                                // Arg 3 variable: $incr_buffer
                                tmp112 = getVarScalar(interp, "incr_buffer", compiledLocals, 5);
                                tmp112.preserve();
                                objv111[1] = tmp112;
                                // Arg 4 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv113 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv113[0] = const17;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                            ? cmdcache11.cmd : null), objv113, 0);
                                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                            updateCmdCache(interp, 11);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv113, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp112 = interp.getResult();
                                tmp112.preserve();
                                objv111[2] = tmp112;
                                // Arg 5 word: "..."
                                StringBuffer sbtmp114 = new StringBuffer(64);
                                tmp112 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 23);
                                sbtmp114.append(tmp112.toString());
                                sbtmp114.append(" = ");
                                tmp112 = TclString.newInstance(sbtmp114);
                                tmp112.preserve();
                                objv111[3] = tmp112;
                                // Arg 6 constant: ...
                                objv111[4] = const18;
                                // Arg 7 variable: $avname_tmpsymbol
                                tmp112 = getVarScalar(interp, "avname_tmpsymbol", compiledLocals, 25);
                                tmp112.preserve();
                                objv111[5] = tmp112;
                                // Arg 8 constant: ", null"
                                objv111[6] = const19;
                                // Arg 9 constant: ", "
                                objv111[7] = const20;
                                // Arg 10 variable: $incr_symbol
                                tmp112 = getVarScalar(interp, "incr_symbol", compiledLocals, 12);
                                tmp112.preserve();
                                objv111[8] = tmp112;
                                // Arg 11 constant: ...
                                objv111[9] = const21;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv111, compiledLocals, 3);
                            } finally {
                                objv111[4] = null;
                                objv111[6] = null;
                                objv111[7] = null;
                                objv111[9] = null;
                                TJC.releaseObjvElems(interp, objv111, 10);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            } else {
                TclObject tmp115 = getVarScalar(interp, "constant_varname", compiledLocals, 8);
                boolean tmp116 = TJC.getBoolean(interp, tmp115);
                if ( tmp116 ) {
                    { // Invoke: set omit_result [...]
                        TclObject tmp117;
                        { // Invoke: ... $key
                            TclObject[] objv118 = TJC.grabObjv(interp, 2);
                            TclObject tmp119;
                            try {
                                // Arg 0 constant: ...
                                objv118[0] = const23;
                                // Arg 1 variable: $key
                                tmp119 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp119.preserve();
                                objv118[1] = tmp119;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                    ? cmdcache12.cmd : null), objv118, 0);
                                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                    updateCmdCache(interp, 12);
                                }
                            } finally {
                                tmp119 = objv118[1];
                                if ( tmp119 != null ) {
                                    tmp119.release();
                                }
                                TJC.releaseObjv(interp, objv118, 2);
                            }
                        } // End Invoke: ...
                        tmp117 = interp.getResult();
                        setVarScalar(interp, "omit_result", tmp117, compiledLocals, 22);
                    } // End Invoke: set
                    { // Invoke: append buffer $incr_value_buffer $incr_buffer [...]
                        TclObject[] objv120 = TJC.grabObjv(interp, 3);
                        TclObject tmp121;
                        try {
                            // Arg 2 variable: $incr_value_buffer
                            tmp121 = getVarScalar(interp, "incr_value_buffer", compiledLocals, 4);
                            tmp121.preserve();
                            objv120[0] = tmp121;
                            // Arg 3 variable: $incr_buffer
                            tmp121 = getVarScalar(interp, "incr_buffer", compiledLocals, 5);
                            tmp121.preserve();
                            objv120[1] = tmp121;
                            // Arg 4 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv122 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv122[0] = const17;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                        ? cmdcache11.cmd : null), objv122, 0);
                                    if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                        updateCmdCache(interp, 11);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv122, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp121 = interp.getResult();
                            tmp121.preserve();
                            objv120[2] = tmp121;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv120, compiledLocals, 3);
                        } finally {
                            TJC.releaseObjvElems(interp, objv120, 3);
                        }
                    } // End Invoke: append
                    { // Invoke: if {!$omit_result} ...
                        // Unary operator: ! $omit_result
                        TclObject tmp123 = getVarScalar(interp, "omit_result", compiledLocals, 22);
                        ExprValue tmp124 = evs0;
                        if ( tmp123.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp124, tmp123);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp124, tmp123);
                        }
                        // End Unary operator: !
                        boolean tmp125 = ( tmp124.getIntValue() != 0 );
                        if ( tmp125 ) {
                            { // Invoke: set result_tmpsymbol [...]
                                TclObject tmp126;
                                { // Invoke: ...
                                    TclObject[] objv127 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: ...
                                        objv127[0] = const11;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv127, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv127, 1);
                                    }
                                } // End Invoke: ...
                                tmp126 = interp.getResult();
                                setVarScalar(interp, "result_tmpsymbol", tmp126, compiledLocals, 23);
                            } // End Invoke: set
                            { // Invoke: append buffer "..."
                                TclObject[] objv128 = TJC.grabObjv(interp, 1);
                                TclObject tmp129;
                                try {
                                    // Arg 2 word: "..."
                                    StringBuffer sbtmp130 = new StringBuffer(64);
                                    sbtmp130.append("TclObject ");
                                    tmp129 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 23);
                                    sbtmp130.append(tmp129.toString());
                                    sbtmp130.append(" = ");
                                    tmp129 = TclString.newInstance(sbtmp130);
                                    tmp129.preserve();
                                    objv128[0] = tmp129;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv128, compiledLocals, 3);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv128, 1);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                    { // Invoke: set vinfo [...]
                        TclObject tmp131;
                        { // Invoke: ... $varname
                            TclObject[] objv132 = TJC.grabObjv(interp, 2);
                            TclObject tmp133;
                            try {
                                // Arg 0 constant: ...
                                objv132[0] = const24;
                                // Arg 1 variable: $varname
                                tmp133 = getVarScalar(interp, "varname", compiledLocals, 9);
                                tmp133.preserve();
                                objv132[1] = tmp133;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                    ? cmdcache13.cmd : null), objv132, 0);
                                if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                    updateCmdCache(interp, 13);
                                }
                            } finally {
                                tmp133 = objv132[1];
                                if ( tmp133 != null ) {
                                    tmp133.release();
                                }
                                TJC.releaseObjv(interp, objv132, 2);
                            }
                        } // End Invoke: ...
                        tmp131 = interp.getResult();
                        setVarScalar(interp, "vinfo", tmp131, compiledLocals, 26);
                    } // End Invoke: set
                    { // Invoke: if ... ... elseif ... ... else ...
                        // Binary operator: [...] == "array"
                        { // Invoke: lindex $vinfo 0
                            TclObject tmp134 = getVarScalar(interp, "vinfo", compiledLocals, 26);
                            tmp134 = TclList.index(interp, tmp134, 0);
                            if ( tmp134 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp134);
                            }
                        } // End Invoke: lindex
                        TclObject tmp135 = interp.getResult();
                        boolean tmp136 = tmp135.toString().equals("array");
                        ExprValue tmp137 = evs0;
                        tmp137.setIntValue(tmp136);
                        // End Binary operator: ==
                        boolean tmp138 = ( tmp137.getIntValue() != 0 );
                        if ( tmp138 ) {
                            { // Invoke: set p1 [...]
                                TclObject tmp139;
                                { // Invoke: lindex $vinfo 1
                                    TclObject tmp140 = getVarScalar(interp, "vinfo", compiledLocals, 26);
                                    tmp140 = TclList.index(interp, tmp140, 1);
                                    if ( tmp140 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp140);
                                    }
                                } // End Invoke: lindex
                                tmp139 = interp.getResult();
                                setVarScalar(interp, "p1", tmp139, compiledLocals, 27);
                            } // End Invoke: set
                            { // Invoke: set p2 [...]
                                TclObject tmp141;
                                { // Invoke: lindex $vinfo 2
                                    TclObject tmp142 = getVarScalar(interp, "vinfo", compiledLocals, 26);
                                    tmp142 = TclList.index(interp, tmp142, 2);
                                    if ( tmp142 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp142);
                                    }
                                } // End Invoke: lindex
                                tmp141 = interp.getResult();
                                setVarScalar(interp, "p2", tmp141, compiledLocals, 28);
                            } // End Invoke: set
                            { // Invoke: set cache_symbol [...]
                                TclObject tmp143;
                                { // Invoke: ... $p1
                                    TclObject[] objv144 = TJC.grabObjv(interp, 2);
                                    TclObject tmp145;
                                    try {
                                        // Arg 0 constant: ...
                                        objv144[0] = const25;
                                        // Arg 1 variable: $p1
                                        tmp145 = getVarScalar(interp, "p1", compiledLocals, 27);
                                        tmp145.preserve();
                                        objv144[1] = tmp145;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                            ? cmdcache14.cmd : null), objv144, 0);
                                        if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                            updateCmdCache(interp, 14);
                                        }
                                    } finally {
                                        tmp145 = objv144[1];
                                        if ( tmp145 != null ) {
                                            tmp145.release();
                                        }
                                        TJC.releaseObjv(interp, objv144, 2);
                                    }
                                } // End Invoke: ...
                                tmp143 = interp.getResult();
                                setVarScalar(interp, "cache_symbol", tmp143, compiledLocals, 29);
                            } // End Invoke: set
                            { // Invoke: set cacheId [...]
                                TclObject tmp146;
                                { // Invoke: ... $cache_symbol
                                    TclObject[] objv147 = TJC.grabObjv(interp, 2);
                                    TclObject tmp148;
                                    try {
                                        // Arg 0 constant: ...
                                        objv147[0] = const26;
                                        // Arg 1 variable: $cache_symbol
                                        tmp148 = getVarScalar(interp, "cache_symbol", compiledLocals, 29);
                                        tmp148.preserve();
                                        objv147[1] = tmp148;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                            ? cmdcache15.cmd : null), objv147, 0);
                                        if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                            updateCmdCache(interp, 15);
                                        }
                                    } finally {
                                        tmp148 = objv147[1];
                                        if ( tmp148 != null ) {
                                            tmp148.release();
                                        }
                                        TJC.releaseObjv(interp, objv147, 2);
                                    }
                                } // End Invoke: ...
                                tmp146 = interp.getResult();
                                setVarScalar(interp, "cacheId", tmp146, compiledLocals, 30);
                            } // End Invoke: set
                            { // Invoke: set qp1 [...]
                                TclObject tmp149;
                                { // Invoke: ... $p1
                                    TclObject[] objv150 = TJC.grabObjv(interp, 2);
                                    TclObject tmp151;
                                    try {
                                        // Arg 0 constant: ...
                                        objv150[0] = const16;
                                        // Arg 1 variable: $p1
                                        tmp151 = getVarScalar(interp, "p1", compiledLocals, 27);
                                        tmp151.preserve();
                                        objv150[1] = tmp151;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                            ? cmdcache10.cmd : null), objv150, 0);
                                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                            updateCmdCache(interp, 10);
                                        }
                                    } finally {
                                        tmp151 = objv150[1];
                                        if ( tmp151 != null ) {
                                            tmp151.release();
                                        }
                                        TJC.releaseObjv(interp, objv150, 2);
                                    }
                                } // End Invoke: ...
                                tmp149 = interp.getResult();
                                setVarScalar(interp, "qp1", tmp149, compiledLocals, 31);
                            } // End Invoke: set
                            { // Invoke: set qp2 [...]
                                TclObject tmp152;
                                { // Invoke: ... $p2
                                    TclObject[] objv153 = TJC.grabObjv(interp, 2);
                                    TclObject tmp154;
                                    try {
                                        // Arg 0 constant: ...
                                        objv153[0] = const16;
                                        // Arg 1 variable: $p2
                                        tmp154 = getVarScalar(interp, "p2", compiledLocals, 28);
                                        tmp154.preserve();
                                        objv153[1] = tmp154;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                            ? cmdcache10.cmd : null), objv153, 0);
                                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                            updateCmdCache(interp, 10);
                                        }
                                    } finally {
                                        tmp154 = objv153[1];
                                        if ( tmp154 != null ) {
                                            tmp154.release();
                                        }
                                        TJC.releaseObjv(interp, objv153, 2);
                                    }
                                } // End Invoke: ...
                                tmp152 = interp.getResult();
                                setVarScalar(interp, "qp2", tmp152, compiledLocals, 32);
                            } // End Invoke: set
                            { // Invoke: append buffer ... $qp1 ", " $qp2 ", " $incr_symbol ", " "compiledLocals" ", " $cacheId ...
                                TclObject[] objv155 = TJC.grabObjv(interp, 11);
                                TclObject tmp156;
                                try {
                                    // Arg 2 constant: ...
                                    objv155[0] = const27;
                                    // Arg 3 variable: $qp1
                                    tmp156 = getVarScalar(interp, "qp1", compiledLocals, 31);
                                    tmp156.preserve();
                                    objv155[1] = tmp156;
                                    // Arg 4 constant: ", "
                                    objv155[2] = const20;
                                    // Arg 5 variable: $qp2
                                    tmp156 = getVarScalar(interp, "qp2", compiledLocals, 32);
                                    tmp156.preserve();
                                    objv155[3] = tmp156;
                                    // Arg 6 constant: ", "
                                    objv155[4] = const20;
                                    // Arg 7 variable: $incr_symbol
                                    tmp156 = getVarScalar(interp, "incr_symbol", compiledLocals, 12);
                                    tmp156.preserve();
                                    objv155[5] = tmp156;
                                    // Arg 8 constant: ", "
                                    objv155[6] = const20;
                                    // Arg 9 constant: "compiledLocals"
                                    objv155[7] = const28;
                                    // Arg 10 constant: ", "
                                    objv155[8] = const20;
                                    // Arg 11 variable: $cacheId
                                    tmp156 = getVarScalar(interp, "cacheId", compiledLocals, 30);
                                    tmp156.preserve();
                                    objv155[9] = tmp156;
                                    // Arg 12 constant: ...
                                    objv155[10] = const21;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv155, compiledLocals, 3);
                                } finally {
                                    tmp156 = objv155[1];
                                    if ( tmp156 != null ) {
                                        tmp156.release();
                                    }
                                    tmp156 = objv155[3];
                                    if ( tmp156 != null ) {
                                        tmp156.release();
                                    }
                                    tmp156 = objv155[5];
                                    if ( tmp156 != null ) {
                                        tmp156.release();
                                    }
                                    tmp156 = objv155[9];
                                    if ( tmp156 != null ) {
                                        tmp156.release();
                                    }
                                    TJC.releaseObjv(interp, objv155, 11);
                                }
                            } // End Invoke: append
                        } else {
                            // Binary operator: [...] == "scalar"
                            { // Invoke: lindex $vinfo 0
                                TclObject tmp157 = getVarScalar(interp, "vinfo", compiledLocals, 26);
                                tmp157 = TclList.index(interp, tmp157, 0);
                                if ( tmp157 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp157);
                                }
                            } // End Invoke: lindex
                            TclObject tmp158 = interp.getResult();
                            boolean tmp159 = tmp158.toString().equals("scalar");
                            ExprValue tmp160 = evs0;
                            tmp160.setIntValue(tmp159);
                            // End Binary operator: ==
                            boolean tmp161 = ( tmp160.getIntValue() != 0 );
                            if ( tmp161 ) {
                                { // Invoke: set qvarname [...]
                                    TclObject tmp162;
                                    { // Invoke: ... $varname
                                        TclObject[] objv163 = TJC.grabObjv(interp, 2);
                                        TclObject tmp164;
                                        try {
                                            // Arg 0 constant: ...
                                            objv163[0] = const16;
                                            // Arg 1 variable: $varname
                                            tmp164 = getVarScalar(interp, "varname", compiledLocals, 9);
                                            tmp164.preserve();
                                            objv163[1] = tmp164;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                ? cmdcache10.cmd : null), objv163, 0);
                                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                updateCmdCache(interp, 10);
                                            }
                                        } finally {
                                            tmp164 = objv163[1];
                                            if ( tmp164 != null ) {
                                                tmp164.release();
                                            }
                                            TJC.releaseObjv(interp, objv163, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp162 = interp.getResult();
                                    setVarScalar(interp, "qvarname", tmp162, compiledLocals, 24);
                                } // End Invoke: set
                                { // Invoke: set cache_symbol [...]
                                    TclObject tmp165;
                                    { // Invoke: ... $varname
                                        TclObject[] objv166 = TJC.grabObjv(interp, 2);
                                        TclObject tmp167;
                                        try {
                                            // Arg 0 constant: ...
                                            objv166[0] = const25;
                                            // Arg 1 variable: $varname
                                            tmp167 = getVarScalar(interp, "varname", compiledLocals, 9);
                                            tmp167.preserve();
                                            objv166[1] = tmp167;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                                ? cmdcache14.cmd : null), objv166, 0);
                                            if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                                updateCmdCache(interp, 14);
                                            }
                                        } finally {
                                            tmp167 = objv166[1];
                                            if ( tmp167 != null ) {
                                                tmp167.release();
                                            }
                                            TJC.releaseObjv(interp, objv166, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp165 = interp.getResult();
                                    setVarScalar(interp, "cache_symbol", tmp165, compiledLocals, 29);
                                } // End Invoke: set
                                { // Invoke: set cacheId [...]
                                    TclObject tmp168;
                                    { // Invoke: ... $cache_symbol
                                        TclObject[] objv169 = TJC.grabObjv(interp, 2);
                                        TclObject tmp170;
                                        try {
                                            // Arg 0 constant: ...
                                            objv169[0] = const26;
                                            // Arg 1 variable: $cache_symbol
                                            tmp170 = getVarScalar(interp, "cache_symbol", compiledLocals, 29);
                                            tmp170.preserve();
                                            objv169[1] = tmp170;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                                ? cmdcache15.cmd : null), objv169, 0);
                                            if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                                updateCmdCache(interp, 15);
                                            }
                                        } finally {
                                            tmp170 = objv169[1];
                                            if ( tmp170 != null ) {
                                                tmp170.release();
                                            }
                                            TJC.releaseObjv(interp, objv169, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp168 = interp.getResult();
                                    setVarScalar(interp, "cacheId", tmp168, compiledLocals, 30);
                                } // End Invoke: set
                                { // Invoke: append buffer ... $qvarname ", " $incr_symbol ", " "compiledLocals" ", " $cacheId ...
                                    TclObject[] objv171 = TJC.grabObjv(interp, 9);
                                    TclObject tmp172;
                                    try {
                                        // Arg 2 constant: ...
                                        objv171[0] = const29;
                                        // Arg 3 variable: $qvarname
                                        tmp172 = getVarScalar(interp, "qvarname", compiledLocals, 24);
                                        tmp172.preserve();
                                        objv171[1] = tmp172;
                                        // Arg 4 constant: ", "
                                        objv171[2] = const20;
                                        // Arg 5 variable: $incr_symbol
                                        tmp172 = getVarScalar(interp, "incr_symbol", compiledLocals, 12);
                                        tmp172.preserve();
                                        objv171[3] = tmp172;
                                        // Arg 6 constant: ", "
                                        objv171[4] = const20;
                                        // Arg 7 constant: "compiledLocals"
                                        objv171[5] = const28;
                                        // Arg 8 constant: ", "
                                        objv171[6] = const20;
                                        // Arg 9 variable: $cacheId
                                        tmp172 = getVarScalar(interp, "cacheId", compiledLocals, 30);
                                        tmp172.preserve();
                                        objv171[7] = tmp172;
                                        // Arg 10 constant: ...
                                        objv171[8] = const21;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv171, compiledLocals, 3);
                                    } finally {
                                        tmp172 = objv171[1];
                                        if ( tmp172 != null ) {
                                            tmp172.release();
                                        }
                                        tmp172 = objv171[3];
                                        if ( tmp172 != null ) {
                                            tmp172.release();
                                        }
                                        tmp172 = objv171[7];
                                        if ( tmp172 != null ) {
                                            tmp172.release();
                                        }
                                        TJC.releaseObjv(interp, objv171, 9);
                                    }
                                } // End Invoke: append
                            } else {
                                { // Invoke: error "..."
                                    TclObject[] objv173 = TJC.grabObjv(interp, 2);
                                    TclObject tmp174;
                                    try {
                                        // Arg 0 constant: error
                                        objv173[0] = const13;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp175 = new StringBuffer(64);
                                        sbtmp175.append("unexpected result ");
                                        sbtmp175.append("{");
                                        tmp174 = getVarScalar(interp, "vinfo", compiledLocals, 26);
                                        sbtmp175.append(tmp174.toString());
                                        sbtmp175.append("}");
                                        sbtmp175.append(" from descend_simple_variable");
                                        tmp174 = TclString.newInstance(sbtmp175);
                                        tmp174.preserve();
                                        objv173[1] = tmp174;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                            ? cmdcache8.cmd : null), objv173, 0);
                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                            updateCmdCache(interp, 8);
                                        }
                                    } finally {
                                        tmp174 = objv173[1];
                                        if ( tmp174 != null ) {
                                            tmp174.release();
                                        }
                                        TJC.releaseObjv(interp, objv173, 2);
                                    }
                                } // End Invoke: error
                            }
                        }
                    } // End Invoke: if
                } else {
                    { // Invoke: set omit_result [...]
                        TclObject tmp176;
                        { // Invoke: ... $key
                            TclObject[] objv177 = TJC.grabObjv(interp, 2);
                            TclObject tmp178;
                            try {
                                // Arg 0 constant: ...
                                objv177[0] = const23;
                                // Arg 1 variable: $key
                                tmp178 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp178.preserve();
                                objv177[1] = tmp178;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                    ? cmdcache12.cmd : null), objv177, 0);
                                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                    updateCmdCache(interp, 12);
                                }
                            } finally {
                                tmp178 = objv177[1];
                                if ( tmp178 != null ) {
                                    tmp178.release();
                                }
                                TJC.releaseObjv(interp, objv177, 2);
                            }
                        } // End Invoke: ...
                        tmp176 = interp.getResult();
                        setVarScalar(interp, "omit_result", tmp176, compiledLocals, 22);
                    } // End Invoke: set
                    { // Invoke: set result_tmpsymbol [...]
                        TclObject tmp179;
                        { // Invoke: ...
                            TclObject[] objv180 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv180[0] = const11;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv180, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv180, 1);
                            }
                        } // End Invoke: ...
                        tmp179 = interp.getResult();
                        setVarScalar(interp, "result_tmpsymbol", tmp179, compiledLocals, 23);
                    } // End Invoke: set
                    { // Invoke: append buffer [...] "..."
                        TclObject[] objv181 = TJC.grabObjv(interp, 2);
                        TclObject tmp182;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv183 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv183[0] = const17;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                        ? cmdcache11.cmd : null), objv183, 0);
                                    if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                        updateCmdCache(interp, 11);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv183, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp182 = interp.getResult();
                            tmp182.preserve();
                            objv181[0] = tmp182;
                            // Arg 3 word: "..."
                            StringBuffer sbtmp184 = new StringBuffer(64);
                            sbtmp184.append("TclObject ");
                            tmp182 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 23);
                            sbtmp184.append(tmp182.toString());
                            sbtmp184.append(";");
                            sbtmp184.append("\n");
                            tmp182 = TclString.newInstance(sbtmp184);
                            tmp182.preserve();
                            objv181[1] = tmp182;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv181, compiledLocals, 3);
                        } finally {
                            TJC.releaseObjvElems(interp, objv181, 2);
                        }
                    } // End Invoke: append
                    { // Invoke: set tuple [...]
                        TclObject tmp185;
                        { // Invoke: ... $key 1 $result_tmpsymbol
                            TclObject[] objv186 = TJC.grabObjv(interp, 4);
                            TclObject tmp187;
                            try {
                                // Arg 0 constant: ...
                                objv186[0] = const30;
                                // Arg 1 variable: $key
                                tmp187 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp187.preserve();
                                objv186[1] = tmp187;
                                // Arg 2 constant: 1
                                objv186[2] = const0;
                                // Arg 3 variable: $result_tmpsymbol
                                tmp187 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 23);
                                tmp187.preserve();
                                objv186[3] = tmp187;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                                    ? cmdcache16.cmd : null), objv186, 0);
                                if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                                    updateCmdCache(interp, 16);
                                }
                            } finally {
                                tmp187 = objv186[1];
                                if ( tmp187 != null ) {
                                    tmp187.release();
                                }
                                tmp187 = objv186[3];
                                if ( tmp187 != null ) {
                                    tmp187.release();
                                }
                                TJC.releaseObjv(interp, objv186, 4);
                            }
                        } // End Invoke: ...
                        tmp185 = interp.getResult();
                        setVarScalar(interp, "tuple", tmp185, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: set varname [...]
                        TclObject tmp188;
                        { // Invoke: lindex $tuple 0
                            TclObject tmp189 = getVarScalar(interp, "tuple", compiledLocals, 6);
                            tmp189 = TclList.index(interp, tmp189, 0);
                            if ( tmp189 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp189);
                            }
                        } // End Invoke: lindex
                        tmp188 = interp.getResult();
                        setVarScalar(interp, "varname", tmp188, compiledLocals, 9);
                    } // End Invoke: set
                    { // Invoke: set keysym [...]
                        TclObject tmp190;
                        { // Invoke: lindex $tuple 1
                            TclObject tmp191 = getVarScalar(interp, "tuple", compiledLocals, 6);
                            tmp191 = TclList.index(interp, tmp191, 1);
                            if ( tmp191 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp191);
                            }
                        } // End Invoke: lindex
                        tmp190 = interp.getResult();
                        setVarScalar(interp, "keysym", tmp190, compiledLocals, 33);
                    } // End Invoke: set
                    { // Invoke: set word_buffer [...]
                        TclObject tmp192;
                        { // Invoke: lindex $tuple 2
                            TclObject tmp193 = getVarScalar(interp, "tuple", compiledLocals, 6);
                            tmp193 = TclList.index(interp, tmp193, 2);
                            if ( tmp193 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp193);
                            }
                        } // End Invoke: lindex
                        tmp192 = interp.getResult();
                        setVarScalar(interp, "word_buffer", tmp192, compiledLocals, 34);
                    } // End Invoke: set
                    { // Invoke: set qvarname [...]
                        TclObject tmp194;
                        { // Invoke: ... $varname
                            TclObject[] objv195 = TJC.grabObjv(interp, 2);
                            TclObject tmp196;
                            try {
                                // Arg 0 constant: ...
                                objv195[0] = const16;
                                // Arg 1 variable: $varname
                                tmp196 = getVarScalar(interp, "varname", compiledLocals, 9);
                                tmp196.preserve();
                                objv195[1] = tmp196;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv195, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                tmp196 = objv195[1];
                                if ( tmp196 != null ) {
                                    tmp196.release();
                                }
                                TJC.releaseObjv(interp, objv195, 2);
                            }
                        } // End Invoke: ...
                        tmp194 = interp.getResult();
                        setVarScalar(interp, "qvarname", tmp194, compiledLocals, 24);
                    } // End Invoke: set
                    { // Invoke: set cache_symbol [...]
                        TclObject tmp197;
                        { // Invoke: ... $varname
                            TclObject[] objv198 = TJC.grabObjv(interp, 2);
                            TclObject tmp199;
                            try {
                                // Arg 0 constant: ...
                                objv198[0] = const25;
                                // Arg 1 variable: $varname
                                tmp199 = getVarScalar(interp, "varname", compiledLocals, 9);
                                tmp199.preserve();
                                objv198[1] = tmp199;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                    ? cmdcache14.cmd : null), objv198, 0);
                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                    updateCmdCache(interp, 14);
                                }
                            } finally {
                                tmp199 = objv198[1];
                                if ( tmp199 != null ) {
                                    tmp199.release();
                                }
                                TJC.releaseObjv(interp, objv198, 2);
                            }
                        } // End Invoke: ...
                        tmp197 = interp.getResult();
                        setVarScalar(interp, "cache_symbol", tmp197, compiledLocals, 29);
                    } // End Invoke: set
                    { // Invoke: set cacheId [...]
                        TclObject tmp200;
                        { // Invoke: ... $cache_symbol
                            TclObject[] objv201 = TJC.grabObjv(interp, 2);
                            TclObject tmp202;
                            try {
                                // Arg 0 constant: ...
                                objv201[0] = const26;
                                // Arg 1 variable: $cache_symbol
                                tmp202 = getVarScalar(interp, "cache_symbol", compiledLocals, 29);
                                tmp202.preserve();
                                objv201[1] = tmp202;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                    ? cmdcache15.cmd : null), objv201, 0);
                                if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                    updateCmdCache(interp, 15);
                                }
                            } finally {
                                tmp202 = objv201[1];
                                if ( tmp202 != null ) {
                                    tmp202.release();
                                }
                                TJC.releaseObjv(interp, objv201, 2);
                            }
                        } // End Invoke: ...
                        tmp200 = interp.getResult();
                        setVarScalar(interp, "cacheId", tmp200, compiledLocals, 30);
                    } // End Invoke: set
                    { // Invoke: append buffer $word_buffer $incr_value_buffer $incr_buffer [...]
                        TclObject[] objv203 = TJC.grabObjv(interp, 4);
                        TclObject tmp204;
                        try {
                            // Arg 2 variable: $word_buffer
                            tmp204 = getVarScalar(interp, "word_buffer", compiledLocals, 34);
                            tmp204.preserve();
                            objv203[0] = tmp204;
                            // Arg 3 variable: $incr_value_buffer
                            tmp204 = getVarScalar(interp, "incr_value_buffer", compiledLocals, 4);
                            tmp204.preserve();
                            objv203[1] = tmp204;
                            // Arg 4 variable: $incr_buffer
                            tmp204 = getVarScalar(interp, "incr_buffer", compiledLocals, 5);
                            tmp204.preserve();
                            objv203[2] = tmp204;
                            // Arg 5 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv205 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv205[0] = const17;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                        ? cmdcache11.cmd : null), objv205, 0);
                                    if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                        updateCmdCache(interp, 11);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv205, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp204 = interp.getResult();
                            tmp204.preserve();
                            objv203[3] = tmp204;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv203, compiledLocals, 3);
                        } finally {
                            TJC.releaseObjvElems(interp, objv203, 4);
                        }
                    } // End Invoke: append
                    { // Invoke: if {!$omit_result} ...
                        // Unary operator: ! $omit_result
                        TclObject tmp206 = getVarScalar(interp, "omit_result", compiledLocals, 22);
                        ExprValue tmp207 = evs0;
                        if ( tmp206.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp207, tmp206);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp207, tmp206);
                        }
                        // End Unary operator: !
                        boolean tmp208 = ( tmp207.getIntValue() != 0 );
                        if ( tmp208 ) {
                            { // Invoke: append buffer "..."
                                TclObject[] objv209 = TJC.grabObjv(interp, 1);
                                TclObject tmp210;
                                try {
                                    // Arg 2 word: "..."
                                    StringBuffer sbtmp211 = new StringBuffer(64);
                                    tmp210 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 23);
                                    sbtmp211.append(tmp210.toString());
                                    sbtmp211.append(" = ");
                                    tmp210 = TclString.newInstance(sbtmp211);
                                    tmp210.preserve();
                                    objv209[0] = tmp210;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv209, compiledLocals, 3);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv209, 1);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                    { // Invoke: append buffer ... $qvarname ", " $keysym ", " $incr_symbol ", " "compiledLocals" ", " $cacheId ...
                        TclObject[] objv212 = TJC.grabObjv(interp, 11);
                        TclObject tmp213;
                        try {
                            // Arg 2 constant: ...
                            objv212[0] = const27;
                            // Arg 3 variable: $qvarname
                            tmp213 = getVarScalar(interp, "qvarname", compiledLocals, 24);
                            tmp213.preserve();
                            objv212[1] = tmp213;
                            // Arg 4 constant: ", "
                            objv212[2] = const20;
                            // Arg 5 variable: $keysym
                            tmp213 = getVarScalar(interp, "keysym", compiledLocals, 33);
                            tmp213.preserve();
                            objv212[3] = tmp213;
                            // Arg 6 constant: ", "
                            objv212[4] = const20;
                            // Arg 7 variable: $incr_symbol
                            tmp213 = getVarScalar(interp, "incr_symbol", compiledLocals, 12);
                            tmp213.preserve();
                            objv212[5] = tmp213;
                            // Arg 8 constant: ", "
                            objv212[6] = const20;
                            // Arg 9 constant: "compiledLocals"
                            objv212[7] = const28;
                            // Arg 10 constant: ", "
                            objv212[8] = const20;
                            // Arg 11 variable: $cacheId
                            tmp213 = getVarScalar(interp, "cacheId", compiledLocals, 30);
                            tmp213.preserve();
                            objv212[9] = tmp213;
                            // Arg 12 constant: ...
                            objv212[10] = const21;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv212, compiledLocals, 3);
                        } finally {
                            tmp213 = objv212[1];
                            if ( tmp213 != null ) {
                                tmp213.release();
                            }
                            tmp213 = objv212[3];
                            if ( tmp213 != null ) {
                                tmp213.release();
                            }
                            tmp213 = objv212[5];
                            if ( tmp213 != null ) {
                                tmp213.release();
                            }
                            tmp213 = objv212[9];
                            if ( tmp213 != null ) {
                                tmp213.release();
                            }
                            TJC.releaseObjv(interp, objv212, 11);
                        }
                    } // End Invoke: append
                }
            }
        } // End Invoke: if
        { // Invoke: if {!$omit_result} ...
            // Unary operator: ! $omit_result
            TclObject tmp214 = getVarScalar(interp, "omit_result", compiledLocals, 22);
            ExprValue tmp215 = evs0;
            if ( tmp214.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp215, tmp214);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp215, tmp214);
            }
            // End Unary operator: !
            boolean tmp216 = ( tmp215.getIntValue() != 0 );
            if ( tmp216 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv217 = TJC.grabObjv(interp, 1);
                    TclObject tmp218;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_set_result $result_tmpsymbol false
                            TclObject[] objv219 = TJC.grabObjv(interp, 3);
                            TclObject tmp220;
                            try {
                                // Arg 0 constant: emitter_set_result
                                objv219[0] = const31;
                                // Arg 1 variable: $result_tmpsymbol
                                tmp220 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 23);
                                tmp220.preserve();
                                objv219[1] = tmp220;
                                // Arg 2 constant: false
                                objv219[2] = const22;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                                    ? cmdcache17.cmd : null), objv219, 0);
                                if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                                    updateCmdCache(interp, 17);
                                }
                            } finally {
                                tmp220 = objv219[1];
                                if ( tmp220 != null ) {
                                    tmp220.release();
                                }
                                TJC.releaseObjv(interp, objv219, 3);
                            }
                        } // End Invoke: emitter_set_result
                        tmp218 = interp.getResult();
                        tmp218.preserve();
                        objv217[0] = tmp218;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv217, compiledLocals, 3);
                    } finally {
                        TJC.releaseObjvElems(interp, objv217, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp221 = getVarScalar(interp, "buffer", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp221);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_inline_command_incr");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_get_argument_tuple");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_get_data");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("tree");
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(2);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_string_is_java_integer");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_parse_value");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_emit_argument");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("true");
        TclBoolean.get(interp, const10);
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_tmpvar_next");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("emitter_statement");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("error");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("expected 2 or 3 arguments to incr");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("emitter_reset_result");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("emitter_double_quote_tcl_string");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("emitter_indent");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("TJC.incrVar(interp, ");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance(", null");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance(", ");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance(");\n");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("false");
        TclBoolean.get(interp, const22);
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("compileproc_omit_set_result");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("descend_simple_variable");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("compileproc_variable_cache_lookup");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("compileproc_get_variable_cache_id_from_symbol");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("incrVarArray(interp, ");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("compiledLocals");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("incrVarScalar(interp, ");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("compileproc_setup_nonconstant_array_variable");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("emitter_set_result");
        const31.preserve(); const31.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 2: {
                cmdName = "descend_get_data";
                break;
            }
            case 3: {
                cmdName = "compileproc_string_is_java_integer";
                break;
            }
            case 4: {
                cmdName = "compileproc_parse_value";
                break;
            }
            case 5: {
                cmdName = "compileproc_emit_argument";
                break;
            }
            case 6: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 7: {
                cmdName = "emitter_statement";
                break;
            }
            case 8: {
                cmdName = "error";
                break;
            }
            case 9: {
                cmdName = "emitter_reset_result";
                break;
            }
            case 10: {
                cmdName = "emitter_double_quote_tcl_string";
                break;
            }
            case 11: {
                cmdName = "emitter_indent";
                break;
            }
            case 12: {
                cmdName = "compileproc_omit_set_result";
                break;
            }
            case 13: {
                cmdName = "descend_simple_variable";
                break;
            }
            case 14: {
                cmdName = "compileproc_variable_cache_lookup";
                break;
            }
            case 15: {
                cmdName = "compileproc_get_variable_cache_id_from_symbol";
                break;
            }
            case 16: {
                cmdName = "compileproc_setup_nonconstant_array_variable";
                break;
            }
            case 17: {
                cmdName = "emitter_set_result";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "cache_variables",
        "buffer",
        "incr_value_buffer",
        "incr_buffer",
        "tuple",
        "type",
        "constant_varname",
        "varname",
        "tree",
        "num_args",
        "incr_symbol",
        "constant_integer_increment",
        "value",
        "is_integer",
        "stringrep_matches",
        "parsed_number",
        "value_type",
        "value_symbol",
        "value_buffer",
        "tmpsymbol",
        "omit_result",
        "result_tmpsymbol",
        "qvarname",
        "avname_tmpsymbol",
        "vinfo",
        "p1",
        "p2",
        "cache_symbol",
        "cacheId",
        "qp1",
        "qp2",
        "keysym",
        "word_buffer"
    };
} // end class CompileprocEmitInlineCommandIncrCmd

