// TJC implementation of procedure compileproc_emit_inline_command_list
package tjc;
import tcl.lang.*;

public class CompileprocEmitInlineCommandListCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 11, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const1;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: tree
                    objv1[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "tree", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp3;
            { // Invoke: llength $tree
                TclObject tmp4 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp5 = TclList.getLength(interp, tmp4);
                interp.setResult(tmp5);
            } // End Invoke: llength
            tmp3 = interp.getResult();
            setVarScalar(interp, "num_args", tmp3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set tmpsymbol [...]
            TclObject tmp6;
            { // Invoke: ...
                TclObject[] objv7 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv7[0] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv7, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv7, 1);
                }
            } // End Invoke: ...
            tmp6 = interp.getResult();
            setVarScalar(interp, "tmpsymbol", tmp6, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv8 = TJC.grabObjv(interp, 1);
            TclObject tmp9;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement "..."
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    TclObject tmp11;
                    try {
                        // Arg 0 constant: emitter_statement
                        objv10[0] = const4;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp12 = new StringBuffer(64);
                        sbtmp12.append("TclObject ");
                        tmp11 = getVarScalar(interp, "tmpsymbol", compiledLocals, 5);
                        sbtmp12.append(tmp11.toString());
                        sbtmp12.append(" = TclList.newInstance()");
                        tmp11 = TclString.newInstance(sbtmp12);
                        tmp11.preserve();
                        objv10[1] = tmp11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv10, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp11 = objv10[1];
                        if ( tmp11 != null ) {
                            tmp11.release();
                        }
                        TJC.releaseObjv(interp, objv10, 2);
                    }
                } // End Invoke: emitter_statement
                tmp9 = interp.getResult();
                tmp9.preserve();
                objv8[0] = tmp9;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv8, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv8, 1);
            }
        } // End Invoke: append
        { // Invoke: set constant_args 1
            setVarScalar(interp, "constant_args", const5, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: for {set i 1} {$i < $num_args} {incr i} ...
            { // Invoke: set i 1
                setVarScalar(interp, "i", const5, compiledLocals, 7);
            } // End Invoke: set
            for ( boolean skip18 = true ; true ; ) {
                if ( skip18 ) {
                    skip18 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 7);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $num_args
                TclObject tmp13 = getVarScalar(interp, "i", compiledLocals, 7);
                ExprValue tmp14 = evs0;
                TJC.exprInitValue(interp, tmp14, tmp13);
                TclObject tmp15 = getVarScalar(interp, "num_args", compiledLocals, 4);
                ExprValue tmp16 = evs1;
                TJC.exprInitValue(interp, tmp16, tmp15);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp14, tmp16);
                // End Binary operator: <
                boolean tmp17 = ( tmp14.getIntValue() != 0 );
                if ( ! tmp17 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set tuple [...]
                    TclObject tmp19;
                    { // Invoke: ... $key $i
                        TclObject[] objv20 = TJC.grabObjv(interp, 3);
                        TclObject tmp21;
                        try {
                            // Arg 0 constant: ...
                            objv20[0] = const6;
                            // Arg 1 variable: $key
                            tmp21 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp21.preserve();
                            objv20[1] = tmp21;
                            // Arg 2 variable: $i
                            tmp21 = getVarScalar(interp, "i", compiledLocals, 7);
                            tmp21.preserve();
                            objv20[2] = tmp21;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv20, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp21 = objv20[1];
                            if ( tmp21 != null ) {
                                tmp21.release();
                            }
                            tmp21 = objv20[2];
                            if ( tmp21 != null ) {
                                tmp21.release();
                            }
                            TJC.releaseObjv(interp, objv20, 3);
                        }
                    } // End Invoke: ...
                    tmp19 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp19, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set type [...]
                    TclObject tmp22;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp23 = getVarScalar(interp, "tuple", compiledLocals, 8);
                        tmp23 = TclList.index(interp, tmp23, 0);
                        if ( tmp23 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp23);
                        }
                    } // End Invoke: lindex
                    tmp22 = interp.getResult();
                    setVarScalar(interp, "type", tmp22, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $type != "constant"
                    TclObject tmp24 = getVarScalar(interp, "type", compiledLocals, 9);
                    boolean tmp25 = ! tmp24.toString().equals("constant");
                    ExprValue tmp26 = evs0;
                    tmp26.setIntValue(tmp25);
                    // End Binary operator: !=
                    boolean tmp27 = ( tmp26.getIntValue() != 0 );
                    if ( tmp27 ) {
                        { // Invoke: set constant_args 0
                            setVarScalar(interp, "constant_args", const7, compiledLocals, 6);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: if {$constant_args} ... else ...
            TclObject tmp28 = getVarScalar(interp, "constant_args", compiledLocals, 6);
            boolean tmp29 = TJC.getBoolean(interp, tmp28);
            if ( tmp29 ) {
                { // Invoke: set value_tmpsymbol {}
                    setVarScalar(interp, "value_tmpsymbol", const0, compiledLocals, 10);
                } // End Invoke: set
            } else {
                { // Invoke: set value_tmpsymbol [...]
                    TclObject tmp30;
                    { // Invoke: ...
                        TclObject[] objv31 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv31[0] = const3;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv31, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv31, 1);
                        }
                    } // End Invoke: ...
                    tmp30 = interp.getResult();
                    setVarScalar(interp, "value_tmpsymbol", tmp30, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv32 = TJC.grabObjv(interp, 1);
                    TclObject tmp33;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv34 = TJC.grabObjv(interp, 2);
                            TclObject tmp35;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv34[0] = const4;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp36 = new StringBuffer(64);
                                sbtmp36.append("TclObject ");
                                tmp35 = getVarScalar(interp, "value_tmpsymbol", compiledLocals, 10);
                                sbtmp36.append(tmp35.toString());
                                tmp35 = TclString.newInstance(sbtmp36);
                                tmp35.preserve();
                                objv34[1] = tmp35;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv34, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp35 = objv34[1];
                                if ( tmp35 != null ) {
                                    tmp35.release();
                                }
                                TJC.releaseObjv(interp, objv34, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp33 = interp.getResult();
                        tmp33.preserve();
                        objv32[0] = tmp33;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv32, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv32, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: if {$num_args == 1} ... elseif {$num_args == 2} ... else ...
            // Binary operator: $num_args == 1
            TclObject tmp37 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp38 = evs0;
            TJC.exprInitValue(interp, tmp38, tmp37);
            ExprValue tmp39 = evs1;
            tmp39.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp38, tmp39);
            // End Binary operator: ==
            boolean tmp40 = ( tmp38.getIntValue() != 0 );
            if ( tmp40 ) {
            } else {
                // Binary operator: $num_args == 2
                TclObject tmp41 = getVarScalar(interp, "num_args", compiledLocals, 4);
                ExprValue tmp42 = evs0;
                TJC.exprInitValue(interp, tmp42, tmp41);
                ExprValue tmp43 = evs1;
                tmp43.setIntValue(2);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp42, tmp43);
                // End Binary operator: ==
                boolean tmp44 = ( tmp42.getIntValue() != 0 );
                if ( tmp44 ) {
                    { // Invoke: append buffer [...]
                        TclObject[] objv45 = TJC.grabObjv(interp, 1);
                        TclObject tmp46;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ... $key 1 $tmpsymbol $value_tmpsymbol
                                TclObject[] objv47 = TJC.grabObjv(interp, 5);
                                TclObject tmp48;
                                try {
                                    // Arg 0 constant: ...
                                    objv47[0] = const8;
                                    // Arg 1 variable: $key
                                    tmp48 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp48.preserve();
                                    objv47[1] = tmp48;
                                    // Arg 2 constant: 1
                                    objv47[2] = const5;
                                    // Arg 3 variable: $tmpsymbol
                                    tmp48 = getVarScalar(interp, "tmpsymbol", compiledLocals, 5);
                                    tmp48.preserve();
                                    objv47[3] = tmp48;
                                    // Arg 4 variable: $value_tmpsymbol
                                    tmp48 = getVarScalar(interp, "value_tmpsymbol", compiledLocals, 10);
                                    tmp48.preserve();
                                    objv47[4] = tmp48;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv47, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp48 = objv47[1];
                                    if ( tmp48 != null ) {
                                        tmp48.release();
                                    }
                                    tmp48 = objv47[3];
                                    if ( tmp48 != null ) {
                                        tmp48.release();
                                    }
                                    tmp48 = objv47[4];
                                    if ( tmp48 != null ) {
                                        tmp48.release();
                                    }
                                    TJC.releaseObjv(interp, objv47, 5);
                                }
                            } // End Invoke: ...
                            tmp46 = interp.getResult();
                            tmp46.preserve();
                            objv45[0] = tmp46;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv45, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv45, 1);
                        }
                    } // End Invoke: append
                } else {
                    { // Invoke: append buffer [...] ...
                        TclObject[] objv49 = TJC.grabObjv(interp, 2);
                        TclObject tmp50;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv51 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv51[0] = const9;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv51, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv51, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp50 = interp.getResult();
                            tmp50.preserve();
                            objv49[0] = tmp50;
                            // Arg 3 constant: ...
                            objv49[1] = const10;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv49, compiledLocals, 2);
                        } finally {
                            tmp50 = objv49[0];
                            if ( tmp50 != null ) {
                                tmp50.release();
                            }
                            TJC.releaseObjv(interp, objv49, 2);
                        }
                    } // End Invoke: append
                    { // Invoke: emitter_indent_level +1
                        TclObject[] objv52 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: emitter_indent_level
                            objv52[0] = const11;
                            // Arg 1 constant: +1
                            objv52[1] = const12;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv52, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv52, 2);
                        }
                    } // End Invoke: emitter_indent_level
                    { // Invoke: for {set i 1} {$i < $num_args} {incr i} ...
                        { // Invoke: set i 1
                            setVarScalar(interp, "i", const5, compiledLocals, 7);
                        } // End Invoke: set
                        for ( boolean skip58 = true ; true ; ) {
                            if ( skip58 ) {
                                skip58 = false;
                            } else {
                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: incr i
                                    interp.resetResult();
                                    incrVarScalar(interp, "i", 1, compiledLocals, 7);
                                } // End Invoke: incr
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }

                            // Binary operator: $i < $num_args
                            TclObject tmp53 = getVarScalar(interp, "i", compiledLocals, 7);
                            ExprValue tmp54 = evs0;
                            TJC.exprInitValue(interp, tmp54, tmp53);
                            TclObject tmp55 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            ExprValue tmp56 = evs1;
                            TJC.exprInitValue(interp, tmp56, tmp55);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp54, tmp56);
                            // End Binary operator: <
                            boolean tmp57 = ( tmp54.getIntValue() != 0 );
                            if ( ! tmp57 ) { break; }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append buffer [...]
                                TclObject[] objv59 = TJC.grabObjv(interp, 1);
                                TclObject tmp60;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $key $i $tmpsymbol $value_tmpsymbol
                                        TclObject[] objv61 = TJC.grabObjv(interp, 5);
                                        TclObject tmp62;
                                        try {
                                            // Arg 0 constant: ...
                                            objv61[0] = const8;
                                            // Arg 1 variable: $key
                                            tmp62 = getVarScalar(interp, "key", compiledLocals, 0);
                                            tmp62.preserve();
                                            objv61[1] = tmp62;
                                            // Arg 2 variable: $i
                                            tmp62 = getVarScalar(interp, "i", compiledLocals, 7);
                                            tmp62.preserve();
                                            objv61[2] = tmp62;
                                            // Arg 3 variable: $tmpsymbol
                                            tmp62 = getVarScalar(interp, "tmpsymbol", compiledLocals, 5);
                                            tmp62.preserve();
                                            objv61[3] = tmp62;
                                            // Arg 4 variable: $value_tmpsymbol
                                            tmp62 = getVarScalar(interp, "value_tmpsymbol", compiledLocals, 10);
                                            tmp62.preserve();
                                            objv61[4] = tmp62;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                ? cmdcache5.cmd : null), objv61, 0);
                                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                updateCmdCache(interp, 5);
                                            }
                                        } finally {
                                            tmp62 = objv61[1];
                                            if ( tmp62 != null ) {
                                                tmp62.release();
                                            }
                                            tmp62 = objv61[2];
                                            if ( tmp62 != null ) {
                                                tmp62.release();
                                            }
                                            tmp62 = objv61[3];
                                            if ( tmp62 != null ) {
                                                tmp62.release();
                                            }
                                            tmp62 = objv61[4];
                                            if ( tmp62 != null ) {
                                                tmp62.release();
                                            }
                                            TJC.releaseObjv(interp, objv61, 5);
                                        }
                                    } // End Invoke: ...
                                    tmp60 = interp.getResult();
                                    tmp60.preserve();
                                    objv59[0] = tmp60;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv59, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv59, 1);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } // End Invoke: for
                    { // Invoke: emitter_indent_level -1
                        TclObject[] objv63 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: emitter_indent_level
                            objv63[0] = const11;
                            // Arg 1 constant: -1
                            objv63[1] = const13;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv63, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv63, 2);
                        }
                    } // End Invoke: emitter_indent_level
                    { // Invoke: append buffer [...] ...
                        TclObject[] objv64 = TJC.grabObjv(interp, 2);
                        TclObject tmp65;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv66 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv66[0] = const9;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv66, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv66, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp65 = interp.getResult();
                            tmp65.preserve();
                            objv64[0] = tmp65;
                            // Arg 3 constant: ...
                            objv64[1] = const14;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv64, compiledLocals, 2);
                        } finally {
                            tmp65 = objv64[0];
                            if ( tmp65 != null ) {
                                tmp65.release();
                            }
                            TJC.releaseObjv(interp, objv64, 2);
                        }
                    } // End Invoke: append
                    { // Invoke: emitter_indent_level +1
                        TclObject[] objv67 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: emitter_indent_level
                            objv67[0] = const11;
                            // Arg 1 constant: +1
                            objv67[1] = const12;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv67, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv67, 2);
                        }
                    } // End Invoke: emitter_indent_level
                    { // Invoke: append buffer [...] [...]
                        TclObject[] objv68 = TJC.grabObjv(interp, 2);
                        TclObject tmp69;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ... $tmpsymbol
                                TclObject[] objv70 = TJC.grabObjv(interp, 2);
                                TclObject tmp71;
                                try {
                                    // Arg 0 constant: ...
                                    objv70[0] = const15;
                                    // Arg 1 variable: $tmpsymbol
                                    tmp71 = getVarScalar(interp, "tmpsymbol", compiledLocals, 5);
                                    tmp71.preserve();
                                    objv70[1] = tmp71;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv70, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    tmp71 = objv70[1];
                                    if ( tmp71 != null ) {
                                        tmp71.release();
                                    }
                                    TJC.releaseObjv(interp, objv70, 2);
                                }
                            } // End Invoke: ...
                            tmp69 = interp.getResult();
                            tmp69.preserve();
                            objv68[0] = tmp69;
                            // Arg 3 command: [...]
                            { // Invoke: emitter_statement "throw ex"
                                TclObject[] objv72 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: emitter_statement
                                    objv72[0] = const4;
                                    // Arg 1 constant: "throw ex"
                                    objv72[1] = const16;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv72, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv72, 2);
                                }
                            } // End Invoke: emitter_statement
                            tmp69 = interp.getResult();
                            tmp69.preserve();
                            objv68[1] = tmp69;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv68, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv68, 2);
                        }
                    } // End Invoke: append
                    { // Invoke: emitter_indent_level -1
                        TclObject[] objv73 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: emitter_indent_level
                            objv73[0] = const11;
                            // Arg 1 constant: -1
                            objv73[1] = const13;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv73, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv73, 2);
                        }
                    } // End Invoke: emitter_indent_level
                    { // Invoke: append buffer [...] ...
                        TclObject[] objv74 = TJC.grabObjv(interp, 2);
                        TclObject tmp75;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv76 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv76[0] = const9;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv76, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv76, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp75 = interp.getResult();
                            tmp75.preserve();
                            objv74[0] = tmp75;
                            // Arg 3 constant: ...
                            objv74[1] = const17;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv74, compiledLocals, 2);
                        } finally {
                            tmp75 = objv74[0];
                            if ( tmp75 != null ) {
                                tmp75.release();
                            }
                            TJC.releaseObjv(interp, objv74, 2);
                        }
                    } // End Invoke: append
                }
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv77 = TJC.grabObjv(interp, 1);
            TclObject tmp78;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_set_result $tmpsymbol false
                    TclObject[] objv79 = TJC.grabObjv(interp, 3);
                    TclObject tmp80;
                    try {
                        // Arg 0 constant: emitter_set_result
                        objv79[0] = const18;
                        // Arg 1 variable: $tmpsymbol
                        tmp80 = getVarScalar(interp, "tmpsymbol", compiledLocals, 5);
                        tmp80.preserve();
                        objv79[1] = tmp80;
                        // Arg 2 constant: false
                        objv79[2] = const19;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                            ? cmdcache9.cmd : null), objv79, 0);
                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                            updateCmdCache(interp, 9);
                        }
                    } finally {
                        tmp80 = objv79[1];
                        if ( tmp80 != null ) {
                            tmp80.release();
                        }
                        TJC.releaseObjv(interp, objv79, 3);
                    }
                } // End Invoke: emitter_set_result
                tmp78 = interp.getResult();
                tmp78.preserve();
                objv77[0] = tmp78;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv77, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv77, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp81 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp81);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_inline_command_list");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_get_data");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_tmpvar_next");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_statement");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(1);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_get_argument_tuple");
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(0);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_emit_inline_command_list_argument");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("emitter_indent");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("try {\n");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("emitter_indent_level");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("+1");
        TclInteger.get(interp, const12);
        const12.preserve(); const12.preserve();
        const13 = TclInteger.newInstance(-1);
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("} catch (TclException ex) {\n");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("emitter_tclobject_release");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("throw ex");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("}\n");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("emitter_set_result");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("false");
        TclBoolean.get(interp, const19);
        const19.preserve(); const19.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 3: {
                cmdName = "emitter_statement";
                break;
            }
            case 4: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 5: {
                cmdName = "compileproc_emit_inline_command_list_argument";
                break;
            }
            case 6: {
                cmdName = "emitter_indent";
                break;
            }
            case 7: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 8: {
                cmdName = "emitter_tclobject_release";
                break;
            }
            case 9: {
                cmdName = "emitter_set_result";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "buffer",
        "tree",
        "num_args",
        "tmpsymbol",
        "constant_args",
        "i",
        "tuple",
        "type",
        "value_tmpsymbol"
    };
} // end class CompileprocEmitInlineCommandListCmd

