// TJC implementation of procedure compileproc_emit_variable
package tjc;
import tcl.lang.*;

public class CompileprocEmitVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 20, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 3 || objv.length > 4) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol vinfo ?declare_flag?");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "vinfo", objv[2], compiledLocals, 1);
        setVarScalar(interp, "declare_flag", 
            ((objv.length <= 3) ? const0 : objv[3]), compiledLocals, 2);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 3);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const1, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$declare_flag} ... else ...
            TclObject tmp0 = getVarScalar(interp, "declare_flag", compiledLocals, 2);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: set declare "TclObject "
                    setVarScalar(interp, "declare", const2, compiledLocals, 5);
                } // End Invoke: set
            } else {
                { // Invoke: set declare ""
                    setVarScalar(interp, "declare", const1, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set vtype [...]
            TclObject tmp2;
            { // Invoke: lindex $vinfo 0
                TclObject tmp3 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                tmp3 = TclList.index(interp, tmp3, 0);
                if ( tmp3 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp3);
                }
            } // End Invoke: lindex
            tmp2 = interp.getResult();
            setVarScalar(interp, "vtype", tmp2, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: switch -exact -- $vtype {scalar} ... {array text} ... {array scalar} ... {array command} ... {word command} ... {array word} ... default ...
            TclObject tmp4 = getVarScalar(interp, "vtype", compiledLocals, 6);
            String tmp5 = tmp4.toString();
            int tmp5_length = tmp5.length();
            char tmp5_first = '\n';
            if ( tmp5_length > 0 ) {
                tmp5_first = tmp5.charAt(0);
            }
            if ( tmp5_length == 6 && tmp5_first == 's'
                    && tmp5.compareTo("scalar") == 0 ) {
                // Pattern {scalar}
                { // Invoke: set vname [...]
                    TclObject tmp6;
                    { // Invoke: lindex $vinfo 1
                        TclObject tmp7 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                        tmp7 = TclList.index(interp, tmp7, 1);
                        if ( tmp7 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp7);
                        }
                    } // End Invoke: lindex
                    tmp6 = interp.getResult();
                    setVarScalar(interp, "vname", tmp6, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv8 = TJC.grabObjv(interp, 1);
                    TclObject tmp9;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $declare$tmpsymbol $vname
                            TclObject[] objv10 = TJC.grabObjv(interp, 3);
                            TclObject tmp11;
                            try {
                                // Arg 0 constant: ...
                                objv10[0] = const3;
                                // Arg 1 word: $declare$tmpsymbol
                                StringBuffer sbtmp12 = new StringBuffer(64);
                                tmp11 = getVarScalar(interp, "declare", compiledLocals, 5);
                                sbtmp12.append(tmp11.toString());
                                tmp11 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                sbtmp12.append(tmp11.toString());
                                tmp11 = TclString.newInstance(sbtmp12);
                                tmp11.preserve();
                                objv10[1] = tmp11;
                                // Arg 2 variable: $vname
                                tmp11 = getVarScalar(interp, "vname", compiledLocals, 7);
                                tmp11.preserve();
                                objv10[2] = tmp11;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv10, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp11 = objv10[1];
                                if ( tmp11 != null ) {
                                    tmp11.release();
                                }
                                tmp11 = objv10[2];
                                if ( tmp11 != null ) {
                                    tmp11.release();
                                }
                                TJC.releaseObjv(interp, objv10, 3);
                            }
                        } // End Invoke: ...
                        tmp9 = interp.getResult();
                        tmp9.preserve();
                        objv8[0] = tmp9;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv8, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv8, 1);
                    }
                } // End Invoke: append
            } else if ( tmp5_length == 10 && tmp5_first == 'a'
                    && tmp5.compareTo("array text") == 0 ) {
                // Pattern {array text}
                { // Invoke: set avname [...]
                    TclObject tmp13;
                    { // Invoke: lindex $vinfo 1 0
                        TclObject[] objv14 = TJC.grabObjv(interp, 4);
                        TclObject tmp15;
                        try {
                            // Arg 0 constant: lindex
                            objv14[0] = const4;
                            // Arg 1 variable: $vinfo
                            tmp15 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                            tmp15.preserve();
                            objv14[1] = tmp15;
                            // Arg 2 constant: 1
                            objv14[2] = const0;
                            // Arg 3 constant: 0
                            objv14[3] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv14, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp15 = objv14[1];
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                            TJC.releaseObjv(interp, objv14, 4);
                        }
                    } // End Invoke: lindex
                    tmp13 = interp.getResult();
                    setVarScalar(interp, "avname", tmp13, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$avname == ""} ...
                    // Binary operator: $avname == ""
                    TclObject tmp16 = getVarScalar(interp, "avname", compiledLocals, 8);
                    ExprValue tmp17 = evs0;
                    TJC.exprEqualsEmptyString(tmp17, tmp16, false);
                    // End Binary operator: ==
                    boolean tmp18 = ( tmp17.getIntValue() != 0 );
                    if ( tmp18 ) {
                        { // Invoke: error "..."
                            TclObject[] objv19 = TJC.grabObjv(interp, 2);
                            TclObject tmp20;
                            try {
                                // Arg 0 constant: error
                                objv19[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp21 = new StringBuffer(64);
                                sbtmp21.append("empty array name in ");
                                sbtmp21.append("{");
                                tmp20 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                                sbtmp21.append(tmp20.toString());
                                sbtmp21.append("}");
                                tmp20 = TclString.newInstance(sbtmp21);
                                tmp20.preserve();
                                objv19[1] = tmp20;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv19, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp20 = objv19[1];
                                if ( tmp20 != null ) {
                                    tmp20.release();
                                }
                                TJC.releaseObjv(interp, objv19, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set kname [...]
                    TclObject tmp22;
                    { // Invoke: lindex $vinfo 1 1
                        TclObject[] objv23 = TJC.grabObjv(interp, 4);
                        TclObject tmp24;
                        try {
                            // Arg 0 constant: lindex
                            objv23[0] = const4;
                            // Arg 1 variable: $vinfo
                            tmp24 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                            tmp24.preserve();
                            objv23[1] = tmp24;
                            // Arg 2 constant: 1
                            objv23[2] = const0;
                            // Arg 3 constant: 1
                            objv23[3] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv23, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp24 = objv23[1];
                            if ( tmp24 != null ) {
                                tmp24.release();
                            }
                            TJC.releaseObjv(interp, objv23, 4);
                        }
                    } // End Invoke: lindex
                    tmp22 = interp.getResult();
                    setVarScalar(interp, "kname", tmp22, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv25 = TJC.grabObjv(interp, 1);
                    TclObject tmp26;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $declare$tmpsymbol $avname $kname true
                            TclObject[] objv27 = TJC.grabObjv(interp, 5);
                            TclObject tmp28;
                            try {
                                // Arg 0 constant: ...
                                objv27[0] = const7;
                                // Arg 1 word: $declare$tmpsymbol
                                StringBuffer sbtmp29 = new StringBuffer(64);
                                tmp28 = getVarScalar(interp, "declare", compiledLocals, 5);
                                sbtmp29.append(tmp28.toString());
                                tmp28 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                sbtmp29.append(tmp28.toString());
                                tmp28 = TclString.newInstance(sbtmp29);
                                tmp28.preserve();
                                objv27[1] = tmp28;
                                // Arg 2 variable: $avname
                                tmp28 = getVarScalar(interp, "avname", compiledLocals, 8);
                                tmp28.preserve();
                                objv27[2] = tmp28;
                                // Arg 3 variable: $kname
                                tmp28 = getVarScalar(interp, "kname", compiledLocals, 9);
                                tmp28.preserve();
                                objv27[3] = tmp28;
                                // Arg 4 constant: true
                                objv27[4] = const8;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv27, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp28 = objv27[1];
                                if ( tmp28 != null ) {
                                    tmp28.release();
                                }
                                tmp28 = objv27[2];
                                if ( tmp28 != null ) {
                                    tmp28.release();
                                }
                                tmp28 = objv27[3];
                                if ( tmp28 != null ) {
                                    tmp28.release();
                                }
                                TJC.releaseObjv(interp, objv27, 5);
                            }
                        } // End Invoke: ...
                        tmp26 = interp.getResult();
                        tmp26.preserve();
                        objv25[0] = tmp26;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv25, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv25, 1);
                    }
                } // End Invoke: append
            } else if ( tmp5_length == 12 && tmp5_first == 'a'
                    && tmp5.compareTo("array scalar") == 0 ) {
                // Pattern {array scalar}
                { // Invoke: set avname [...]
                    TclObject tmp30;
                    { // Invoke: lindex $vinfo 1 0
                        TclObject[] objv31 = TJC.grabObjv(interp, 4);
                        TclObject tmp32;
                        try {
                            // Arg 0 constant: lindex
                            objv31[0] = const4;
                            // Arg 1 variable: $vinfo
                            tmp32 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                            tmp32.preserve();
                            objv31[1] = tmp32;
                            // Arg 2 constant: 1
                            objv31[2] = const0;
                            // Arg 3 constant: 0
                            objv31[3] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv31, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp32 = objv31[1];
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                            TJC.releaseObjv(interp, objv31, 4);
                        }
                    } // End Invoke: lindex
                    tmp30 = interp.getResult();
                    setVarScalar(interp, "avname", tmp30, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$avname == ""} ...
                    // Binary operator: $avname == ""
                    TclObject tmp33 = getVarScalar(interp, "avname", compiledLocals, 8);
                    ExprValue tmp34 = evs0;
                    TJC.exprEqualsEmptyString(tmp34, tmp33, false);
                    // End Binary operator: ==
                    boolean tmp35 = ( tmp34.getIntValue() != 0 );
                    if ( tmp35 ) {
                        { // Invoke: error "..."
                            TclObject[] objv36 = TJC.grabObjv(interp, 2);
                            TclObject tmp37;
                            try {
                                // Arg 0 constant: error
                                objv36[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp38 = new StringBuffer(64);
                                sbtmp38.append("empty array name in ");
                                sbtmp38.append("{");
                                tmp37 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                                sbtmp38.append(tmp37.toString());
                                sbtmp38.append("}");
                                tmp37 = TclString.newInstance(sbtmp38);
                                tmp37.preserve();
                                objv36[1] = tmp37;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv36, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp37 = objv36[1];
                                if ( tmp37 != null ) {
                                    tmp37.release();
                                }
                                TJC.releaseObjv(interp, objv36, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set kvname [...]
                    TclObject tmp39;
                    { // Invoke: lindex $vinfo 1 1
                        TclObject[] objv40 = TJC.grabObjv(interp, 4);
                        TclObject tmp41;
                        try {
                            // Arg 0 constant: lindex
                            objv40[0] = const4;
                            // Arg 1 variable: $vinfo
                            tmp41 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                            tmp41.preserve();
                            objv40[1] = tmp41;
                            // Arg 2 constant: 1
                            objv40[2] = const0;
                            // Arg 3 constant: 1
                            objv40[3] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv40, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp41 = objv40[1];
                            if ( tmp41 != null ) {
                                tmp41.release();
                            }
                            TJC.releaseObjv(interp, objv40, 4);
                        }
                    } // End Invoke: lindex
                    tmp39 = interp.getResult();
                    setVarScalar(interp, "kvname", tmp39, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: if {$kvname == ""} ...
                    // Binary operator: $kvname == ""
                    TclObject tmp42 = getVarScalar(interp, "kvname", compiledLocals, 10);
                    ExprValue tmp43 = evs0;
                    TJC.exprEqualsEmptyString(tmp43, tmp42, false);
                    // End Binary operator: ==
                    boolean tmp44 = ( tmp43.getIntValue() != 0 );
                    if ( tmp44 ) {
                        { // Invoke: error "..."
                            TclObject[] objv45 = TJC.grabObjv(interp, 2);
                            TclObject tmp46;
                            try {
                                // Arg 0 constant: error
                                objv45[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp47 = new StringBuffer(64);
                                sbtmp47.append("empty array key variable name in ");
                                sbtmp47.append("{");
                                tmp46 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                                sbtmp47.append(tmp46.toString());
                                sbtmp47.append("}");
                                tmp46 = TclString.newInstance(sbtmp47);
                                tmp46.preserve();
                                objv45[1] = tmp46;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv45, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp46 = objv45[1];
                                if ( tmp46 != null ) {
                                    tmp46.release();
                                }
                                TJC.releaseObjv(interp, objv45, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...] [...]
                    TclObject[] objv48 = TJC.grabObjv(interp, 2);
                    TclObject tmp49;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $declare$tmpsymbol $kvname
                            TclObject[] objv50 = TJC.grabObjv(interp, 3);
                            TclObject tmp51;
                            try {
                                // Arg 0 constant: ...
                                objv50[0] = const3;
                                // Arg 1 word: $declare$tmpsymbol
                                StringBuffer sbtmp52 = new StringBuffer(64);
                                tmp51 = getVarScalar(interp, "declare", compiledLocals, 5);
                                sbtmp52.append(tmp51.toString());
                                tmp51 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                sbtmp52.append(tmp51.toString());
                                tmp51 = TclString.newInstance(sbtmp52);
                                tmp51.preserve();
                                objv50[1] = tmp51;
                                // Arg 2 variable: $kvname
                                tmp51 = getVarScalar(interp, "kvname", compiledLocals, 10);
                                tmp51.preserve();
                                objv50[2] = tmp51;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv50, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp51 = objv50[1];
                                if ( tmp51 != null ) {
                                    tmp51.release();
                                }
                                tmp51 = objv50[2];
                                if ( tmp51 != null ) {
                                    tmp51.release();
                                }
                                TJC.releaseObjv(interp, objv50, 3);
                            }
                        } // End Invoke: ...
                        tmp49 = interp.getResult();
                        tmp49.preserve();
                        objv48[0] = tmp49;
                        // Arg 3 command: [...]
                        { // Invoke: ... $tmpsymbol $avname "..." false
                            TclObject[] objv53 = TJC.grabObjv(interp, 5);
                            TclObject tmp54;
                            try {
                                // Arg 0 constant: ...
                                objv53[0] = const7;
                                // Arg 1 variable: $tmpsymbol
                                tmp54 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                tmp54.preserve();
                                objv53[1] = tmp54;
                                // Arg 2 variable: $avname
                                tmp54 = getVarScalar(interp, "avname", compiledLocals, 8);
                                tmp54.preserve();
                                objv53[2] = tmp54;
                                // Arg 3 word: "..."
                                StringBuffer sbtmp55 = new StringBuffer(64);
                                tmp54 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                sbtmp55.append(tmp54.toString());
                                sbtmp55.append(".toString()");
                                tmp54 = TclString.newInstance(sbtmp55);
                                tmp54.preserve();
                                objv53[3] = tmp54;
                                // Arg 4 constant: false
                                objv53[4] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv53, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp54 = objv53[1];
                                if ( tmp54 != null ) {
                                    tmp54.release();
                                }
                                tmp54 = objv53[2];
                                if ( tmp54 != null ) {
                                    tmp54.release();
                                }
                                tmp54 = objv53[3];
                                if ( tmp54 != null ) {
                                    tmp54.release();
                                }
                                TJC.releaseObjv(interp, objv53, 5);
                            }
                        } // End Invoke: ...
                        tmp49 = interp.getResult();
                        tmp49.preserve();
                        objv48[1] = tmp49;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv48, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv48, 2);
                    }
                } // End Invoke: append
            } else if ( tmp5_length == 13 && tmp5_first == 'a'
                    && tmp5.compareTo("array command") == 0 ) {
                // Pattern {array command}
                { // Invoke: set avname [...]
                    TclObject tmp56;
                    { // Invoke: lindex $vinfo 1 0
                        TclObject[] objv57 = TJC.grabObjv(interp, 4);
                        TclObject tmp58;
                        try {
                            // Arg 0 constant: lindex
                            objv57[0] = const4;
                            // Arg 1 variable: $vinfo
                            tmp58 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                            tmp58.preserve();
                            objv57[1] = tmp58;
                            // Arg 2 constant: 1
                            objv57[2] = const0;
                            // Arg 3 constant: 0
                            objv57[3] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv57, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp58 = objv57[1];
                            if ( tmp58 != null ) {
                                tmp58.release();
                            }
                            TJC.releaseObjv(interp, objv57, 4);
                        }
                    } // End Invoke: lindex
                    tmp56 = interp.getResult();
                    setVarScalar(interp, "avname", tmp56, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$avname == ""} ...
                    // Binary operator: $avname == ""
                    TclObject tmp59 = getVarScalar(interp, "avname", compiledLocals, 8);
                    ExprValue tmp60 = evs0;
                    TJC.exprEqualsEmptyString(tmp60, tmp59, false);
                    // End Binary operator: ==
                    boolean tmp61 = ( tmp60.getIntValue() != 0 );
                    if ( tmp61 ) {
                        { // Invoke: error "..."
                            TclObject[] objv62 = TJC.grabObjv(interp, 2);
                            TclObject tmp63;
                            try {
                                // Arg 0 constant: error
                                objv62[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp64 = new StringBuffer(64);
                                sbtmp64.append("empty array name in ");
                                sbtmp64.append("{");
                                tmp63 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                                sbtmp64.append(tmp63.toString());
                                sbtmp64.append("}");
                                tmp63 = TclString.newInstance(sbtmp64);
                                tmp63.preserve();
                                objv62[1] = tmp63;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv62, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp63 = objv62[1];
                                if ( tmp63 != null ) {
                                    tmp63.release();
                                }
                                TJC.releaseObjv(interp, objv62, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set ckeys [...]
                    TclObject tmp65;
                    { // Invoke: lindex $vinfo 1 1
                        TclObject[] objv66 = TJC.grabObjv(interp, 4);
                        TclObject tmp67;
                        try {
                            // Arg 0 constant: lindex
                            objv66[0] = const4;
                            // Arg 1 variable: $vinfo
                            tmp67 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                            tmp67.preserve();
                            objv66[1] = tmp67;
                            // Arg 2 constant: 1
                            objv66[2] = const0;
                            // Arg 3 constant: 1
                            objv66[3] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv66, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp67 = objv66[1];
                            if ( tmp67 != null ) {
                                tmp67.release();
                            }
                            TJC.releaseObjv(interp, objv66, 4);
                        }
                    } // End Invoke: lindex
                    tmp65 = interp.getResult();
                    setVarScalar(interp, "ckeys", tmp65, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: ... $ckeys
                        TclObject[] objv68 = TJC.grabObjv(interp, 2);
                        TclObject tmp69;
                        try {
                            // Arg 0 constant: ...
                            objv68[0] = const10;
                            // Arg 1 variable: $ckeys
                            tmp69 = getVarScalar(interp, "ckeys", compiledLocals, 11);
                            tmp69.preserve();
                            objv68[1] = tmp69;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv68, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp69 = objv68[1];
                            if ( tmp69 != null ) {
                                tmp69.release();
                            }
                            TJC.releaseObjv(interp, objv68, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp70 = interp.getResult();
                    ExprValue tmp71 = evs0;
                    TJC.exprInitValue(interp, tmp71, tmp70);
                    boolean tmp72 = tmp71.getBooleanValue(interp);
                    if ( tmp72 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv73 = TJC.grabObjv(interp, 1);
                            TclObject tmp74;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $declare$tmpsymbol $avname "" true
                                    TclObject[] objv75 = TJC.grabObjv(interp, 5);
                                    TclObject tmp76;
                                    try {
                                        // Arg 0 constant: ...
                                        objv75[0] = const7;
                                        // Arg 1 word: $declare$tmpsymbol
                                        StringBuffer sbtmp77 = new StringBuffer(64);
                                        tmp76 = getVarScalar(interp, "declare", compiledLocals, 5);
                                        sbtmp77.append(tmp76.toString());
                                        tmp76 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                        sbtmp77.append(tmp76.toString());
                                        tmp76 = TclString.newInstance(sbtmp77);
                                        tmp76.preserve();
                                        objv75[1] = tmp76;
                                        // Arg 2 variable: $avname
                                        tmp76 = getVarScalar(interp, "avname", compiledLocals, 8);
                                        tmp76.preserve();
                                        objv75[2] = tmp76;
                                        // Arg 3 constant: ""
                                        objv75[3] = const1;
                                        // Arg 4 constant: true
                                        objv75[4] = const8;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv75, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp76 = objv75[1];
                                        if ( tmp76 != null ) {
                                            tmp76.release();
                                        }
                                        tmp76 = objv75[2];
                                        if ( tmp76 != null ) {
                                            tmp76.release();
                                        }
                                        TJC.releaseObjv(interp, objv75, 5);
                                    }
                                } // End Invoke: ...
                                tmp74 = interp.getResult();
                                tmp74.preserve();
                                objv73[0] = tmp74;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv73, compiledLocals, 4);
                            } finally {
                                TJC.releaseObjvElems(interp, objv73, 1);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: foreach ckey $ckeys ...
                            TclObject tmp78 = null;
                            try {
                                tmp78 = getVarScalar(interp, "ckeys", compiledLocals, 11);
                                tmp78.preserve();
                                final int tmp78_length = TclList.getLength(interp, tmp78);

                                for ( int index79 = 0 ; index79 < tmp78_length ; index79++ ) {
                                    TclObject tmp80 = TclList.index(interp, tmp78, index79);
                                    try {
                                        setVarScalar(interp, "ckey", tmp80, compiledLocals, 12);
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "ckey");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv81 = TJC.grabObjv(interp, 1);
                                        TclObject tmp82;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... $ckey
                                                TclObject[] objv83 = TJC.grabObjv(interp, 2);
                                                TclObject tmp84;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv83[0] = const11;
                                                    // Arg 1 variable: $ckey
                                                    tmp84 = getVarScalar(interp, "ckey", compiledLocals, 12);
                                                    tmp84.preserve();
                                                    objv83[1] = tmp84;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                        ? cmdcache6.cmd : null), objv83, 0);
                                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                        updateCmdCache(interp, 6);
                                                    }
                                                } finally {
                                                    tmp84 = objv83[1];
                                                    if ( tmp84 != null ) {
                                                        tmp84.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv83, 2);
                                                }
                                            } // End Invoke: ...
                                            tmp82 = interp.getResult();
                                            tmp82.preserve();
                                            objv81[0] = tmp82;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv81, compiledLocals, 4);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv81, 1);
                                        }
                                    } // End Invoke: append
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp78 != null ) {
                                    tmp78.release();
                                }
                            }
                        } // End Invoke: foreach
                        { // Invoke: append buffer [...] $declare $tmpsymbol ... ... [...]
                            TclObject[] objv85 = TJC.grabObjv(interp, 6);
                            TclObject tmp86;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv87 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv87[0] = const12;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv87, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv87, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp86 = interp.getResult();
                                tmp86.preserve();
                                objv85[0] = tmp86;
                                // Arg 3 variable: $declare
                                tmp86 = getVarScalar(interp, "declare", compiledLocals, 5);
                                tmp86.preserve();
                                objv85[1] = tmp86;
                                // Arg 4 variable: $tmpsymbol
                                tmp86 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                tmp86.preserve();
                                objv85[2] = tmp86;
                                // Arg 5 constant: ...
                                objv85[3] = const13;
                                // Arg 6 constant: ...
                                objv85[4] = const14;
                                // Arg 7 command: [...]
                                { // Invoke: ... $tmpsymbol $avname "..." false
                                    TclObject[] objv88 = TJC.grabObjv(interp, 5);
                                    TclObject tmp89;
                                    try {
                                        // Arg 0 constant: ...
                                        objv88[0] = const7;
                                        // Arg 1 variable: $tmpsymbol
                                        tmp89 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                        tmp89.preserve();
                                        objv88[1] = tmp89;
                                        // Arg 2 variable: $avname
                                        tmp89 = getVarScalar(interp, "avname", compiledLocals, 8);
                                        tmp89.preserve();
                                        objv88[2] = tmp89;
                                        // Arg 3 word: "..."
                                        StringBuffer sbtmp90 = new StringBuffer(64);
                                        tmp89 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                        sbtmp90.append(tmp89.toString());
                                        sbtmp90.append(".toString()");
                                        tmp89 = TclString.newInstance(sbtmp90);
                                        tmp89.preserve();
                                        objv88[3] = tmp89;
                                        // Arg 4 constant: false
                                        objv88[4] = const9;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv88, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp89 = objv88[1];
                                        if ( tmp89 != null ) {
                                            tmp89.release();
                                        }
                                        tmp89 = objv88[2];
                                        if ( tmp89 != null ) {
                                            tmp89.release();
                                        }
                                        tmp89 = objv88[3];
                                        if ( tmp89 != null ) {
                                            tmp89.release();
                                        }
                                        TJC.releaseObjv(interp, objv88, 5);
                                    }
                                } // End Invoke: ...
                                tmp86 = interp.getResult();
                                tmp86.preserve();
                                objv85[5] = tmp86;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv85, compiledLocals, 4);
                            } finally {
                                tmp86 = objv85[0];
                                if ( tmp86 != null ) {
                                    tmp86.release();
                                }
                                tmp86 = objv85[1];
                                if ( tmp86 != null ) {
                                    tmp86.release();
                                }
                                tmp86 = objv85[2];
                                if ( tmp86 != null ) {
                                    tmp86.release();
                                }
                                tmp86 = objv85[5];
                                if ( tmp86 != null ) {
                                    tmp86.release();
                                }
                                TJC.releaseObjv(interp, objv85, 6);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            } else if ( tmp5_length == 12 && tmp5_first == 'w'
                    && tmp5.compareTo("word command") == 0 ) {
                // Pattern {word command}
                { // Invoke: set ckeys [...]
                    TclObject tmp91;
                    { // Invoke: lindex $vinfo 1 0
                        TclObject[] objv92 = TJC.grabObjv(interp, 4);
                        TclObject tmp93;
                        try {
                            // Arg 0 constant: lindex
                            objv92[0] = const4;
                            // Arg 1 variable: $vinfo
                            tmp93 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                            tmp93.preserve();
                            objv92[1] = tmp93;
                            // Arg 2 constant: 1
                            objv92[2] = const0;
                            // Arg 3 constant: 0
                            objv92[3] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv92, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp93 = objv92[1];
                            if ( tmp93 != null ) {
                                tmp93.release();
                            }
                            TJC.releaseObjv(interp, objv92, 4);
                        }
                    } // End Invoke: lindex
                    tmp91 = interp.getResult();
                    setVarScalar(interp, "ckeys", tmp91, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: ... $ckeys
                        TclObject[] objv94 = TJC.grabObjv(interp, 2);
                        TclObject tmp95;
                        try {
                            // Arg 0 constant: ...
                            objv94[0] = const10;
                            // Arg 1 variable: $ckeys
                            tmp95 = getVarScalar(interp, "ckeys", compiledLocals, 11);
                            tmp95.preserve();
                            objv94[1] = tmp95;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv94, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp95 = objv94[1];
                            if ( tmp95 != null ) {
                                tmp95.release();
                            }
                            TJC.releaseObjv(interp, objv94, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp96 = interp.getResult();
                    ExprValue tmp97 = evs0;
                    TJC.exprInitValue(interp, tmp97, tmp96);
                    boolean tmp98 = tmp97.getBooleanValue(interp);
                    if ( tmp98 ) {
                        { // Invoke: set esym [...]
                            TclObject tmp99;
                            { // Invoke: ... {}
                                TclObject[] objv100 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: ...
                                    objv100[0] = const15;
                                    // Arg 1 constant: {}
                                    objv100[1] = const1;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv100, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv100, 2);
                                }
                            } // End Invoke: ...
                            tmp99 = interp.getResult();
                            setVarScalar(interp, "esym", tmp99, compiledLocals, 13);
                        } // End Invoke: set
                        { // Invoke: append buffer [...] $declare $tmpsymbol " = " $esym ...
                            TclObject[] objv101 = TJC.grabObjv(interp, 6);
                            TclObject tmp102;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv103 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv103[0] = const12;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv103, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv103, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp102 = interp.getResult();
                                tmp102.preserve();
                                objv101[0] = tmp102;
                                // Arg 3 variable: $declare
                                tmp102 = getVarScalar(interp, "declare", compiledLocals, 5);
                                tmp102.preserve();
                                objv101[1] = tmp102;
                                // Arg 4 variable: $tmpsymbol
                                tmp102 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                tmp102.preserve();
                                objv101[2] = tmp102;
                                // Arg 5 constant: " = "
                                objv101[3] = const16;
                                // Arg 6 variable: $esym
                                tmp102 = getVarScalar(interp, "esym", compiledLocals, 13);
                                tmp102.preserve();
                                objv101[4] = tmp102;
                                // Arg 7 constant: ...
                                objv101[5] = const14;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv101, compiledLocals, 4);
                            } finally {
                                tmp102 = objv101[0];
                                if ( tmp102 != null ) {
                                    tmp102.release();
                                }
                                tmp102 = objv101[1];
                                if ( tmp102 != null ) {
                                    tmp102.release();
                                }
                                tmp102 = objv101[2];
                                if ( tmp102 != null ) {
                                    tmp102.release();
                                }
                                tmp102 = objv101[4];
                                if ( tmp102 != null ) {
                                    tmp102.release();
                                }
                                TJC.releaseObjv(interp, objv101, 6);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: foreach ckey $ckeys ...
                            TclObject tmp104 = null;
                            try {
                                tmp104 = getVarScalar(interp, "ckeys", compiledLocals, 11);
                                tmp104.preserve();
                                final int tmp104_length = TclList.getLength(interp, tmp104);

                                for ( int index105 = 0 ; index105 < tmp104_length ; index105++ ) {
                                    TclObject tmp106 = TclList.index(interp, tmp104, index105);
                                    try {
                                        setVarScalar(interp, "ckey", tmp106, compiledLocals, 12);
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "ckey");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv107 = TJC.grabObjv(interp, 1);
                                        TclObject tmp108;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... $ckey
                                                TclObject[] objv109 = TJC.grabObjv(interp, 2);
                                                TclObject tmp110;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv109[0] = const11;
                                                    // Arg 1 variable: $ckey
                                                    tmp110 = getVarScalar(interp, "ckey", compiledLocals, 12);
                                                    tmp110.preserve();
                                                    objv109[1] = tmp110;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                        ? cmdcache6.cmd : null), objv109, 0);
                                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                        updateCmdCache(interp, 6);
                                                    }
                                                } finally {
                                                    tmp110 = objv109[1];
                                                    if ( tmp110 != null ) {
                                                        tmp110.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv109, 2);
                                                }
                                            } // End Invoke: ...
                                            tmp108 = interp.getResult();
                                            tmp108.preserve();
                                            objv107[0] = tmp108;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv107, compiledLocals, 4);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv107, 1);
                                        }
                                    } // End Invoke: append
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp104 != null ) {
                                    tmp104.release();
                                }
                            }
                        } // End Invoke: foreach
                        { // Invoke: append buffer [...] $declare $tmpsymbol ... ...
                            TclObject[] objv111 = TJC.grabObjv(interp, 5);
                            TclObject tmp112;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv113 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv113[0] = const12;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv113, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv113, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp112 = interp.getResult();
                                tmp112.preserve();
                                objv111[0] = tmp112;
                                // Arg 3 variable: $declare
                                tmp112 = getVarScalar(interp, "declare", compiledLocals, 5);
                                tmp112.preserve();
                                objv111[1] = tmp112;
                                // Arg 4 variable: $tmpsymbol
                                tmp112 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                tmp112.preserve();
                                objv111[2] = tmp112;
                                // Arg 5 constant: ...
                                objv111[3] = const13;
                                // Arg 6 constant: ...
                                objv111[4] = const14;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv111, compiledLocals, 4);
                            } finally {
                                tmp112 = objv111[0];
                                if ( tmp112 != null ) {
                                    tmp112.release();
                                }
                                tmp112 = objv111[1];
                                if ( tmp112 != null ) {
                                    tmp112.release();
                                }
                                tmp112 = objv111[2];
                                if ( tmp112 != null ) {
                                    tmp112.release();
                                }
                                TJC.releaseObjv(interp, objv111, 5);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            } else if ( tmp5_length == 10 && tmp5_first == 'a'
                    && tmp5.compareTo("array word") == 0 ) {
                // Pattern {array word}
                { // Invoke: set avname [...]
                    TclObject tmp114;
                    { // Invoke: lindex $vinfo 1 0
                        TclObject[] objv115 = TJC.grabObjv(interp, 4);
                        TclObject tmp116;
                        try {
                            // Arg 0 constant: lindex
                            objv115[0] = const4;
                            // Arg 1 variable: $vinfo
                            tmp116 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                            tmp116.preserve();
                            objv115[1] = tmp116;
                            // Arg 2 constant: 1
                            objv115[2] = const0;
                            // Arg 3 constant: 0
                            objv115[3] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv115, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp116 = objv115[1];
                            if ( tmp116 != null ) {
                                tmp116.release();
                            }
                            TJC.releaseObjv(interp, objv115, 4);
                        }
                    } // End Invoke: lindex
                    tmp114 = interp.getResult();
                    setVarScalar(interp, "avname", tmp114, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$avname == ""} ...
                    // Binary operator: $avname == ""
                    TclObject tmp117 = getVarScalar(interp, "avname", compiledLocals, 8);
                    ExprValue tmp118 = evs0;
                    TJC.exprEqualsEmptyString(tmp118, tmp117, false);
                    // End Binary operator: ==
                    boolean tmp119 = ( tmp118.getIntValue() != 0 );
                    if ( tmp119 ) {
                        { // Invoke: error "..."
                            TclObject[] objv120 = TJC.grabObjv(interp, 2);
                            TclObject tmp121;
                            try {
                                // Arg 0 constant: error
                                objv120[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp122 = new StringBuffer(64);
                                sbtmp122.append("empty array name in ");
                                sbtmp122.append("{");
                                tmp121 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                                sbtmp122.append(tmp121.toString());
                                sbtmp122.append("}");
                                tmp121 = TclString.newInstance(sbtmp122);
                                tmp121.preserve();
                                objv120[1] = tmp121;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv120, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp121 = objv120[1];
                                if ( tmp121 != null ) {
                                    tmp121.release();
                                }
                                TJC.releaseObjv(interp, objv120, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set values [...]
                    TclObject tmp123;
                    { // Invoke: lindex $vinfo 1 1
                        TclObject[] objv124 = TJC.grabObjv(interp, 4);
                        TclObject tmp125;
                        try {
                            // Arg 0 constant: lindex
                            objv124[0] = const4;
                            // Arg 1 variable: $vinfo
                            tmp125 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                            tmp125.preserve();
                            objv124[1] = tmp125;
                            // Arg 2 constant: 1
                            objv124[2] = const0;
                            // Arg 3 constant: 1
                            objv124[3] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv124, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp125 = objv124[1];
                            if ( tmp125 != null ) {
                                tmp125.release();
                            }
                            TJC.releaseObjv(interp, objv124, 4);
                        }
                    } // End Invoke: lindex
                    tmp123 = interp.getResult();
                    setVarScalar(interp, "values", tmp123, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] == 0
                    { // Invoke: llength $values
                        TclObject tmp126 = getVarScalar(interp, "values", compiledLocals, 14);
                        int tmp127 = TclList.getLength(interp, tmp126);
                        interp.setResult(tmp127);
                    } // End Invoke: llength
                    TclObject tmp128 = interp.getResult();
                    ExprValue tmp129 = evs0;
                    TJC.exprInitValue(interp, tmp129, tmp128);
                    ExprValue tmp130 = evs1;
                    tmp130.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp129, tmp130);
                    // End Binary operator: ==
                    boolean tmp131 = ( tmp129.getIntValue() != 0 );
                    if ( tmp131 ) {
                        { // Invoke: error "..."
                            TclObject[] objv132 = TJC.grabObjv(interp, 2);
                            TclObject tmp133;
                            try {
                                // Arg 0 constant: error
                                objv132[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp134 = new StringBuffer(64);
                                sbtmp134.append("empty array values in ");
                                sbtmp134.append("{");
                                tmp133 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                                sbtmp134.append(tmp133.toString());
                                sbtmp134.append("}");
                                tmp133 = TclString.newInstance(sbtmp134);
                                tmp133.preserve();
                                objv132[1] = tmp133;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv132, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp133 = objv132[1];
                                if ( tmp133 != null ) {
                                    tmp133.release();
                                }
                                TJC.releaseObjv(interp, objv132, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: if {$declare_flag} ...
                    TclObject tmp135 = getVarScalar(interp, "declare_flag", compiledLocals, 2);
                    boolean tmp136 = TJC.getBoolean(interp, tmp135);
                    if ( tmp136 ) {
                        { // Invoke: append buffer [...] $declare $tmpsymbol ...
                            TclObject[] objv137 = TJC.grabObjv(interp, 4);
                            TclObject tmp138;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv139 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv139[0] = const12;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv139, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv139, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp138 = interp.getResult();
                                tmp138.preserve();
                                objv137[0] = tmp138;
                                // Arg 3 variable: $declare
                                tmp138 = getVarScalar(interp, "declare", compiledLocals, 5);
                                tmp138.preserve();
                                objv137[1] = tmp138;
                                // Arg 4 variable: $tmpsymbol
                                tmp138 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                tmp138.preserve();
                                objv137[2] = tmp138;
                                // Arg 5 constant: ...
                                objv137[3] = const14;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv137, compiledLocals, 4);
                            } finally {
                                tmp138 = objv137[0];
                                if ( tmp138 != null ) {
                                    tmp138.release();
                                }
                                tmp138 = objv137[1];
                                if ( tmp138 != null ) {
                                    tmp138.release();
                                }
                                tmp138 = objv137[2];
                                if ( tmp138 != null ) {
                                    tmp138.release();
                                }
                                TJC.releaseObjv(interp, objv137, 4);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: if ... ... else ...
                    // Binary operator: [...] > 1
                    { // Invoke: llength $values
                        TclObject tmp140 = getVarScalar(interp, "values", compiledLocals, 14);
                        int tmp141 = TclList.getLength(interp, tmp140);
                        interp.setResult(tmp141);
                    } // End Invoke: llength
                    TclObject tmp142 = interp.getResult();
                    ExprValue tmp143 = evs0;
                    TJC.exprInitValue(interp, tmp143, tmp142);
                    ExprValue tmp144 = evs1;
                    tmp144.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp143, tmp144);
                    // End Binary operator: >
                    boolean tmp145 = ( tmp143.getIntValue() != 0 );
                    if ( tmp145 ) {
                        { // Invoke: set sbtmp [...]
                            TclObject tmp146;
                            { // Invoke: ... sbtmp
                                TclObject[] objv147 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: ...
                                    objv147[0] = const17;
                                    // Arg 1 constant: sbtmp
                                    objv147[1] = const18;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                        ? cmdcache9.cmd : null), objv147, 0);
                                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                        updateCmdCache(interp, 9);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv147, 2);
                                }
                            } // End Invoke: ...
                            tmp146 = interp.getResult();
                            setVarScalar(interp, "sbtmp", tmp146, compiledLocals, 15);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv148 = TJC.grabObjv(interp, 1);
                            TclObject tmp149;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv150 = TJC.grabObjv(interp, 2);
                                    TclObject tmp151;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv150[0] = const19;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp152 = new StringBuffer(64);
                                        sbtmp152.append("StringBuffer ");
                                        tmp151 = getVarScalar(interp, "sbtmp", compiledLocals, 15);
                                        sbtmp152.append(tmp151.toString());
                                        sbtmp152.append(" = new StringBuffer(64)");
                                        tmp151 = TclString.newInstance(sbtmp152);
                                        tmp151.preserve();
                                        objv150[1] = tmp151;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                            ? cmdcache10.cmd : null), objv150, 0);
                                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                            updateCmdCache(interp, 10);
                                        }
                                    } finally {
                                        tmp151 = objv150[1];
                                        if ( tmp151 != null ) {
                                            tmp151.release();
                                        }
                                        TJC.releaseObjv(interp, objv150, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp149 = interp.getResult();
                                tmp149.preserve();
                                objv148[0] = tmp149;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv148, compiledLocals, 4);
                            } finally {
                                TJC.releaseObjvElems(interp, objv148, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: foreach value $values ...
                            TclObject tmp153 = null;
                            try {
                                tmp153 = getVarScalar(interp, "values", compiledLocals, 14);
                                tmp153.preserve();
                                final int tmp153_length = TclList.getLength(interp, tmp153);

                                for ( int index154 = 0 ; index154 < tmp153_length ; index154++ ) {
                                    TclObject tmp155 = TclList.index(interp, tmp153, index154);
                                    try {
                                        setVarScalar(interp, "value", tmp155, compiledLocals, 16);
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "value");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: set type [...]
                                        TclObject tmp156;
                                        { // Invoke: lindex $value 0
                                            TclObject tmp157 = getVarScalar(interp, "value", compiledLocals, 16);
                                            tmp157 = TclList.index(interp, tmp157, 0);
                                            if ( tmp157 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp157);
                                            }
                                        } // End Invoke: lindex
                                        tmp156 = interp.getResult();
                                        setVarScalar(interp, "type", tmp156, compiledLocals, 17);
                                    } // End Invoke: set
                                    { // Invoke: if {$type == "text"} ... else ...
                                        // Binary operator: $type == "text"
                                        TclObject tmp158 = getVarScalar(interp, "type", compiledLocals, 17);
                                        boolean tmp159 = tmp158.toString().equals("text");
                                        ExprValue tmp160 = evs0;
                                        tmp160.setIntValue(tmp159);
                                        // End Binary operator: ==
                                        boolean tmp161 = ( tmp160.getIntValue() != 0 );
                                        if ( tmp161 ) {
                                            { // Invoke: set str [...]
                                                TclObject tmp162;
                                                { // Invoke: ... [...]
                                                    TclObject[] objv163 = TJC.grabObjv(interp, 2);
                                                    TclObject tmp164;
                                                    try {
                                                        // Arg 0 constant: ...
                                                        objv163[0] = const20;
                                                        // Arg 1 command: [...]
                                                        { // Invoke: lindex $value 1
                                                            TclObject tmp165 = getVarScalar(interp, "value", compiledLocals, 16);
                                                            tmp165 = TclList.index(interp, tmp165, 1);
                                                            if ( tmp165 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp165);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp164 = interp.getResult();
                                                        tmp164.preserve();
                                                        objv163[1] = tmp164;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                            ? cmdcache11.cmd : null), objv163, 0);
                                                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                            updateCmdCache(interp, 11);
                                                        }
                                                    } finally {
                                                        tmp164 = objv163[1];
                                                        if ( tmp164 != null ) {
                                                            tmp164.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv163, 2);
                                                    }
                                                } // End Invoke: ...
                                                tmp162 = interp.getResult();
                                                setVarScalar(interp, "str", tmp162, compiledLocals, 18);
                                            } // End Invoke: set
                                            { // Invoke: append buffer [...] $sbtmp ... $str ...
                                                TclObject[] objv166 = TJC.grabObjv(interp, 5);
                                                TclObject tmp167;
                                                try {
                                                    // Arg 2 command: [...]
                                                    { // Invoke: emitter_indent
                                                        TclObject[] objv168 = TJC.grabObjv(interp, 1);
                                                        try {
                                                            // Arg 0 constant: emitter_indent
                                                            objv168[0] = const12;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                                ? cmdcache7.cmd : null), objv168, 0);
                                                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                                updateCmdCache(interp, 7);
                                                            }
                                                        } finally {
                                                            TJC.releaseObjv(interp, objv168, 1);
                                                        }
                                                    } // End Invoke: emitter_indent
                                                    tmp167 = interp.getResult();
                                                    tmp167.preserve();
                                                    objv166[0] = tmp167;
                                                    // Arg 3 variable: $sbtmp
                                                    tmp167 = getVarScalar(interp, "sbtmp", compiledLocals, 15);
                                                    tmp167.preserve();
                                                    objv166[1] = tmp167;
                                                    // Arg 4 constant: ...
                                                    objv166[2] = const21;
                                                    // Arg 5 variable: $str
                                                    tmp167 = getVarScalar(interp, "str", compiledLocals, 18);
                                                    tmp167.preserve();
                                                    objv166[3] = tmp167;
                                                    // Arg 6 constant: ...
                                                    objv166[4] = const22;
                                                    interp.resetResult();
                                                    appendVarScalar(interp, "buffer", objv166, compiledLocals, 4);
                                                } finally {
                                                    tmp167 = objv166[0];
                                                    if ( tmp167 != null ) {
                                                        tmp167.release();
                                                    }
                                                    tmp167 = objv166[1];
                                                    if ( tmp167 != null ) {
                                                        tmp167.release();
                                                    }
                                                    tmp167 = objv166[3];
                                                    if ( tmp167 != null ) {
                                                        tmp167.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv166, 5);
                                                }
                                            } // End Invoke: append
                                        } else {
                                            { // Invoke: append buffer [...] [...]
                                                TclObject[] objv169 = TJC.grabObjv(interp, 2);
                                                TclObject tmp170;
                                                try {
                                                    // Arg 2 command: [...]
                                                    { // Invoke: ... $tmpsymbol $value 0
                                                        TclObject[] objv171 = TJC.grabObjv(interp, 4);
                                                        TclObject tmp172;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv171[0] = const23;
                                                            // Arg 1 variable: $tmpsymbol
                                                            tmp172 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                                            tmp172.preserve();
                                                            objv171[1] = tmp172;
                                                            // Arg 2 variable: $value
                                                            tmp172 = getVarScalar(interp, "value", compiledLocals, 16);
                                                            tmp172.preserve();
                                                            objv171[2] = tmp172;
                                                            // Arg 3 constant: 0
                                                            objv171[3] = const5;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                                                ? cmdcache12.cmd : null), objv171, 0);
                                                            if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                                                updateCmdCache(interp, 12);
                                                            }
                                                        } finally {
                                                            tmp172 = objv171[1];
                                                            if ( tmp172 != null ) {
                                                                tmp172.release();
                                                            }
                                                            tmp172 = objv171[2];
                                                            if ( tmp172 != null ) {
                                                                tmp172.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv171, 4);
                                                        }
                                                    } // End Invoke: ...
                                                    tmp170 = interp.getResult();
                                                    tmp170.preserve();
                                                    objv169[0] = tmp170;
                                                    // Arg 3 command: [...]
                                                    { // Invoke: emitter_statement "..."
                                                        TclObject[] objv173 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp174;
                                                        try {
                                                            // Arg 0 constant: emitter_statement
                                                            objv173[0] = const19;
                                                            // Arg 1 word: "..."
                                                            StringBuffer sbtmp175 = new StringBuffer(64);
                                                            tmp174 = getVarScalar(interp, "sbtmp", compiledLocals, 15);
                                                            sbtmp175.append(tmp174.toString());
                                                            sbtmp175.append(".append(");
                                                            tmp174 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                                            sbtmp175.append(tmp174.toString());
                                                            sbtmp175.append(".toString())");
                                                            tmp174 = TclString.newInstance(sbtmp175);
                                                            tmp174.preserve();
                                                            objv173[1] = tmp174;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                                ? cmdcache10.cmd : null), objv173, 0);
                                                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                                updateCmdCache(interp, 10);
                                                            }
                                                        } finally {
                                                            tmp174 = objv173[1];
                                                            if ( tmp174 != null ) {
                                                                tmp174.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv173, 2);
                                                        }
                                                    } // End Invoke: emitter_statement
                                                    tmp170 = interp.getResult();
                                                    tmp170.preserve();
                                                    objv169[1] = tmp170;
                                                    interp.resetResult();
                                                    appendVarScalar(interp, "buffer", objv169, compiledLocals, 4);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv169, 2);
                                                }
                                            } // End Invoke: append
                                        }
                                    } // End Invoke: if
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp153 != null ) {
                                    tmp153.release();
                                }
                            }
                        } // End Invoke: foreach
                        { // Invoke: set result $sbtmp.toString()
                            TclObject tmp176;
                            StringBuffer sbtmp177 = new StringBuffer(64);
                            tmp176 = getVarScalar(interp, "sbtmp", compiledLocals, 15);
                            sbtmp177.append(tmp176.toString());
                            sbtmp177.append(".toString()");
                            tmp176 = TclString.newInstance(sbtmp177);
                            setVarScalar(interp, "result", tmp176, compiledLocals, 19);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set value [...]
                            TclObject tmp178;
                            { // Invoke: lindex $values 0
                                TclObject tmp179 = getVarScalar(interp, "values", compiledLocals, 14);
                                tmp179 = TclList.index(interp, tmp179, 0);
                                if ( tmp179 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp179);
                                }
                            } // End Invoke: lindex
                            tmp178 = interp.getResult();
                            setVarScalar(interp, "value", tmp178, compiledLocals, 16);
                        } // End Invoke: set
                        { // Invoke: set type [...]
                            TclObject tmp180;
                            { // Invoke: lindex $value 0
                                TclObject tmp181 = getVarScalar(interp, "value", compiledLocals, 16);
                                tmp181 = TclList.index(interp, tmp181, 0);
                                if ( tmp181 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp181);
                                }
                            } // End Invoke: lindex
                            tmp180 = interp.getResult();
                            setVarScalar(interp, "type", tmp180, compiledLocals, 17);
                        } // End Invoke: set
                        { // Invoke: if {$type == "text"} ...
                            // Binary operator: $type == "text"
                            TclObject tmp182 = getVarScalar(interp, "type", compiledLocals, 17);
                            boolean tmp183 = tmp182.toString().equals("text");
                            ExprValue tmp184 = evs0;
                            tmp184.setIntValue(tmp183);
                            // End Binary operator: ==
                            boolean tmp185 = ( tmp184.getIntValue() != 0 );
                            if ( tmp185 ) {
                                { // Invoke: error ...
                                    TclObject[] objv186 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: error
                                        objv186[0] = const6;
                                        // Arg 1 constant: ...
                                        objv186[1] = const24;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv186, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv186, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: append buffer [...]
                            TclObject[] objv187 = TJC.grabObjv(interp, 1);
                            TclObject tmp188;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $tmpsymbol $value 0
                                    TclObject[] objv189 = TJC.grabObjv(interp, 4);
                                    TclObject tmp190;
                                    try {
                                        // Arg 0 constant: ...
                                        objv189[0] = const23;
                                        // Arg 1 variable: $tmpsymbol
                                        tmp190 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                        tmp190.preserve();
                                        objv189[1] = tmp190;
                                        // Arg 2 variable: $value
                                        tmp190 = getVarScalar(interp, "value", compiledLocals, 16);
                                        tmp190.preserve();
                                        objv189[2] = tmp190;
                                        // Arg 3 constant: 0
                                        objv189[3] = const5;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                            ? cmdcache12.cmd : null), objv189, 0);
                                        if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                            updateCmdCache(interp, 12);
                                        }
                                    } finally {
                                        tmp190 = objv189[1];
                                        if ( tmp190 != null ) {
                                            tmp190.release();
                                        }
                                        tmp190 = objv189[2];
                                        if ( tmp190 != null ) {
                                            tmp190.release();
                                        }
                                        TJC.releaseObjv(interp, objv189, 4);
                                    }
                                } // End Invoke: ...
                                tmp188 = interp.getResult();
                                tmp188.preserve();
                                objv187[0] = tmp188;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv187, compiledLocals, 4);
                            } finally {
                                TJC.releaseObjvElems(interp, objv187, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set result "..."
                            TclObject tmp191;
                            StringBuffer sbtmp192 = new StringBuffer(64);
                            tmp191 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                            sbtmp192.append(tmp191.toString());
                            sbtmp192.append(".toString()");
                            tmp191 = TclString.newInstance(sbtmp192);
                            setVarScalar(interp, "result", tmp191, compiledLocals, 19);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv193 = TJC.grabObjv(interp, 1);
                    TclObject tmp194;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $tmpsymbol $avname $result false
                            TclObject[] objv195 = TJC.grabObjv(interp, 5);
                            TclObject tmp196;
                            try {
                                // Arg 0 constant: ...
                                objv195[0] = const7;
                                // Arg 1 variable: $tmpsymbol
                                tmp196 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                tmp196.preserve();
                                objv195[1] = tmp196;
                                // Arg 2 variable: $avname
                                tmp196 = getVarScalar(interp, "avname", compiledLocals, 8);
                                tmp196.preserve();
                                objv195[2] = tmp196;
                                // Arg 3 variable: $result
                                tmp196 = getVarScalar(interp, "result", compiledLocals, 19);
                                tmp196.preserve();
                                objv195[3] = tmp196;
                                // Arg 4 constant: false
                                objv195[4] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv195, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp196 = objv195[1];
                                if ( tmp196 != null ) {
                                    tmp196.release();
                                }
                                tmp196 = objv195[2];
                                if ( tmp196 != null ) {
                                    tmp196.release();
                                }
                                tmp196 = objv195[3];
                                if ( tmp196 != null ) {
                                    tmp196.release();
                                }
                                TJC.releaseObjv(interp, objv195, 5);
                            }
                        } // End Invoke: ...
                        tmp194 = interp.getResult();
                        tmp194.preserve();
                        objv193[0] = tmp194;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv193, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv193, 1);
                    }
                } // End Invoke: append
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv197 = TJC.grabObjv(interp, 2);
                    TclObject tmp198;
                    try {
                        // Arg 0 constant: error
                        objv197[0] = const6;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp199 = new StringBuffer(64);
                        sbtmp199.append("unhandled non-scalar type ");
                        sbtmp199.append("\"");
                        tmp198 = getVarScalar(interp, "vtype", compiledLocals, 6);
                        sbtmp199.append(tmp198.toString());
                        sbtmp199.append("\"");
                        sbtmp199.append(" in vinfo ");
                        sbtmp199.append("{");
                        tmp198 = getVarScalar(interp, "vinfo", compiledLocals, 1);
                        sbtmp199.append(tmp198.toString());
                        sbtmp199.append("}");
                        tmp198 = TclString.newInstance(sbtmp199);
                        tmp198.preserve();
                        objv197[1] = tmp198;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv197, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp198 = objv197[1];
                        if ( tmp198 != null ) {
                            tmp198.release();
                        }
                        TJC.releaseObjv(interp, objv197, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        { // Invoke: return $buffer
            TclObject tmp200 = getVarScalar(interp, "buffer", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp200);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_variable");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("TclObject ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_emit_scalar_variable_get");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("lindex");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(0);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("error");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_emit_array_variable_get");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("true");
        TclBoolean.get(interp, const8);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("false");
        TclBoolean.get(interp, const9);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_is_empty_command");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_emit_invoke");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("emitter_indent");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance(" = interp.getResult()");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance(";\n");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("compileproc_constant_cache_get");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance(" = ");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("compileproc_tmpvar_next");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("sbtmp");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("emitter_statement");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("emitter_backslash_tcl_string");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance(".append(\"");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("\");\n");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("compileproc_emit_variable");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("unexpected single constant value for word");
        const24.preserve(); const24.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_emit_scalar_variable_get";
                break;
            }
            case 2: {
                cmdName = "lindex";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "compileproc_emit_array_variable_get";
                break;
            }
            case 5: {
                cmdName = "compileproc_is_empty_command";
                break;
            }
            case 6: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 7: {
                cmdName = "emitter_indent";
                break;
            }
            case 8: {
                cmdName = "compileproc_constant_cache_get";
                break;
            }
            case 9: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 10: {
                cmdName = "emitter_statement";
                break;
            }
            case 11: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            case 12: {
                cmdName = "compileproc_emit_variable";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "vinfo",
        "declare_flag",
        "_compileproc",
        "buffer",
        "declare",
        "vtype",
        "vname",
        "avname",
        "kname",
        "kvname",
        "ckeys",
        "ckey",
        "esym",
        "values",
        "sbtmp",
        "value",
        "type",
        "str",
        "result"
    };
} // end class CompileprocEmitVariableCmd

