// TJC implementation of procedure compileproc_expr_evaluate_emit_binary_operator
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateEmitBinaryOperatorCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 27, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "op_tuple");
        }
        setVarScalar(interp, "op_tuple", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set op_buffer ""
            setVarScalar(interp, "op_buffer", const0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp0;
            { // Invoke: lindex $op_tuple 0
                TclObject tmp1 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "type", tmp0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $type != "binary operator"
            TclObject tmp2 = getVarScalar(interp, "type", compiledLocals, 4);
            boolean tmp3 = ! tmp2.toString().equals("binary operator");
            ExprValue tmp4 = evs0;
            tmp4.setIntValue(tmp3);
            // End Binary operator: !=
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error "..."
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp8 = new StringBuffer(64);
                        sbtmp8.append("expected ");
                        sbtmp8.append("{");
                        sbtmp8.append("binary operator");
                        sbtmp8.append("}");
                        sbtmp8.append(" but got type ");
                        sbtmp8.append("{");
                        tmp7 = getVarScalar(interp, "type", compiledLocals, 4);
                        sbtmp8.append(tmp7.toString());
                        sbtmp8.append("}");
                        tmp7 = TclString.newInstance(sbtmp8);
                        tmp7.preserve();
                        objv6[1] = tmp7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv6, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp7 = objv6[1];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set vtuple [...]
            TclObject tmp9;
            { // Invoke: lindex $op_tuple 1
                TclObject tmp10 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                tmp10 = TclList.index(interp, tmp10, 1);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            tmp9 = interp.getResult();
            setVarScalar(interp, "vtuple", tmp9, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set op [...]
            TclObject tmp11;
            { // Invoke: lindex $vtuple 0
                TclObject tmp12 = getVarScalar(interp, "vtuple", compiledLocals, 5);
                tmp12 = TclList.index(interp, tmp12, 0);
                if ( tmp12 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp12);
                }
            } // End Invoke: lindex
            tmp11 = interp.getResult();
            setVarScalar(interp, "op", tmp11, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set values [...]
            TclObject tmp13;
            { // Invoke: lindex $vtuple 1
                TclObject tmp14 = getVarScalar(interp, "vtuple", compiledLocals, 5);
                tmp14 = TclList.index(interp, tmp14, 1);
                if ( tmp14 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp14);
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "values", tmp13, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != 2
            { // Invoke: llength $values
                TclObject tmp15 = getVarScalar(interp, "values", compiledLocals, 7);
                int tmp16 = TclList.getLength(interp, tmp15);
                interp.setResult(tmp16);
            } // End Invoke: llength
            TclObject tmp17 = interp.getResult();
            ExprValue tmp18 = evs0;
            TJC.exprInitValue(interp, tmp18, tmp17);
            ExprValue tmp19 = evs1;
            tmp19.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp18, tmp19);
            // End Binary operator: !=
            boolean tmp20 = ( tmp18.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: error "..."
                    TclObject[] objv21 = TJC.grabObjv(interp, 2);
                    TclObject tmp22;
                    try {
                        // Arg 0 constant: error
                        objv21[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp23 = new StringBuffer(64);
                        sbtmp23.append("values length should be 2, not ");
                        { // Invoke: llength $values
                            TclObject tmp24 = getVarScalar(interp, "values", compiledLocals, 7);
                            int tmp25 = TclList.getLength(interp, tmp24);
                            interp.setResult(tmp25);
                        } // End Invoke: llength
                        tmp22 = interp.getResult();
                        sbtmp23.append(tmp22.toString());
                        sbtmp23.append(", values_list was ");
                        sbtmp23.append("{");
                        tmp22 = getVarScalar(interp, "values", compiledLocals, 7);
                        sbtmp23.append(tmp22.toString());
                        sbtmp23.append("}");
                        tmp22 = TclString.newInstance(sbtmp23);
                        tmp22.preserve();
                        objv21[1] = tmp22;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv21, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp22 = objv21[1];
                        if ( tmp22 != null ) {
                            tmp22.release();
                        }
                        TJC.releaseObjv(interp, objv21, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set logic_op 0
            setVarScalar(interp, "logic_op", const2, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set equals_op 0
            setVarScalar(interp, "equals_op", const2, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set bcompare_op 0
            setVarScalar(interp, "bcompare_op", const2, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set math_op 0
            setVarScalar(interp, "math_op", const2, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: set bitwise_op 0
            setVarScalar(interp, "bitwise_op", const2, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: switch -exact -- $op {*} ... {/} ... {%} ... {+} ... {-} ... {<<} ... {>>} ... {<} ... {>} ... {<=} ... {>=} ... {==} ... {!=} ... {&} ... {^} ... {|} ... {eq} ... {ne} ... {&&} - {||} ... default ...
            TclObject tmp26 = getVarScalar(interp, "op", compiledLocals, 6);
            String tmp27 = tmp26.toString();
            int tmp27_length = tmp27.length();
            char tmp27_first = '\n';
            if ( tmp27_length > 0 ) {
                tmp27_first = tmp27.charAt(0);
            }
            if ( tmp27_length == 1 && tmp27_first == '*' ) {
                // Pattern {*}
                { // Invoke: set opval TJC.EXPR_OP_MULT
                    setVarScalar(interp, "opval", const3, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set math_op 1
                    setVarScalar(interp, "math_op", const4, compiledLocals, 11);
                } // End Invoke: set
            } else if ( tmp27_length == 1 && tmp27_first == '/' ) {
                // Pattern {/}
                { // Invoke: set opval TJC.EXPR_OP_DIVIDE
                    setVarScalar(interp, "opval", const5, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set math_op 1
                    setVarScalar(interp, "math_op", const4, compiledLocals, 11);
                } // End Invoke: set
            } else if ( tmp27_length == 1 && tmp27_first == '%' ) {
                // Pattern {%}
                { // Invoke: set opval TJC.EXPR_OP_MOD
                    setVarScalar(interp, "opval", const6, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set math_op 1
                    setVarScalar(interp, "math_op", const4, compiledLocals, 11);
                } // End Invoke: set
            } else if ( tmp27_length == 1 && tmp27_first == '+' ) {
                // Pattern {+}
                { // Invoke: set opval TJC.EXPR_OP_PLUS
                    setVarScalar(interp, "opval", const7, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set math_op 1
                    setVarScalar(interp, "math_op", const4, compiledLocals, 11);
                } // End Invoke: set
            } else if ( tmp27_length == 1 && tmp27_first == '-' ) {
                // Pattern {-}
                { // Invoke: set opval TJC.EXPR_OP_MINUS
                    setVarScalar(interp, "opval", const8, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set math_op 1
                    setVarScalar(interp, "math_op", const4, compiledLocals, 11);
                } // End Invoke: set
            } else if ( tmp27_length == 2 && tmp27_first == '<'
                    && tmp27.compareTo("<<") == 0 ) {
                // Pattern {<<}
                { // Invoke: set opval ...
                    setVarScalar(interp, "opval", const9, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set bitwise_op 1
                    setVarScalar(interp, "bitwise_op", const4, compiledLocals, 12);
                } // End Invoke: set
            } else if ( tmp27_length == 2 && tmp27_first == '>'
                    && tmp27.compareTo(">>") == 0 ) {
                // Pattern {>>}
                { // Invoke: set opval ...
                    setVarScalar(interp, "opval", const10, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set bitwise_op 1
                    setVarScalar(interp, "bitwise_op", const4, compiledLocals, 12);
                } // End Invoke: set
            } else if ( tmp27_length == 1 && tmp27_first == '<' ) {
                // Pattern {<}
                { // Invoke: set opval TJC.EXPR_OP_LESS
                    setVarScalar(interp, "opval", const11, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set bcompare_op 1
                    setVarScalar(interp, "bcompare_op", const4, compiledLocals, 10);
                } // End Invoke: set
            } else if ( tmp27_length == 1 && tmp27_first == '>' ) {
                // Pattern {>}
                { // Invoke: set opval TJC.EXPR_OP_GREATER
                    setVarScalar(interp, "opval", const12, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set bcompare_op 1
                    setVarScalar(interp, "bcompare_op", const4, compiledLocals, 10);
                } // End Invoke: set
            } else if ( tmp27_length == 2 && tmp27_first == '<'
                    && tmp27.compareTo("<=") == 0 ) {
                // Pattern {<=}
                { // Invoke: set opval TJC.EXPR_OP_LEQ
                    setVarScalar(interp, "opval", const13, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set bcompare_op 1
                    setVarScalar(interp, "bcompare_op", const4, compiledLocals, 10);
                } // End Invoke: set
            } else if ( tmp27_length == 2 && tmp27_first == '>'
                    && tmp27.compareTo(">=") == 0 ) {
                // Pattern {>=}
                { // Invoke: set opval TJC.EXPR_OP_GEQ
                    setVarScalar(interp, "opval", const14, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set bcompare_op 1
                    setVarScalar(interp, "bcompare_op", const4, compiledLocals, 10);
                } // End Invoke: set
            } else if ( tmp27_length == 2 && tmp27_first == '='
                    && tmp27.compareTo("==") == 0 ) {
                // Pattern {==}
                { // Invoke: set opval TJC.EXPR_OP_EQUAL
                    setVarScalar(interp, "opval", const15, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set equals_op 1
                    setVarScalar(interp, "equals_op", const4, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set bcompare_op 1
                    setVarScalar(interp, "bcompare_op", const4, compiledLocals, 10);
                } // End Invoke: set
            } else if ( tmp27_length == 2 && tmp27_first == '!'
                    && tmp27.compareTo("!=") == 0 ) {
                // Pattern {!=}
                { // Invoke: set opval TJC.EXPR_OP_NEQ
                    setVarScalar(interp, "opval", const16, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set equals_op 1
                    setVarScalar(interp, "equals_op", const4, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set bcompare_op 1
                    setVarScalar(interp, "bcompare_op", const4, compiledLocals, 10);
                } // End Invoke: set
            } else if ( tmp27_length == 1 && tmp27_first == '&' ) {
                // Pattern {&}
                { // Invoke: set opval TJC.EXPR_OP_BIT_AND
                    setVarScalar(interp, "opval", const17, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set bitwise_op 1
                    setVarScalar(interp, "bitwise_op", const4, compiledLocals, 12);
                } // End Invoke: set
            } else if ( tmp27_length == 1 && tmp27_first == '^' ) {
                // Pattern {^}
                { // Invoke: set opval TJC.EXPR_OP_BIT_XOR
                    setVarScalar(interp, "opval", const18, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set bitwise_op 1
                    setVarScalar(interp, "bitwise_op", const4, compiledLocals, 12);
                } // End Invoke: set
            } else if ( tmp27_length == 1 && tmp27_first == '|' ) {
                // Pattern {|}
                { // Invoke: set opval TJC.EXPR_OP_BIT_OR
                    setVarScalar(interp, "opval", const19, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set bitwise_op 1
                    setVarScalar(interp, "bitwise_op", const4, compiledLocals, 12);
                } // End Invoke: set
            } else if ( tmp27_length == 2 && tmp27_first == 'e'
                    && tmp27.compareTo("eq") == 0 ) {
                // Pattern {eq}
                { // Invoke: set opval TJC.EXPR_OP_STREQ
                    setVarScalar(interp, "opval", const20, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set equals_op 1
                    setVarScalar(interp, "equals_op", const4, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set bcompare_op 1
                    setVarScalar(interp, "bcompare_op", const4, compiledLocals, 10);
                } // End Invoke: set
            } else if ( tmp27_length == 2 && tmp27_first == 'n'
                    && tmp27.compareTo("ne") == 0 ) {
                // Pattern {ne}
                { // Invoke: set opval TJC.EXPR_OP_STRNEQ
                    setVarScalar(interp, "opval", const21, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set equals_op 1
                    setVarScalar(interp, "equals_op", const4, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set bcompare_op 1
                    setVarScalar(interp, "bcompare_op", const4, compiledLocals, 10);
                } // End Invoke: set
            } else if ( ( tmp27_length == 2 && tmp27_first == '&'
                    && tmp27.compareTo("&&") == 0 ) ||
                ( tmp27_length == 2 && tmp27_first == '|'
                    && tmp27.compareTo("||") == 0 ) ) {
                // Pattern {||}
                { // Invoke: set logic_op 1
                    setVarScalar(interp, "logic_op", const4, compiledLocals, 8);
                } // End Invoke: set
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv28 = TJC.grabObjv(interp, 2);
                    TclObject tmp29;
                    try {
                        // Arg 0 constant: error
                        objv28[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp30 = new StringBuffer(64);
                        sbtmp30.append("unsupported binary operator ");
                        sbtmp30.append("\"");
                        tmp29 = getVarScalar(interp, "op", compiledLocals, 6);
                        sbtmp30.append(tmp29.toString());
                        sbtmp30.append("\"");
                        tmp29 = TclString.newInstance(sbtmp30);
                        tmp29.preserve();
                        objv28[1] = tmp29;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv28, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp29 = objv28[1];
                        if ( tmp29 != null ) {
                            tmp29.release();
                        }
                        TJC.releaseObjv(interp, objv28, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        { // Invoke: set left_tuple [...]
            TclObject tmp31;
            { // Invoke: lindex $values 0
                TclObject tmp32 = getVarScalar(interp, "values", compiledLocals, 7);
                tmp32 = TclList.index(interp, tmp32, 0);
                if ( tmp32 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp32);
                }
            } // End Invoke: lindex
            tmp31 = interp.getResult();
            setVarScalar(interp, "left_tuple", tmp31, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set right_tuple [...]
            TclObject tmp33;
            { // Invoke: lindex $values 1
                TclObject tmp34 = getVarScalar(interp, "values", compiledLocals, 7);
                tmp34 = TclList.index(interp, tmp34, 1);
                if ( tmp34 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp34);
                }
            } // End Invoke: lindex
            tmp33 = interp.getResult();
            setVarScalar(interp, "right_tuple", tmp33, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: set left_peek_tuple [...]
            TclObject tmp35;
            { // Invoke: ... $left_tuple
                TclObject[] objv36 = TJC.grabObjv(interp, 2);
                TclObject tmp37;
                try {
                    // Arg 0 constant: ...
                    objv36[0] = const22;
                    // Arg 1 variable: $left_tuple
                    tmp37 = getVarScalar(interp, "left_tuple", compiledLocals, 14);
                    tmp37.preserve();
                    objv36[1] = tmp37;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv36, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp37 = objv36[1];
                    if ( tmp37 != null ) {
                        tmp37.release();
                    }
                    TJC.releaseObjv(interp, objv36, 2);
                }
            } // End Invoke: ...
            tmp35 = interp.getResult();
            setVarScalar(interp, "left_peek_tuple", tmp35, compiledLocals, 16);
        } // End Invoke: set
        { // Invoke: set right_peek_tuple [...]
            TclObject tmp38;
            { // Invoke: ... $right_tuple
                TclObject[] objv39 = TJC.grabObjv(interp, 2);
                TclObject tmp40;
                try {
                    // Arg 0 constant: ...
                    objv39[0] = const22;
                    // Arg 1 variable: $right_tuple
                    tmp40 = getVarScalar(interp, "right_tuple", compiledLocals, 15);
                    tmp40.preserve();
                    objv39[1] = tmp40;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv39, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp40 = objv39[1];
                    if ( tmp40 != null ) {
                        tmp40.release();
                    }
                    TJC.releaseObjv(interp, objv39, 2);
                }
            } // End Invoke: ...
            tmp38 = interp.getResult();
            setVarScalar(interp, "right_peek_tuple", tmp38, compiledLocals, 17);
        } // End Invoke: set
        { // Invoke: set left_infostr [...]
            TclObject tmp41;
            { // Invoke: lindex $left_peek_tuple 3
                TclObject tmp42 = getVarScalar(interp, "left_peek_tuple", compiledLocals, 16);
                tmp42 = TclList.index(interp, tmp42, 3);
                if ( tmp42 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp42);
                }
            } // End Invoke: lindex
            tmp41 = interp.getResult();
            setVarScalar(interp, "left_infostr", tmp41, compiledLocals, 18);
        } // End Invoke: set
        { // Invoke: set right_infostr [...]
            TclObject tmp43;
            { // Invoke: lindex $right_peek_tuple 3
                TclObject tmp44 = getVarScalar(interp, "right_peek_tuple", compiledLocals, 17);
                tmp44 = TclList.index(interp, tmp44, 3);
                if ( tmp44 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp44);
                }
            } // End Invoke: lindex
            tmp43 = interp.getResult();
            setVarScalar(interp, "right_infostr", tmp43, compiledLocals, 19);
        } // End Invoke: set
        { // Invoke: if {$equals_op} ... elseif {$logic_op} ... else ...
            TclObject tmp45 = getVarScalar(interp, "equals_op", compiledLocals, 9);
            boolean tmp46 = TJC.getBoolean(interp, tmp45);
            if ( tmp46 ) {
                { // Invoke: set op_tuple [...]
                    TclObject tmp47;
                    { // Invoke: ... $op $left_tuple $left_peek_tuple $right_tuple $right_peek_tuple
                        TclObject[] objv48 = TJC.grabObjv(interp, 6);
                        TclObject tmp49;
                        try {
                            // Arg 0 constant: ...
                            objv48[0] = const23;
                            // Arg 1 variable: $op
                            tmp49 = getVarScalar(interp, "op", compiledLocals, 6);
                            tmp49.preserve();
                            objv48[1] = tmp49;
                            // Arg 2 variable: $left_tuple
                            tmp49 = getVarScalar(interp, "left_tuple", compiledLocals, 14);
                            tmp49.preserve();
                            objv48[2] = tmp49;
                            // Arg 3 variable: $left_peek_tuple
                            tmp49 = getVarScalar(interp, "left_peek_tuple", compiledLocals, 16);
                            tmp49.preserve();
                            objv48[3] = tmp49;
                            // Arg 4 variable: $right_tuple
                            tmp49 = getVarScalar(interp, "right_tuple", compiledLocals, 15);
                            tmp49.preserve();
                            objv48[4] = tmp49;
                            // Arg 5 variable: $right_peek_tuple
                            tmp49 = getVarScalar(interp, "right_peek_tuple", compiledLocals, 17);
                            tmp49.preserve();
                            objv48[5] = tmp49;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv48, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            objv48[0] = null;
                            TJC.releaseObjvElems(interp, objv48, 6);
                        }
                    } // End Invoke: ...
                    tmp47 = interp.getResult();
                    setVarScalar(interp, "op_tuple", tmp47, compiledLocals, 0);
                } // End Invoke: set
            } else {
                TclObject tmp50 = getVarScalar(interp, "logic_op", compiledLocals, 8);
                boolean tmp51 = TJC.getBoolean(interp, tmp50);
                if ( tmp51 ) {
                    { // Invoke: set op_tuple [...]
                        TclObject tmp52;
                        { // Invoke: ... $op $left_tuple $left_peek_tuple $right_tuple $right_peek_tuple
                            TclObject[] objv53 = TJC.grabObjv(interp, 6);
                            TclObject tmp54;
                            try {
                                // Arg 0 constant: ...
                                objv53[0] = const24;
                                // Arg 1 variable: $op
                                tmp54 = getVarScalar(interp, "op", compiledLocals, 6);
                                tmp54.preserve();
                                objv53[1] = tmp54;
                                // Arg 2 variable: $left_tuple
                                tmp54 = getVarScalar(interp, "left_tuple", compiledLocals, 14);
                                tmp54.preserve();
                                objv53[2] = tmp54;
                                // Arg 3 variable: $left_peek_tuple
                                tmp54 = getVarScalar(interp, "left_peek_tuple", compiledLocals, 16);
                                tmp54.preserve();
                                objv53[3] = tmp54;
                                // Arg 4 variable: $right_tuple
                                tmp54 = getVarScalar(interp, "right_tuple", compiledLocals, 15);
                                tmp54.preserve();
                                objv53[4] = tmp54;
                                // Arg 5 variable: $right_peek_tuple
                                tmp54 = getVarScalar(interp, "right_peek_tuple", compiledLocals, 17);
                                tmp54.preserve();
                                objv53[5] = tmp54;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv53, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                objv53[0] = null;
                                TJC.releaseObjvElems(interp, objv53, 6);
                            }
                        } // End Invoke: ...
                        tmp52 = interp.getResult();
                        setVarScalar(interp, "op_tuple", tmp52, compiledLocals, 0);
                    } // End Invoke: set
                } else {
                    { // Invoke: set op_tuple {}
                        setVarScalar(interp, "op_tuple", const0, compiledLocals, 0);
                    } // End Invoke: set
                }
            }
        } // End Invoke: if
        { // Invoke: if {$op_tuple != {}} ... else ...
            // Binary operator: $op_tuple != ""
            TclObject tmp55 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
            ExprValue tmp56 = evs0;
            TJC.exprEqualsEmptyString(tmp56, tmp55, true);
            // End Binary operator: !=
            boolean tmp57 = ( tmp56.getIntValue() != 0 );
            if ( tmp57 ) {
                { // Invoke: set ev1 [...]
                    TclObject tmp58;
                    { // Invoke: lindex $op_tuple 0
                        TclObject tmp59 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                        tmp59 = TclList.index(interp, tmp59, 0);
                        if ( tmp59 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp59);
                        }
                    } // End Invoke: lindex
                    tmp58 = interp.getResult();
                    setVarScalar(interp, "ev1", tmp58, compiledLocals, 20);
                } // End Invoke: set
                { // Invoke: set op_buffer [...]
                    TclObject tmp60;
                    { // Invoke: lindex $op_tuple 1
                        TclObject tmp61 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                        tmp61 = TclList.index(interp, tmp61, 1);
                        if ( tmp61 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp61);
                        }
                    } // End Invoke: lindex
                    tmp60 = interp.getResult();
                    setVarScalar(interp, "op_buffer", tmp60, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set ... [...]
                    TclObject tmp62;
                    { // Invoke: lindex $op_tuple 2
                        TclObject tmp63 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                        tmp63 = TclList.index(interp, tmp63, 2);
                        if ( tmp63 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp63);
                        }
                    } // End Invoke: lindex
                    tmp62 = interp.getResult();
                    setVarScalar(interp, "left_operand_ev_types", tmp62, compiledLocals, 21);
                } // End Invoke: set
                { // Invoke: set ... [...]
                    TclObject tmp64;
                    { // Invoke: lindex $op_tuple 3
                        TclObject tmp65 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                        tmp65 = TclList.index(interp, tmp65, 3);
                        if ( tmp65 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp65);
                        }
                    } // End Invoke: lindex
                    tmp64 = interp.getResult();
                    setVarScalar(interp, "right_operand_ev_types", tmp64, compiledLocals, 22);
                } // End Invoke: set
            } else {
                { // Invoke: set left_eval_tuple [...]
                    TclObject tmp66;
                    { // Invoke: ... $left_tuple
                        TclObject[] objv67 = TJC.grabObjv(interp, 2);
                        TclObject tmp68;
                        try {
                            // Arg 0 constant: ...
                            objv67[0] = const25;
                            // Arg 1 variable: $left_tuple
                            tmp68 = getVarScalar(interp, "left_tuple", compiledLocals, 14);
                            tmp68.preserve();
                            objv67[1] = tmp68;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv67, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp68 = objv67[1];
                            if ( tmp68 != null ) {
                                tmp68.release();
                            }
                            TJC.releaseObjv(interp, objv67, 2);
                        }
                    } // End Invoke: ...
                    tmp66 = interp.getResult();
                    setVarScalar(interp, "left_eval_tuple", tmp66, compiledLocals, 23);
                } // End Invoke: set
                { // Invoke: set right_eval_tuple [...]
                    TclObject tmp69;
                    { // Invoke: ... $right_tuple
                        TclObject[] objv70 = TJC.grabObjv(interp, 2);
                        TclObject tmp71;
                        try {
                            // Arg 0 constant: ...
                            objv70[0] = const25;
                            // Arg 1 variable: $right_tuple
                            tmp71 = getVarScalar(interp, "right_tuple", compiledLocals, 15);
                            tmp71.preserve();
                            objv70[1] = tmp71;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv70, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp71 = objv70[1];
                            if ( tmp71 != null ) {
                                tmp71.release();
                            }
                            TJC.releaseObjv(interp, objv70, 2);
                        }
                    } // End Invoke: ...
                    tmp69 = interp.getResult();
                    setVarScalar(interp, "right_eval_tuple", tmp69, compiledLocals, 24);
                } // End Invoke: set
                { // Invoke: set ev1 [...]
                    TclObject tmp72;
                    { // Invoke: lindex $left_eval_tuple 1
                        TclObject tmp73 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 23);
                        tmp73 = TclList.index(interp, tmp73, 1);
                        if ( tmp73 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp73);
                        }
                    } // End Invoke: lindex
                    tmp72 = interp.getResult();
                    setVarScalar(interp, "ev1", tmp72, compiledLocals, 20);
                } // End Invoke: set
                { // Invoke: set ev2 [...]
                    TclObject tmp74;
                    { // Invoke: lindex $right_eval_tuple 1
                        TclObject tmp75 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 24);
                        tmp75 = TclList.index(interp, tmp75, 1);
                        if ( tmp75 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp75);
                        }
                    } // End Invoke: lindex
                    tmp74 = interp.getResult();
                    setVarScalar(interp, "ev2", tmp74, compiledLocals, 25);
                } // End Invoke: set
                { // Invoke: append op_buffer [...] [...]
                    TclObject[] objv76 = TJC.grabObjv(interp, 2);
                    TclObject tmp77;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: lindex $left_eval_tuple 2
                            TclObject tmp78 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 23);
                            tmp78 = TclList.index(interp, tmp78, 2);
                            if ( tmp78 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp78);
                            }
                        } // End Invoke: lindex
                        tmp77 = interp.getResult();
                        tmp77.preserve();
                        objv76[0] = tmp77;
                        // Arg 3 command: [...]
                        { // Invoke: lindex $right_eval_tuple 2
                            TclObject tmp79 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 24);
                            tmp79 = TclList.index(interp, tmp79, 2);
                            if ( tmp79 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp79);
                            }
                        } // End Invoke: lindex
                        tmp77 = interp.getResult();
                        tmp77.preserve();
                        objv76[1] = tmp77;
                        interp.resetResult();
                        appendVarScalar(interp, "op_buffer", objv76, compiledLocals, 3);
                    } finally {
                        TJC.releaseObjvElems(interp, objv76, 2);
                    }
                } // End Invoke: append
                { // Invoke: set ... [...]
                    TclObject tmp80;
                    { // Invoke: lindex $left_eval_tuple 3 3
                        TclObject[] objv81 = TJC.grabObjv(interp, 4);
                        TclObject tmp82;
                        try {
                            // Arg 0 constant: lindex
                            objv81[0] = const26;
                            // Arg 1 variable: $left_eval_tuple
                            tmp82 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 23);
                            tmp82.preserve();
                            objv81[1] = tmp82;
                            // Arg 2 constant: 3
                            objv81[2] = const27;
                            // Arg 3 constant: 3
                            objv81[3] = const27;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv81, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp82 = objv81[1];
                            if ( tmp82 != null ) {
                                tmp82.release();
                            }
                            TJC.releaseObjv(interp, objv81, 4);
                        }
                    } // End Invoke: lindex
                    tmp80 = interp.getResult();
                    setVarScalar(interp, "left_operand_ev_types", tmp80, compiledLocals, 21);
                } // End Invoke: set
                { // Invoke: set ... [...]
                    TclObject tmp83;
                    { // Invoke: lindex $right_eval_tuple 3 3
                        TclObject[] objv84 = TJC.grabObjv(interp, 4);
                        TclObject tmp85;
                        try {
                            // Arg 0 constant: lindex
                            objv84[0] = const26;
                            // Arg 1 variable: $right_eval_tuple
                            tmp85 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 24);
                            tmp85.preserve();
                            objv84[1] = tmp85;
                            // Arg 2 constant: 3
                            objv84[2] = const27;
                            // Arg 3 constant: 3
                            objv84[3] = const27;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv84, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp85 = objv84[1];
                            if ( tmp85 != null ) {
                                tmp85.release();
                            }
                            TJC.releaseObjv(interp, objv84, 4);
                        }
                    } // End Invoke: lindex
                    tmp83 = interp.getResult();
                    setVarScalar(interp, "right_operand_ev_types", tmp83, compiledLocals, 22);
                } // End Invoke: set
                { // Invoke: append op_buffer [...] ... $opval ", " $ev1 ", " $ev2 ... [...]
                    TclObject[] objv86 = TJC.grabObjv(interp, 9);
                    TclObject tmp87;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv88 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv88[0] = const28;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv88, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv88, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp87 = interp.getResult();
                        tmp87.preserve();
                        objv86[0] = tmp87;
                        // Arg 3 constant: ...
                        objv86[1] = const29;
                        // Arg 4 variable: $opval
                        tmp87 = getVarScalar(interp, "opval", compiledLocals, 13);
                        tmp87.preserve();
                        objv86[2] = tmp87;
                        // Arg 5 constant: ", "
                        objv86[3] = const30;
                        // Arg 6 variable: $ev1
                        tmp87 = getVarScalar(interp, "ev1", compiledLocals, 20);
                        tmp87.preserve();
                        objv86[4] = tmp87;
                        // Arg 7 constant: ", "
                        objv86[5] = const30;
                        // Arg 8 variable: $ev2
                        tmp87 = getVarScalar(interp, "ev2", compiledLocals, 25);
                        tmp87.preserve();
                        objv86[6] = tmp87;
                        // Arg 9 constant: ...
                        objv86[7] = const31;
                        // Arg 10 command: [...]
                        { // Invoke: ... $ev2
                            TclObject[] objv89 = TJC.grabObjv(interp, 2);
                            TclObject tmp90;
                            try {
                                // Arg 0 constant: ...
                                objv89[0] = const32;
                                // Arg 1 variable: $ev2
                                tmp90 = getVarScalar(interp, "ev2", compiledLocals, 25);
                                tmp90.preserve();
                                objv89[1] = tmp90;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv89, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                tmp90 = objv89[1];
                                if ( tmp90 != null ) {
                                    tmp90.release();
                                }
                                TJC.releaseObjv(interp, objv89, 2);
                            }
                        } // End Invoke: ...
                        tmp87 = interp.getResult();
                        tmp87.preserve();
                        objv86[8] = tmp87;
                        interp.resetResult();
                        appendVarScalar(interp, "op_buffer", objv86, compiledLocals, 3);
                    } finally {
                        objv86[1] = null;
                        objv86[3] = null;
                        objv86[5] = null;
                        objv86[7] = null;
                        TJC.releaseObjvElems(interp, objv86, 9);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...] ... $left_infostr " " $op " " $right_infostr ... $op_buffer [...] ... $op ...
            TclObject[] objv91 = TJC.grabObjv(interp, 13);
            TclObject tmp92;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv93 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv93[0] = const28;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv93, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv93, 1);
                    }
                } // End Invoke: emitter_indent
                tmp92 = interp.getResult();
                tmp92.preserve();
                objv91[0] = tmp92;
                // Arg 3 constant: ...
                objv91[1] = const33;
                // Arg 4 variable: $left_infostr
                tmp92 = getVarScalar(interp, "left_infostr", compiledLocals, 18);
                tmp92.preserve();
                objv91[2] = tmp92;
                // Arg 5 constant: " "
                objv91[3] = const34;
                // Arg 6 variable: $op
                tmp92 = getVarScalar(interp, "op", compiledLocals, 6);
                tmp92.preserve();
                objv91[4] = tmp92;
                // Arg 7 constant: " "
                objv91[5] = const34;
                // Arg 8 variable: $right_infostr
                tmp92 = getVarScalar(interp, "right_infostr", compiledLocals, 19);
                tmp92.preserve();
                objv91[6] = tmp92;
                // Arg 9 constant: ...
                objv91[7] = const35;
                // Arg 10 variable: $op_buffer
                tmp92 = getVarScalar(interp, "op_buffer", compiledLocals, 3);
                tmp92.preserve();
                objv91[8] = tmp92;
                // Arg 11 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv94 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv94[0] = const28;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv94, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv94, 1);
                    }
                } // End Invoke: emitter_indent
                tmp92 = interp.getResult();
                tmp92.preserve();
                objv91[9] = tmp92;
                // Arg 12 constant: ...
                objv91[10] = const36;
                // Arg 13 variable: $op
                tmp92 = getVarScalar(interp, "op", compiledLocals, 6);
                tmp92.preserve();
                objv91[11] = tmp92;
                // Arg 14 constant: ...
                objv91[12] = const35;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv91, compiledLocals, 2);
            } finally {
                objv91[1] = null;
                objv91[3] = null;
                objv91[5] = null;
                objv91[7] = null;
                objv91[10] = null;
                objv91[12] = null;
                TJC.releaseObjvElems(interp, objv91, 13);
            }
        } // End Invoke: append
        { // Invoke: if ... ... elseif {$math_op} ... elseif {$bitwise_op} ... else ...
            // Binary operator: $bcompare_op || $logic_op
            TclObject tmp95 = getVarScalar(interp, "bcompare_op", compiledLocals, 10);
            ExprValue tmp96 = evs0;
            TJC.exprInitValue(interp, tmp96, tmp95);
            if (!tmp96.getBooleanValue(interp)) {
            TclObject tmp97 = getVarScalar(interp, "logic_op", compiledLocals, 8);
            ExprValue tmp98 = evs1;
            TJC.exprInitValue(interp, tmp98, tmp97);
            tmp96.setIntValue(tmp98.getBooleanValue(interp));
            } else {
            tmp96.setIntValue(1);
            } // End if: !$bcompare_op
            // End Binary operator: ||
            boolean tmp99 = ( tmp96.getIntValue() != 0 );
            if ( tmp99 ) {
                { // Invoke: set ev_types boolean
                    setVarScalar(interp, "ev_types", const37, compiledLocals, 26);
                } // End Invoke: set
            } else {
                TclObject tmp100 = getVarScalar(interp, "math_op", compiledLocals, 11);
                boolean tmp101 = TJC.getBoolean(interp, tmp100);
                if ( tmp101 ) {
                    { // Invoke: if {$op == "%"} ... else ...
                        // Binary operator: $op == "%"
                        TclObject tmp102 = getVarScalar(interp, "op", compiledLocals, 6);
                        boolean tmp103 = tmp102.toString().equals("%");
                        ExprValue tmp104 = evs0;
                        tmp104.setIntValue(tmp103);
                        // End Binary operator: ==
                        boolean tmp105 = ( tmp104.getIntValue() != 0 );
                        if ( tmp105 ) {
                            { // Invoke: set ev_types int
                                setVarScalar(interp, "ev_types", const38, compiledLocals, 26);
                            } // End Invoke: set
                        } else {
                            { // Invoke: if ... ... elseif ... ... else ...
                                // Binary operator: () && ()
                                // Binary operator: $left_operand_ev_types == "int"
                                TclObject tmp106 = getVarScalar(interp, "left_operand_ev_types", compiledLocals, 21);
                                boolean tmp107 = tmp106.toString().equals("int");
                                ExprValue tmp108 = evs0;
                                tmp108.setIntValue(tmp107);
                                // End Binary operator: ==
                                if (tmp108.getBooleanValue(interp)) {
                                // Binary operator: $right_operand_ev_types == "int"
                                TclObject tmp109 = getVarScalar(interp, "right_operand_ev_types", compiledLocals, 22);
                                boolean tmp110 = tmp109.toString().equals("int");
                                ExprValue tmp111 = evs1;
                                tmp111.setIntValue(tmp110);
                                // End Binary operator: ==
                                tmp108.setIntValue(tmp111.getBooleanValue(interp));
                                } else {
                                tmp108.setIntValue(0);
                                } // End if: ()
                                // End Binary operator: &&
                                boolean tmp112 = ( tmp108.getIntValue() != 0 );
                                if ( tmp112 ) {
                                    { // Invoke: set ev_types int
                                        setVarScalar(interp, "ev_types", const38, compiledLocals, 26);
                                    } // End Invoke: set
                                } else {
                                    // Binary operator: () || ()
                                    // Binary operator: $left_operand_ev_types == "double"
                                    TclObject tmp113 = getVarScalar(interp, "left_operand_ev_types", compiledLocals, 21);
                                    boolean tmp114 = tmp113.toString().equals("double");
                                    ExprValue tmp115 = evs0;
                                    tmp115.setIntValue(tmp114);
                                    // End Binary operator: ==
                                    if (!tmp115.getBooleanValue(interp)) {
                                    // Binary operator: $right_operand_ev_types == "double"
                                    TclObject tmp116 = getVarScalar(interp, "right_operand_ev_types", compiledLocals, 22);
                                    boolean tmp117 = tmp116.toString().equals("double");
                                    ExprValue tmp118 = evs1;
                                    tmp118.setIntValue(tmp117);
                                    // End Binary operator: ==
                                    tmp115.setIntValue(tmp118.getBooleanValue(interp));
                                    } else {
                                    tmp115.setIntValue(1);
                                    } // End if: !()
                                    // End Binary operator: ||
                                    boolean tmp119 = ( tmp115.getIntValue() != 0 );
                                    if ( tmp119 ) {
                                        { // Invoke: set ev_types double
                                            setVarScalar(interp, "ev_types", const39, compiledLocals, 26);
                                        } // End Invoke: set
                                    } else {
                                        { // Invoke: set ev_types {int double}
                                            setVarScalar(interp, "ev_types", const40, compiledLocals, 26);
                                        } // End Invoke: set
                                    }
                                }
                            } // End Invoke: if
                        }
                    } // End Invoke: if
                } else {
                    TclObject tmp120 = getVarScalar(interp, "bitwise_op", compiledLocals, 12);
                    boolean tmp121 = TJC.getBoolean(interp, tmp120);
                    if ( tmp121 ) {
                        { // Invoke: set ev_types int
                            setVarScalar(interp, "ev_types", const38, compiledLocals, 26);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set ev_types {int double}
                            setVarScalar(interp, "ev_types", const40, compiledLocals, 26);
                        } // End Invoke: set
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $ev1 $buffer $ev_types
                TclObject tmp122 = TclList.newInstance();
                TclObject tmp123;
                try {
                    tmp123 = getVarScalar(interp, "ev1", compiledLocals, 20);
                    TclList.append(interp, tmp122, tmp123);
                    tmp123 = getVarScalar(interp, "buffer", compiledLocals, 2);
                    TclList.append(interp, tmp122, tmp123);
                    tmp123 = getVarScalar(interp, "ev_types", compiledLocals, 26);
                    TclList.append(interp, tmp122, tmp123);
                } catch (TclException ex) {
                    tmp122.release();
                    throw ex;
                }
                interp.setResult(tmp122);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate_emit_binary_operator");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;
    TclObject const38;
    TclObject const39;
    TclObject const40;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("TJC.EXPR_OP_MULT");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("TJC.EXPR_OP_DIVIDE");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("TJC.EXPR_OP_MOD");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("TJC.EXPR_OP_PLUS");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("TJC.EXPR_OP_MINUS");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("TJC.EXPR_OP_LEFT_SHIFT");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("TJC.EXPR_OP_RIGHT_SHIFT");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("TJC.EXPR_OP_LESS");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("TJC.EXPR_OP_GREATER");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("TJC.EXPR_OP_LEQ");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("TJC.EXPR_OP_GEQ");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("TJC.EXPR_OP_EQUAL");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("TJC.EXPR_OP_NEQ");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("TJC.EXPR_OP_BIT_AND");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("TJC.EXPR_OP_BIT_XOR");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("TJC.EXPR_OP_BIT_OR");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("TJC.EXPR_OP_STREQ");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("TJC.EXPR_OP_STRNEQ");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("compileproc_expr_peek_operand");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("compileproc_expr_evaluate_emit_binary_equals_operator");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("compileproc_expr_evaluate_emit_binary_logic_operator");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("compileproc_expr_evaluate_emit_exprvalue");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("lindex");
        const26.preserve(); const26.preserve();
        const27 = TclInteger.newInstance(3);
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("emitter_indent");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("TJC.exprBinaryOperator(interp, ");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance(", ");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance(");\n");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("compileproc_emit_exprvalue_release");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("// Binary operator: ");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance(" ");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance("\n");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance("// End Binary operator: ");
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance("boolean");
        const37.preserve(); const37.preserve();
        const38 = TclString.newInstance("int");
        const38.preserve(); const38.preserve();
        const39 = TclString.newInstance("double");
        const39.preserve(); const39.preserve();
        const40 = TclString.newInstance("int double");
        const40.preserve(); const40.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "compileproc_expr_peek_operand";
                break;
            }
            case 3: {
                cmdName = "compileproc_expr_evaluate_emit_binary_equals_operator";
                break;
            }
            case 4: {
                cmdName = "compileproc_expr_evaluate_emit_binary_logic_operator";
                break;
            }
            case 5: {
                cmdName = "compileproc_expr_evaluate_emit_exprvalue";
                break;
            }
            case 6: {
                cmdName = "lindex";
                break;
            }
            case 7: {
                cmdName = "emitter_indent";
                break;
            }
            case 8: {
                cmdName = "compileproc_emit_exprvalue_release";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "op_tuple",
        "_compileproc",
        "buffer",
        "op_buffer",
        "type",
        "vtuple",
        "op",
        "values",
        "logic_op",
        "equals_op",
        "bcompare_op",
        "math_op",
        "bitwise_op",
        "opval",
        "left_tuple",
        "right_tuple",
        "left_peek_tuple",
        "right_peek_tuple",
        "left_infostr",
        "right_infostr",
        "ev1",
        "left_operand_ev_types",
        "right_operand_ev_types",
        "left_eval_tuple",
        "right_eval_tuple",
        "ev2",
        "ev_types"
    };
} // end class CompileprocExprEvaluateEmitBinaryOperatorCmd

