// TJC implementation of procedure compileproc_expr_value_stack_alias
package tjc;
import tcl.lang.*;

public class CompileprocExprValueStackAliasCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "alias symbol");
        }
        setVarScalar(interp, "alias", objv[1], compiledLocals, 0);
        setVarScalar(interp, "symbol", objv[2], compiledLocals, 1);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_expr_value_stack", "_compileproc_expr_value_stack", 2);
        } // End Invoke: global
        { // Invoke: set "..." $symbol
            TclObject tmp0;
            String tmp1;
            StringBuffer sbtmp2 = new StringBuffer(64);
            sbtmp2.append("alias,");
            tmp0 = getVarScalar(interp, "alias", compiledLocals, 0);
            sbtmp2.append(tmp0.toString());
            tmp1 = sbtmp2.toString();
            tmp0 = getVarScalar(interp, "symbol", compiledLocals, 1);
            tmp0 = setVarArray(interp, "_compileproc_expr_value_stack", tmp1, tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_value_stack_alias");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "alias",
        "symbol",
        "_compileproc_expr_value_stack"
    };
} // end class CompileprocExprValueStackAliasCmd

