// TJC implementation of procedure compileproc_expr_value_stack_get
package tjc;
import tcl.lang.*;

public class CompileprocExprValueStackGetCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_expr_value_stack", "_compileproc_expr_value_stack", 0);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! $::_compileproc(...)
            initVarScoped(interp, "::_compileproc", compiledLocals, 1);
            TclObject tmp0 = getVarArray(interp, "::_compileproc", "options,expr_value_stack", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            if ( tmp0.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp1, tmp0);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp1, tmp0);
            }
            // End Unary operator: !
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: error ...
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv3[0] = const0;
                        // Arg 1 constant: ...
                        objv3[1] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv3, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Unary operator: ! [...]
            { // Invoke: info exists ...
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv4[0] = const2;
                    // Arg 1 constant: exists
                    objv4[1] = const3;
                    // Arg 2 constant: ...
                    objv4[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: info
            TclObject tmp5 = interp.getResult();
            ExprValue tmp6 = evs0;
            if ( tmp5.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp6, tmp5);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp6, tmp5);
            }
            // End Unary operator: !
            boolean tmp7 = ( tmp6.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: set ordered_symbols [...]
                    TclObject tmp8;
                    { // Invoke: list
                        TclObject tmp9 = TclList.newInstance();
                        interp.setResult(tmp9);
                    } // End Invoke: list
                    tmp8 = interp.getResult();
                    setVarScalar(interp, "ordered_symbols", tmp8, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: set used_stack [...]
                    TclObject tmp10;
                    { // Invoke: list
                        TclObject tmp11 = TclList.newInstance();
                        interp.setResult(tmp11);
                    } // End Invoke: list
                    tmp10 = interp.getResult();
                    setVarScalar(interp, "used_stack", tmp10, compiledLocals, 3);
                } // End Invoke: set
            } else {
                { // Invoke: set ordered_symbols $...
                    TclObject tmp12;
                    tmp12 = getVarArray(interp, "_compileproc_expr_value_stack", "ordered_symbols", compiledLocals, 0);
                    setVarScalar(interp, "ordered_symbols", tmp12, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: set used_stack $...
                    TclObject tmp13;
                    tmp13 = getVarArray(interp, "_compileproc_expr_value_stack", "used_stack", compiledLocals, 0);
                    setVarScalar(interp, "used_stack", tmp13, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set symbols_size [...]
            TclObject tmp14;
            { // Invoke: llength $ordered_symbols
                TclObject tmp15 = getVarScalar(interp, "ordered_symbols", compiledLocals, 2);
                int tmp16 = TclList.getLength(interp, tmp15);
                interp.setResult(tmp16);
            } // End Invoke: llength
            tmp14 = interp.getResult();
            setVarScalar(interp, "symbols_size", tmp14, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set stack_size [...]
            TclObject tmp17;
            { // Invoke: llength $used_stack
                TclObject tmp18 = getVarScalar(interp, "used_stack", compiledLocals, 3);
                int tmp19 = TclList.getLength(interp, tmp18);
                interp.setResult(tmp19);
            } // End Invoke: llength
            tmp17 = interp.getResult();
            setVarScalar(interp, "stack_size", tmp17, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ... elseif ... ... else ...
            // Binary operator: $stack_size > $symbols_size
            TclObject tmp20 = getVarScalar(interp, "stack_size", compiledLocals, 5);
            ExprValue tmp21 = evs0;
            TJC.exprInitValue(interp, tmp21, tmp20);
            TclObject tmp22 = getVarScalar(interp, "symbols_size", compiledLocals, 4);
            ExprValue tmp23 = evs1;
            TJC.exprInitValue(interp, tmp23, tmp22);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp21, tmp23);
            // End Binary operator: >
            boolean tmp24 = ( tmp21.getIntValue() != 0 );
            if ( tmp24 ) {
                { // Invoke: error "..."
                    TclObject[] objv25 = TJC.grabObjv(interp, 2);
                    TclObject tmp26;
                    try {
                        // Arg 0 constant: error
                        objv25[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp27 = new StringBuffer(64);
                        sbtmp27.append("stack ");
                        sbtmp27.append("{");
                        tmp26 = getVarScalar(interp, "used_stack", compiledLocals, 3);
                        sbtmp27.append(tmp26.toString());
                        sbtmp27.append("}");
                        sbtmp27.append(" size is larger than symbols ");
                        sbtmp27.append("{");
                        tmp26 = getVarScalar(interp, "ordered_symbols", compiledLocals, 2);
                        sbtmp27.append(tmp26.toString());
                        sbtmp27.append("}");
                        tmp26 = TclString.newInstance(sbtmp27);
                        tmp26.preserve();
                        objv25[1] = tmp26;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv25, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp26 = objv25[1];
                        if ( tmp26 != null ) {
                            tmp26.release();
                        }
                        TJC.releaseObjv(interp, objv25, 2);
                    }
                } // End Invoke: error
            } else {
                // Binary operator: $stack_size == $symbols_size
                TclObject tmp28 = getVarScalar(interp, "stack_size", compiledLocals, 5);
                ExprValue tmp29 = evs0;
                TJC.exprInitValue(interp, tmp29, tmp28);
                TclObject tmp30 = getVarScalar(interp, "symbols_size", compiledLocals, 4);
                ExprValue tmp31 = evs1;
                TJC.exprInitValue(interp, tmp31, tmp30);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp29, tmp31);
                // End Binary operator: ==
                boolean tmp32 = ( tmp29.getIntValue() != 0 );
                if ( tmp32 ) {
                    { // Invoke: set symbol "evs${symbols_size}"
                        TclObject tmp33;
                        StringBuffer sbtmp34 = new StringBuffer(64);
                        sbtmp34.append("evs");
                        tmp33 = getVarScalar(interp, "symbols_size", compiledLocals, 4);
                        sbtmp34.append(tmp33.toString());
                        tmp33 = TclString.newInstance(sbtmp34);
                        setVarScalar(interp, "symbol", tmp33, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: lappend ordered_symbols $symbol
                        TclObject[] objv35 = TJC.grabObjv(interp, 1);
                        TclObject tmp36;
                        try {
                            // Arg 2 variable: $symbol
                            tmp36 = getVarScalar(interp, "symbol", compiledLocals, 6);
                            tmp36.preserve();
                            objv35[0] = tmp36;
                            interp.resetResult();
                            lappendVarScalar(interp, "ordered_symbols", objv35, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv35, 1);
                        }
                    } // End Invoke: lappend
                } else {
                    { // Invoke: set symbol [...]
                        TclObject tmp37;
                        { // Invoke: lindex $ordered_symbols $stack_size
                            TclObject tmp38 = null;
                            TclObject tmp39;
                            try {
                                tmp38 = getVarScalar(interp, "ordered_symbols", compiledLocals, 2);
                                tmp38.preserve();
                                tmp39 = getVarScalar(interp, "stack_size", compiledLocals, 5);
                                TJC.lindexNonconst(interp, tmp38, tmp39);
                            } finally {
                                if ( tmp38 != null ) {
                                    tmp38.release();
                                }
                            }
                        } // End Invoke: lindex
                        tmp37 = interp.getResult();
                        setVarScalar(interp, "symbol", tmp37, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: if {$symbol == ""} ...
                        // Binary operator: $symbol == ""
                        TclObject tmp40 = getVarScalar(interp, "symbol", compiledLocals, 6);
                        ExprValue tmp41 = evs0;
                        TJC.exprEqualsEmptyString(tmp41, tmp40, false);
                        // End Binary operator: ==
                        boolean tmp42 = ( tmp41.getIntValue() != 0 );
                        if ( tmp42 ) {
                            { // Invoke: error "..."
                                TclObject[] objv43 = TJC.grabObjv(interp, 2);
                                TclObject tmp44;
                                try {
                                    // Arg 0 constant: error
                                    objv43[0] = const0;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp45 = new StringBuffer(64);
                                    sbtmp45.append("empty symbol grabbed from ordered_symbols index ");
                                    tmp44 = getVarScalar(interp, "stack_size", compiledLocals, 5);
                                    sbtmp45.append(tmp44.toString());
                                    sbtmp45.append(" : ");
                                    sbtmp45.append("{");
                                    tmp44 = getVarScalar(interp, "ordered_symbols", compiledLocals, 2);
                                    sbtmp45.append(tmp44.toString());
                                    sbtmp45.append("}");
                                    tmp44 = TclString.newInstance(sbtmp45);
                                    tmp44.preserve();
                                    objv43[1] = tmp44;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv43, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp44 = objv43[1];
                                    if ( tmp44 != null ) {
                                        tmp44.release();
                                    }
                                    TJC.releaseObjv(interp, objv43, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                }
            }
        } // End Invoke: if
        { // Invoke: lappend used_stack $symbol
            TclObject[] objv46 = TJC.grabObjv(interp, 1);
            TclObject tmp47;
            try {
                // Arg 2 variable: $symbol
                tmp47 = getVarScalar(interp, "symbol", compiledLocals, 6);
                tmp47.preserve();
                objv46[0] = tmp47;
                interp.resetResult();
                lappendVarScalar(interp, "used_stack", objv46, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv46, 1);
            }
        } // End Invoke: lappend
        { // Invoke: set ... $ordered_symbols
            TclObject tmp48;
            tmp48 = getVarScalar(interp, "ordered_symbols", compiledLocals, 2);
            setVarArray(interp, "_compileproc_expr_value_stack", "ordered_symbols", tmp48, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... $used_stack
            TclObject tmp49;
            tmp49 = getVarScalar(interp, "used_stack", compiledLocals, 3);
            setVarArray(interp, "_compileproc_expr_value_stack", "used_stack", tmp49, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: return $symbol
            TclObject tmp50 = getVarScalar(interp, "symbol", compiledLocals, 6);
            interp.resetResult();
            interp.setResult(tmp50);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_value_stack_get");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_expr_value_stack_get invoked but expr_value_stack flag is off");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("info");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("exists");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("_compileproc_expr_value_stack(ordered_symbols)");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "info";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_compileproc_expr_value_stack",
        "::_compileproc",
        "ordered_symbols",
        "used_stack",
        "symbols_size",
        "stack_size",
        "symbol"
    };
} // end class CompileprocExprValueStackGetCmd

