// TJC implementation of procedure compileproc_expr_value_stack_release
package tjc;
import tcl.lang.*;

public class CompileprocExprValueStackReleaseCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "symbol");
        }
        setVarScalar(interp, "symbol", objv[1], compiledLocals, 0);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_expr_value_stack", "_compileproc_expr_value_stack", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            { // Invoke: info exists "..."
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                TclObject tmp1;
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp2 = new StringBuffer(64);
                    sbtmp2.append("_compileproc_expr_value_stack(alias,");
                    tmp1 = getVarScalar(interp, "symbol", compiledLocals, 0);
                    sbtmp2.append(tmp1.toString());
                    sbtmp2.append(")");
                    tmp1 = TclString.newInstance(sbtmp2);
                    tmp1.preserve();
                    objv0[2] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[2];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp3 = interp.getResult();
            ExprValue tmp4 = evs0;
            TJC.exprInitValue(interp, tmp4, tmp3);
            boolean tmp5 = tmp4.getBooleanValue(interp);
            if ( tmp5 ) {
                { // Invoke: set top $...
                    TclObject tmp6;
                    StringBuffer sbtmp7 = new StringBuffer(64);
                    sbtmp7.append("alias,");
                    tmp6 = getVarScalar(interp, "symbol", compiledLocals, 0);
                    sbtmp7.append(tmp6.toString());
                    tmp6 = getVarArray(interp, "_compileproc_expr_value_stack", sbtmp7.toString(), compiledLocals, 1);
                    setVarScalar(interp, "top", tmp6, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: unset "..."
                    TclObject[] objv8 = TJC.grabObjv(interp, 2);
                    TclObject tmp9;
                    try {
                        // Arg 0 constant: unset
                        objv8[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp10 = new StringBuffer(64);
                        sbtmp10.append("_compileproc_expr_value_stack(alias,");
                        tmp9 = getVarScalar(interp, "symbol", compiledLocals, 0);
                        sbtmp10.append(tmp9.toString());
                        sbtmp10.append(")");
                        tmp9 = TclString.newInstance(sbtmp10);
                        tmp9.preserve();
                        objv8[1] = tmp9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv8, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp9 = objv8[1];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        TJC.releaseObjv(interp, objv8, 2);
                    }
                } // End Invoke: unset
                { // Invoke: set symbol $top
                    TclObject tmp11;
                    tmp11 = getVarScalar(interp, "top", compiledLocals, 2);
                    setVarScalar(interp, "symbol", tmp11, compiledLocals, 0);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set used_stack $...
            TclObject tmp12;
            tmp12 = getVarArray(interp, "_compileproc_expr_value_stack", "used_stack", compiledLocals, 1);
            setVarScalar(interp, "used_stack", tmp12, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set top [...]
            TclObject tmp13;
            { // Invoke: lindex $used_stack end
                TclObject tmp14 = null;
                TclObject tmp15;
                try {
                    tmp14 = getVarScalar(interp, "used_stack", compiledLocals, 3);
                    tmp14.preserve();
                    tmp15 = const3;
                    TJC.lindexNonconst(interp, tmp14, tmp15);
                } finally {
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "top", tmp13, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {$symbol ne $top} ...
            // Binary operator: $symbol ne $top
            TclObject tmp16 = getVarScalar(interp, "symbol", compiledLocals, 0);
            String tmp17 = tmp16.toString();
            TclObject tmp18 = getVarScalar(interp, "top", compiledLocals, 2);
            String tmp19 = tmp18.toString();
            boolean tmp20 = ! tmp17.equals(tmp19);
            ExprValue tmp21 = evs0;
            tmp21.setIntValue(tmp20);
            // End Binary operator: ne
            boolean tmp22 = ( tmp21.getIntValue() != 0 );
            if ( tmp22 ) {
                { // Invoke: error "..."
                    TclObject[] objv23 = TJC.grabObjv(interp, 2);
                    TclObject tmp24;
                    try {
                        // Arg 0 constant: error
                        objv23[0] = const4;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp25 = new StringBuffer(64);
                        sbtmp25.append("released symbol ");
                        tmp24 = getVarScalar(interp, "symbol", compiledLocals, 0);
                        sbtmp25.append(tmp24.toString());
                        sbtmp25.append(" is not at the top of the stack ");
                        sbtmp25.append("{");
                        tmp24 = getVarScalar(interp, "used_stack", compiledLocals, 3);
                        sbtmp25.append(tmp24.toString());
                        sbtmp25.append("}");
                        tmp24 = TclString.newInstance(sbtmp25);
                        tmp24.preserve();
                        objv23[1] = tmp24;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv23, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp24 = objv23[1];
                        if ( tmp24 != null ) {
                            tmp24.release();
                        }
                        TJC.releaseObjv(interp, objv23, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set used_stack [...]
            TclObject tmp26;
            { // Invoke: lreplace $used_stack end end
                TclObject[] objv27 = TJC.grabObjv(interp, 4);
                TclObject tmp28;
                try {
                    // Arg 0 constant: lreplace
                    objv27[0] = const5;
                    // Arg 1 variable: $used_stack
                    tmp28 = getVarScalar(interp, "used_stack", compiledLocals, 3);
                    tmp28.preserve();
                    objv27[1] = tmp28;
                    // Arg 2 constant: end
                    objv27[2] = const3;
                    // Arg 3 constant: end
                    objv27[3] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv27, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp28 = objv27[1];
                    if ( tmp28 != null ) {
                        tmp28.release();
                    }
                    TJC.releaseObjv(interp, objv27, 4);
                }
            } // End Invoke: lreplace
            tmp26 = interp.getResult();
            setVarScalar(interp, "used_stack", tmp26, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set ... $used_stack
            TclObject tmp29;
            tmp29 = getVarScalar(interp, "used_stack", compiledLocals, 3);
            setVarArray(interp, "_compileproc_expr_value_stack", "used_stack", tmp29, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_value_stack_release");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("unset");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("end");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("error");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("lreplace");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "unset";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "lreplace";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "symbol",
        "_compileproc_expr_value_stack",
        "top",
        "used_stack"
    };
} // end class CompileprocExprValueStackReleaseCmd

