// TJC implementation of procedure compileproc_expr_value_stack_release_generate
package tjc;
import tcl.lang.*;

public class CompileprocExprValueStackReleaseGenerateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_expr_value_stack", "_compileproc_expr_value_stack", 0);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set ordered_symbols $...
            TclObject tmp0;
            tmp0 = getVarArray(interp, "_compileproc_expr_value_stack", "ordered_symbols", compiledLocals, 0);
            setVarScalar(interp, "ordered_symbols", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set i [...]
            TclObject tmp1;
            { // Invoke: llength $ordered_symbols
                TclObject tmp2 = getVarScalar(interp, "ordered_symbols", compiledLocals, 2);
                int tmp3 = TclList.getLength(interp, tmp2);
                interp.setResult(tmp3);
            } // End Invoke: llength
            tmp1 = interp.getResult();
            setVarScalar(interp, "i", tmp1, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: incr i -1
            interp.resetResult();
            incrVarScalar(interp, "i", -1, compiledLocals, 3);
        } // End Invoke: incr
        { // Invoke: set ... $...
            TclObject tmp4;
            initVarScoped(interp, "::_compileproc", compiledLocals, 4);
            tmp4 = getVarArray(interp, "::_compileproc", "options,expr_value_stack_null", compiledLocals, 4);
            setVarScalar(interp, "expr_value_stack_null", tmp4, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: for {} {$i >= 0} {incr i -1} ...
            for ( boolean skip9 = true ; true ; ) {
                if ( skip9 ) {
                    skip9 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i -1
                        interp.resetResult();
                        incrVarScalar(interp, "i", -1, compiledLocals, 3);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i >= 0
                TclObject tmp5 = getVarScalar(interp, "i", compiledLocals, 3);
                ExprValue tmp6 = evs0;
                TJC.exprInitValue(interp, tmp6, tmp5);
                ExprValue tmp7 = evs1;
                tmp7.setIntValue(0);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp6, tmp7);
                // End Binary operator: >=
                boolean tmp8 = ( tmp6.getIntValue() != 0 );
                if ( ! tmp8 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set symbol [...]
                    TclObject tmp10;
                    { // Invoke: lindex $ordered_symbols $i
                        TclObject tmp11 = null;
                        TclObject tmp12;
                        try {
                            tmp11 = getVarScalar(interp, "ordered_symbols", compiledLocals, 2);
                            tmp11.preserve();
                            tmp12 = getVarScalar(interp, "i", compiledLocals, 3);
                            TJC.lindexNonconst(interp, tmp11, tmp12);
                        } finally {
                            if ( tmp11 != null ) {
                                tmp11.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp10 = interp.getResult();
                    setVarScalar(interp, "symbol", tmp10, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    TclObject tmp13 = getVarScalar(interp, "expr_value_stack_null", compiledLocals, 5);
                    boolean tmp14 = TJC.getBoolean(interp, tmp13);
                    if ( tmp14 ) {
                        { // Invoke: append buffer [...] "..."
                            TclObject[] objv15 = TJC.grabObjv(interp, 2);
                            TclObject tmp16;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv17 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv17[0] = const1;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv17, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv17, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp16 = interp.getResult();
                                tmp16.preserve();
                                objv15[0] = tmp16;
                                // Arg 3 word: "..."
                                StringBuffer sbtmp18 = new StringBuffer(64);
                                sbtmp18.append("if ( ");
                                tmp16 = getVarScalar(interp, "symbol", compiledLocals, 6);
                                sbtmp18.append(tmp16.toString());
                                sbtmp18.append(" != null ) ");
                                sbtmp18.append("{");
                                sbtmp18.append(" TJC.exprReleaseValue(interp, ");
                                tmp16 = getVarScalar(interp, "symbol", compiledLocals, 6);
                                sbtmp18.append(tmp16.toString());
                                sbtmp18.append(")");
                                sbtmp18.append(";");
                                sbtmp18.append(" ");
                                sbtmp18.append("}");
                                sbtmp18.append("\n");
                                tmp16 = TclString.newInstance(sbtmp18);
                                tmp16.preserve();
                                objv15[1] = tmp16;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv15, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv15, 2);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: append buffer [...] "..."
                            TclObject[] objv19 = TJC.grabObjv(interp, 2);
                            TclObject tmp20;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv21 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv21[0] = const1;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv21, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv21, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp20 = interp.getResult();
                                tmp20.preserve();
                                objv19[0] = tmp20;
                                // Arg 3 word: "..."
                                StringBuffer sbtmp22 = new StringBuffer(64);
                                sbtmp22.append("TJC.exprReleaseValue(interp, ");
                                tmp20 = getVarScalar(interp, "symbol", compiledLocals, 6);
                                sbtmp22.append(tmp20.toString());
                                sbtmp22.append(")");
                                sbtmp22.append(";");
                                sbtmp22.append("\n");
                                tmp20 = TclString.newInstance(sbtmp22);
                                tmp20.preserve();
                                objv19[1] = tmp20;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv19, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv19, 2);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: return $buffer
            TclObject tmp23 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp23);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_value_stack_release_generate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_compileproc_expr_value_stack",
        "buffer",
        "ordered_symbols",
        "i",
        "::_compileproc",
        "expr_value_stack_null",
        "symbol"
    };
} // end class CompileprocExprValueStackReleaseGenerateCmd

