// TJC implementation of procedure compileproc_generate_key
package tjc;
import tcl.lang.*;

public class CompileprocGenerateKeyCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 11, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "cmdname argl inargl");
        }
        setVarScalar(interp, "cmdname", objv[1], compiledLocals, 0);
        setVarScalar(interp, "argl", objv[2], compiledLocals, 1);
        setVarScalar(interp, "inargl", objv[3], compiledLocals, 2);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 3);
        } // End Invoke: global
        { // Invoke: set num_args [...]
            TclObject tmp0;
            { // Invoke: llength $argl
                TclObject tmp1 = getVarScalar(interp, "argl", compiledLocals, 1);
                int tmp2 = TclList.getLength(interp, tmp1);
                interp.setResult(tmp2);
            } // End Invoke: llength
            tmp0 = interp.getResult();
            setVarScalar(interp, "num_args", tmp0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: incr num_args 1
            interp.resetResult();
            incrVarScalar(interp, "num_args", 1, compiledLocals, 4);
        } // End Invoke: incr
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists ...
                TclObject[] objv3 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv3[0] = const0;
                    // Arg 1 constant: exists
                    objv3[1] = const1;
                    // Arg 2 constant: ...
                    objv3[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv3, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv3, 3);
                }
            } // End Invoke: info
            TclObject tmp4 = interp.getResult();
            ExprValue tmp5 = evs0;
            if ( tmp4.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp5, tmp4);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp5, tmp4);
            }
            // End Unary operator: !
            boolean tmp6 = ( tmp5.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: set ... 0
                    setVarArray(interp, "_compileproc_key_info", "generated", const3, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set key "..."
            TclObject tmp7;
            StringBuffer sbtmp8 = new StringBuffer(64);
            sbtmp8.append("gkey");
            tmp7 = getVarArray(interp, "_compileproc_key_info", "generated", compiledLocals, 3);
            sbtmp8.append(tmp7.toString());
            tmp7 = TclString.newInstance(sbtmp8);
            setVarScalar(interp, "key", tmp7, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: incr ...
            interp.resetResult();
            incrVarArray(interp, "_compileproc_key_info", "generated", 1, compiledLocals, 3);
        } // End Invoke: incr
        { // Invoke: set types [...]
            TclObject tmp9;
            { // Invoke: list
                TclObject tmp10 = TclList.newInstance();
                interp.setResult(tmp10);
            } // End Invoke: list
            tmp9 = interp.getResult();
            setVarScalar(interp, "types", tmp9, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $num_args} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const3, compiledLocals, 7);
            } // End Invoke: set
            for ( boolean skip16 = true ; true ; ) {
                if ( skip16 ) {
                    skip16 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 7);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $num_args
                TclObject tmp11 = getVarScalar(interp, "i", compiledLocals, 7);
                ExprValue tmp12 = evs0;
                TJC.exprInitValue(interp, tmp12, tmp11);
                TclObject tmp13 = getVarScalar(interp, "num_args", compiledLocals, 4);
                ExprValue tmp14 = evs1;
                TJC.exprInitValue(interp, tmp14, tmp13);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp12, tmp14);
                // End Binary operator: <
                boolean tmp15 = ( tmp12.getIntValue() != 0 );
                if ( ! tmp15 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: lappend types constant
                    TclObject[] objv17 = TJC.grabObjv(interp, 1);
                    TclObject tmp18;
                    try {
                        // Arg 2 constant: constant
                        objv17[0] = const4;
                        interp.resetResult();
                        lappendVarScalar(interp, "types", objv17, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjv(interp, objv17, 1);
                    }
                } // End Invoke: lappend
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: set values [...]
            TclObject tmp19;
            { // Invoke: list
                TclObject tmp20 = TclList.newInstance();
                interp.setResult(tmp20);
            } // End Invoke: list
            tmp19 = interp.getResult();
            setVarScalar(interp, "values", tmp19, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set instrs [...]
            TclObject tmp21;
            { // Invoke: list
                TclObject tmp22 = TclList.newInstance();
                interp.setResult(tmp22);
            } // End Invoke: list
            tmp21 = interp.getResult();
            setVarScalar(interp, "instrs", tmp21, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: lappend values $cmdname
            TclObject[] objv23 = TJC.grabObjv(interp, 1);
            TclObject tmp24;
            try {
                // Arg 2 variable: $cmdname
                tmp24 = getVarScalar(interp, "cmdname", compiledLocals, 0);
                tmp24.preserve();
                objv23[0] = tmp24;
                interp.resetResult();
                lappendVarScalar(interp, "values", objv23, compiledLocals, 8);
            } finally {
                TJC.releaseObjvElems(interp, objv23, 1);
            }
        } // End Invoke: lappend
        { // Invoke: lappend instrs $cmdname
            TclObject[] objv25 = TJC.grabObjv(interp, 1);
            TclObject tmp26;
            try {
                // Arg 2 variable: $cmdname
                tmp26 = getVarScalar(interp, "cmdname", compiledLocals, 0);
                tmp26.preserve();
                objv25[0] = tmp26;
                interp.resetResult();
                lappendVarScalar(interp, "instrs", objv25, compiledLocals, 9);
            } finally {
                TJC.releaseObjvElems(interp, objv25, 1);
            }
        } // End Invoke: lappend
        { // Invoke: for {set i 0} ... {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const3, compiledLocals, 7);
            } // End Invoke: set
            for ( boolean skip33 = true ; true ; ) {
                if ( skip33 ) {
                    skip33 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 7);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < ()
                TclObject tmp27 = getVarScalar(interp, "i", compiledLocals, 7);
                ExprValue tmp28 = evs0;
                TJC.exprInitValue(interp, tmp28, tmp27);
                // Binary operator: $num_args - 1
                TclObject tmp29 = getVarScalar(interp, "num_args", compiledLocals, 4);
                ExprValue tmp30 = evs1;
                TJC.exprInitValue(interp, tmp30, tmp29);
                ExprValue tmp31 = evs2;
                tmp31.setIntValue(1);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp30, tmp31);
                // End Binary operator: -
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp28, tmp30);
                // End Binary operator: <
                boolean tmp32 = ( tmp28.getIntValue() != 0 );
                if ( ! tmp32 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: lappend values [...]
                    TclObject[] objv34 = TJC.grabObjv(interp, 1);
                    TclObject tmp35;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: lindex $argl $i
                            TclObject tmp36 = null;
                            TclObject tmp37;
                            try {
                                tmp36 = getVarScalar(interp, "argl", compiledLocals, 1);
                                tmp36.preserve();
                                tmp37 = getVarScalar(interp, "i", compiledLocals, 7);
                                TJC.lindexNonconst(interp, tmp36, tmp37);
                            } finally {
                                if ( tmp36 != null ) {
                                    tmp36.release();
                                }
                            }
                        } // End Invoke: lindex
                        tmp35 = interp.getResult();
                        tmp35.preserve();
                        objv34[0] = tmp35;
                        interp.resetResult();
                        lappendVarScalar(interp, "values", objv34, compiledLocals, 8);
                    } finally {
                        TJC.releaseObjvElems(interp, objv34, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: lappend instrs [...]
                    TclObject[] objv38 = TJC.grabObjv(interp, 1);
                    TclObject tmp39;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: lindex $inargl $i
                            TclObject tmp40 = null;
                            TclObject tmp41;
                            try {
                                tmp40 = getVarScalar(interp, "inargl", compiledLocals, 2);
                                tmp40.preserve();
                                tmp41 = getVarScalar(interp, "i", compiledLocals, 7);
                                TJC.lindexNonconst(interp, tmp40, tmp41);
                            } finally {
                                if ( tmp40 != null ) {
                                    tmp40.release();
                                }
                            }
                        } // End Invoke: lindex
                        tmp39 = interp.getResult();
                        tmp39.preserve();
                        objv38[0] = tmp39;
                        interp.resetResult();
                        lappendVarScalar(interp, "instrs", objv38, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv38, 1);
                    }
                } // End Invoke: lappend
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: foreach str $values ...
            TclObject tmp42 = null;
            try {
                tmp42 = getVarScalar(interp, "values", compiledLocals, 8);
                tmp42.preserve();
                final int tmp42_length = TclList.getLength(interp, tmp42);

                for ( int index43 = 0 ; index43 < tmp42_length ; index43++ ) {
                    TclObject tmp44 = TclList.index(interp, tmp42, index43);
                    try {
                        setVarScalar(interp, "str", tmp44, compiledLocals, 10);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "str");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: ... $str
                        TclObject[] objv45 = TJC.grabObjv(interp, 2);
                        TclObject tmp46;
                        try {
                            // Arg 0 constant: ...
                            objv45[0] = const5;
                            // Arg 1 variable: $str
                            tmp46 = getVarScalar(interp, "str", compiledLocals, 10);
                            tmp46.preserve();
                            objv45[1] = tmp46;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv45, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp46 = objv45[1];
                            if ( tmp46 != null ) {
                                tmp46.release();
                            }
                            TJC.releaseObjv(interp, objv45, 2);
                        }
                    } // End Invoke: ...
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp42 != null ) {
                    tmp42.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set "..." $types
            TclObject tmp47;
            String tmp48;
            StringBuffer sbtmp49 = new StringBuffer(64);
            tmp47 = getVarScalar(interp, "key", compiledLocals, 5);
            sbtmp49.append(tmp47.toString());
            sbtmp49.append(",types");
            tmp48 = sbtmp49.toString();
            tmp47 = getVarScalar(interp, "types", compiledLocals, 6);
            tmp47 = setVarArray(interp, "_compileproc_key_info", tmp48, tmp47, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set "..." $values
            TclObject tmp50;
            String tmp51;
            StringBuffer sbtmp52 = new StringBuffer(64);
            tmp50 = getVarScalar(interp, "key", compiledLocals, 5);
            sbtmp52.append(tmp50.toString());
            sbtmp52.append(",values");
            tmp51 = sbtmp52.toString();
            tmp50 = getVarScalar(interp, "values", compiledLocals, 8);
            tmp50 = setVarArray(interp, "_compileproc_key_info", tmp51, tmp50, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set "..." $instrs
            TclObject tmp53;
            String tmp54;
            StringBuffer sbtmp55 = new StringBuffer(64);
            tmp53 = getVarScalar(interp, "key", compiledLocals, 5);
            sbtmp55.append(tmp53.toString());
            sbtmp55.append(",instrs");
            tmp54 = sbtmp55.toString();
            tmp53 = getVarScalar(interp, "instrs", compiledLocals, 9);
            tmp53 = setVarArray(interp, "_compileproc_key_info", tmp54, tmp53, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set "..." $num_args
            TclObject tmp56;
            String tmp57;
            StringBuffer sbtmp58 = new StringBuffer(64);
            tmp56 = getVarScalar(interp, "key", compiledLocals, 5);
            sbtmp58.append(tmp56.toString());
            sbtmp58.append(",num_args");
            tmp57 = sbtmp58.toString();
            tmp56 = getVarScalar(interp, "num_args", compiledLocals, 4);
            tmp56 = setVarArray(interp, "_compileproc_key_info", tmp57, tmp56, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: return $key
            TclObject tmp59 = getVarScalar(interp, "key", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp59);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_generate_key");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_compileproc_key_info(generated)");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("constant");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_constant_cache_add");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "compileproc_constant_cache_add";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "cmdname",
        "argl",
        "inargl",
        "_compileproc_key_info",
        "num_args",
        "key",
        "types",
        "i",
        "values",
        "instrs",
        "str"
    };
} // end class CompileprocGenerateKeyCmd

