// TJC implementation of procedure _descend_commands_pop
package tjc;
import tcl.lang.*;

public class DescendCommandsPopCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 0);
        } // End Invoke: global
        { // Invoke: set l [...]
            TclObject tmp0;
            { // Invoke: lindex $... 0
                TclObject tmp1 = getVarArray(interp, "_descend", "commands_stack", compiledLocals, 0);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "l", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp2;
            { // Invoke: lrange $... 1 end
                TclObject[] objv3 = TJC.grabObjv(interp, 4);
                TclObject tmp4;
                try {
                    // Arg 0 constant: lrange
                    objv3[0] = const0;
                    // Arg 1 variable: $...
                    tmp4 = getVarArray(interp, "_descend", "commands_stack", compiledLocals, 0);
                    tmp4.preserve();
                    objv3[1] = tmp4;
                    // Arg 2 constant: 1
                    objv3[2] = const1;
                    // Arg 3 constant: end
                    objv3[3] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv3, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp4 = objv3[1];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 4);
                }
            } // End Invoke: lrange
            tmp2 = interp.getResult();
            setVarArray(interp, "_descend", "commands_stack", tmp2, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: return $l
            TclObject tmp5 = getVarScalar(interp, "l", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp5);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_descend_commands_pop");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("lrange");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("end");
        const2.preserve(); const2.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "lrange";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_descend",
        "l"
    };
} // end class DescendCommandsPopCmd

