// TJC implementation of procedure descend_container_catch_validate
package tjc;
import tcl.lang.*;

public class DescendContainerCatchValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp6;
            { // Invoke: llength $tree
                TclObject tmp7 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp8 = TclList.getLength(interp, tmp7);
                interp.setResult(tmp8);
            } // End Invoke: llength
            tmp6 = interp.getResult();
            setVarScalar(interp, "num_args", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () && ()
            // Binary operator: $num_args != 2
            TclObject tmp9 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp10 = evs0;
            TJC.exprInitValue(interp, tmp10, tmp9);
            ExprValue tmp11 = evs1;
            tmp11.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp10, tmp11);
            // End Binary operator: !=
            if (tmp10.getBooleanValue(interp)) {
            // Binary operator: $num_args != 3
            TclObject tmp12 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp13 = evs1;
            TJC.exprInitValue(interp, tmp13, tmp12);
            ExprValue tmp14 = evs2;
            tmp14.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp13, tmp14);
            // End Binary operator: !=
            tmp10.setIntValue(tmp13.getBooleanValue(interp));
            } else {
            tmp10.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp15 = ( tmp10.getIntValue() != 0 );
            if ( tmp15 ) {
                { // Invoke: set _descend($key,usage) 1
                    TclObject tmp16;
                    String tmp17;
                    StringBuffer sbtmp18 = new StringBuffer(64);
                    tmp16 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp18.append(tmp16.toString());
                    sbtmp18.append(",usage");
                    tmp17 = sbtmp18.toString();
                    setVarArray(interp, "_descend", tmp17, const3, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list numArgs "catch" $num_args "2 or 3"
                        TclObject tmp19 = TclList.newInstance();
                        TclObject tmp20;
                        try {
                            TclList.append(interp, tmp19, const4);
                            TclList.append(interp, tmp19, const5);
                            tmp20 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            TclList.append(interp, tmp19, tmp20);
                            TclList.append(interp, tmp19, const6);
                        } catch (TclException ex) {
                            tmp19.release();
                            throw ex;
                        }
                        interp.setResult(tmp19);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: ... $key 1
                TclObject[] objv21 = TJC.grabObjv(interp, 3);
                TclObject tmp22;
                try {
                    // Arg 0 constant: ...
                    objv21[0] = const7;
                    // Arg 1 variable: $key
                    tmp22 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp22.preserve();
                    objv21[1] = tmp22;
                    // Arg 2 constant: 1
                    objv21[2] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv21, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp22 = objv21[1];
                    if ( tmp22 != null ) {
                        tmp22.release();
                    }
                    TJC.releaseObjv(interp, objv21, 3);
                }
            } // End Invoke: ...
            TclObject tmp23 = interp.getResult();
            ExprValue tmp24 = evs0;
            TJC.exprInitValue(interp, tmp24, tmp23);
            boolean tmp25 = tmp24.getBooleanValue(interp);
            if ( tmp25 ) {
                { // Invoke: set "..." 1
                    TclObject tmp26;
                    String tmp27;
                    StringBuffer sbtmp28 = new StringBuffer(64);
                    tmp26 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp28.append(tmp26.toString());
                    sbtmp28.append(",static_container");
                    tmp27 = sbtmp28.toString();
                    setVarArray(interp, "_descend", tmp27, const3, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$num_args == 3} ... else ...
            // Binary operator: $num_args == 3
            TclObject tmp29 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp30 = evs0;
            TJC.exprInitValue(interp, tmp30, tmp29);
            ExprValue tmp31 = evs1;
            tmp31.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp30, tmp31);
            // End Binary operator: ==
            boolean tmp32 = ( tmp30.getIntValue() != 0 );
            if ( tmp32 ) {
                { // Invoke: set "..." [...]
                    TclObject tmp33;
                    String tmp35;
                    StringBuffer sbtmp36 = new StringBuffer(64);
                    tmp33 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp36.append(tmp33.toString());
                    sbtmp36.append(",validated");
                    tmp35 = sbtmp36.toString();
                    { // Invoke: list 1 2
                        TclObject tmp34 = TclList.newInstance();
                        try {
                            TclList.append(interp, tmp34, const3);
                            TclList.append(interp, tmp34, const8);
                        } catch (TclException ex) {
                            tmp34.release();
                            throw ex;
                        }
                        interp.setResult(tmp34);
                    } // End Invoke: list
                    tmp33 = interp.getResult();
                    tmp33 = setVarArray(interp, "_descend", tmp35, tmp33, compiledLocals, 1);
                } // End Invoke: set
            } else {
                { // Invoke: set "..." [...]
                    TclObject tmp37;
                    String tmp39;
                    StringBuffer sbtmp40 = new StringBuffer(64);
                    tmp37 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp40.append(tmp37.toString());
                    sbtmp40.append(",validated");
                    tmp39 = sbtmp40.toString();
                    { // Invoke: list 1 {}
                        TclObject tmp38 = TclList.newInstance();
                        try {
                            TclList.append(interp, tmp38, const3);
                            TclList.append(interp, tmp38, const9);
                        } catch (TclException ex) {
                            tmp38.release();
                            throw ex;
                        }
                        interp.setResult(tmp38);
                    } // End Invoke: list
                    tmp37 = interp.getResult();
                    tmp37 = setVarArray(interp, "_descend", tmp39, tmp37, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return "OK"
            interp.resetResult();
            interp.setResult(const10);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_catch_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("numArgs");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("catch");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("2 or 3");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_argument_body_is_static");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(2);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("OK");
        const10.preserve(); const10.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "num_args"
    };
} // end class DescendContainerCatchValidateCmd

