// TJC implementation of procedure descend_container_catch_variable
package tjc;
import tcl.lang.*;

public class DescendContainerCatchVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set validated [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key validated
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: validated
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "validated", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$validated == {}} ...
            // Binary operator: $validated == ""
            TclObject tmp3 = getVarScalar(interp, "validated", compiledLocals, 1);
            ExprValue tmp4 = evs0;
            TJC.exprEqualsEmptyString(tmp4, tmp3, false);
            // End Binary operator: ==
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error "not validated"
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const2;
                        // Arg 1 constant: "not validated"
                        objv6[1] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv6, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set index [...]
            TclObject tmp7;
            { // Invoke: lindex $validated 1
                TclObject tmp8 = getVarScalar(interp, "validated", compiledLocals, 1);
                tmp8 = TclList.index(interp, tmp8, 1);
                if ( tmp8 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp8);
                }
            } // End Invoke: lindex
            tmp7 = interp.getResult();
            setVarScalar(interp, "index", tmp7, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {$index == {}} ...
            // Binary operator: $index == ""
            TclObject tmp9 = getVarScalar(interp, "index", compiledLocals, 2);
            ExprValue tmp10 = evs0;
            TJC.exprEqualsEmptyString(tmp10, tmp9, false);
            // End Binary operator: ==
            boolean tmp11 = ( tmp10.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: error ...
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv12[0] = const2;
                        // Arg 1 constant: ...
                        objv12[1] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv12, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set script [...]
            TclObject tmp13;
            { // Invoke: descend_get_data $key script
                TclObject[] objv14 = TJC.grabObjv(interp, 3);
                TclObject tmp15;
                try {
                    // Arg 0 constant: descend_get_data
                    objv14[0] = const0;
                    // Arg 1 variable: $key
                    tmp15 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp15.preserve();
                    objv14[1] = tmp15;
                    // Arg 2 constant: script
                    objv14[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv14, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp15 = objv14[1];
                    if ( tmp15 != null ) {
                        tmp15.release();
                    }
                    TJC.releaseObjv(interp, objv14, 3);
                }
            } // End Invoke: descend_get_data
            tmp13 = interp.getResult();
            setVarScalar(interp, "script", tmp13, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp16;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv17 = TJC.grabObjv(interp, 3);
                TclObject tmp18;
                try {
                    // Arg 0 constant: descend_get_data
                    objv17[0] = const0;
                    // Arg 1 variable: $key
                    tmp18 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp18.preserve();
                    objv17[1] = tmp18;
                    // Arg 2 constant: tree
                    objv17[2] = const6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv17, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp18 = objv17[1];
                    if ( tmp18 != null ) {
                        tmp18.release();
                    }
                    TJC.releaseObjv(interp, objv17, 3);
                }
            } // End Invoke: descend_get_data
            tmp16 = interp.getResult();
            setVarScalar(interp, "tree", tmp16, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set subtree [...]
            TclObject tmp19;
            { // Invoke: lindex $tree $index
                TclObject tmp20 = null;
                TclObject tmp21;
                try {
                    tmp20 = getVarScalar(interp, "tree", compiledLocals, 4);
                    tmp20.preserve();
                    tmp21 = getVarScalar(interp, "index", compiledLocals, 2);
                    TJC.lindexNonconst(interp, tmp20, tmp21);
                } finally {
                    if ( tmp20 != null ) {
                        tmp20.release();
                    }
                }
            } // End Invoke: lindex
            tmp19 = interp.getResult();
            setVarScalar(interp, "subtree", tmp19, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: parse_is_simple_text $subtree
                TclObject[] objv22 = TJC.grabObjv(interp, 2);
                TclObject tmp23;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv22[0] = const7;
                    // Arg 1 variable: $subtree
                    tmp23 = getVarScalar(interp, "subtree", compiledLocals, 5);
                    tmp23.preserve();
                    objv22[1] = tmp23;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv22, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp23 = objv22[1];
                    if ( tmp23 != null ) {
                        tmp23.release();
                    }
                    TJC.releaseObjv(interp, objv22, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp24 = interp.getResult();
            ExprValue tmp25 = evs0;
            TJC.exprInitValue(interp, tmp25, tmp24);
            boolean tmp26 = tmp25.getBooleanValue(interp);
            if ( tmp26 ) {
                { // Invoke: return [...]
                    { // Invoke: list 1 [...]
                        TclObject tmp27 = TclList.newInstance();
                        TclObject tmp28;
                        try {
                            TclList.append(interp, tmp27, const8);
                            { // Invoke: ... $script $subtree "text"
                                TclObject[] objv29 = TJC.grabObjv(interp, 4);
                                TclObject tmp30;
                                try {
                                    // Arg 0 constant: ...
                                    objv29[0] = const9;
                                    // Arg 1 variable: $script
                                    tmp30 = getVarScalar(interp, "script", compiledLocals, 3);
                                    tmp30.preserve();
                                    objv29[1] = tmp30;
                                    // Arg 2 variable: $subtree
                                    tmp30 = getVarScalar(interp, "subtree", compiledLocals, 5);
                                    tmp30.preserve();
                                    objv29[2] = tmp30;
                                    // Arg 3 constant: "text"
                                    objv29[3] = const10;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv29, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp30 = objv29[1];
                                    if ( tmp30 != null ) {
                                        tmp30.release();
                                    }
                                    tmp30 = objv29[2];
                                    if ( tmp30 != null ) {
                                        tmp30.release();
                                    }
                                    TJC.releaseObjv(interp, objv29, 4);
                                }
                            } // End Invoke: ...
                            tmp28 = interp.getResult();
                            TclList.append(interp, tmp27, tmp28);
                        } catch (TclException ex) {
                            tmp27.release();
                            throw ex;
                        }
                        interp.setResult(tmp27);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return {0 {}}
                    interp.resetResult();
                    interp.setResult(const11);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_catch_variable");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("validated");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("not validated");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("no variable argument");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("script");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("tree");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("parse_is_simple_text");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(1);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("parse_get_simple_text");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("text");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("0 {}");
        const11.preserve(); const11.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 4: {
                cmdName = "parse_get_simple_text";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "validated",
        "index",
        "script",
        "tree",
        "subtree"
    };
} // end class DescendContainerCatchVariableCmd

