// TJC implementation of procedure descend_container_for
package tjc;
import tcl.lang.*;

public class DescendContainerForCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set result [...]
            TclObject tmp6;
            { // Invoke: ... $key
                TclObject[] objv7 = TJC.grabObjv(interp, 2);
                TclObject tmp8;
                try {
                    // Arg 0 constant: ...
                    objv7[0] = const3;
                    // Arg 1 variable: $key
                    tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp8.preserve();
                    objv7[1] = tmp8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv7, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp8 = objv7[1];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 2);
                }
            } // End Invoke: ...
            tmp6 = interp.getResult();
            setVarScalar(interp, "result", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$result != "OK"} ...
            // Binary operator: $result != "OK"
            TclObject tmp9 = getVarScalar(interp, "result", compiledLocals, 4);
            boolean tmp10 = ! tmp9.toString().equals("OK");
            ExprValue tmp11 = evs0;
            tmp11.setIntValue(tmp10);
            // End Binary operator: !=
            boolean tmp12 = ( tmp11.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: if ... ...
                    { // Invoke: descend_get_data $key usage
                        TclObject[] objv13 = TJC.grabObjv(interp, 3);
                        TclObject tmp14;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv13[0] = const0;
                            // Arg 1 variable: $key
                            tmp14 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp14.preserve();
                            objv13[1] = tmp14;
                            // Arg 2 constant: usage
                            objv13[2] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv13, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp14 = objv13[1];
                            if ( tmp14 != null ) {
                                tmp14.release();
                            }
                            TJC.releaseObjv(interp, objv13, 3);
                        }
                    } // End Invoke: descend_get_data
                    TclObject tmp15 = interp.getResult();
                    ExprValue tmp16 = evs0;
                    TJC.exprInitValue(interp, tmp16, tmp15);
                    boolean tmp17 = tmp16.getBooleanValue(interp);
                    if ( tmp17 ) {
                        { // Invoke: descend_report_usage $key $result
                            TclObject[] objv18 = TJC.grabObjv(interp, 3);
                            TclObject tmp19;
                            try {
                                // Arg 0 constant: descend_report_usage
                                objv18[0] = const5;
                                // Arg 1 variable: $key
                                tmp19 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp19.preserve();
                                objv18[1] = tmp19;
                                // Arg 2 variable: $result
                                tmp19 = getVarScalar(interp, "result", compiledLocals, 4);
                                tmp19.preserve();
                                objv18[2] = tmp19;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv18, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp19 = objv18[1];
                                if ( tmp19 != null ) {
                                    tmp19.release();
                                }
                                tmp19 = objv18[2];
                                if ( tmp19 != null ) {
                                    tmp19.release();
                                }
                                TJC.releaseObjv(interp, objv18, 3);
                            }
                        } // End Invoke: descend_report_usage
                    }
                } // End Invoke: if
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set container_commands [...]
            TclObject tmp20;
            { // Invoke: list
                TclObject tmp21 = TclList.newInstance();
                interp.setResult(tmp21);
            } // End Invoke: list
            tmp20 = interp.getResult();
            setVarScalar(interp, "container_commands", tmp20, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set body_index [...]
            TclObject tmp22;
            { // Invoke: ... $key
                TclObject[] objv23 = TJC.grabObjv(interp, 2);
                TclObject tmp24;
                try {
                    // Arg 0 constant: ...
                    objv23[0] = const6;
                    // Arg 1 variable: $key
                    tmp24 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp24.preserve();
                    objv23[1] = tmp24;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv23, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp24 = objv23[1];
                    if ( tmp24 != null ) {
                        tmp24.release();
                    }
                    TJC.releaseObjv(interp, objv23, 2);
                }
            } // End Invoke: ...
            tmp22 = interp.getResult();
            setVarScalar(interp, "body_index", tmp22, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: ... $key $body_index
                TclObject[] objv25 = TJC.grabObjv(interp, 3);
                TclObject tmp26;
                try {
                    // Arg 0 constant: ...
                    objv25[0] = const7;
                    // Arg 1 variable: $key
                    tmp26 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp26.preserve();
                    objv25[1] = tmp26;
                    // Arg 2 variable: $body_index
                    tmp26 = getVarScalar(interp, "body_index", compiledLocals, 6);
                    tmp26.preserve();
                    objv25[2] = tmp26;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv25, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp26 = objv25[1];
                    if ( tmp26 != null ) {
                        tmp26.release();
                    }
                    tmp26 = objv25[2];
                    if ( tmp26 != null ) {
                        tmp26.release();
                    }
                    TJC.releaseObjv(interp, objv25, 3);
                }
            } // End Invoke: ...
            TclObject tmp27 = interp.getResult();
            ExprValue tmp28 = evs0;
            TJC.exprInitValue(interp, tmp28, tmp27);
            boolean tmp29 = tmp28.getBooleanValue(interp);
            if ( tmp29 ) {
                { // Invoke: ...
                    TclObject[] objv30 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv30[0] = const8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv30, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv30, 1);
                    }
                } // End Invoke: ...
                { // Invoke: ... $key $script $tree $body_index
                    TclObject[] objv31 = TJC.grabObjv(interp, 5);
                    TclObject tmp32;
                    try {
                        // Arg 0 constant: ...
                        objv31[0] = const9;
                        // Arg 1 variable: $key
                        tmp32 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp32.preserve();
                        objv31[1] = tmp32;
                        // Arg 2 variable: $script
                        tmp32 = getVarScalar(interp, "script", compiledLocals, 2);
                        tmp32.preserve();
                        objv31[2] = tmp32;
                        // Arg 3 variable: $tree
                        tmp32 = getVarScalar(interp, "tree", compiledLocals, 3);
                        tmp32.preserve();
                        objv31[3] = tmp32;
                        // Arg 4 variable: $body_index
                        tmp32 = getVarScalar(interp, "body_index", compiledLocals, 6);
                        tmp32.preserve();
                        objv31[4] = tmp32;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv31, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        tmp32 = objv31[1];
                        if ( tmp32 != null ) {
                            tmp32.release();
                        }
                        tmp32 = objv31[2];
                        if ( tmp32 != null ) {
                            tmp32.release();
                        }
                        tmp32 = objv31[3];
                        if ( tmp32 != null ) {
                            tmp32.release();
                        }
                        tmp32 = objv31[4];
                        if ( tmp32 != null ) {
                            tmp32.release();
                        }
                        TJC.releaseObjv(interp, objv31, 5);
                    }
                } // End Invoke: ...
                { // Invoke: lappend container_commands [...]
                    TclObject[] objv33 = TJC.grabObjv(interp, 1);
                    TclObject tmp34;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv35 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv35[0] = const10;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv35, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv35, 1);
                            }
                        } // End Invoke: ...
                        tmp34 = interp.getResult();
                        tmp34.preserve();
                        objv33[0] = tmp34;
                        interp.resetResult();
                        lappendVarScalar(interp, "container_commands", objv33, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv33, 1);
                    }
                } // End Invoke: lappend
            } else {
                { // Invoke: lappend container_commands {}
                    TclObject[] objv36 = TJC.grabObjv(interp, 1);
                    TclObject tmp37;
                    try {
                        // Arg 2 constant: {}
                        objv36[0] = const11;
                        interp.resetResult();
                        lappendVarScalar(interp, "container_commands", objv36, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjv(interp, objv36, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: ...
            TclObject[] objv38 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: ...
                objv38[0] = const8;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                    ? cmdcache6.cmd : null), objv38, 0);
                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                    updateCmdCache(interp, 6);
                }
            } finally {
                TJC.releaseObjv(interp, objv38, 1);
            }
        } // End Invoke: ...
        { // Invoke: set expr_index [...]
            TclObject tmp39;
            { // Invoke: ... $key
                TclObject[] objv40 = TJC.grabObjv(interp, 2);
                TclObject tmp41;
                try {
                    // Arg 0 constant: ...
                    objv40[0] = const12;
                    // Arg 1 variable: $key
                    tmp41 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp41.preserve();
                    objv40[1] = tmp41;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                        ? cmdcache9.cmd : null), objv40, 0);
                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                        updateCmdCache(interp, 9);
                    }
                } finally {
                    tmp41 = objv40[1];
                    if ( tmp41 != null ) {
                        tmp41.release();
                    }
                    TJC.releaseObjv(interp, objv40, 2);
                }
            } // End Invoke: ...
            tmp39 = interp.getResult();
            setVarScalar(interp, "expr_index", tmp39, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: ... $key $expr_index
            TclObject[] objv42 = TJC.grabObjv(interp, 3);
            TclObject tmp43;
            try {
                // Arg 0 constant: ...
                objv42[0] = const13;
                // Arg 1 variable: $key
                tmp43 = getVarScalar(interp, "key", compiledLocals, 0);
                tmp43.preserve();
                objv42[1] = tmp43;
                // Arg 2 variable: $expr_index
                tmp43 = getVarScalar(interp, "expr_index", compiledLocals, 7);
                tmp43.preserve();
                objv42[2] = tmp43;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                    ? cmdcache10.cmd : null), objv42, 0);
                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                    updateCmdCache(interp, 10);
                }
            } finally {
                tmp43 = objv42[1];
                if ( tmp43 != null ) {
                    tmp43.release();
                }
                tmp43 = objv42[2];
                if ( tmp43 != null ) {
                    tmp43.release();
                }
                TJC.releaseObjv(interp, objv42, 3);
            }
        } // End Invoke: ...
        { // Invoke: lappend container_commands [...]
            TclObject[] objv44 = TJC.grabObjv(interp, 1);
            TclObject tmp45;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv46 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv46[0] = const10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                            ? cmdcache8.cmd : null), objv46, 0);
                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                            updateCmdCache(interp, 8);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv46, 1);
                    }
                } // End Invoke: ...
                tmp45 = interp.getResult();
                tmp45.preserve();
                objv44[0] = tmp45;
                interp.resetResult();
                lappendVarScalar(interp, "container_commands", objv44, compiledLocals, 5);
            } finally {
                TJC.releaseObjvElems(interp, objv44, 1);
            }
        } // End Invoke: lappend
        { // Invoke: set body_index [...]
            TclObject tmp47;
            { // Invoke: ... $key
                TclObject[] objv48 = TJC.grabObjv(interp, 2);
                TclObject tmp49;
                try {
                    // Arg 0 constant: ...
                    objv48[0] = const14;
                    // Arg 1 variable: $key
                    tmp49 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp49.preserve();
                    objv48[1] = tmp49;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                        ? cmdcache11.cmd : null), objv48, 0);
                    if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                        updateCmdCache(interp, 11);
                    }
                } finally {
                    tmp49 = objv48[1];
                    if ( tmp49 != null ) {
                        tmp49.release();
                    }
                    TJC.releaseObjv(interp, objv48, 2);
                }
            } // End Invoke: ...
            tmp47 = interp.getResult();
            setVarScalar(interp, "body_index", tmp47, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: ... $key $body_index
                TclObject[] objv50 = TJC.grabObjv(interp, 3);
                TclObject tmp51;
                try {
                    // Arg 0 constant: ...
                    objv50[0] = const7;
                    // Arg 1 variable: $key
                    tmp51 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp51.preserve();
                    objv50[1] = tmp51;
                    // Arg 2 variable: $body_index
                    tmp51 = getVarScalar(interp, "body_index", compiledLocals, 6);
                    tmp51.preserve();
                    objv50[2] = tmp51;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv50, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp51 = objv50[1];
                    if ( tmp51 != null ) {
                        tmp51.release();
                    }
                    tmp51 = objv50[2];
                    if ( tmp51 != null ) {
                        tmp51.release();
                    }
                    TJC.releaseObjv(interp, objv50, 3);
                }
            } // End Invoke: ...
            TclObject tmp52 = interp.getResult();
            ExprValue tmp53 = evs0;
            TJC.exprInitValue(interp, tmp53, tmp52);
            boolean tmp54 = tmp53.getBooleanValue(interp);
            if ( tmp54 ) {
                { // Invoke: ...
                    TclObject[] objv55 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv55[0] = const8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv55, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv55, 1);
                    }
                } // End Invoke: ...
                { // Invoke: ... $key $script $tree $body_index
                    TclObject[] objv56 = TJC.grabObjv(interp, 5);
                    TclObject tmp57;
                    try {
                        // Arg 0 constant: ...
                        objv56[0] = const9;
                        // Arg 1 variable: $key
                        tmp57 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp57.preserve();
                        objv56[1] = tmp57;
                        // Arg 2 variable: $script
                        tmp57 = getVarScalar(interp, "script", compiledLocals, 2);
                        tmp57.preserve();
                        objv56[2] = tmp57;
                        // Arg 3 variable: $tree
                        tmp57 = getVarScalar(interp, "tree", compiledLocals, 3);
                        tmp57.preserve();
                        objv56[3] = tmp57;
                        // Arg 4 variable: $body_index
                        tmp57 = getVarScalar(interp, "body_index", compiledLocals, 6);
                        tmp57.preserve();
                        objv56[4] = tmp57;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv56, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        tmp57 = objv56[1];
                        if ( tmp57 != null ) {
                            tmp57.release();
                        }
                        tmp57 = objv56[2];
                        if ( tmp57 != null ) {
                            tmp57.release();
                        }
                        tmp57 = objv56[3];
                        if ( tmp57 != null ) {
                            tmp57.release();
                        }
                        tmp57 = objv56[4];
                        if ( tmp57 != null ) {
                            tmp57.release();
                        }
                        TJC.releaseObjv(interp, objv56, 5);
                    }
                } // End Invoke: ...
                { // Invoke: lappend container_commands [...]
                    TclObject[] objv58 = TJC.grabObjv(interp, 1);
                    TclObject tmp59;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv60 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv60[0] = const10;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv60, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv60, 1);
                            }
                        } // End Invoke: ...
                        tmp59 = interp.getResult();
                        tmp59.preserve();
                        objv58[0] = tmp59;
                        interp.resetResult();
                        lappendVarScalar(interp, "container_commands", objv58, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv58, 1);
                    }
                } // End Invoke: lappend
            } else {
                { // Invoke: lappend container_commands {}
                    TclObject[] objv61 = TJC.grabObjv(interp, 1);
                    TclObject tmp62;
                    try {
                        // Arg 2 constant: {}
                        objv61[0] = const11;
                        interp.resetResult();
                        lappendVarScalar(interp, "container_commands", objv61, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjv(interp, objv61, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: set body_index [...]
            TclObject tmp63;
            { // Invoke: ... $key
                TclObject[] objv64 = TJC.grabObjv(interp, 2);
                TclObject tmp65;
                try {
                    // Arg 0 constant: ...
                    objv64[0] = const15;
                    // Arg 1 variable: $key
                    tmp65 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp65.preserve();
                    objv64[1] = tmp65;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                        ? cmdcache12.cmd : null), objv64, 0);
                    if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                        updateCmdCache(interp, 12);
                    }
                } finally {
                    tmp65 = objv64[1];
                    if ( tmp65 != null ) {
                        tmp65.release();
                    }
                    TJC.releaseObjv(interp, objv64, 2);
                }
            } // End Invoke: ...
            tmp63 = interp.getResult();
            setVarScalar(interp, "body_index", tmp63, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ...
            { // Invoke: ... $key $body_index
                TclObject[] objv66 = TJC.grabObjv(interp, 3);
                TclObject tmp67;
                try {
                    // Arg 0 constant: ...
                    objv66[0] = const7;
                    // Arg 1 variable: $key
                    tmp67 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp67.preserve();
                    objv66[1] = tmp67;
                    // Arg 2 variable: $body_index
                    tmp67 = getVarScalar(interp, "body_index", compiledLocals, 6);
                    tmp67.preserve();
                    objv66[2] = tmp67;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv66, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp67 = objv66[1];
                    if ( tmp67 != null ) {
                        tmp67.release();
                    }
                    tmp67 = objv66[2];
                    if ( tmp67 != null ) {
                        tmp67.release();
                    }
                    TJC.releaseObjv(interp, objv66, 3);
                }
            } // End Invoke: ...
            TclObject tmp68 = interp.getResult();
            ExprValue tmp69 = evs0;
            TJC.exprInitValue(interp, tmp69, tmp68);
            boolean tmp70 = tmp69.getBooleanValue(interp);
            if ( tmp70 ) {
                { // Invoke: ...
                    TclObject[] objv71 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv71[0] = const8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv71, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv71, 1);
                    }
                } // End Invoke: ...
                { // Invoke: ... $key $script $tree $body_index
                    TclObject[] objv72 = TJC.grabObjv(interp, 5);
                    TclObject tmp73;
                    try {
                        // Arg 0 constant: ...
                        objv72[0] = const9;
                        // Arg 1 variable: $key
                        tmp73 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp73.preserve();
                        objv72[1] = tmp73;
                        // Arg 2 variable: $script
                        tmp73 = getVarScalar(interp, "script", compiledLocals, 2);
                        tmp73.preserve();
                        objv72[2] = tmp73;
                        // Arg 3 variable: $tree
                        tmp73 = getVarScalar(interp, "tree", compiledLocals, 3);
                        tmp73.preserve();
                        objv72[3] = tmp73;
                        // Arg 4 variable: $body_index
                        tmp73 = getVarScalar(interp, "body_index", compiledLocals, 6);
                        tmp73.preserve();
                        objv72[4] = tmp73;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv72, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        tmp73 = objv72[1];
                        if ( tmp73 != null ) {
                            tmp73.release();
                        }
                        tmp73 = objv72[2];
                        if ( tmp73 != null ) {
                            tmp73.release();
                        }
                        tmp73 = objv72[3];
                        if ( tmp73 != null ) {
                            tmp73.release();
                        }
                        tmp73 = objv72[4];
                        if ( tmp73 != null ) {
                            tmp73.release();
                        }
                        TJC.releaseObjv(interp, objv72, 5);
                    }
                } // End Invoke: ...
                { // Invoke: lappend container_commands [...]
                    TclObject[] objv74 = TJC.grabObjv(interp, 1);
                    TclObject tmp75;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv76 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv76[0] = const10;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv76, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv76, 1);
                            }
                        } // End Invoke: ...
                        tmp75 = interp.getResult();
                        tmp75.preserve();
                        objv74[0] = tmp75;
                        interp.resetResult();
                        lappendVarScalar(interp, "container_commands", objv74, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv74, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: set "..." $container_commands
            TclObject tmp77;
            String tmp78;
            StringBuffer sbtmp79 = new StringBuffer(64);
            tmp77 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp79.append(tmp77.toString());
            sbtmp79.append(",container_commands");
            tmp78 = sbtmp79.toString();
            tmp77 = getVarScalar(interp, "container_commands", compiledLocals, 5);
            tmp77 = setVarArray(interp, "_descend", tmp78, tmp77, compiledLocals, 1);
            interp.setResult(tmp77);
        } // End Invoke: set
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_for");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_container_for_validate");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("usage");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_report_usage");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_container_for_start");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_argument_body_is_static");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("_descend_commands_push");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("descend_container_body_argument");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("_descend_commands_pop");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("descend_container_for_expr");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("descend_container_expr_argument");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("descend_container_for_next");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("descend_container_for_body");
        const15.preserve(); const15.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "descend_container_for_validate";
                break;
            }
            case 3: {
                cmdName = "descend_report_usage";
                break;
            }
            case 4: {
                cmdName = "descend_container_for_start";
                break;
            }
            case 5: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            case 6: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 7: {
                cmdName = "descend_container_body_argument";
                break;
            }
            case 8: {
                cmdName = "_descend_commands_pop";
                break;
            }
            case 9: {
                cmdName = "descend_container_for_expr";
                break;
            }
            case 10: {
                cmdName = "descend_container_expr_argument";
                break;
            }
            case 11: {
                cmdName = "descend_container_for_next";
                break;
            }
            case 12: {
                cmdName = "descend_container_for_body";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "result",
        "container_commands",
        "body_index",
        "expr_index"
    };
} // end class DescendContainerForCmd

