// TJC implementation of procedure descend_container_foreach
package tjc;
import tcl.lang.*;

public class DescendContainerForeachCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set result [...]
            TclObject tmp6;
            { // Invoke: ... $key
                TclObject[] objv7 = TJC.grabObjv(interp, 2);
                TclObject tmp8;
                try {
                    // Arg 0 constant: ...
                    objv7[0] = const3;
                    // Arg 1 variable: $key
                    tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp8.preserve();
                    objv7[1] = tmp8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv7, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp8 = objv7[1];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 2);
                }
            } // End Invoke: ...
            tmp6 = interp.getResult();
            setVarScalar(interp, "result", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$result != "OK"} ...
            // Binary operator: $result != "OK"
            TclObject tmp9 = getVarScalar(interp, "result", compiledLocals, 4);
            boolean tmp10 = ! tmp9.toString().equals("OK");
            ExprValue tmp11 = evs0;
            tmp11.setIntValue(tmp10);
            // End Binary operator: !=
            boolean tmp12 = ( tmp11.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: if ... ...
                    { // Invoke: descend_get_data $key usage
                        TclObject[] objv13 = TJC.grabObjv(interp, 3);
                        TclObject tmp14;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv13[0] = const0;
                            // Arg 1 variable: $key
                            tmp14 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp14.preserve();
                            objv13[1] = tmp14;
                            // Arg 2 constant: usage
                            objv13[2] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv13, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp14 = objv13[1];
                            if ( tmp14 != null ) {
                                tmp14.release();
                            }
                            TJC.releaseObjv(interp, objv13, 3);
                        }
                    } // End Invoke: descend_get_data
                    TclObject tmp15 = interp.getResult();
                    ExprValue tmp16 = evs0;
                    TJC.exprInitValue(interp, tmp16, tmp15);
                    boolean tmp17 = tmp16.getBooleanValue(interp);
                    if ( tmp17 ) {
                        { // Invoke: descend_report_usage $key $result
                            TclObject[] objv18 = TJC.grabObjv(interp, 3);
                            TclObject tmp19;
                            try {
                                // Arg 0 constant: descend_report_usage
                                objv18[0] = const5;
                                // Arg 1 variable: $key
                                tmp19 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp19.preserve();
                                objv18[1] = tmp19;
                                // Arg 2 variable: $result
                                tmp19 = getVarScalar(interp, "result", compiledLocals, 4);
                                tmp19.preserve();
                                objv18[2] = tmp19;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv18, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp19 = objv18[1];
                                if ( tmp19 != null ) {
                                    tmp19.release();
                                }
                                tmp19 = objv18[2];
                                if ( tmp19 != null ) {
                                    tmp19.release();
                                }
                                TJC.releaseObjv(interp, objv18, 3);
                            }
                        } // End Invoke: descend_report_usage
                    }
                } // End Invoke: if
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            { // Invoke: ... $key
                TclObject[] objv20 = TJC.grabObjv(interp, 2);
                TclObject tmp21;
                try {
                    // Arg 0 constant: ...
                    objv20[0] = const6;
                    // Arg 1 variable: $key
                    tmp21 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp21.preserve();
                    objv20[1] = tmp21;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv20, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp21 = objv20[1];
                    if ( tmp21 != null ) {
                        tmp21.release();
                    }
                    TJC.releaseObjv(interp, objv20, 2);
                }
            } // End Invoke: ...
            TclObject tmp22 = interp.getResult();
            ExprValue tmp23 = evs0;
            TJC.exprInitValue(interp, tmp23, tmp22);
            boolean tmp24 = tmp23.getBooleanValue(interp);
            if ( tmp24 ) {
                { // Invoke: if ... ... else ...
                    { // Invoke: ... $key
                        TclObject[] objv25 = TJC.grabObjv(interp, 2);
                        TclObject tmp26;
                        try {
                            // Arg 0 constant: ...
                            objv25[0] = const7;
                            // Arg 1 variable: $key
                            tmp26 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp26.preserve();
                            objv25[1] = tmp26;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv25, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp26 = objv25[1];
                            if ( tmp26 != null ) {
                                tmp26.release();
                            }
                            TJC.releaseObjv(interp, objv25, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp27 = interp.getResult();
                    ExprValue tmp28 = evs0;
                    TJC.exprInitValue(interp, tmp28, tmp27);
                    boolean tmp29 = tmp28.getBooleanValue(interp);
                    if ( tmp29 ) {
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: set body_index [...]
            TclObject tmp30;
            { // Invoke: ... $key
                TclObject[] objv31 = TJC.grabObjv(interp, 2);
                TclObject tmp32;
                try {
                    // Arg 0 constant: ...
                    objv31[0] = const8;
                    // Arg 1 variable: $key
                    tmp32 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp32.preserve();
                    objv31[1] = tmp32;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv31, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    tmp32 = objv31[1];
                    if ( tmp32 != null ) {
                        tmp32.release();
                    }
                    TJC.releaseObjv(interp, objv31, 2);
                }
            } // End Invoke: ...
            tmp30 = interp.getResult();
            setVarScalar(interp, "body_index", tmp30, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: ... $key $body_index
                TclObject[] objv33 = TJC.grabObjv(interp, 3);
                TclObject tmp34;
                try {
                    // Arg 0 constant: ...
                    objv33[0] = const9;
                    // Arg 1 variable: $key
                    tmp34 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp34.preserve();
                    objv33[1] = tmp34;
                    // Arg 2 variable: $body_index
                    tmp34 = getVarScalar(interp, "body_index", compiledLocals, 5);
                    tmp34.preserve();
                    objv33[2] = tmp34;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv33, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    tmp34 = objv33[1];
                    if ( tmp34 != null ) {
                        tmp34.release();
                    }
                    tmp34 = objv33[2];
                    if ( tmp34 != null ) {
                        tmp34.release();
                    }
                    TJC.releaseObjv(interp, objv33, 3);
                }
            } // End Invoke: ...
            TclObject tmp35 = interp.getResult();
            ExprValue tmp36 = evs0;
            TJC.exprInitValue(interp, tmp36, tmp35);
            boolean tmp37 = tmp36.getBooleanValue(interp);
            if ( tmp37 ) {
                { // Invoke: ...
                    TclObject[] objv38 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv38[0] = const10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                            ? cmdcache8.cmd : null), objv38, 0);
                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                            updateCmdCache(interp, 8);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv38, 1);
                    }
                } // End Invoke: ...
                { // Invoke: ... $key $script $tree $body_index
                    TclObject[] objv39 = TJC.grabObjv(interp, 5);
                    TclObject tmp40;
                    try {
                        // Arg 0 constant: ...
                        objv39[0] = const11;
                        // Arg 1 variable: $key
                        tmp40 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp40.preserve();
                        objv39[1] = tmp40;
                        // Arg 2 variable: $script
                        tmp40 = getVarScalar(interp, "script", compiledLocals, 2);
                        tmp40.preserve();
                        objv39[2] = tmp40;
                        // Arg 3 variable: $tree
                        tmp40 = getVarScalar(interp, "tree", compiledLocals, 3);
                        tmp40.preserve();
                        objv39[3] = tmp40;
                        // Arg 4 variable: $body_index
                        tmp40 = getVarScalar(interp, "body_index", compiledLocals, 5);
                        tmp40.preserve();
                        objv39[4] = tmp40;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                            ? cmdcache9.cmd : null), objv39, 0);
                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                            updateCmdCache(interp, 9);
                        }
                    } finally {
                        tmp40 = objv39[1];
                        if ( tmp40 != null ) {
                            tmp40.release();
                        }
                        tmp40 = objv39[2];
                        if ( tmp40 != null ) {
                            tmp40.release();
                        }
                        tmp40 = objv39[3];
                        if ( tmp40 != null ) {
                            tmp40.release();
                        }
                        tmp40 = objv39[4];
                        if ( tmp40 != null ) {
                            tmp40.release();
                        }
                        TJC.releaseObjv(interp, objv39, 5);
                    }
                } // End Invoke: ...
                { // Invoke: set "..." [...]
                    TclObject tmp41;
                    String tmp43;
                    StringBuffer sbtmp44 = new StringBuffer(64);
                    tmp41 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp44.append(tmp41.toString());
                    sbtmp44.append(",container_commands");
                    tmp43 = sbtmp44.toString();
                    { // Invoke: ...
                        TclObject[] objv42 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv42[0] = const12;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                ? cmdcache10.cmd : null), objv42, 0);
                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                updateCmdCache(interp, 10);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv42, 1);
                        }
                    } // End Invoke: ...
                    tmp41 = interp.getResult();
                    tmp41 = setVarArray(interp, "_descend", tmp43, tmp41, compiledLocals, 1);
                    interp.setResult(tmp41);
                } // End Invoke: set
            } else {
                { // Invoke: set "..." {}
                    TclObject tmp45;
                    String tmp46;
                    StringBuffer sbtmp47 = new StringBuffer(64);
                    tmp45 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp47.append(tmp45.toString());
                    sbtmp47.append(",container_commands");
                    tmp46 = sbtmp47.toString();
                    tmp45 = setVarArray(interp, "_descend", tmp46, const13, compiledLocals, 1);
                    interp.setResult(tmp45);
                } // End Invoke: set
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_foreach");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_container_foreach_validate");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("usage");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_report_usage");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_container_foreach_has_single_list");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_foreach_has_single_variable");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_container_foreach_body");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("descend_container_argument_body_is_static");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("_descend_commands_push");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("descend_container_body_argument");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("_descend_commands_pop");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "descend_container_foreach_validate";
                break;
            }
            case 3: {
                cmdName = "descend_report_usage";
                break;
            }
            case 4: {
                cmdName = "descend_container_foreach_has_single_list";
                break;
            }
            case 5: {
                cmdName = "descend_container_foreach_has_single_variable";
                break;
            }
            case 6: {
                cmdName = "descend_container_foreach_body";
                break;
            }
            case 7: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            case 8: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 9: {
                cmdName = "descend_container_body_argument";
                break;
            }
            case 10: {
                cmdName = "_descend_commands_pop";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "result",
        "body_index"
    };
} // end class DescendContainerForeachCmd

