// TJC implementation of procedure descend_container_if_validate
package tjc;
import tcl.lang.*;

public class DescendContainerIfValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 16, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set indexes_expr_body [...]
            TclObject tmp6;
            { // Invoke: list
                TclObject tmp7 = TclList.newInstance();
                interp.setResult(tmp7);
            } // End Invoke: list
            tmp6 = interp.getResult();
            setVarScalar(interp, "indexes_expr_body", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set indexes_elseif_body [...]
            TclObject tmp8;
            { // Invoke: list
                TclObject tmp9 = TclList.newInstance();
                interp.setResult(tmp9);
            } // End Invoke: list
            tmp8 = interp.getResult();
            setVarScalar(interp, "indexes_elseif_body", tmp8, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set indexes_else_body [...]
            TclObject tmp10;
            { // Invoke: list
                TclObject tmp11 = TclList.newInstance();
                interp.setResult(tmp11);
            } // End Invoke: list
            tmp10 = interp.getResult();
            setVarScalar(interp, "indexes_else_body", tmp10, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set "..." {}
            TclObject tmp12;
            String tmp13;
            StringBuffer sbtmp14 = new StringBuffer(64);
            tmp12 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp14.append(tmp12.toString());
            sbtmp14.append(",validated");
            tmp13 = sbtmp14.toString();
            setVarArray(interp, "_descend", tmp13, const3, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set i 1
            setVarScalar(interp, "i", const4, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set argc [...]
            TclObject tmp15;
            { // Invoke: llength $tree
                TclObject tmp16 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp17 = TclList.getLength(interp, tmp16);
                interp.setResult(tmp17);
            } // End Invoke: llength
            tmp15 = interp.getResult();
            setVarScalar(interp, "argc", tmp15, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set clause "if"
            setVarScalar(interp, "clause", const5, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set keywordNeeded 0
            setVarScalar(interp, "keywordNeeded", const6, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set static 1
            setVarScalar(interp, "static", const4, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: while {1} ...
            for ( ; true ; ) {
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: if {$i >= $argc} ...
                    // Binary operator: $i >= $argc
                    TclObject tmp18 = getVarScalar(interp, "i", compiledLocals, 7);
                    ExprValue tmp19 = evs0;
                    TJC.exprInitValue(interp, tmp19, tmp18);
                    TclObject tmp20 = getVarScalar(interp, "argc", compiledLocals, 8);
                    ExprValue tmp21 = evs1;
                    TJC.exprInitValue(interp, tmp21, tmp20);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp19, tmp21);
                    // End Binary operator: >=
                    boolean tmp22 = ( tmp19.getIntValue() != 0 );
                    if ( tmp22 ) {
                        { // Invoke: set word [...]
                            TclObject tmp23;
                            { // Invoke: lindex [...] 1
                                { // Invoke: lindex $tree [...]
                                    TclObject tmp25 = null;
                                    TclObject tmp26;
                                    try {
                                        tmp25 = getVarScalar(interp, "tree", compiledLocals, 3);
                                        tmp25.preserve();
                                        { // Invoke: expr {$i - 1}
                                            // Binary operator: $i - 1
                                            TclObject tmp27 = getVarScalar(interp, "i", compiledLocals, 7);
                                            ExprValue tmp28 = evs0;
                                            TJC.exprInitValue(interp, tmp28, tmp27);
                                            ExprValue tmp29 = evs1;
                                            tmp29.setIntValue(1);
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp28, tmp29);
                                            // End Binary operator: -
                                            TJC.exprSetResult(interp, tmp28);
                                        } // End Invoke: expr
                                        tmp26 = interp.getResult();
                                        TJC.lindexNonconst(interp, tmp25, tmp26);
                                    } finally {
                                        if ( tmp25 != null ) {
                                            tmp25.release();
                                        }
                                    }
                                } // End Invoke: lindex
                                TclObject tmp24 = interp.getResult();
                                tmp24 = TclList.index(interp, tmp24, 1);
                                if ( tmp24 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp24);
                                }
                            } // End Invoke: lindex
                            tmp23 = interp.getResult();
                            setVarScalar(interp, "word", tmp23, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: set end [...]
                            TclObject tmp30;
                            { // Invoke: expr ...
                                // Binary operator: [...] + [...]
                                { // Invoke: lindex $word 0
                                    TclObject tmp31 = getVarScalar(interp, "word", compiledLocals, 12);
                                    tmp31 = TclList.index(interp, tmp31, 0);
                                    if ( tmp31 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp31);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp32 = interp.getResult();
                                ExprValue tmp33 = evs0;
                                TJC.exprInitValue(interp, tmp33, tmp32);
                                { // Invoke: lindex $word 1
                                    TclObject tmp34 = getVarScalar(interp, "word", compiledLocals, 12);
                                    tmp34 = TclList.index(interp, tmp34, 1);
                                    if ( tmp34 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp34);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp35 = interp.getResult();
                                ExprValue tmp36 = evs1;
                                TJC.exprInitValue(interp, tmp36, tmp35);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp33, tmp36);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp33);
                            } // End Invoke: expr
                            tmp30 = interp.getResult();
                            setVarScalar(interp, "end", tmp30, compiledLocals, 13);
                        } // End Invoke: set
                        { // Invoke: set _descend($key,usage) 1
                            TclObject tmp37;
                            String tmp38;
                            StringBuffer sbtmp39 = new StringBuffer(64);
                            tmp37 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp39.append(tmp37.toString());
                            sbtmp39.append(",usage");
                            tmp38 = sbtmp39.toString();
                            setVarArray(interp, "_descend", tmp38, const4, compiledLocals, 1);
                        } // End Invoke: set
                        { // Invoke: return [...]
                            { // Invoke: list noExpr [...] $clause
                                TclObject tmp40 = TclList.newInstance();
                                TclObject tmp41;
                                try {
                                    TclList.append(interp, tmp40, const7);
                                    { // Invoke: list $end 1
                                        TclObject tmp42 = TclList.newInstance();
                                        TclObject tmp43;
                                        try {
                                            tmp43 = getVarScalar(interp, "end", compiledLocals, 13);
                                            TclList.append(interp, tmp42, tmp43);
                                            TclList.append(interp, tmp42, const4);
                                        } catch (TclException ex) {
                                            tmp42.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp42);
                                    } // End Invoke: list
                                    tmp41 = interp.getResult();
                                    TclList.append(interp, tmp40, tmp41);
                                    tmp41 = getVarScalar(interp, "clause", compiledLocals, 9);
                                    TclList.append(interp, tmp40, tmp41);
                                } catch (TclException ex) {
                                    tmp40.release();
                                    throw ex;
                                }
                                interp.setResult(tmp40);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: ... $key $i
                        TclObject[] objv44 = TJC.grabObjv(interp, 3);
                        TclObject tmp45;
                        try {
                            // Arg 0 constant: ...
                            objv44[0] = const8;
                            // Arg 1 variable: $key
                            tmp45 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp45.preserve();
                            objv44[1] = tmp45;
                            // Arg 2 variable: $i
                            tmp45 = getVarScalar(interp, "i", compiledLocals, 7);
                            tmp45.preserve();
                            objv44[2] = tmp45;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv44, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp45 = objv44[1];
                            if ( tmp45 != null ) {
                                tmp45.release();
                            }
                            tmp45 = objv44[2];
                            if ( tmp45 != null ) {
                                tmp45.release();
                            }
                            TJC.releaseObjv(interp, objv44, 3);
                        }
                    } // End Invoke: ...
                    TclObject tmp46 = interp.getResult();
                    ExprValue tmp47 = evs0;
                    if ( tmp46.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp47, tmp46);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp47, tmp46);
                    }
                    // End Unary operator: !
                    boolean tmp48 = ( tmp47.getIntValue() != 0 );
                    if ( tmp48 ) {
                        { // Invoke: set _descend($key,usage) 1
                            TclObject tmp49;
                            String tmp50;
                            StringBuffer sbtmp51 = new StringBuffer(64);
                            tmp49 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp51.append(tmp49.toString());
                            sbtmp51.append(",usage");
                            tmp50 = sbtmp51.toString();
                            setVarArray(interp, "_descend", tmp50, const4, compiledLocals, 1);
                        } // End Invoke: set
                        { // Invoke: return [...]
                            { // Invoke: list invalidArg "if" $i {} $clause "expr argument"
                                TclObject tmp52 = TclList.newInstance();
                                TclObject tmp53;
                                try {
                                    TclList.append(interp, tmp52, const9);
                                    TclList.append(interp, tmp52, const5);
                                    tmp53 = getVarScalar(interp, "i", compiledLocals, 7);
                                    TclList.append(interp, tmp52, tmp53);
                                    TclList.append(interp, tmp52, const3);
                                    tmp53 = getVarScalar(interp, "clause", compiledLocals, 9);
                                    TclList.append(interp, tmp52, tmp53);
                                    TclList.append(interp, tmp52, const10);
                                } catch (TclException ex) {
                                    tmp52.release();
                                    throw ex;
                                }
                                interp.setResult(tmp52);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: ... $key $i
                        TclObject[] objv54 = TJC.grabObjv(interp, 3);
                        TclObject tmp55;
                        try {
                            // Arg 0 constant: ...
                            objv54[0] = const11;
                            // Arg 1 variable: $key
                            tmp55 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp55.preserve();
                            objv54[1] = tmp55;
                            // Arg 2 variable: $i
                            tmp55 = getVarScalar(interp, "i", compiledLocals, 7);
                            tmp55.preserve();
                            objv54[2] = tmp55;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv54, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp55 = objv54[1];
                            if ( tmp55 != null ) {
                                tmp55.release();
                            }
                            tmp55 = objv54[2];
                            if ( tmp55 != null ) {
                                tmp55.release();
                            }
                            TJC.releaseObjv(interp, objv54, 3);
                        }
                    } // End Invoke: ...
                    TclObject tmp56 = interp.getResult();
                    ExprValue tmp57 = evs0;
                    if ( tmp56.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp57, tmp56);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp57, tmp56);
                    }
                    // End Unary operator: !
                    boolean tmp58 = ( tmp57.getIntValue() != 0 );
                    if ( tmp58 ) {
                        { // Invoke: set static 0
                            setVarScalar(interp, "static", const6, compiledLocals, 11);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if {$clause == "if"} ... else ...
                    // Binary operator: $clause == "if"
                    TclObject tmp59 = getVarScalar(interp, "clause", compiledLocals, 9);
                    boolean tmp60 = tmp59.toString().equals("if");
                    ExprValue tmp61 = evs0;
                    tmp61.setIntValue(tmp60);
                    // End Binary operator: ==
                    boolean tmp62 = ( tmp61.getIntValue() != 0 );
                    if ( tmp62 ) {
                        { // Invoke: lappend indexes_expr_body $i
                            TclObject[] objv63 = TJC.grabObjv(interp, 1);
                            TclObject tmp64;
                            try {
                                // Arg 2 variable: $i
                                tmp64 = getVarScalar(interp, "i", compiledLocals, 7);
                                tmp64.preserve();
                                objv63[0] = tmp64;
                                interp.resetResult();
                                lappendVarScalar(interp, "indexes_expr_body", objv63, compiledLocals, 4);
                            } finally {
                                TJC.releaseObjvElems(interp, objv63, 1);
                            }
                        } // End Invoke: lappend
                    } else {
                        { // Invoke: lappend indexes_elseif_body $i
                            TclObject[] objv65 = TJC.grabObjv(interp, 1);
                            TclObject tmp66;
                            try {
                                // Arg 2 variable: $i
                                tmp66 = getVarScalar(interp, "i", compiledLocals, 7);
                                tmp66.preserve();
                                objv65[0] = tmp66;
                                interp.resetResult();
                                lappendVarScalar(interp, "indexes_elseif_body", objv65, compiledLocals, 5);
                            } finally {
                                TJC.releaseObjvElems(interp, objv65, 1);
                            }
                        } // End Invoke: lappend
                    }
                } // End Invoke: if
                { // Invoke: incr i
                    interp.resetResult();
                    incrVarScalar(interp, "i", 1, compiledLocals, 7);
                } // End Invoke: incr
                { // Invoke: if {$i < $argc} ...
                    // Binary operator: $i < $argc
                    TclObject tmp67 = getVarScalar(interp, "i", compiledLocals, 7);
                    ExprValue tmp68 = evs0;
                    TJC.exprInitValue(interp, tmp68, tmp67);
                    TclObject tmp69 = getVarScalar(interp, "argc", compiledLocals, 8);
                    ExprValue tmp70 = evs1;
                    TJC.exprInitValue(interp, tmp70, tmp69);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp68, tmp70);
                    // End Binary operator: <
                    boolean tmp71 = ( tmp68.getIntValue() != 0 );
                    if ( tmp71 ) {
                        { // Invoke: set subtree [...]
                            TclObject tmp72;
                            { // Invoke: lindex $tree $i
                                TclObject tmp73 = null;
                                TclObject tmp74;
                                try {
                                    tmp73 = getVarScalar(interp, "tree", compiledLocals, 3);
                                    tmp73.preserve();
                                    tmp74 = getVarScalar(interp, "i", compiledLocals, 7);
                                    TJC.lindexNonconst(interp, tmp73, tmp74);
                                } finally {
                                    if ( tmp73 != null ) {
                                        tmp73.release();
                                    }
                                }
                            } // End Invoke: lindex
                            tmp72 = interp.getResult();
                            setVarScalar(interp, "subtree", tmp72, compiledLocals, 14);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            { // Invoke: parse_is_simple_text $subtree
                                TclObject[] objv75 = TJC.grabObjv(interp, 2);
                                TclObject tmp76;
                                try {
                                    // Arg 0 constant: parse_is_simple_text
                                    objv75[0] = const12;
                                    // Arg 1 variable: $subtree
                                    tmp76 = getVarScalar(interp, "subtree", compiledLocals, 14);
                                    tmp76.preserve();
                                    objv75[1] = tmp76;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv75, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp76 = objv75[1];
                                    if ( tmp76 != null ) {
                                        tmp76.release();
                                    }
                                    TJC.releaseObjv(interp, objv75, 2);
                                }
                            } // End Invoke: parse_is_simple_text
                            TclObject tmp77 = interp.getResult();
                            ExprValue tmp78 = evs0;
                            TJC.exprInitValue(interp, tmp78, tmp77);
                            boolean tmp79 = tmp78.getBooleanValue(interp);
                            if ( tmp79 ) {
                                { // Invoke: set text [...]
                                    TclObject tmp80;
                                    { // Invoke: ... $script $subtree "text"
                                        TclObject[] objv81 = TJC.grabObjv(interp, 4);
                                        TclObject tmp82;
                                        try {
                                            // Arg 0 constant: ...
                                            objv81[0] = const13;
                                            // Arg 1 variable: $script
                                            tmp82 = getVarScalar(interp, "script", compiledLocals, 2);
                                            tmp82.preserve();
                                            objv81[1] = tmp82;
                                            // Arg 2 variable: $subtree
                                            tmp82 = getVarScalar(interp, "subtree", compiledLocals, 14);
                                            tmp82.preserve();
                                            objv81[2] = tmp82;
                                            // Arg 3 constant: "text"
                                            objv81[3] = const14;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                ? cmdcache5.cmd : null), objv81, 0);
                                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                updateCmdCache(interp, 5);
                                            }
                                        } finally {
                                            tmp82 = objv81[1];
                                            if ( tmp82 != null ) {
                                                tmp82.release();
                                            }
                                            tmp82 = objv81[2];
                                            if ( tmp82 != null ) {
                                                tmp82.release();
                                            }
                                            TJC.releaseObjv(interp, objv81, 4);
                                        }
                                    } // End Invoke: ...
                                    tmp80 = interp.getResult();
                                    setVarScalar(interp, "text", tmp80, compiledLocals, 15);
                                } // End Invoke: set
                                { // Invoke: if {$text == "then"} ...
                                    // Binary operator: $text == "then"
                                    TclObject tmp83 = getVarScalar(interp, "text", compiledLocals, 15);
                                    boolean tmp84 = tmp83.toString().equals("then");
                                    ExprValue tmp85 = evs0;
                                    tmp85.setIntValue(tmp84);
                                    // End Binary operator: ==
                                    boolean tmp86 = ( tmp85.getIntValue() != 0 );
                                    if ( tmp86 ) {
                                        { // Invoke: incr i
                                            interp.resetResult();
                                            incrVarScalar(interp, "i", 1, compiledLocals, 7);
                                        } // End Invoke: incr
                                    }
                                } // End Invoke: if
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
                { // Invoke: if {$i >= $argc} ...
                    // Binary operator: $i >= $argc
                    TclObject tmp87 = getVarScalar(interp, "i", compiledLocals, 7);
                    ExprValue tmp88 = evs0;
                    TJC.exprInitValue(interp, tmp88, tmp87);
                    TclObject tmp89 = getVarScalar(interp, "argc", compiledLocals, 8);
                    ExprValue tmp90 = evs1;
                    TJC.exprInitValue(interp, tmp90, tmp89);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp88, tmp90);
                    // End Binary operator: >=
                    boolean tmp91 = ( tmp88.getIntValue() != 0 );
                    if ( tmp91 ) {
                        { // Invoke: set word [...]
                            TclObject tmp92;
                            { // Invoke: lindex [...] 1
                                { // Invoke: lindex $tree [...]
                                    TclObject tmp94 = null;
                                    TclObject tmp95;
                                    try {
                                        tmp94 = getVarScalar(interp, "tree", compiledLocals, 3);
                                        tmp94.preserve();
                                        { // Invoke: expr {$i - 1}
                                            // Binary operator: $i - 1
                                            TclObject tmp96 = getVarScalar(interp, "i", compiledLocals, 7);
                                            ExprValue tmp97 = evs0;
                                            TJC.exprInitValue(interp, tmp97, tmp96);
                                            ExprValue tmp98 = evs1;
                                            tmp98.setIntValue(1);
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp97, tmp98);
                                            // End Binary operator: -
                                            TJC.exprSetResult(interp, tmp97);
                                        } // End Invoke: expr
                                        tmp95 = interp.getResult();
                                        TJC.lindexNonconst(interp, tmp94, tmp95);
                                    } finally {
                                        if ( tmp94 != null ) {
                                            tmp94.release();
                                        }
                                    }
                                } // End Invoke: lindex
                                TclObject tmp93 = interp.getResult();
                                tmp93 = TclList.index(interp, tmp93, 1);
                                if ( tmp93 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp93);
                                }
                            } // End Invoke: lindex
                            tmp92 = interp.getResult();
                            setVarScalar(interp, "word", tmp92, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: set end [...]
                            TclObject tmp99;
                            { // Invoke: expr ...
                                // Binary operator: [...] + [...]
                                { // Invoke: lindex $word 0
                                    TclObject tmp100 = getVarScalar(interp, "word", compiledLocals, 12);
                                    tmp100 = TclList.index(interp, tmp100, 0);
                                    if ( tmp100 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp100);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp101 = interp.getResult();
                                ExprValue tmp102 = evs0;
                                TJC.exprInitValue(interp, tmp102, tmp101);
                                { // Invoke: lindex $word 1
                                    TclObject tmp103 = getVarScalar(interp, "word", compiledLocals, 12);
                                    tmp103 = TclList.index(interp, tmp103, 1);
                                    if ( tmp103 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp103);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp104 = interp.getResult();
                                ExprValue tmp105 = evs1;
                                TJC.exprInitValue(interp, tmp105, tmp104);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp102, tmp105);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp102);
                            } // End Invoke: expr
                            tmp99 = interp.getResult();
                            setVarScalar(interp, "end", tmp99, compiledLocals, 13);
                        } // End Invoke: set
                        { // Invoke: set _descend($key,usage) 1
                            TclObject tmp106;
                            String tmp107;
                            StringBuffer sbtmp108 = new StringBuffer(64);
                            tmp106 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp108.append(tmp106.toString());
                            sbtmp108.append(",usage");
                            tmp107 = sbtmp108.toString();
                            setVarArray(interp, "_descend", tmp107, const4, compiledLocals, 1);
                        } // End Invoke: set
                        { // Invoke: return [...]
                            { // Invoke: list noScript [...] $clause
                                TclObject tmp109 = TclList.newInstance();
                                TclObject tmp110;
                                try {
                                    TclList.append(interp, tmp109, const15);
                                    { // Invoke: list $end 1
                                        TclObject tmp111 = TclList.newInstance();
                                        TclObject tmp112;
                                        try {
                                            tmp112 = getVarScalar(interp, "end", compiledLocals, 13);
                                            TclList.append(interp, tmp111, tmp112);
                                            TclList.append(interp, tmp111, const4);
                                        } catch (TclException ex) {
                                            tmp111.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp111);
                                    } // End Invoke: list
                                    tmp110 = interp.getResult();
                                    TclList.append(interp, tmp109, tmp110);
                                    tmp110 = getVarScalar(interp, "clause", compiledLocals, 9);
                                    TclList.append(interp, tmp109, tmp110);
                                } catch (TclException ex) {
                                    tmp109.release();
                                    throw ex;
                                }
                                interp.setResult(tmp109);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: ... $key $i
                        TclObject[] objv113 = TJC.grabObjv(interp, 3);
                        TclObject tmp114;
                        try {
                            // Arg 0 constant: ...
                            objv113[0] = const11;
                            // Arg 1 variable: $key
                            tmp114 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp114.preserve();
                            objv113[1] = tmp114;
                            // Arg 2 variable: $i
                            tmp114 = getVarScalar(interp, "i", compiledLocals, 7);
                            tmp114.preserve();
                            objv113[2] = tmp114;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv113, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp114 = objv113[1];
                            if ( tmp114 != null ) {
                                tmp114.release();
                            }
                            tmp114 = objv113[2];
                            if ( tmp114 != null ) {
                                tmp114.release();
                            }
                            TJC.releaseObjv(interp, objv113, 3);
                        }
                    } // End Invoke: ...
                    TclObject tmp115 = interp.getResult();
                    ExprValue tmp116 = evs0;
                    if ( tmp115.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp116, tmp115);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp116, tmp115);
                    }
                    // End Unary operator: !
                    boolean tmp117 = ( tmp116.getIntValue() != 0 );
                    if ( tmp117 ) {
                        { // Invoke: set static 0
                            setVarScalar(interp, "static", const6, compiledLocals, 11);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if {$clause == "if"} ... else ...
                    // Binary operator: $clause == "if"
                    TclObject tmp118 = getVarScalar(interp, "clause", compiledLocals, 9);
                    boolean tmp119 = tmp118.toString().equals("if");
                    ExprValue tmp120 = evs0;
                    tmp120.setIntValue(tmp119);
                    // End Binary operator: ==
                    boolean tmp121 = ( tmp120.getIntValue() != 0 );
                    if ( tmp121 ) {
                        { // Invoke: lappend indexes_expr_body $i
                            TclObject[] objv122 = TJC.grabObjv(interp, 1);
                            TclObject tmp123;
                            try {
                                // Arg 2 variable: $i
                                tmp123 = getVarScalar(interp, "i", compiledLocals, 7);
                                tmp123.preserve();
                                objv122[0] = tmp123;
                                interp.resetResult();
                                lappendVarScalar(interp, "indexes_expr_body", objv122, compiledLocals, 4);
                            } finally {
                                TJC.releaseObjvElems(interp, objv122, 1);
                            }
                        } // End Invoke: lappend
                    } else {
                        { // Invoke: lappend indexes_elseif_body $i
                            TclObject[] objv124 = TJC.grabObjv(interp, 1);
                            TclObject tmp125;
                            try {
                                // Arg 2 variable: $i
                                tmp125 = getVarScalar(interp, "i", compiledLocals, 7);
                                tmp125.preserve();
                                objv124[0] = tmp125;
                                interp.resetResult();
                                lappendVarScalar(interp, "indexes_elseif_body", objv124, compiledLocals, 5);
                            } finally {
                                TJC.releaseObjvElems(interp, objv124, 1);
                            }
                        } // End Invoke: lappend
                    }
                } // End Invoke: if
                { // Invoke: set keywordNeeded 1
                    setVarScalar(interp, "keywordNeeded", const4, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: incr i
                    interp.resetResult();
                    incrVarScalar(interp, "i", 1, compiledLocals, 7);
                } // End Invoke: incr
                { // Invoke: if {$i >= $argc} ...
                    // Binary operator: $i >= $argc
                    TclObject tmp126 = getVarScalar(interp, "i", compiledLocals, 7);
                    ExprValue tmp127 = evs0;
                    TJC.exprInitValue(interp, tmp127, tmp126);
                    TclObject tmp128 = getVarScalar(interp, "argc", compiledLocals, 8);
                    ExprValue tmp129 = evs1;
                    TJC.exprInitValue(interp, tmp129, tmp128);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp127, tmp129);
                    // End Binary operator: >=
                    boolean tmp130 = ( tmp127.getIntValue() != 0 );
                    if ( tmp130 ) {
                        { // Invoke: set "..." $static
                            TclObject tmp131;
                            String tmp132;
                            StringBuffer sbtmp133 = new StringBuffer(64);
                            tmp131 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp133.append(tmp131.toString());
                            sbtmp133.append(",static_container");
                            tmp132 = sbtmp133.toString();
                            tmp131 = getVarScalar(interp, "static", compiledLocals, 11);
                            tmp131 = setVarArray(interp, "_descend", tmp132, tmp131, compiledLocals, 1);
                        } // End Invoke: set
                        { // Invoke: set "..." [...]
                            TclObject tmp134;
                            String tmp137;
                            StringBuffer sbtmp138 = new StringBuffer(64);
                            tmp134 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp138.append(tmp134.toString());
                            sbtmp138.append(",validated");
                            tmp137 = sbtmp138.toString();
                            { // Invoke: list $indexes_expr_body $indexes_elseif_body $indexes_else_body
                                TclObject tmp135 = TclList.newInstance();
                                TclObject tmp136;
                                try {
                                    tmp136 = getVarScalar(interp, "indexes_expr_body", compiledLocals, 4);
                                    TclList.append(interp, tmp135, tmp136);
                                    tmp136 = getVarScalar(interp, "indexes_elseif_body", compiledLocals, 5);
                                    TclList.append(interp, tmp135, tmp136);
                                    tmp136 = getVarScalar(interp, "indexes_else_body", compiledLocals, 6);
                                    TclList.append(interp, tmp135, tmp136);
                                } catch (TclException ex) {
                                    tmp135.release();
                                    throw ex;
                                }
                                interp.setResult(tmp135);
                            } // End Invoke: list
                            tmp134 = interp.getResult();
                            tmp134 = setVarArray(interp, "_descend", tmp137, tmp134, compiledLocals, 1);
                        } // End Invoke: set
                        { // Invoke: return "OK"
                            interp.resetResult();
                            interp.setResult(const16);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: set subtree [...]
                    TclObject tmp139;
                    { // Invoke: lindex $tree $i
                        TclObject tmp140 = null;
                        TclObject tmp141;
                        try {
                            tmp140 = getVarScalar(interp, "tree", compiledLocals, 3);
                            tmp140.preserve();
                            tmp141 = getVarScalar(interp, "i", compiledLocals, 7);
                            TJC.lindexNonconst(interp, tmp140, tmp141);
                        } finally {
                            if ( tmp140 != null ) {
                                tmp140.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp139 = interp.getResult();
                    setVarScalar(interp, "subtree", tmp139, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: if ... ...
                    { // Invoke: parse_is_simple_text $subtree
                        TclObject[] objv142 = TJC.grabObjv(interp, 2);
                        TclObject tmp143;
                        try {
                            // Arg 0 constant: parse_is_simple_text
                            objv142[0] = const12;
                            // Arg 1 variable: $subtree
                            tmp143 = getVarScalar(interp, "subtree", compiledLocals, 14);
                            tmp143.preserve();
                            objv142[1] = tmp143;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv142, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp143 = objv142[1];
                            if ( tmp143 != null ) {
                                tmp143.release();
                            }
                            TJC.releaseObjv(interp, objv142, 2);
                        }
                    } // End Invoke: parse_is_simple_text
                    TclObject tmp144 = interp.getResult();
                    ExprValue tmp145 = evs0;
                    TJC.exprInitValue(interp, tmp145, tmp144);
                    boolean tmp146 = tmp145.getBooleanValue(interp);
                    if ( tmp146 ) {
                        { // Invoke: set text [...]
                            TclObject tmp147;
                            { // Invoke: ... $script $subtree "text"
                                TclObject[] objv148 = TJC.grabObjv(interp, 4);
                                TclObject tmp149;
                                try {
                                    // Arg 0 constant: ...
                                    objv148[0] = const13;
                                    // Arg 1 variable: $script
                                    tmp149 = getVarScalar(interp, "script", compiledLocals, 2);
                                    tmp149.preserve();
                                    objv148[1] = tmp149;
                                    // Arg 2 variable: $subtree
                                    tmp149 = getVarScalar(interp, "subtree", compiledLocals, 14);
                                    tmp149.preserve();
                                    objv148[2] = tmp149;
                                    // Arg 3 constant: "text"
                                    objv148[3] = const14;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv148, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp149 = objv148[1];
                                    if ( tmp149 != null ) {
                                        tmp149.release();
                                    }
                                    tmp149 = objv148[2];
                                    if ( tmp149 != null ) {
                                        tmp149.release();
                                    }
                                    TJC.releaseObjv(interp, objv148, 4);
                                }
                            } // End Invoke: ...
                            tmp147 = interp.getResult();
                            setVarScalar(interp, "text", tmp147, compiledLocals, 15);
                        } // End Invoke: set
                        { // Invoke: if {$text == "elseif"} ...
                            // Binary operator: $text == "elseif"
                            TclObject tmp150 = getVarScalar(interp, "text", compiledLocals, 15);
                            boolean tmp151 = tmp150.toString().equals("elseif");
                            ExprValue tmp152 = evs0;
                            tmp152.setIntValue(tmp151);
                            // End Binary operator: ==
                            boolean tmp153 = ( tmp152.getIntValue() != 0 );
                            if ( tmp153 ) {
                                { // Invoke: set keywordNeeded 0
                                    setVarScalar(interp, "keywordNeeded", const6, compiledLocals, 10);
                                } // End Invoke: set
                                { // Invoke: set clause "elseif"
                                    setVarScalar(interp, "clause", const17, compiledLocals, 9);
                                } // End Invoke: set
                                { // Invoke: incr i
                                    interp.resetResult();
                                    incrVarScalar(interp, "i", 1, compiledLocals, 7);
                                } // End Invoke: incr
                                { // Invoke: continue
                                    if ( true ) { continue; }
                                } // End Invoke: continue
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
                { // Invoke: break
                    if ( true ) { break; }
                } // End Invoke: break
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: while
        { // Invoke: set subtree [...]
            TclObject tmp154;
            { // Invoke: lindex $tree $i
                TclObject tmp155 = null;
                TclObject tmp156;
                try {
                    tmp155 = getVarScalar(interp, "tree", compiledLocals, 3);
                    tmp155.preserve();
                    tmp156 = getVarScalar(interp, "i", compiledLocals, 7);
                    TJC.lindexNonconst(interp, tmp155, tmp156);
                } finally {
                    if ( tmp155 != null ) {
                        tmp155.release();
                    }
                }
            } // End Invoke: lindex
            tmp154 = interp.getResult();
            setVarScalar(interp, "subtree", tmp154, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] && ()
            { // Invoke: parse_is_simple_text $subtree
                TclObject[] objv157 = TJC.grabObjv(interp, 2);
                TclObject tmp158;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv157[0] = const12;
                    // Arg 1 variable: $subtree
                    tmp158 = getVarScalar(interp, "subtree", compiledLocals, 14);
                    tmp158.preserve();
                    objv157[1] = tmp158;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv157, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp158 = objv157[1];
                    if ( tmp158 != null ) {
                        tmp158.release();
                    }
                    TJC.releaseObjv(interp, objv157, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp159 = interp.getResult();
            ExprValue tmp160 = evs0;
            TJC.exprInitValue(interp, tmp160, tmp159);
            if (tmp160.getBooleanValue(interp)) {
            // Binary operator: [...] == "else"
            { // Invoke: ... $script $subtree "text"
                TclObject[] objv161 = TJC.grabObjv(interp, 4);
                TclObject tmp162;
                try {
                    // Arg 0 constant: ...
                    objv161[0] = const13;
                    // Arg 1 variable: $script
                    tmp162 = getVarScalar(interp, "script", compiledLocals, 2);
                    tmp162.preserve();
                    objv161[1] = tmp162;
                    // Arg 2 variable: $subtree
                    tmp162 = getVarScalar(interp, "subtree", compiledLocals, 14);
                    tmp162.preserve();
                    objv161[2] = tmp162;
                    // Arg 3 constant: "text"
                    objv161[3] = const14;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv161, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp162 = objv161[1];
                    if ( tmp162 != null ) {
                        tmp162.release();
                    }
                    tmp162 = objv161[2];
                    if ( tmp162 != null ) {
                        tmp162.release();
                    }
                    TJC.releaseObjv(interp, objv161, 4);
                }
            } // End Invoke: ...
            TclObject tmp163 = interp.getResult();
            boolean tmp164 = tmp163.toString().equals("else");
            ExprValue tmp165 = evs1;
            tmp165.setIntValue(tmp164);
            // End Binary operator: ==
            tmp160.setIntValue(tmp165.getBooleanValue(interp));
            } else {
            tmp160.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp166 = ( tmp160.getIntValue() != 0 );
            if ( tmp166 ) {
                { // Invoke: set clause "else"
                    setVarScalar(interp, "clause", const18, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set keywordNeeded 0
                    setVarScalar(interp, "keywordNeeded", const6, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: incr i
                    interp.resetResult();
                    incrVarScalar(interp, "i", 1, compiledLocals, 7);
                } // End Invoke: incr
                { // Invoke: if {$i >= $argc} ...
                    // Binary operator: $i >= $argc
                    TclObject tmp167 = getVarScalar(interp, "i", compiledLocals, 7);
                    ExprValue tmp168 = evs0;
                    TJC.exprInitValue(interp, tmp168, tmp167);
                    TclObject tmp169 = getVarScalar(interp, "argc", compiledLocals, 8);
                    ExprValue tmp170 = evs1;
                    TJC.exprInitValue(interp, tmp170, tmp169);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp168, tmp170);
                    // End Binary operator: >=
                    boolean tmp171 = ( tmp168.getIntValue() != 0 );
                    if ( tmp171 ) {
                        { // Invoke: set word [...]
                            TclObject tmp172;
                            { // Invoke: lindex [...] 1
                                { // Invoke: lindex $tree [...]
                                    TclObject tmp174 = null;
                                    TclObject tmp175;
                                    try {
                                        tmp174 = getVarScalar(interp, "tree", compiledLocals, 3);
                                        tmp174.preserve();
                                        { // Invoke: expr {$i - 1}
                                            // Binary operator: $i - 1
                                            TclObject tmp176 = getVarScalar(interp, "i", compiledLocals, 7);
                                            ExprValue tmp177 = evs0;
                                            TJC.exprInitValue(interp, tmp177, tmp176);
                                            ExprValue tmp178 = evs1;
                                            tmp178.setIntValue(1);
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp177, tmp178);
                                            // End Binary operator: -
                                            TJC.exprSetResult(interp, tmp177);
                                        } // End Invoke: expr
                                        tmp175 = interp.getResult();
                                        TJC.lindexNonconst(interp, tmp174, tmp175);
                                    } finally {
                                        if ( tmp174 != null ) {
                                            tmp174.release();
                                        }
                                    }
                                } // End Invoke: lindex
                                TclObject tmp173 = interp.getResult();
                                tmp173 = TclList.index(interp, tmp173, 1);
                                if ( tmp173 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp173);
                                }
                            } // End Invoke: lindex
                            tmp172 = interp.getResult();
                            setVarScalar(interp, "word", tmp172, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: set end [...]
                            TclObject tmp179;
                            { // Invoke: expr ...
                                // Binary operator: [...] + [...]
                                { // Invoke: lindex $word 0
                                    TclObject tmp180 = getVarScalar(interp, "word", compiledLocals, 12);
                                    tmp180 = TclList.index(interp, tmp180, 0);
                                    if ( tmp180 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp180);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp181 = interp.getResult();
                                ExprValue tmp182 = evs0;
                                TJC.exprInitValue(interp, tmp182, tmp181);
                                { // Invoke: lindex $word 1
                                    TclObject tmp183 = getVarScalar(interp, "word", compiledLocals, 12);
                                    tmp183 = TclList.index(interp, tmp183, 1);
                                    if ( tmp183 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp183);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp184 = interp.getResult();
                                ExprValue tmp185 = evs1;
                                TJC.exprInitValue(interp, tmp185, tmp184);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp182, tmp185);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp182);
                            } // End Invoke: expr
                            tmp179 = interp.getResult();
                            setVarScalar(interp, "end", tmp179, compiledLocals, 13);
                        } // End Invoke: set
                        { // Invoke: set _descend($key,usage) 1
                            TclObject tmp186;
                            String tmp187;
                            StringBuffer sbtmp188 = new StringBuffer(64);
                            tmp186 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp188.append(tmp186.toString());
                            sbtmp188.append(",usage");
                            tmp187 = sbtmp188.toString();
                            setVarArray(interp, "_descend", tmp187, const4, compiledLocals, 1);
                        } // End Invoke: set
                        { // Invoke: return [...]
                            { // Invoke: list noScript [...] $clause
                                TclObject tmp189 = TclList.newInstance();
                                TclObject tmp190;
                                try {
                                    TclList.append(interp, tmp189, const15);
                                    { // Invoke: list $end 1
                                        TclObject tmp191 = TclList.newInstance();
                                        TclObject tmp192;
                                        try {
                                            tmp192 = getVarScalar(interp, "end", compiledLocals, 13);
                                            TclList.append(interp, tmp191, tmp192);
                                            TclList.append(interp, tmp191, const4);
                                        } catch (TclException ex) {
                                            tmp191.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp191);
                                    } // End Invoke: list
                                    tmp190 = interp.getResult();
                                    TclList.append(interp, tmp189, tmp190);
                                    tmp190 = getVarScalar(interp, "clause", compiledLocals, 9);
                                    TclList.append(interp, tmp189, tmp190);
                                } catch (TclException ex) {
                                    tmp189.release();
                                    throw ex;
                                }
                                interp.setResult(tmp189);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: ... $key $i
                        TclObject[] objv193 = TJC.grabObjv(interp, 3);
                        TclObject tmp194;
                        try {
                            // Arg 0 constant: ...
                            objv193[0] = const11;
                            // Arg 1 variable: $key
                            tmp194 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp194.preserve();
                            objv193[1] = tmp194;
                            // Arg 2 variable: $i
                            tmp194 = getVarScalar(interp, "i", compiledLocals, 7);
                            tmp194.preserve();
                            objv193[2] = tmp194;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv193, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp194 = objv193[1];
                            if ( tmp194 != null ) {
                                tmp194.release();
                            }
                            tmp194 = objv193[2];
                            if ( tmp194 != null ) {
                                tmp194.release();
                            }
                            TJC.releaseObjv(interp, objv193, 3);
                        }
                    } // End Invoke: ...
                    TclObject tmp195 = interp.getResult();
                    ExprValue tmp196 = evs0;
                    if ( tmp195.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp196, tmp195);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp196, tmp195);
                    }
                    // End Unary operator: !
                    boolean tmp197 = ( tmp196.getIntValue() != 0 );
                    if ( tmp197 ) {
                        { // Invoke: set static 0
                            setVarScalar(interp, "static", const6, compiledLocals, 11);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: lappend indexes_else_body $i
                    TclObject[] objv198 = TJC.grabObjv(interp, 1);
                    TclObject tmp199;
                    try {
                        // Arg 2 variable: $i
                        tmp199 = getVarScalar(interp, "i", compiledLocals, 7);
                        tmp199.preserve();
                        objv198[0] = tmp199;
                        interp.resetResult();
                        lappendVarScalar(interp, "indexes_else_body", objv198, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv198, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: $keywordNeeded || ()
            TclObject tmp200 = getVarScalar(interp, "keywordNeeded", compiledLocals, 10);
            ExprValue tmp201 = evs0;
            TJC.exprInitValue(interp, tmp201, tmp200);
            if (!tmp201.getBooleanValue(interp)) {
            // Binary operator: () != $argc
            // Binary operator: $i + 1
            TclObject tmp202 = getVarScalar(interp, "i", compiledLocals, 7);
            ExprValue tmp203 = evs1;
            TJC.exprInitValue(interp, tmp203, tmp202);
            ExprValue tmp204 = evs2;
            tmp204.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp203, tmp204);
            // End Binary operator: +
            TclObject tmp205 = getVarScalar(interp, "argc", compiledLocals, 8);
            ExprValue tmp206 = evs2;
            TJC.exprInitValue(interp, tmp206, tmp205);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp203, tmp206);
            // End Binary operator: !=
            tmp201.setIntValue(tmp203.getBooleanValue(interp));
            } else {
            tmp201.setIntValue(1);
            } // End if: !$keywordNeeded
            // End Binary operator: ||
            boolean tmp207 = ( tmp201.getIntValue() != 0 );
            if ( tmp207 ) {
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: ... $key $i
                        TclObject[] objv208 = TJC.grabObjv(interp, 3);
                        TclObject tmp209;
                        try {
                            // Arg 0 constant: ...
                            objv208[0] = const11;
                            // Arg 1 variable: $key
                            tmp209 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp209.preserve();
                            objv208[1] = tmp209;
                            // Arg 2 variable: $i
                            tmp209 = getVarScalar(interp, "i", compiledLocals, 7);
                            tmp209.preserve();
                            objv208[2] = tmp209;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv208, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp209 = objv208[1];
                            if ( tmp209 != null ) {
                                tmp209.release();
                            }
                            tmp209 = objv208[2];
                            if ( tmp209 != null ) {
                                tmp209.release();
                            }
                            TJC.releaseObjv(interp, objv208, 3);
                        }
                    } // End Invoke: ...
                    TclObject tmp210 = interp.getResult();
                    ExprValue tmp211 = evs0;
                    if ( tmp210.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp211, tmp210);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp211, tmp210);
                    }
                    // End Unary operator: !
                    boolean tmp212 = ( tmp211.getIntValue() != 0 );
                    if ( tmp212 ) {
                        { // Invoke: set static 0
                            setVarScalar(interp, "static", const6, compiledLocals, 11);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: lappend indexes_else_body $i
                    TclObject[] objv213 = TJC.grabObjv(interp, 1);
                    TclObject tmp214;
                    try {
                        // Arg 2 variable: $i
                        tmp214 = getVarScalar(interp, "i", compiledLocals, 7);
                        tmp214.preserve();
                        objv213[0] = tmp214;
                        interp.resetResult();
                        lappendVarScalar(interp, "indexes_else_body", objv213, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv213, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: set "..." $static
            TclObject tmp215;
            String tmp216;
            StringBuffer sbtmp217 = new StringBuffer(64);
            tmp215 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp217.append(tmp215.toString());
            sbtmp217.append(",static_container");
            tmp216 = sbtmp217.toString();
            tmp215 = getVarScalar(interp, "static", compiledLocals, 11);
            tmp215 = setVarArray(interp, "_descend", tmp216, tmp215, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set "..." [...]
            TclObject tmp218;
            String tmp221;
            StringBuffer sbtmp222 = new StringBuffer(64);
            tmp218 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp222.append(tmp218.toString());
            sbtmp222.append(",validated");
            tmp221 = sbtmp222.toString();
            { // Invoke: list $indexes_expr_body $indexes_elseif_body $indexes_else_body
                TclObject tmp219 = TclList.newInstance();
                TclObject tmp220;
                try {
                    tmp220 = getVarScalar(interp, "indexes_expr_body", compiledLocals, 4);
                    TclList.append(interp, tmp219, tmp220);
                    tmp220 = getVarScalar(interp, "indexes_elseif_body", compiledLocals, 5);
                    TclList.append(interp, tmp219, tmp220);
                    tmp220 = getVarScalar(interp, "indexes_else_body", compiledLocals, 6);
                    TclList.append(interp, tmp219, tmp220);
                } catch (TclException ex) {
                    tmp219.release();
                    throw ex;
                }
                interp.setResult(tmp219);
            } // End Invoke: list
            tmp218 = interp.getResult();
            tmp218 = setVarArray(interp, "_descend", tmp221, tmp218, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return "OK"
            interp.resetResult();
            interp.setResult(const16);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_if_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("if");
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(0);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("noExpr");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_container_expr_argument_validate");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("invalidArg");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("expr argument");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("descend_container_argument_body_is_static");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("parse_is_simple_text");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("parse_get_simple_text");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("text");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("noScript");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("OK");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("elseif");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("else");
        const18.preserve(); const18.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "descend_container_expr_argument_validate";
                break;
            }
            case 3: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            case 4: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 5: {
                cmdName = "parse_get_simple_text";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "indexes_expr_body",
        "indexes_elseif_body",
        "indexes_else_body",
        "i",
        "argc",
        "clause",
        "keywordNeeded",
        "static",
        "word",
        "end",
        "subtree",
        "text"
    };
} // end class DescendContainerIfValidateCmd

