// TJC implementation of procedure descend_container_switch
package tjc;
import tcl.lang.*;

public class DescendContainerSwitchCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set result [...]
            TclObject tmp0;
            { // Invoke: ... $key
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "result", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {$result != "OK"} ...
            // Binary operator: $result != "OK"
            TclObject tmp3 = getVarScalar(interp, "result", compiledLocals, 2);
            boolean tmp4 = ! tmp3.toString().equals("OK");
            ExprValue tmp5 = evs0;
            tmp5.setIntValue(tmp4);
            // End Binary operator: !=
            boolean tmp6 = ( tmp5.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: if ... ...
                    { // Invoke: descend_get_data $key usage
                        TclObject[] objv7 = TJC.grabObjv(interp, 3);
                        TclObject tmp8;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv7[0] = const1;
                            // Arg 1 variable: $key
                            tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp8.preserve();
                            objv7[1] = tmp8;
                            // Arg 2 constant: usage
                            objv7[2] = const2;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv7, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp8 = objv7[1];
                            if ( tmp8 != null ) {
                                tmp8.release();
                            }
                            TJC.releaseObjv(interp, objv7, 3);
                        }
                    } // End Invoke: descend_get_data
                    TclObject tmp9 = interp.getResult();
                    ExprValue tmp10 = evs0;
                    TJC.exprInitValue(interp, tmp10, tmp9);
                    boolean tmp11 = tmp10.getBooleanValue(interp);
                    if ( tmp11 ) {
                        { // Invoke: descend_report_usage $key $result
                            TclObject[] objv12 = TJC.grabObjv(interp, 3);
                            TclObject tmp13;
                            try {
                                // Arg 0 constant: descend_report_usage
                                objv12[0] = const3;
                                // Arg 1 variable: $key
                                tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp13.preserve();
                                objv12[1] = tmp13;
                                // Arg 2 variable: $result
                                tmp13 = getVarScalar(interp, "result", compiledLocals, 2);
                                tmp13.preserve();
                                objv12[2] = tmp13;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv12, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp13 = objv12[1];
                                if ( tmp13 != null ) {
                                    tmp13.release();
                                }
                                tmp13 = objv12[2];
                                if ( tmp13 != null ) {
                                    tmp13.release();
                                }
                                TJC.releaseObjv(interp, objv12, 3);
                            }
                        } // End Invoke: descend_report_usage
                    }
                } // End Invoke: if
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set script [...]
            TclObject tmp14;
            { // Invoke: descend_get_data $key script
                TclObject[] objv15 = TJC.grabObjv(interp, 3);
                TclObject tmp16;
                try {
                    // Arg 0 constant: descend_get_data
                    objv15[0] = const1;
                    // Arg 1 variable: $key
                    tmp16 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp16.preserve();
                    objv15[1] = tmp16;
                    // Arg 2 constant: script
                    objv15[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv15, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp16 = objv15[1];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    TJC.releaseObjv(interp, objv15, 3);
                }
            } // End Invoke: descend_get_data
            tmp14 = interp.getResult();
            setVarScalar(interp, "script", tmp14, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp17;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv18 = TJC.grabObjv(interp, 3);
                TclObject tmp19;
                try {
                    // Arg 0 constant: descend_get_data
                    objv18[0] = const1;
                    // Arg 1 variable: $key
                    tmp19 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp19.preserve();
                    objv18[1] = tmp19;
                    // Arg 2 constant: tree
                    objv18[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv18, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp19 = objv18[1];
                    if ( tmp19 != null ) {
                        tmp19.release();
                    }
                    TJC.releaseObjv(interp, objv18, 3);
                }
            } // End Invoke: descend_get_data
            tmp17 = interp.getResult();
            setVarScalar(interp, "tree", tmp17, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set string_index [...]
            TclObject tmp20;
            { // Invoke: ... $key
                TclObject[] objv21 = TJC.grabObjv(interp, 2);
                TclObject tmp22;
                try {
                    // Arg 0 constant: ...
                    objv21[0] = const6;
                    // Arg 1 variable: $key
                    tmp22 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp22.preserve();
                    objv21[1] = tmp22;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv21, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp22 = objv21[1];
                    if ( tmp22 != null ) {
                        tmp22.release();
                    }
                    TJC.releaseObjv(interp, objv21, 2);
                }
            } // End Invoke: ...
            tmp20 = interp.getResult();
            setVarScalar(interp, "string_index", tmp20, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set container_commands [...]
            TclObject tmp23;
            { // Invoke: list
                TclObject tmp24 = TclList.newInstance();
                interp.setResult(tmp24);
            } // End Invoke: list
            tmp23 = interp.getResult();
            setVarScalar(interp, "container_commands", tmp23, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: foreach ... [...] ...
            TclObject tmp25 = null;
            try {
                { // Invoke: ... $key
                    TclObject[] objv26 = TJC.grabObjv(interp, 2);
                    TclObject tmp27;
                    try {
                        // Arg 0 constant: ...
                        objv26[0] = const7;
                        // Arg 1 variable: $key
                        tmp27 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp27.preserve();
                        objv26[1] = tmp27;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv26, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp27 = objv26[1];
                        if ( tmp27 != null ) {
                            tmp27.release();
                        }
                        TJC.releaseObjv(interp, objv26, 2);
                    }
                } // End Invoke: ...
                tmp25 = interp.getResult();
                tmp25.preserve();
                final int tmp25_length = TclList.getLength(interp, tmp25);

                for ( int index28 = 0 ; index28 < tmp25_length ; index28 += 2 ) {
                    TclObject tmp29 = null;
                    if ( index28 < tmp25_length ) {
                        tmp29 = TclList.index(interp, tmp25, index28);
                    }
                    TclObject tmp30 = null;
                    if ( index28 + 1 < tmp25_length ) {
                        tmp30 = TclList.index(interp, tmp25, index28 + 1);
                    }
                    try {
                        if ( tmp29 == null ) {
                            setVarScalar(interp, "pat_index", "", compiledLocals, 7);
                        } else {
                            setVarScalar(interp, "pat_index", tmp29, compiledLocals, 7);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "pat_index");
                    }
                    try {
                        if ( tmp30 == null ) {
                            setVarScalar(interp, "body_index", "", compiledLocals, 8);
                        } else {
                            setVarScalar(interp, "body_index", tmp30, compiledLocals, 8);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "body_index");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ...
                        { // Invoke: ... $key $body_index
                            TclObject[] objv31 = TJC.grabObjv(interp, 3);
                            TclObject tmp32;
                            try {
                                // Arg 0 constant: ...
                                objv31[0] = const8;
                                // Arg 1 variable: $key
                                tmp32 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp32.preserve();
                                objv31[1] = tmp32;
                                // Arg 2 variable: $body_index
                                tmp32 = getVarScalar(interp, "body_index", compiledLocals, 8);
                                tmp32.preserve();
                                objv31[2] = tmp32;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv31, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp32 = objv31[1];
                                if ( tmp32 != null ) {
                                    tmp32.release();
                                }
                                tmp32 = objv31[2];
                                if ( tmp32 != null ) {
                                    tmp32.release();
                                }
                                TJC.releaseObjv(interp, objv31, 3);
                            }
                        } // End Invoke: ...
                        TclObject tmp33 = interp.getResult();
                        ExprValue tmp34 = evs0;
                        TJC.exprInitValue(interp, tmp34, tmp33);
                        boolean tmp35 = tmp34.getBooleanValue(interp);
                        if ( tmp35 ) {
                            { // Invoke: lappend container_commands {}
                                TclObject[] objv36 = TJC.grabObjv(interp, 1);
                                TclObject tmp37;
                                try {
                                    // Arg 2 constant: {}
                                    objv36[0] = const9;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "container_commands", objv36, compiledLocals, 6);
                                } finally {
                                    TJC.releaseObjv(interp, objv36, 1);
                                }
                            } // End Invoke: lappend
                            { // Invoke: continue
                                if ( true ) { continue; }
                            } // End Invoke: continue
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ... else ...
                        { // Invoke: ... $key $body_index
                            TclObject[] objv38 = TJC.grabObjv(interp, 3);
                            TclObject tmp39;
                            try {
                                // Arg 0 constant: ...
                                objv38[0] = const10;
                                // Arg 1 variable: $key
                                tmp39 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp39.preserve();
                                objv38[1] = tmp39;
                                // Arg 2 variable: $body_index
                                tmp39 = getVarScalar(interp, "body_index", compiledLocals, 8);
                                tmp39.preserve();
                                objv38[2] = tmp39;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv38, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                tmp39 = objv38[1];
                                if ( tmp39 != null ) {
                                    tmp39.release();
                                }
                                tmp39 = objv38[2];
                                if ( tmp39 != null ) {
                                    tmp39.release();
                                }
                                TJC.releaseObjv(interp, objv38, 3);
                            }
                        } // End Invoke: ...
                        TclObject tmp40 = interp.getResult();
                        ExprValue tmp41 = evs0;
                        TJC.exprInitValue(interp, tmp41, tmp40);
                        boolean tmp42 = tmp41.getBooleanValue(interp);
                        if ( tmp42 ) {
                            { // Invoke: ...
                                TclObject[] objv43 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv43[0] = const11;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv43, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv43, 1);
                                }
                            } // End Invoke: ...
                            { // Invoke: ... $key $script $tree $body_index
                                TclObject[] objv44 = TJC.grabObjv(interp, 5);
                                TclObject tmp45;
                                try {
                                    // Arg 0 constant: ...
                                    objv44[0] = const12;
                                    // Arg 1 variable: $key
                                    tmp45 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp45.preserve();
                                    objv44[1] = tmp45;
                                    // Arg 2 variable: $script
                                    tmp45 = getVarScalar(interp, "script", compiledLocals, 3);
                                    tmp45.preserve();
                                    objv44[2] = tmp45;
                                    // Arg 3 variable: $tree
                                    tmp45 = getVarScalar(interp, "tree", compiledLocals, 4);
                                    tmp45.preserve();
                                    objv44[3] = tmp45;
                                    // Arg 4 variable: $body_index
                                    tmp45 = getVarScalar(interp, "body_index", compiledLocals, 8);
                                    tmp45.preserve();
                                    objv44[4] = tmp45;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                        ? cmdcache9.cmd : null), objv44, 0);
                                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                        updateCmdCache(interp, 9);
                                    }
                                } finally {
                                    tmp45 = objv44[1];
                                    if ( tmp45 != null ) {
                                        tmp45.release();
                                    }
                                    tmp45 = objv44[2];
                                    if ( tmp45 != null ) {
                                        tmp45.release();
                                    }
                                    tmp45 = objv44[3];
                                    if ( tmp45 != null ) {
                                        tmp45.release();
                                    }
                                    tmp45 = objv44[4];
                                    if ( tmp45 != null ) {
                                        tmp45.release();
                                    }
                                    TJC.releaseObjv(interp, objv44, 5);
                                }
                            } // End Invoke: ...
                            { // Invoke: lappend container_commands [...]
                                TclObject[] objv46 = TJC.grabObjv(interp, 1);
                                TclObject tmp47;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ...
                                        TclObject[] objv48 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: ...
                                            objv48[0] = const13;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                ? cmdcache10.cmd : null), objv48, 0);
                                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                updateCmdCache(interp, 10);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv48, 1);
                                        }
                                    } // End Invoke: ...
                                    tmp47 = interp.getResult();
                                    tmp47.preserve();
                                    objv46[0] = tmp47;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "container_commands", objv46, compiledLocals, 6);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv46, 1);
                                }
                            } // End Invoke: lappend
                        } else {
                            { // Invoke: lappend container_commands {}
                                TclObject[] objv49 = TJC.grabObjv(interp, 1);
                                TclObject tmp50;
                                try {
                                    // Arg 2 constant: {}
                                    objv49[0] = const9;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "container_commands", objv49, compiledLocals, 6);
                                } finally {
                                    TJC.releaseObjv(interp, objv49, 1);
                                }
                            } // End Invoke: lappend
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp25 != null ) {
                    tmp25.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set "..." $container_commands
            TclObject tmp51;
            String tmp52;
            StringBuffer sbtmp53 = new StringBuffer(64);
            tmp51 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp53.append(tmp51.toString());
            sbtmp53.append(",container_commands");
            tmp52 = sbtmp53.toString();
            tmp51 = getVarScalar(interp, "container_commands", compiledLocals, 6);
            tmp51 = setVarArray(interp, "_descend", tmp52, tmp51, compiledLocals, 1);
            interp.setResult(tmp51);
        } // End Invoke: set
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_switch");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_container_switch_validate");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_get_data");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("usage");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_report_usage");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("script");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("tree");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_container_switch_string");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_switch_patbody_indexes");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_container_switch_is_fallthrough");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("descend_container_argument_body_is_static");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("_descend_commands_push");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("descend_container_body_argument");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("_descend_commands_pop");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_container_switch_validate";
                break;
            }
            case 2: {
                cmdName = "descend_get_data";
                break;
            }
            case 3: {
                cmdName = "descend_report_usage";
                break;
            }
            case 4: {
                cmdName = "descend_container_switch_string";
                break;
            }
            case 5: {
                cmdName = "descend_container_switch_patbody_indexes";
                break;
            }
            case 6: {
                cmdName = "descend_container_switch_is_fallthrough";
                break;
            }
            case 7: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            case 8: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 9: {
                cmdName = "descend_container_body_argument";
                break;
            }
            case 10: {
                cmdName = "_descend_commands_pop";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "result",
        "script",
        "tree",
        "string_index",
        "container_commands",
        "pat_index",
        "body_index"
    };
} // end class DescendContainerSwitchCmd

