// TJC implementation of procedure descend_get_container_stack
package tjc;
import tcl.lang.*;

public class DescendGetContainerStackCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 0);
        } // End Invoke: global
        { // Invoke: return $...
            TclObject tmp0 = getVarArray(interp, "_descend", "container_stack", compiledLocals, 0);
            interp.resetResult();
            interp.setResult(tmp0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_get_container_stack");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "_descend"
    };
} // end class DescendGetContainerStackCmd

