// TJC implementation of procedure descend_get_data
package tjc;
import tcl.lang.*;

public class DescendGetDataCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key dname");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "dname", objv[2], compiledLocals, 1);
        { // Invoke: if ... ...
            { // Invoke: catch ... err
                int code0 = TCL.OK;
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set result $...
                    TclObject tmp1;
                    StringBuffer sbtmp2 = new StringBuffer(64);
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp2.append(tmp1.toString());
                    sbtmp2.append(",");
                    tmp1 = getVarScalar(interp, "dname", compiledLocals, 1);
                    sbtmp2.append(tmp1.toString());
                    initVarScoped(interp, "::_descend", compiledLocals, 2);
                    tmp1 = getVarArray(interp, "::_descend", sbtmp2.toString(), compiledLocals, 2);
                    tmp1 = setVarScalar(interp, "result", tmp1, compiledLocals, 3);
                    interp.setResult(tmp1);
                } // End Invoke: set
                } catch (TclException ex) {
                    code0 = ex.getCompletionCode();
                }
                TclObject result = interp.getResult();
                try {
                    setVarScalar(interp, "err", result, compiledLocals, 4);
                } catch (TclException ex) {
                    TJC.catchVarErr(interp);
                }
                interp.resetResult();
                interp.setResult(code0);
            } // End Invoke: catch
            TclObject tmp3 = interp.getResult();
            ExprValue tmp4 = evs0;
            TJC.exprInitValue(interp, tmp4, tmp3);
            boolean tmp5 = tmp4.getBooleanValue(interp);
            if ( tmp5 ) {
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: info exists "..."
                        TclObject[] objv6 = TJC.grabObjv(interp, 3);
                        TclObject tmp7;
                        try {
                            // Arg 0 constant: info
                            objv6[0] = const0;
                            // Arg 1 constant: exists
                            objv6[1] = const1;
                            // Arg 2 word: "..."
                            StringBuffer sbtmp8 = new StringBuffer(64);
                            sbtmp8.append("::_descend(");
                            tmp7 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp8.append(tmp7.toString());
                            sbtmp8.append(",script)");
                            tmp7 = TclString.newInstance(sbtmp8);
                            tmp7.preserve();
                            objv6[2] = tmp7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv6, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp7 = objv6[2];
                            if ( tmp7 != null ) {
                                tmp7.release();
                            }
                            TJC.releaseObjv(interp, objv6, 3);
                        }
                    } // End Invoke: info
                    TclObject tmp9 = interp.getResult();
                    ExprValue tmp10 = evs0;
                    if ( tmp9.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp10, tmp9);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp10, tmp9);
                    }
                    // End Unary operator: !
                    boolean tmp11 = ( tmp10.getIntValue() != 0 );
                    if ( tmp11 ) {
                        { // Invoke: error "..."
                            TclObject[] objv12 = TJC.grabObjv(interp, 2);
                            TclObject tmp13;
                            try {
                                // Arg 0 constant: error
                                objv12[0] = const2;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp14 = new StringBuffer(64);
                                sbtmp14.append("key ");
                                sbtmp14.append("\"");
                                tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                                sbtmp14.append(tmp13.toString());
                                sbtmp14.append("\"");
                                sbtmp14.append(" does not exists");
                                tmp13 = TclString.newInstance(sbtmp14);
                                tmp13.preserve();
                                objv12[1] = tmp13;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv12, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp13 = objv12[1];
                                if ( tmp13 != null ) {
                                    tmp13.release();
                                }
                                TJC.releaseObjv(interp, objv12, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: info exists "..."
                        TclObject[] objv15 = TJC.grabObjv(interp, 3);
                        TclObject tmp16;
                        try {
                            // Arg 0 constant: info
                            objv15[0] = const0;
                            // Arg 1 constant: exists
                            objv15[1] = const1;
                            // Arg 2 word: "..."
                            StringBuffer sbtmp17 = new StringBuffer(64);
                            sbtmp17.append("::_descend(");
                            tmp16 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp17.append(tmp16.toString());
                            sbtmp17.append(",");
                            tmp16 = getVarScalar(interp, "dname", compiledLocals, 1);
                            sbtmp17.append(tmp16.toString());
                            sbtmp17.append(")");
                            tmp16 = TclString.newInstance(sbtmp17);
                            tmp16.preserve();
                            objv15[2] = tmp16;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv15, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp16 = objv15[2];
                            if ( tmp16 != null ) {
                                tmp16.release();
                            }
                            TJC.releaseObjv(interp, objv15, 3);
                        }
                    } // End Invoke: info
                    TclObject tmp18 = interp.getResult();
                    ExprValue tmp19 = evs0;
                    if ( tmp18.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp19, tmp18);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp19, tmp18);
                    }
                    // End Unary operator: !
                    boolean tmp20 = ( tmp19.getIntValue() != 0 );
                    if ( tmp20 ) {
                        { // Invoke: error "..."
                            TclObject[] objv21 = TJC.grabObjv(interp, 2);
                            TclObject tmp22;
                            try {
                                // Arg 0 constant: error
                                objv21[0] = const2;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp23 = new StringBuffer(64);
                                sbtmp23.append("data ");
                                sbtmp23.append("\"");
                                tmp22 = getVarScalar(interp, "dname", compiledLocals, 1);
                                sbtmp23.append(tmp22.toString());
                                sbtmp23.append("\"");
                                sbtmp23.append(" does not exists for key ");
                                sbtmp23.append("\"");
                                tmp22 = getVarScalar(interp, "key", compiledLocals, 0);
                                sbtmp23.append(tmp22.toString());
                                sbtmp23.append("\"");
                                tmp22 = TclString.newInstance(sbtmp23);
                                tmp22.preserve();
                                objv21[1] = tmp22;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv21, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp22 = objv21[1];
                                if ( tmp22 != null ) {
                                    tmp22.release();
                                }
                                TJC.releaseObjv(interp, objv21, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: error $err
                    TclObject[] objv24 = TJC.grabObjv(interp, 2);
                    TclObject tmp25;
                    try {
                        // Arg 0 constant: error
                        objv24[0] = const2;
                        // Arg 1 variable: $err
                        tmp25 = getVarScalar(interp, "err", compiledLocals, 4);
                        tmp25.preserve();
                        objv24[1] = tmp25;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv24, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp25 = objv24[1];
                        if ( tmp25 != null ) {
                            tmp25.release();
                        }
                        TJC.releaseObjv(interp, objv24, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: return $result
            TclObject tmp26 = getVarScalar(interp, "result", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp26);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_get_data");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "dname",
        "::_descend",
        "result",
        "err"
    };
} // end class DescendGetDataCmd

