// TJC implementation of procedure descend_nested_subtree
package tjc;
import tcl.lang.*;

public class DescendNestedSubtreeCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        try {
        if (objv.length < 3 || objv.length > 4) {
            throw new TclNumArgsException(interp, 1, objv, "script subtree ?undetermined?");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "subtree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "undetermined", 
            ((objv.length <= 3) ? const0 : objv[3]), compiledLocals, 2);
        { // Invoke: set nested 1
            setVarScalar(interp, "nested", const1, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set chknested 1
            setVarScalar(interp, "chknested", const1, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set outermost 0
            setVarScalar(interp, "outermost", const0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set range [...]
            TclObject tmp0;
            { // Invoke: lindex $subtree 1
                TclObject tmp1 = getVarScalar(interp, "subtree", compiledLocals, 1);
                tmp1 = TclList.index(interp, tmp1, 1);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "range", tmp0, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set unbracked_range [...]
            TclObject tmp2;
            { // Invoke: ... $script $subtree $range
                TclObject[] objv3 = TJC.grabObjv(interp, 4);
                TclObject tmp4;
                try {
                    // Arg 0 constant: ...
                    objv3[0] = const2;
                    // Arg 1 variable: $script
                    tmp4 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp4.preserve();
                    objv3[1] = tmp4;
                    // Arg 2 variable: $subtree
                    tmp4 = getVarScalar(interp, "subtree", compiledLocals, 1);
                    tmp4.preserve();
                    objv3[2] = tmp4;
                    // Arg 3 variable: $range
                    tmp4 = getVarScalar(interp, "range", compiledLocals, 6);
                    tmp4.preserve();
                    objv3[3] = tmp4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv3, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp4 = objv3[1];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    tmp4 = objv3[2];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    tmp4 = objv3[3];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 4);
                }
            } // End Invoke: ...
            tmp2 = interp.getResult();
            setVarScalar(interp, "unbracked_range", tmp2, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set keys [...]
            TclObject tmp5;
            { // Invoke: descend_start $script $unbracked_range $nested $chknested $undetermined $outermost
                TclObject[] objv6 = TJC.grabObjv(interp, 7);
                TclObject tmp7;
                try {
                    // Arg 0 constant: descend_start
                    objv6[0] = const3;
                    // Arg 1 variable: $script
                    tmp7 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp7.preserve();
                    objv6[1] = tmp7;
                    // Arg 2 variable: $unbracked_range
                    tmp7 = getVarScalar(interp, "unbracked_range", compiledLocals, 7);
                    tmp7.preserve();
                    objv6[2] = tmp7;
                    // Arg 3 variable: $nested
                    tmp7 = getVarScalar(interp, "nested", compiledLocals, 3);
                    tmp7.preserve();
                    objv6[3] = tmp7;
                    // Arg 4 variable: $chknested
                    tmp7 = getVarScalar(interp, "chknested", compiledLocals, 4);
                    tmp7.preserve();
                    objv6[4] = tmp7;
                    // Arg 5 variable: $undetermined
                    tmp7 = getVarScalar(interp, "undetermined", compiledLocals, 2);
                    tmp7.preserve();
                    objv6[5] = tmp7;
                    // Arg 6 variable: $outermost
                    tmp7 = getVarScalar(interp, "outermost", compiledLocals, 5);
                    tmp7.preserve();
                    objv6[6] = tmp7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv6, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    objv6[0] = null;
                    TJC.releaseObjvElems(interp, objv6, 7);
                }
            } // End Invoke: descend_start
            tmp5 = interp.getResult();
            setVarScalar(interp, "keys", tmp5, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: return $keys
            TclObject tmp8 = getVarScalar(interp, "keys", compiledLocals, 8);
            interp.resetResult();
            interp.setResult(tmp8);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_nested_subtree");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_range_bracked");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_start");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_range_bracked";
                break;
            }
            case 2: {
                cmdName = "descend_start";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "subtree",
        "undetermined",
        "nested",
        "chknested",
        "outermost",
        "range",
        "unbracked_range",
        "keys"
    };
} // end class DescendNestedSubtreeCmd

