// TJC implementation of procedure emitter_container_foreach_list_release
package tjc;
import tcl.lang.*;

public class EmitterContainerForeachListReleaseCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "list_symbol");
        }
        setVarScalar(interp, "list_symbol", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: append buffer [...] [...] [...]
            TclObject[] objv0 = TJC.grabObjv(interp, 3);
            TclObject tmp1;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... "..."
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    TclObject tmp3;
                    try {
                        // Arg 0 constant: ...
                        objv2[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp4 = new StringBuffer(64);
                        tmp3 = getVarScalar(interp, "list_symbol", compiledLocals, 0);
                        sbtmp4.append(tmp3.toString());
                        sbtmp4.append(" != null");
                        tmp3 = TclString.newInstance(sbtmp4);
                        tmp3.preserve();
                        objv2[1] = tmp3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp3 = objv2[1];
                        if ( tmp3 != null ) {
                            tmp3.release();
                        }
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: ...
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[0] = tmp1;
                // Arg 3 command: [...]
                { // Invoke: ... $list_symbol
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: ...
                        objv5[0] = const2;
                        // Arg 1 variable: $list_symbol
                        tmp6 = getVarScalar(interp, "list_symbol", compiledLocals, 0);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: ...
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[1] = tmp1;
                // Arg 4 command: [...]
                { // Invoke: ...
                    TclObject[] objv7 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv7[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv7, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv7, 1);
                    }
                } // End Invoke: ...
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[2] = tmp1;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv0, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv0, 3);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp8 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp8);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_container_foreach_list_release");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_container_if_start");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("emitter_tclobject_release");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_container_if_end");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_container_if_start";
                break;
            }
            case 2: {
                cmdName = "emitter_tclobject_release";
                break;
            }
            case 3: {
                cmdName = "emitter_container_if_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "list_symbol",
        "buffer"
    };
} // end class EmitterContainerForeachListReleaseCmd

