// TJC implementation of procedure jdk_config_isvar
package tjc;
import tcl.lang.*;

public class JdkConfigIsvarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "name");
        }
        setVarScalar(interp, "name", objv[1], compiledLocals, 0);
        { // Invoke: switch -exact $name {JAVAC} - {JAR} - {CLASSPATH} ... default ...
            TclObject tmp0 = getVarScalar(interp, "name", compiledLocals, 0);
            String tmp1 = tmp0.toString();
            TJC.switchStringIsNotOption(interp, tmp1);
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            interp.resetResult();
            if ( ( tmp1_length == 5 && tmp1_first == 'J'
                    && tmp1.compareTo("JAVAC") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 'J'
                    && tmp1.compareTo("JAR") == 0 ) ||
                ( tmp1_length == 9 && tmp1_first == 'C'
                    && tmp1.compareTo("CLASSPATH") == 0 ) ) {
                // Pattern {CLASSPATH}
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Pattern default
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "jdk_config_isvar");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
    }

    String[] compiledLocalsNames = {
        "name"
    };
} // end class JdkConfigIsvarCmd

