// TJC implementation of procedure jdk_tool_jar
package tjc;
import tcl.lang.*;

public class JdkToolJarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 12, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 2 || objv.length > 3) {
            throw new TclNumArgsException(interp, 1, objv, "jarname ?location?");
        }
        setVarScalar(interp, "jarname", objv[1], compiledLocals, 0);
        setVarScalar(interp, "location", 
            ((objv.length <= 2) ? const0 : objv[2]), compiledLocals, 1);
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const1, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set TJC [...]
            TclObject tmp0;
            { // Invoke: file join [...] [...]
                TclObject[] objv1 = TJC.grabObjv(interp, 4);
                TclObject tmp2;
                try {
                    // Arg 0 constant: file
                    objv1[0] = const2;
                    // Arg 1 constant: join
                    objv1[1] = const3;
                    // Arg 2 command: [...]
                    { // Invoke: pwd
                        TclObject[] objv3 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: pwd
                            objv3[0] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv3, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv3, 1);
                        }
                    } // End Invoke: pwd
                    tmp2 = interp.getResult();
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    // Arg 3 command: [...]
                    { // Invoke: jdk_tjc_rootdir
                        TclObject[] objv4 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: jdk_tjc_rootdir
                            objv4[0] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv4, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv4, 1);
                        }
                    } // End Invoke: jdk_tjc_rootdir
                    tmp2 = interp.getResult();
                    tmp2.preserve();
                    objv1[3] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv1, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[3];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 4);
                }
            } // End Invoke: file
            tmp0 = interp.getResult();
            setVarScalar(interp, "TJC", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set TJC_BUILD [...]
            TclObject tmp5;
            { // Invoke: file join $TJC build
                TclObject[] objv6 = TJC.grabObjv(interp, 4);
                TclObject tmp7;
                try {
                    // Arg 0 constant: file
                    objv6[0] = const2;
                    // Arg 1 constant: join
                    objv6[1] = const3;
                    // Arg 2 variable: $TJC
                    tmp7 = getVarScalar(interp, "TJC", compiledLocals, 3);
                    tmp7.preserve();
                    objv6[2] = tmp7;
                    // Arg 3 constant: build
                    objv6[3] = const6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv6, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp7 = objv6[2];
                    if ( tmp7 != null ) {
                        tmp7.release();
                    }
                    TJC.releaseObjv(interp, objv6, 4);
                }
            } // End Invoke: file
            tmp5 = interp.getResult();
            setVarScalar(interp, "TJC_BUILD", tmp5, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set TJC_SOURCE [...]
            TclObject tmp8;
            { // Invoke: file join $TJC source
                TclObject[] objv9 = TJC.grabObjv(interp, 4);
                TclObject tmp10;
                try {
                    // Arg 0 constant: file
                    objv9[0] = const2;
                    // Arg 1 constant: join
                    objv9[1] = const3;
                    // Arg 2 variable: $TJC
                    tmp10 = getVarScalar(interp, "TJC", compiledLocals, 3);
                    tmp10.preserve();
                    objv9[2] = tmp10;
                    // Arg 3 constant: source
                    objv9[3] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv9, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp10 = objv9[2];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    TJC.releaseObjv(interp, objv9, 4);
                }
            } // End Invoke: file
            tmp8 = interp.getResult();
            setVarScalar(interp, "TJC_SOURCE", tmp8, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set TJC_JAR [...]
            TclObject tmp11;
            { // Invoke: file join $TJC jar
                TclObject[] objv12 = TJC.grabObjv(interp, 4);
                TclObject tmp13;
                try {
                    // Arg 0 constant: file
                    objv12[0] = const2;
                    // Arg 1 constant: join
                    objv12[1] = const3;
                    // Arg 2 variable: $TJC
                    tmp13 = getVarScalar(interp, "TJC", compiledLocals, 3);
                    tmp13.preserve();
                    objv12[2] = tmp13;
                    // Arg 3 constant: jar
                    objv12[3] = const8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv12, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp13 = objv12[2];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    TJC.releaseObjv(interp, objv12, 4);
                }
            } // End Invoke: file
            tmp11 = interp.getResult();
            setVarScalar(interp, "TJC_JAR", tmp11, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set jar [...]
            TclObject tmp14;
            { // Invoke: jdk_config_var JAR
                TclObject[] objv15 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: jdk_config_var
                    objv15[0] = const9;
                    // Arg 1 constant: JAR
                    objv15[1] = const10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv15, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv15, 2);
                }
            } // End Invoke: jdk_config_var
            tmp14 = interp.getResult();
            setVarScalar(interp, "jar", tmp14, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if {$jar == ""} ...
            // Binary operator: $jar == ""
            TclObject tmp16 = getVarScalar(interp, "jar", compiledLocals, 7);
            ExprValue tmp17 = evs0;
            TJC.exprEqualsEmptyString(tmp17, tmp16, false);
            // End Binary operator: ==
            boolean tmp18 = ( tmp17.getIntValue() != 0 );
            if ( tmp18 ) {
                { // Invoke: error "JAR not defined"
                    TclObject[] objv19 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv19[0] = const11;
                        // Arg 1 constant: "JAR not defined"
                        objv19[1] = const12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv19, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv19, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: file mkdir $TJC_JAR
            TclObject[] objv20 = TJC.grabObjv(interp, 3);
            TclObject tmp21;
            try {
                // Arg 0 constant: file
                objv20[0] = const2;
                // Arg 1 constant: mkdir
                objv20[1] = const13;
                // Arg 2 variable: $TJC_JAR
                tmp21 = getVarScalar(interp, "TJC_JAR", compiledLocals, 6);
                tmp21.preserve();
                objv20[2] = tmp21;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv20, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                tmp21 = objv20[2];
                if ( tmp21 != null ) {
                    tmp21.release();
                }
                TJC.releaseObjv(interp, objv20, 3);
            }
        } // End Invoke: file
        { // Invoke: if ... ... else ...
            // Binary operator: $location == "BUILD"
            TclObject tmp22 = getVarScalar(interp, "location", compiledLocals, 1);
            boolean tmp23 = tmp22.toString().equals("BUILD");
            ExprValue tmp24 = evs0;
            tmp24.setIntValue(tmp23);
            // End Binary operator: ==
            boolean tmp25 = ( tmp24.getIntValue() != 0 );
            if ( tmp25 ) {
                { // Invoke: cd $TJC_BUILD
                    TclObject[] objv26 = TJC.grabObjv(interp, 2);
                    TclObject tmp27;
                    try {
                        // Arg 0 constant: cd
                        objv26[0] = const14;
                        // Arg 1 variable: $TJC_BUILD
                        tmp27 = getVarScalar(interp, "TJC_BUILD", compiledLocals, 4);
                        tmp27.preserve();
                        objv26[1] = tmp27;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv26, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp27 = objv26[1];
                        if ( tmp27 != null ) {
                            tmp27.release();
                        }
                        TJC.releaseObjv(interp, objv26, 2);
                    }
                } // End Invoke: cd
            } else {
                { // Invoke: cd $TJC_SOURCE
                    TclObject[] objv28 = TJC.grabObjv(interp, 2);
                    TclObject tmp29;
                    try {
                        // Arg 0 constant: cd
                        objv28[0] = const14;
                        // Arg 1 variable: $TJC_SOURCE
                        tmp29 = getVarScalar(interp, "TJC_SOURCE", compiledLocals, 5);
                        tmp29.preserve();
                        objv28[1] = tmp29;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv28, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp29 = objv28[1];
                        if ( tmp29 != null ) {
                            tmp29.release();
                        }
                        TJC.releaseObjv(interp, objv28, 2);
                    }
                } // End Invoke: cd
            }
        } // End Invoke: if
        { // Invoke: set rdirs [...]
            TclObject tmp30;
            { // Invoke: glob *
                TclObject[] objv31 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: glob
                    objv31[0] = const15;
                    // Arg 1 constant: *
                    objv31[1] = const16;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv31, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv31, 2);
                }
            } // End Invoke: glob
            tmp30 = interp.getResult();
            setVarScalar(interp, "rdirs", tmp30, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp32 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp33 = TJC.getBoolean(interp, tmp32);
            if ( tmp33 ) {
                { // Invoke: puts "..."
                    TclObject[] objv34 = TJC.grabObjv(interp, 2);
                    TclObject tmp35;
                    try {
                        // Arg 0 constant: puts
                        objv34[0] = const17;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp36 = new StringBuffer(64);
                        sbtmp36.append("JAR exec: ");
                        tmp35 = getVarScalar(interp, "jar", compiledLocals, 7);
                        sbtmp36.append(tmp35.toString());
                        sbtmp36.append(" -cf ");
                        tmp35 = getVarScalar(interp, "TJC_JAR", compiledLocals, 6);
                        sbtmp36.append(tmp35.toString());
                        sbtmp36.append("/");
                        tmp35 = getVarScalar(interp, "jarname", compiledLocals, 0);
                        sbtmp36.append(tmp35.toString());
                        sbtmp36.append(" ");
                        tmp35 = getVarScalar(interp, "rdirs", compiledLocals, 8);
                        sbtmp36.append(tmp35.toString());
                        tmp35 = TclString.newInstance(sbtmp36);
                        tmp35.preserve();
                        objv34[1] = tmp35;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                            ? cmdcache8.cmd : null), objv34, 0);
                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                            updateCmdCache(interp, 8);
                        }
                    } finally {
                        tmp35 = objv34[1];
                        if ( tmp35 != null ) {
                            tmp35.release();
                        }
                        TJC.releaseObjv(interp, objv34, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set caught 0
            setVarScalar(interp, "caught", const1, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if ... ...
            { // Invoke: catch ... err
                int code37 = TCL.OK;
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: eval ... $rdirs
                    TclObject[] objv38 = TJC.grabObjv(interp, 3);
                    TclObject tmp39;
                    try {
                        // Arg 0 constant: eval
                        objv38[0] = const18;
                        // Arg 1 constant: ...
                        objv38[1] = const19;
                        // Arg 2 variable: $rdirs
                        tmp39 = getVarScalar(interp, "rdirs", compiledLocals, 8);
                        tmp39.preserve();
                        objv38[2] = tmp39;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                            ? cmdcache9.cmd : null), objv38, 0);
                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                            updateCmdCache(interp, 9);
                        }
                    } finally {
                        tmp39 = objv38[2];
                        if ( tmp39 != null ) {
                            tmp39.release();
                        }
                        TJC.releaseObjv(interp, objv38, 3);
                    }
                } // End Invoke: eval
                } catch (TclException ex) {
                    code37 = ex.getCompletionCode();
                }
                TclObject result = interp.getResult();
                try {
                    setVarScalar(interp, "err", result, compiledLocals, 10);
                } catch (TclException ex) {
                    TJC.catchVarErr(interp);
                }
                interp.resetResult();
                interp.setResult(code37);
            } // End Invoke: catch
            TclObject tmp40 = interp.getResult();
            ExprValue tmp41 = evs0;
            TJC.exprInitValue(interp, tmp41, tmp40);
            boolean tmp42 = tmp41.getBooleanValue(interp);
            if ( tmp42 ) {
                { // Invoke: puts stderr $err
                    TclObject[] objv43 = TJC.grabObjv(interp, 3);
                    TclObject tmp44;
                    try {
                        // Arg 0 constant: puts
                        objv43[0] = const17;
                        // Arg 1 constant: stderr
                        objv43[1] = const20;
                        // Arg 2 variable: $err
                        tmp44 = getVarScalar(interp, "err", compiledLocals, 10);
                        tmp44.preserve();
                        objv43[2] = tmp44;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                            ? cmdcache8.cmd : null), objv43, 0);
                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                            updateCmdCache(interp, 8);
                        }
                    } finally {
                        tmp44 = objv43[2];
                        if ( tmp44 != null ) {
                            tmp44.release();
                        }
                        TJC.releaseObjv(interp, objv43, 3);
                    }
                } // End Invoke: puts
                { // Invoke: set caught 1
                    setVarScalar(interp, "caught", const21, compiledLocals, 9);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: cd ../..
            TclObject[] objv45 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: cd
                objv45[0] = const14;
                // Arg 1 constant: ../..
                objv45[1] = const22;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                    ? cmdcache6.cmd : null), objv45, 0);
                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                    updateCmdCache(interp, 6);
                }
            } finally {
                TJC.releaseObjv(interp, objv45, 2);
            }
        } // End Invoke: cd
        { // Invoke: if {$caught} ... else ...
            TclObject tmp46 = getVarScalar(interp, "caught", compiledLocals, 9);
            boolean tmp47 = TJC.getBoolean(interp, tmp46);
            if ( tmp47 ) {
                { // Invoke: return [...]
                    { // Invoke: list ERROR $err
                        TclObject tmp48 = TclList.newInstance();
                        TclObject tmp49;
                        try {
                            TclList.append(interp, tmp48, const23);
                            tmp49 = getVarScalar(interp, "err", compiledLocals, 10);
                            TclList.append(interp, tmp48, tmp49);
                        } catch (TclException ex) {
                            tmp48.release();
                            throw ex;
                        }
                        interp.setResult(tmp48);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: set jarfile [...]
                    TclObject tmp50;
                    { // Invoke: file join $TJC_JAR/$jarname
                        TclObject[] objv51 = TJC.grabObjv(interp, 3);
                        TclObject tmp52;
                        try {
                            // Arg 0 constant: file
                            objv51[0] = const2;
                            // Arg 1 constant: join
                            objv51[1] = const3;
                            // Arg 2 word: $TJC_JAR/$jarname
                            StringBuffer sbtmp53 = new StringBuffer(64);
                            tmp52 = getVarScalar(interp, "TJC_JAR", compiledLocals, 6);
                            sbtmp53.append(tmp52.toString());
                            sbtmp53.append("/");
                            tmp52 = getVarScalar(interp, "jarname", compiledLocals, 0);
                            sbtmp53.append(tmp52.toString());
                            tmp52 = TclString.newInstance(sbtmp53);
                            tmp52.preserve();
                            objv51[2] = tmp52;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv51, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp52 = objv51[2];
                            if ( tmp52 != null ) {
                                tmp52.release();
                            }
                            TJC.releaseObjv(interp, objv51, 3);
                        }
                    } // End Invoke: file
                    tmp50 = interp.getResult();
                    setVarScalar(interp, "jarfile", tmp50, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: file exists $jarfile
                        TclObject[] objv54 = TJC.grabObjv(interp, 3);
                        TclObject tmp55;
                        try {
                            // Arg 0 constant: file
                            objv54[0] = const2;
                            // Arg 1 constant: exists
                            objv54[1] = const24;
                            // Arg 2 variable: $jarfile
                            tmp55 = getVarScalar(interp, "jarfile", compiledLocals, 11);
                            tmp55.preserve();
                            objv54[2] = tmp55;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv54, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp55 = objv54[2];
                            if ( tmp55 != null ) {
                                tmp55.release();
                            }
                            TJC.releaseObjv(interp, objv54, 3);
                        }
                    } // End Invoke: file
                    TclObject tmp56 = interp.getResult();
                    ExprValue tmp57 = evs0;
                    TJC.exprInitValue(interp, tmp57, tmp56);
                    boolean tmp58 = tmp57.getBooleanValue(interp);
                    if ( tmp58 ) {
                        { // Invoke: return $jarfile
                            TclObject tmp59 = getVarScalar(interp, "jarfile", compiledLocals, 11);
                            interp.resetResult();
                            interp.setResult(tmp59);
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        { // Invoke: return [...]
                            { // Invoke: ERROR "..."
                                TclObject[] objv60 = TJC.grabObjv(interp, 2);
                                TclObject tmp61;
                                try {
                                    // Arg 0 constant: ERROR
                                    objv60[0] = const23;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp62 = new StringBuffer(64);
                                    sbtmp62.append("jar file TJC_JAR/");
                                    tmp61 = getVarScalar(interp, "jarname", compiledLocals, 0);
                                    sbtmp62.append(tmp61.toString());
                                    sbtmp62.append(" not found");
                                    tmp61 = TclString.newInstance(sbtmp62);
                                    tmp61.preserve();
                                    objv60[1] = tmp61;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                        ? cmdcache10.cmd : null), objv60, 0);
                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                        updateCmdCache(interp, 10);
                                    }
                                } finally {
                                    tmp61 = objv60[1];
                                    if ( tmp61 != null ) {
                                        tmp61.release();
                                    }
                                    TJC.releaseObjv(interp, objv60, 2);
                                }
                            } // End Invoke: ERROR
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "jdk_tool_jar");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("BUILD");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("file");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("join");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("pwd");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("jdk_tjc_rootdir");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("build");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("source");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("jar");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("jdk_config_var");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("JAR");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("error");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("JAR not defined");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("mkdir");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("cd");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("glob");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("*");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("puts");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("eval");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("exec $jar -cf $TJC_JAR/$jarname");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("stderr");
        const20.preserve(); const20.preserve();
        const21 = TclInteger.newInstance(1);
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("../..");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("ERROR");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("exists");
        const24.preserve(); const24.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "pwd";
                break;
            }
            case 2: {
                cmdName = "jdk_tjc_rootdir";
                break;
            }
            case 3: {
                cmdName = "file";
                break;
            }
            case 4: {
                cmdName = "jdk_config_var";
                break;
            }
            case 5: {
                cmdName = "error";
                break;
            }
            case 6: {
                cmdName = "cd";
                break;
            }
            case 7: {
                cmdName = "glob";
                break;
            }
            case 8: {
                cmdName = "puts";
                break;
            }
            case 9: {
                cmdName = "eval";
                break;
            }
            case 10: {
                cmdName = "ERROR";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "jarname",
        "location",
        "debug",
        "TJC",
        "TJC_BUILD",
        "TJC_SOURCE",
        "TJC_JAR",
        "jar",
        "rdirs",
        "caught",
        "err",
        "jarfile"
    };
} // end class JdkToolJarCmd

