// TJC implementation of procedure jdk_tool_javac_save
package tjc;
import tcl.lang.*;

public class JdkToolJavacSaveCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "cname cdata");
        }
        setVarScalar(interp, "cname", objv[1], compiledLocals, 0);
        setVarScalar(interp, "cdata", objv[2], compiledLocals, 1);
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set TJC [...]
            TclObject tmp0;
            { // Invoke: file join [...] [...]
                TclObject[] objv1 = TJC.grabObjv(interp, 4);
                TclObject tmp2;
                try {
                    // Arg 0 constant: file
                    objv1[0] = const1;
                    // Arg 1 constant: join
                    objv1[1] = const2;
                    // Arg 2 command: [...]
                    { // Invoke: pwd
                        TclObject[] objv3 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: pwd
                            objv3[0] = const3;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv3, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv3, 1);
                        }
                    } // End Invoke: pwd
                    tmp2 = interp.getResult();
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    // Arg 3 command: [...]
                    { // Invoke: jdk_tjc_rootdir
                        TclObject[] objv4 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: jdk_tjc_rootdir
                            objv4[0] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv4, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv4, 1);
                        }
                    } // End Invoke: jdk_tjc_rootdir
                    tmp2 = interp.getResult();
                    tmp2.preserve();
                    objv1[3] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv1, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[3];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 4);
                }
            } // End Invoke: file
            tmp0 = interp.getResult();
            setVarScalar(interp, "TJC", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: [...] == ()
            { // Invoke: string first "." $cname
                char tmp5 = '.';
                TclObject tmp6 = getVarScalar(interp, "cname", compiledLocals, 0);
                String tmp7 = tmp6.toString();
                int tmp8 = tmp7.indexOf(tmp5);
                interp.setResult(tmp8);
            } // End Invoke: string
            TclObject tmp9 = interp.getResult();
            ExprValue tmp10 = evs0;
            TJC.exprInitValue(interp, tmp10, tmp9);
            // Unary operator: - 1
            ExprValue tmp11 = evs1;
            tmp11.setIntValue(-1);
            // End Unary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp10, tmp11);
            // End Binary operator: ==
            boolean tmp12 = ( tmp10.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: set pkg_dir [...]
                    TclObject tmp13;
                    { // Invoke: file join $TJC source default
                        TclObject[] objv14 = TJC.grabObjv(interp, 5);
                        TclObject tmp15;
                        try {
                            // Arg 0 constant: file
                            objv14[0] = const1;
                            // Arg 1 constant: join
                            objv14[1] = const2;
                            // Arg 2 variable: $TJC
                            tmp15 = getVarScalar(interp, "TJC", compiledLocals, 3);
                            tmp15.preserve();
                            objv14[2] = tmp15;
                            // Arg 3 constant: source
                            objv14[3] = const5;
                            // Arg 4 constant: default
                            objv14[4] = const6;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv14, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp15 = objv14[2];
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                            TJC.releaseObjv(interp, objv14, 5);
                        }
                    } // End Invoke: file
                    tmp13 = interp.getResult();
                    setVarScalar(interp, "pkg_dir", tmp13, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set fname [...]
                    TclObject tmp16;
                    { // Invoke: file join $pkg_dir $cname.java
                        TclObject[] objv17 = TJC.grabObjv(interp, 4);
                        TclObject tmp18;
                        try {
                            // Arg 0 constant: file
                            objv17[0] = const1;
                            // Arg 1 constant: join
                            objv17[1] = const2;
                            // Arg 2 variable: $pkg_dir
                            tmp18 = getVarScalar(interp, "pkg_dir", compiledLocals, 4);
                            tmp18.preserve();
                            objv17[2] = tmp18;
                            // Arg 3 word: $cname.java
                            StringBuffer sbtmp19 = new StringBuffer(64);
                            tmp18 = getVarScalar(interp, "cname", compiledLocals, 0);
                            sbtmp19.append(tmp18.toString());
                            sbtmp19.append(".java");
                            tmp18 = TclString.newInstance(sbtmp19);
                            tmp18.preserve();
                            objv17[3] = tmp18;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv17, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp18 = objv17[2];
                            if ( tmp18 != null ) {
                                tmp18.release();
                            }
                            tmp18 = objv17[3];
                            if ( tmp18 != null ) {
                                tmp18.release();
                            }
                            TJC.releaseObjv(interp, objv17, 4);
                        }
                    } // End Invoke: file
                    tmp16 = interp.getResult();
                    setVarScalar(interp, "fname", tmp16, compiledLocals, 5);
                } // End Invoke: set
            } else {
                { // Invoke: set names [...]
                    TclObject tmp20;
                    { // Invoke: split $cname .
                        TclObject[] objv21 = TJC.grabObjv(interp, 3);
                        TclObject tmp22;
                        try {
                            // Arg 0 constant: split
                            objv21[0] = const7;
                            // Arg 1 variable: $cname
                            tmp22 = getVarScalar(interp, "cname", compiledLocals, 0);
                            tmp22.preserve();
                            objv21[1] = tmp22;
                            // Arg 2 constant: .
                            objv21[2] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv21, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp22 = objv21[1];
                            if ( tmp22 != null ) {
                                tmp22.release();
                            }
                            TJC.releaseObjv(interp, objv21, 3);
                        }
                    } // End Invoke: split
                    tmp20 = interp.getResult();
                    setVarScalar(interp, "names", tmp20, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set pkg_dir [...]
                    TclObject tmp23;
                    { // Invoke: eval ... [...]
                        TclObject[] objv24 = TJC.grabObjv(interp, 3);
                        TclObject tmp25;
                        try {
                            // Arg 0 constant: eval
                            objv24[0] = const9;
                            // Arg 1 constant: ...
                            objv24[1] = const10;
                            // Arg 2 command: [...]
                            { // Invoke: lrange $names 0 end-1
                                TclObject[] objv26 = TJC.grabObjv(interp, 4);
                                TclObject tmp27;
                                try {
                                    // Arg 0 constant: lrange
                                    objv26[0] = const11;
                                    // Arg 1 variable: $names
                                    tmp27 = getVarScalar(interp, "names", compiledLocals, 6);
                                    tmp27.preserve();
                                    objv26[1] = tmp27;
                                    // Arg 2 constant: 0
                                    objv26[2] = const0;
                                    // Arg 3 constant: end-1
                                    objv26[3] = const12;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv26, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp27 = objv26[1];
                                    if ( tmp27 != null ) {
                                        tmp27.release();
                                    }
                                    TJC.releaseObjv(interp, objv26, 4);
                                }
                            } // End Invoke: lrange
                            tmp25 = interp.getResult();
                            tmp25.preserve();
                            objv24[2] = tmp25;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv24, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp25 = objv24[2];
                            if ( tmp25 != null ) {
                                tmp25.release();
                            }
                            TJC.releaseObjv(interp, objv24, 3);
                        }
                    } // End Invoke: eval
                    tmp23 = interp.getResult();
                    setVarScalar(interp, "pkg_dir", tmp23, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set fname [...]
                    TclObject tmp28;
                    { // Invoke: file join $pkg_dir "..."
                        TclObject[] objv29 = TJC.grabObjv(interp, 4);
                        TclObject tmp30;
                        try {
                            // Arg 0 constant: file
                            objv29[0] = const1;
                            // Arg 1 constant: join
                            objv29[1] = const2;
                            // Arg 2 variable: $pkg_dir
                            tmp30 = getVarScalar(interp, "pkg_dir", compiledLocals, 4);
                            tmp30.preserve();
                            objv29[2] = tmp30;
                            // Arg 3 word: "..."
                            StringBuffer sbtmp31 = new StringBuffer(64);
                            { // Invoke: lindex $names end
                                TclObject tmp32 = null;
                                TclObject tmp33;
                                try {
                                    tmp32 = getVarScalar(interp, "names", compiledLocals, 6);
                                    tmp32.preserve();
                                    tmp33 = const13;
                                    TJC.lindexNonconst(interp, tmp32, tmp33);
                                } finally {
                                    if ( tmp32 != null ) {
                                        tmp32.release();
                                    }
                                }
                            } // End Invoke: lindex
                            tmp30 = interp.getResult();
                            sbtmp31.append(tmp30.toString());
                            sbtmp31.append(".java");
                            tmp30 = TclString.newInstance(sbtmp31);
                            tmp30.preserve();
                            objv29[3] = tmp30;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv29, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp30 = objv29[2];
                            if ( tmp30 != null ) {
                                tmp30.release();
                            }
                            tmp30 = objv29[3];
                            if ( tmp30 != null ) {
                                tmp30.release();
                            }
                            TJC.releaseObjv(interp, objv29, 4);
                        }
                    } // End Invoke: file
                    tmp28 = interp.getResult();
                    setVarScalar(interp, "fname", tmp28, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$debug} ...
            TclObject tmp34 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp35 = TJC.getBoolean(interp, tmp34);
            if ( tmp35 ) {
                { // Invoke: puts "..."
                    TclObject[] objv36 = TJC.grabObjv(interp, 2);
                    TclObject tmp37;
                    try {
                        // Arg 0 constant: puts
                        objv36[0] = const14;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp38 = new StringBuffer(64);
                        sbtmp38.append("pkg_dir is ");
                        sbtmp38.append("\"");
                        tmp37 = getVarScalar(interp, "pkg_dir", compiledLocals, 4);
                        sbtmp38.append(tmp37.toString());
                        sbtmp38.append("\"");
                        tmp37 = TclString.newInstance(sbtmp38);
                        tmp37.preserve();
                        objv36[1] = tmp37;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv36, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        tmp37 = objv36[1];
                        if ( tmp37 != null ) {
                            tmp37.release();
                        }
                        TJC.releaseObjv(interp, objv36, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv39 = TJC.grabObjv(interp, 2);
                    TclObject tmp40;
                    try {
                        // Arg 0 constant: puts
                        objv39[0] = const14;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp41 = new StringBuffer(64);
                        sbtmp41.append("fname is ");
                        sbtmp41.append("\"");
                        tmp40 = getVarScalar(interp, "fname", compiledLocals, 5);
                        sbtmp41.append(tmp40.toString());
                        sbtmp41.append("\"");
                        tmp40 = TclString.newInstance(sbtmp41);
                        tmp40.preserve();
                        objv39[1] = tmp40;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv39, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        tmp40 = objv39[1];
                        if ( tmp40 != null ) {
                            tmp40.release();
                        }
                        TJC.releaseObjv(interp, objv39, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: if ... ... elseif ... ...
            // Unary operator: ! [...]
            { // Invoke: file exists $pkg_dir
                TclObject[] objv42 = TJC.grabObjv(interp, 3);
                TclObject tmp43;
                try {
                    // Arg 0 constant: file
                    objv42[0] = const1;
                    // Arg 1 constant: exists
                    objv42[1] = const15;
                    // Arg 2 variable: $pkg_dir
                    tmp43 = getVarScalar(interp, "pkg_dir", compiledLocals, 4);
                    tmp43.preserve();
                    objv42[2] = tmp43;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv42, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp43 = objv42[2];
                    if ( tmp43 != null ) {
                        tmp43.release();
                    }
                    TJC.releaseObjv(interp, objv42, 3);
                }
            } // End Invoke: file
            TclObject tmp44 = interp.getResult();
            ExprValue tmp45 = evs0;
            if ( tmp44.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp45, tmp44);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp45, tmp44);
            }
            // End Unary operator: !
            boolean tmp46 = ( tmp45.getIntValue() != 0 );
            if ( tmp46 ) {
                { // Invoke: file mkdir $pkg_dir
                    TclObject[] objv47 = TJC.grabObjv(interp, 3);
                    TclObject tmp48;
                    try {
                        // Arg 0 constant: file
                        objv47[0] = const1;
                        // Arg 1 constant: mkdir
                        objv47[1] = const16;
                        // Arg 2 variable: $pkg_dir
                        tmp48 = getVarScalar(interp, "pkg_dir", compiledLocals, 4);
                        tmp48.preserve();
                        objv47[2] = tmp48;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv47, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp48 = objv47[2];
                        if ( tmp48 != null ) {
                            tmp48.release();
                        }
                        TJC.releaseObjv(interp, objv47, 3);
                    }
                } // End Invoke: file
            } else {
                // Binary operator: [...] && ()
                { // Invoke: file exists $pkg_dir
                    TclObject[] objv49 = TJC.grabObjv(interp, 3);
                    TclObject tmp50;
                    try {
                        // Arg 0 constant: file
                        objv49[0] = const1;
                        // Arg 1 constant: exists
                        objv49[1] = const15;
                        // Arg 2 variable: $pkg_dir
                        tmp50 = getVarScalar(interp, "pkg_dir", compiledLocals, 4);
                        tmp50.preserve();
                        objv49[2] = tmp50;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv49, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp50 = objv49[2];
                        if ( tmp50 != null ) {
                            tmp50.release();
                        }
                        TJC.releaseObjv(interp, objv49, 3);
                    }
                } // End Invoke: file
                TclObject tmp51 = interp.getResult();
                ExprValue tmp52 = evs0;
                TJC.exprInitValue(interp, tmp52, tmp51);
                if (tmp52.getBooleanValue(interp)) {
                // Unary operator: ! [...]
                { // Invoke: file isdirectory $pkg_dir
                    TclObject[] objv53 = TJC.grabObjv(interp, 3);
                    TclObject tmp54;
                    try {
                        // Arg 0 constant: file
                        objv53[0] = const1;
                        // Arg 1 constant: isdirectory
                        objv53[1] = const17;
                        // Arg 2 variable: $pkg_dir
                        tmp54 = getVarScalar(interp, "pkg_dir", compiledLocals, 4);
                        tmp54.preserve();
                        objv53[2] = tmp54;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv53, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp54 = objv53[2];
                        if ( tmp54 != null ) {
                            tmp54.release();
                        }
                        TJC.releaseObjv(interp, objv53, 3);
                    }
                } // End Invoke: file
                TclObject tmp55 = interp.getResult();
                ExprValue tmp56 = evs1;
                if ( tmp55.isIntType() ) {
                    TJC.exprUnaryNotOperatorKnownInt(tmp56, tmp55);
                } else {
                    TJC.exprUnaryNotOperator(interp, tmp56, tmp55);
                }
                // End Unary operator: !
                tmp52.setIntValue(tmp56.getBooleanValue(interp));
                } else {
                tmp52.setIntValue(0);
                } // End if: [...]
                // End Binary operator: &&
                boolean tmp57 = ( tmp52.getIntValue() != 0 );
                if ( tmp57 ) {
                    { // Invoke: error "..."
                        TclObject[] objv58 = TJC.grabObjv(interp, 2);
                        TclObject tmp59;
                        try {
                            // Arg 0 constant: error
                            objv58[0] = const18;
                            // Arg 1 word: "..."
                            StringBuffer sbtmp60 = new StringBuffer(64);
                            sbtmp60.append("mkdir ");
                            sbtmp60.append("\"");
                            tmp59 = getVarScalar(interp, "pkg_dir", compiledLocals, 4);
                            sbtmp60.append(tmp59.toString());
                            sbtmp60.append("\"");
                            sbtmp60.append(", file exists with that name");
                            tmp59 = TclString.newInstance(sbtmp60);
                            tmp59.preserve();
                            objv58[1] = tmp59;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv58, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            tmp59 = objv58[1];
                            if ( tmp59 != null ) {
                                tmp59.release();
                            }
                            TJC.releaseObjv(interp, objv58, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        { // Invoke: tjc_util_file_saveas $fname $cdata
            TclObject[] objv61 = TJC.grabObjv(interp, 3);
            TclObject tmp62;
            try {
                // Arg 0 constant: tjc_util_file_saveas
                objv61[0] = const19;
                // Arg 1 variable: $fname
                tmp62 = getVarScalar(interp, "fname", compiledLocals, 5);
                tmp62.preserve();
                objv61[1] = tmp62;
                // Arg 2 variable: $cdata
                tmp62 = getVarScalar(interp, "cdata", compiledLocals, 1);
                tmp62.preserve();
                objv61[2] = tmp62;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                    ? cmdcache9.cmd : null), objv61, 0);
                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                    updateCmdCache(interp, 9);
                }
            } finally {
                tmp62 = objv61[1];
                if ( tmp62 != null ) {
                    tmp62.release();
                }
                tmp62 = objv61[2];
                if ( tmp62 != null ) {
                    tmp62.release();
                }
                TJC.releaseObjv(interp, objv61, 3);
            }
        } // End Invoke: tjc_util_file_saveas
        { // Invoke: return $fname
            TclObject tmp63 = getVarScalar(interp, "fname", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp63);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "jdk_tool_javac_save");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("file");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("join");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("pwd");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("jdk_tjc_rootdir");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("source");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("default");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("split");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(".");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("eval");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("file join $TJC source");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("lrange");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("end-1");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("end");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("puts");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("exists");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("mkdir");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("isdirectory");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("error");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("tjc_util_file_saveas");
        const19.preserve(); const19.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "pwd";
                break;
            }
            case 2: {
                cmdName = "jdk_tjc_rootdir";
                break;
            }
            case 3: {
                cmdName = "file";
                break;
            }
            case 4: {
                cmdName = "split";
                break;
            }
            case 5: {
                cmdName = "lrange";
                break;
            }
            case 6: {
                cmdName = "eval";
                break;
            }
            case 7: {
                cmdName = "puts";
                break;
            }
            case 8: {
                cmdName = "error";
                break;
            }
            case 9: {
                cmdName = "tjc_util_file_saveas";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "cname",
        "cdata",
        "debug",
        "TJC",
        "pkg_dir",
        "fname",
        "names"
    };
} // end class JdkToolJavacSaveCmd

