// TJC implementation of procedure module_filter_include_source
package tjc;
import tcl.lang.*;

public class ModuleFilterIncludeSourceCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "source_files include_source_files");
        }
        setVarScalar(interp, "source_files", objv[1], compiledLocals, 0);
        setVarScalar(interp, "include_source_files", objv[2], compiledLocals, 1);
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $...
                TclObject tmp0 = getVarScalar(interp, "include_source_files", compiledLocals, 1);
                int tmp1 = TclList.getLength(interp, tmp0);
                interp.setResult(tmp1);
            } // End Invoke: llength
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            ExprValue tmp4 = evs1;
            tmp4.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp3, tmp4);
            // End Binary operator: ==
            boolean tmp5 = ( tmp3.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: return $source_files
                    TclObject tmp6 = getVarScalar(interp, "source_files", compiledLocals, 0);
                    interp.resetResult();
                    interp.setResult(tmp6);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: foreach include_file $... ...
            TclObject tmp7 = null;
            try {
                tmp7 = getVarScalar(interp, "include_source_files", compiledLocals, 1);
                tmp7.preserve();
                final int tmp7_length = TclList.getLength(interp, tmp7);

                for ( int index8 = 0 ; index8 < tmp7_length ; index8++ ) {
                    TclObject tmp9 = TclList.index(interp, tmp7, index8);
                    try {
                        setVarScalar(interp, "include_file", tmp9, compiledLocals, 2);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "include_file");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set include_tail [...]
                        TclObject tmp10;
                        { // Invoke: file tail $include_file
                            TclObject[] objv11 = TJC.grabObjv(interp, 3);
                            TclObject tmp12;
                            try {
                                // Arg 0 constant: file
                                objv11[0] = const0;
                                // Arg 1 constant: tail
                                objv11[1] = const1;
                                // Arg 2 variable: $include_file
                                tmp12 = getVarScalar(interp, "include_file", compiledLocals, 2);
                                tmp12.preserve();
                                objv11[2] = tmp12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv11, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp12 = objv11[2];
                                if ( tmp12 != null ) {
                                    tmp12.release();
                                }
                                TJC.releaseObjv(interp, objv11, 3);
                            }
                        } // End Invoke: file
                        tmp10 = interp.getResult();
                        setVarScalar(interp, "include_tail", tmp10, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: set "..." ""
                        TclObject tmp13 = getVarScalar(interp, "include_tail", compiledLocals, 3);
                        String tmp14 = tmp13.toString();
                        setVarArray(interp, "include_tails", tmp14, const2, compiledLocals, 4);
                    } // End Invoke: set
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp7 != null ) {
                    tmp7.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set ... [...]
            TclObject tmp15;
            { // Invoke: list
                TclObject tmp16 = TclList.newInstance();
                interp.setResult(tmp16);
            } // End Invoke: list
            tmp15 = interp.getResult();
            setVarScalar(interp, "filtered_source_files", tmp15, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: foreach source_file $source_files ...
            TclObject tmp17 = null;
            try {
                tmp17 = getVarScalar(interp, "source_files", compiledLocals, 0);
                tmp17.preserve();
                final int tmp17_length = TclList.getLength(interp, tmp17);

                for ( int index18 = 0 ; index18 < tmp17_length ; index18++ ) {
                    TclObject tmp19 = TclList.index(interp, tmp17, index18);
                    try {
                        setVarScalar(interp, "source_file", tmp19, compiledLocals, 6);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "source_file");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set source_tail [...]
                        TclObject tmp20;
                        { // Invoke: file tail $source_file
                            TclObject[] objv21 = TJC.grabObjv(interp, 3);
                            TclObject tmp22;
                            try {
                                // Arg 0 constant: file
                                objv21[0] = const0;
                                // Arg 1 constant: tail
                                objv21[1] = const1;
                                // Arg 2 variable: $source_file
                                tmp22 = getVarScalar(interp, "source_file", compiledLocals, 6);
                                tmp22.preserve();
                                objv21[2] = tmp22;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv21, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp22 = objv21[2];
                                if ( tmp22 != null ) {
                                    tmp22.release();
                                }
                                TJC.releaseObjv(interp, objv21, 3);
                            }
                        } // End Invoke: file
                        tmp20 = interp.getResult();
                        setVarScalar(interp, "source_tail", tmp20, compiledLocals, 7);
                    } // End Invoke: set
                    { // Invoke: if ... ... else ...
                        { // Invoke: info exists "..."
                            TclObject[] objv23 = TJC.grabObjv(interp, 3);
                            TclObject tmp24;
                            try {
                                // Arg 0 constant: info
                                objv23[0] = const3;
                                // Arg 1 constant: exists
                                objv23[1] = const4;
                                // Arg 2 word: "..."
                                StringBuffer sbtmp25 = new StringBuffer(64);
                                sbtmp25.append("include_tails(");
                                tmp24 = getVarScalar(interp, "source_tail", compiledLocals, 7);
                                sbtmp25.append(tmp24.toString());
                                sbtmp25.append(")");
                                tmp24 = TclString.newInstance(sbtmp25);
                                tmp24.preserve();
                                objv23[2] = tmp24;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv23, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp24 = objv23[2];
                                if ( tmp24 != null ) {
                                    tmp24.release();
                                }
                                TJC.releaseObjv(interp, objv23, 3);
                            }
                        } // End Invoke: info
                        TclObject tmp26 = interp.getResult();
                        ExprValue tmp27 = evs0;
                        TJC.exprInitValue(interp, tmp27, tmp26);
                        boolean tmp28 = tmp27.getBooleanValue(interp);
                        if ( tmp28 ) {
                        } else {
                            { // Invoke: lappend ... $source_file
                                TclObject[] objv29 = TJC.grabObjv(interp, 1);
                                TclObject tmp30;
                                try {
                                    // Arg 2 variable: $source_file
                                    tmp30 = getVarScalar(interp, "source_file", compiledLocals, 6);
                                    tmp30.preserve();
                                    objv29[0] = tmp30;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "filtered_source_files", objv29, compiledLocals, 5);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv29, 1);
                                }
                            } // End Invoke: lappend
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp17 != null ) {
                    tmp17.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: return $...
            TclObject tmp31 = getVarScalar(interp, "filtered_source_files", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp31);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_filter_include_source");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("file");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("tail");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("info");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("exists");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "file";
                break;
            }
            case 2: {
                cmdName = "info";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "source_files",
        "include_source_files",
        "include_file",
        "include_tail",
        "include_tails",
        "filtered_source_files",
        "source_file",
        "source_tail"
    };
} // end class ModuleFilterIncludeSourceCmd

