// TJC implementation of procedure module_option_default
package tjc;
import tcl.lang.*;

public class ModuleOptionDefaultCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "option");
        }
        setVarScalar(interp, "option", objv[1], compiledLocals, 0);
        { // Invoke: switch -exact -- $option {cache-commands} {return 0} {cache-variables} {return 0} {compile} {return 1} {constant-increment} {return 1} {dummy} {return 0} {inline-expr} {return 0} ... {return 1} ... {return 0} {inline-commands} {return 0} {inline-containers} {return 0} {inline-controls} {return 0} {O} {return 0} {omit-results} {return 0} default ...
            TclObject tmp0 = getVarScalar(interp, "option", compiledLocals, 0);
            String tmp1 = tmp0.toString();
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            interp.resetResult();
            if ( tmp1_length == 14 && tmp1_first == 'c'
                    && tmp1.compareTo("cache-commands") == 0 ) {
                // Pattern {cache-commands}
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 15 && tmp1_first == 'c'
                    && tmp1.compareTo("cache-variables") == 0 ) {
                // Pattern {cache-variables}
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 7 && tmp1_first == 'c'
                    && tmp1.compareTo("compile") == 0 ) {
                // Pattern {compile}
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 18 && tmp1_first == 'c'
                    && tmp1.compareTo("constant-increment") == 0 ) {
                // Pattern {constant-increment}
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 5 && tmp1_first == 'd'
                    && tmp1.compareTo("dummy") == 0 ) {
                // Pattern {dummy}
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 11 && tmp1_first == 'i'
                    && tmp1.compareTo("inline-expr") == 0 ) {
                // Pattern {inline-expr}
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 23 && tmp1_first == 'i'
                    && tmp1.compareTo("inline-expr-value-stack") == 0 ) {
                // Pattern ...
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 28 && tmp1_first == 'i'
                    && tmp1.compareTo("inline-expr-value-stack-null") == 0 ) {
                // Pattern ...
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 15 && tmp1_first == 'i'
                    && tmp1.compareTo("inline-commands") == 0 ) {
                // Pattern {inline-commands}
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 17 && tmp1_first == 'i'
                    && tmp1.compareTo("inline-containers") == 0 ) {
                // Pattern {inline-containers}
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 15 && tmp1_first == 'i'
                    && tmp1.compareTo("inline-controls") == 0 ) {
                // Pattern {inline-controls}
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 1 && tmp1_first == 'O' ) {
                // Pattern {O}
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 12 && tmp1_first == 'o'
                    && tmp1.compareTo("omit-results") == 0 ) {
                // Pattern {omit-results}
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    TclObject tmp3;
                    try {
                        // Arg 0 constant: error
                        objv2[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp4 = new StringBuffer(64);
                        sbtmp4.append("unknown option ");
                        sbtmp4.append("\"");
                        tmp3 = getVarScalar(interp, "option", compiledLocals, 0);
                        sbtmp4.append(tmp3.toString());
                        sbtmp4.append("\"");
                        tmp3 = TclString.newInstance(sbtmp4);
                        tmp3.preserve();
                        objv2[1] = tmp3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp3 = objv2[1];
                        if ( tmp3 != null ) {
                            tmp3.release();
                        }
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_option_default");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "option"
    };
} // end class ModuleOptionDefaultCmd

