// TJC implementation of procedure nameproc_generate
package tjc;
import tcl.lang.*;

public class NameprocGenerateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "proc_name");
        }
        setVarScalar(interp, "proc_name", objv[1], compiledLocals, 0);
        { // Invoke: global _nameproc
            TJC.makeGlobalLinkVar(interp, "_nameproc", "_nameproc", 1);
        } // End Invoke: global
        { // Invoke: set cname [...]
            TclObject tmp0;
            { // Invoke: nameproc_class_name $proc_name
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                TclObject tmp2;
                try {
                    // Arg 0 constant: nameproc_class_name
                    objv1[0] = const0;
                    // Arg 1 variable: $proc_name
                    tmp2 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: nameproc_class_name
            tmp0 = interp.getResult();
            setVarScalar(interp, "cname", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Unary operator: ! [...]
            { // Invoke: info exists "..."
                TclObject[] objv3 = TJC.grabObjv(interp, 3);
                TclObject tmp4;
                try {
                    // Arg 0 constant: info
                    objv3[0] = const1;
                    // Arg 1 constant: exists
                    objv3[1] = const2;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp5 = new StringBuffer(64);
                    sbtmp5.append("_nameproc(name,");
                    tmp4 = getVarScalar(interp, "cname", compiledLocals, 2);
                    sbtmp5.append(tmp4.toString());
                    sbtmp5.append(")");
                    tmp4 = TclString.newInstance(sbtmp5);
                    tmp4.preserve();
                    objv3[2] = tmp4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv3, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp4 = objv3[2];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 3);
                }
            } // End Invoke: info
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs0;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            boolean tmp8 = ( tmp7.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: set "..." 1
                    TclObject tmp9;
                    String tmp10;
                    StringBuffer sbtmp11 = new StringBuffer(64);
                    sbtmp11.append("name,");
                    tmp9 = getVarScalar(interp, "cname", compiledLocals, 2);
                    sbtmp11.append(tmp9.toString());
                    tmp10 = sbtmp11.toString();
                    setVarArray(interp, "_nameproc", tmp10, const3, compiledLocals, 1);
                } // End Invoke: set
            } else {
                { // Invoke: incr "..."
                    TclObject tmp12;
                    String tmp13;
                    StringBuffer sbtmp14 = new StringBuffer(64);
                    sbtmp14.append("name,");
                    tmp12 = getVarScalar(interp, "cname", compiledLocals, 2);
                    sbtmp14.append(tmp12.toString());
                    tmp13 = sbtmp14.toString();
                    interp.resetResult();
                    incrVarArray(interp, "_nameproc", tmp13, 1, compiledLocals, 1);
                } // End Invoke: incr
                { // Invoke: set cname [...]
                    TclObject tmp15;
                    { // Invoke: nameproc_class_name $proc_name $...
                        TclObject[] objv16 = TJC.grabObjv(interp, 3);
                        TclObject tmp17;
                        try {
                            // Arg 0 constant: nameproc_class_name
                            objv16[0] = const0;
                            // Arg 1 variable: $proc_name
                            tmp17 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                            tmp17.preserve();
                            objv16[1] = tmp17;
                            // Arg 2 variable: $...
                            StringBuffer sbtmp18 = new StringBuffer(64);
                            sbtmp18.append("name,");
                            tmp17 = getVarScalar(interp, "cname", compiledLocals, 2);
                            sbtmp18.append(tmp17.toString());
                            tmp17 = getVarArray(interp, "_nameproc", sbtmp18.toString(), compiledLocals, 1);
                            tmp17.preserve();
                            objv16[2] = tmp17;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv16, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp17 = objv16[1];
                            if ( tmp17 != null ) {
                                tmp17.release();
                            }
                            tmp17 = objv16[2];
                            if ( tmp17 != null ) {
                                tmp17.release();
                            }
                            TJC.releaseObjv(interp, objv16, 3);
                        }
                    } // End Invoke: nameproc_class_name
                    tmp15 = interp.getResult();
                    setVarScalar(interp, "cname", tmp15, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: ... $_nameproc(package) $cname
                TclObject[] objv19 = TJC.grabObjv(interp, 3);
                TclObject tmp20;
                try {
                    // Arg 0 constant: ...
                    objv19[0] = const4;
                    // Arg 1 variable: $_nameproc(package)
                    tmp20 = getVarArray(interp, "_nameproc", "package", compiledLocals, 1);
                    tmp20.preserve();
                    objv19[1] = tmp20;
                    // Arg 2 variable: $cname
                    tmp20 = getVarScalar(interp, "cname", compiledLocals, 2);
                    tmp20.preserve();
                    objv19[2] = tmp20;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv19, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp20 = objv19[1];
                    if ( tmp20 != null ) {
                        tmp20.release();
                    }
                    tmp20 = objv19[2];
                    if ( tmp20 != null ) {
                        tmp20.release();
                    }
                    TJC.releaseObjv(interp, objv19, 3);
                }
            } // End Invoke: ...
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "nameproc_generate");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("nameproc_class_name");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("info");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("exists");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("nameproc_full_class_name");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "nameproc_class_name";
                break;
            }
            case 2: {
                cmdName = "info";
                break;
            }
            case 3: {
                cmdName = "nameproc_full_class_name";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "proc_name",
        "_nameproc",
        "cname"
    };
} // end class NameprocGenerateCmd

