// TJC implementation of procedure _parse_expr_iterate_subexpr
package tjc;
import tcl.lang.*;

public class ParseExprIterateSubexprCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "cmd_elem in_cmd");
        }
        setVarScalar(interp, "cmd_elem", objv[1], compiledLocals, 0);
        setVarScalar(interp, "in_cmd", objv[2], compiledLocals, 1);
        { // Invoke: global _parse
            TJC.makeGlobalLinkVar(interp, "_parse", "_parse", 2);
        } // End Invoke: global
        { // Invoke: set type [...]
            TclObject tmp0;
            { // Invoke: lindex $cmd_elem 0
                TclObject tmp1 = getVarScalar(interp, "cmd_elem", compiledLocals, 0);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "type", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$type != "subexpr"} ...
            // Binary operator: $type != "subexpr"
            TclObject tmp2 = getVarScalar(interp, "type", compiledLocals, 3);
            boolean tmp3 = ! tmp2.toString().equals("subexpr");
            ExprValue tmp4 = evs0;
            tmp4.setIntValue(tmp3);
            // End Binary operator: !=
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error "..."
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp8 = new StringBuffer(64);
                        sbtmp8.append("expected ");
                        sbtmp8.append("\"");
                        sbtmp8.append("subexpr");
                        sbtmp8.append("\"");
                        sbtmp8.append(" operand but got ");
                        sbtmp8.append("\"");
                        tmp7 = getVarScalar(interp, "type", compiledLocals, 3);
                        sbtmp8.append(tmp7.toString());
                        sbtmp8.append("\"");
                        sbtmp8.append(" from ");
                        sbtmp8.append("{");
                        tmp7 = getVarScalar(interp, "cmd_elem", compiledLocals, 0);
                        sbtmp8.append(tmp7.toString());
                        sbtmp8.append("}");
                        tmp7 = TclString.newInstance(sbtmp8);
                        tmp7.preserve();
                        objv6[1] = tmp7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv6, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp7 = objv6[1];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set script {}
            setVarScalar(interp, "script", const1, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set etree {}
            setVarScalar(interp, "etree", const1, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set type {subexpression}
            setVarScalar(interp, "type", const2, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set values {}
            setVarScalar(interp, "values", const1, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set ranges {}
            setVarScalar(interp, "ranges", const1, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set cmd [...]
            TclObject tmp9;
            { // Invoke: list $in_cmd $script $etree $type $values $ranges
                TclObject tmp10 = TclList.newInstance();
                TclObject tmp11;
                try {
                    tmp11 = getVarScalar(interp, "in_cmd", compiledLocals, 1);
                    TclList.append(interp, tmp10, tmp11);
                    tmp11 = getVarScalar(interp, "script", compiledLocals, 4);
                    TclList.append(interp, tmp10, tmp11);
                    tmp11 = getVarScalar(interp, "etree", compiledLocals, 5);
                    TclList.append(interp, tmp10, tmp11);
                    tmp11 = getVarScalar(interp, "type", compiledLocals, 3);
                    TclList.append(interp, tmp10, tmp11);
                    tmp11 = getVarScalar(interp, "values", compiledLocals, 6);
                    TclList.append(interp, tmp10, tmp11);
                    tmp11 = getVarScalar(interp, "ranges", compiledLocals, 7);
                    TclList.append(interp, tmp10, tmp11);
                } catch (TclException ex) {
                    tmp10.release();
                    throw ex;
                }
                interp.setResult(tmp10);
            } // End Invoke: list
            tmp9 = interp.getResult();
            setVarScalar(interp, "cmd", tmp9, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: namespace eval :: $cmd
            TclObject[] objv12 = TJC.grabObjv(interp, 4);
            TclObject tmp13;
            try {
                // Arg 0 constant: namespace
                objv12[0] = const3;
                // Arg 1 constant: eval
                objv12[1] = const4;
                // Arg 2 constant: ::
                objv12[2] = const5;
                // Arg 3 variable: $cmd
                tmp13 = getVarScalar(interp, "cmd", compiledLocals, 8);
                tmp13.preserve();
                objv12[3] = tmp13;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv12, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                tmp13 = objv12[3];
                if ( tmp13 != null ) {
                    tmp13.release();
                }
                TJC.releaseObjv(interp, objv12, 4);
            }
        } // End Invoke: namespace
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_parse_expr_iterate_subexpr");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("subexpression");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("namespace");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("eval");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("::");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "namespace";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "cmd_elem",
        "in_cmd",
        "_parse",
        "type",
        "script",
        "etree",
        "values",
        "ranges",
        "cmd"
    };
} // end class ParseExprIterateSubexprCmd

