// TJC implementation of procedure parse_get_constant_text
package tjc;
import tcl.lang.*;

public class ParseGetConstantTextCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script stree");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        { // Invoke: if ... ... elseif ... ... else ...
            { // Invoke: parse_is_simple_text $stree
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv0[0] = const0;
                    // Arg 1 variable: $stree
                    tmp1 = getVarScalar(interp, "stree", compiledLocals, 1);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            boolean tmp4 = tmp3.getBooleanValue(interp);
            if ( tmp4 ) {
                { // Invoke: set quoted [...]
                    TclObject tmp5;
                    { // Invoke: ... $script $stree
                        TclObject[] objv6 = TJC.grabObjv(interp, 3);
                        TclObject tmp7;
                        try {
                            // Arg 0 constant: ...
                            objv6[0] = const1;
                            // Arg 1 variable: $script
                            tmp7 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp7.preserve();
                            objv6[1] = tmp7;
                            // Arg 2 variable: $stree
                            tmp7 = getVarScalar(interp, "stree", compiledLocals, 1);
                            tmp7.preserve();
                            objv6[2] = tmp7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv6, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp7 = objv6[1];
                            if ( tmp7 != null ) {
                                tmp7.release();
                            }
                            tmp7 = objv6[2];
                            if ( tmp7 != null ) {
                                tmp7.release();
                            }
                            TJC.releaseObjv(interp, objv6, 3);
                        }
                    } // End Invoke: ...
                    tmp5 = interp.getResult();
                    setVarScalar(interp, "quoted", tmp5, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: set first [...]
                    TclObject tmp8;
                    { // Invoke: string index $quoted 0
                        TclObject tmp9 = getVarScalar(interp, "quoted", compiledLocals, 2);
                        String tmp10 = tmp9.toString();
                        TclObject tmp11 = TJC.stringIndex(interp, tmp10, const2);
                        interp.setResult(tmp11);
                    } // End Invoke: string
                    tmp8 = interp.getResult();
                    setVarScalar(interp, "first", tmp8, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set last [...]
                    TclObject tmp12;
                    { // Invoke: string index $quoted end
                        TclObject tmp13 = getVarScalar(interp, "quoted", compiledLocals, 2);
                        String tmp14 = tmp13.toString();
                        TclObject tmp15 = TJC.stringIndex(interp, tmp14, const3);
                        interp.setResult(tmp15);
                    } // End Invoke: string
                    tmp12 = interp.getResult();
                    setVarScalar(interp, "last", tmp12, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: if ... ... elseif ... ... else ...
                    // Binary operator: () && ()
                    // Binary operator: $first == "{"
                    TclObject tmp16 = getVarScalar(interp, "first", compiledLocals, 3);
                    boolean tmp17 = tmp16.toString().equals("{");
                    ExprValue tmp18 = evs0;
                    tmp18.setIntValue(tmp17);
                    // End Binary operator: ==
                    if (tmp18.getBooleanValue(interp)) {
                    // Binary operator: $last == "}"
                    TclObject tmp19 = getVarScalar(interp, "last", compiledLocals, 4);
                    boolean tmp20 = tmp19.toString().equals("}");
                    ExprValue tmp21 = evs1;
                    tmp21.setIntValue(tmp20);
                    // End Binary operator: ==
                    tmp18.setIntValue(tmp21.getBooleanValue(interp));
                    } else {
                    tmp18.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp22 = ( tmp18.getIntValue() != 0 );
                    if ( tmp22 ) {
                        { // Invoke: set qchars ...
                            setVarScalar(interp, "qchars", const4, compiledLocals, 5);
                        } // End Invoke: set
                    } else {
                        // Binary operator: () && ()
                        // Binary operator: $first == "\""
                        TclObject tmp23 = getVarScalar(interp, "first", compiledLocals, 3);
                        boolean tmp24 = tmp23.toString().equals("\"");
                        ExprValue tmp25 = evs0;
                        tmp25.setIntValue(tmp24);
                        // End Binary operator: ==
                        if (tmp25.getBooleanValue(interp)) {
                        // Binary operator: $last == "\""
                        TclObject tmp26 = getVarScalar(interp, "last", compiledLocals, 4);
                        boolean tmp27 = tmp26.toString().equals("\"");
                        ExprValue tmp28 = evs1;
                        tmp28.setIntValue(tmp27);
                        // End Binary operator: ==
                        tmp25.setIntValue(tmp28.getBooleanValue(interp));
                        } else {
                        tmp25.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp29 = ( tmp25.getIntValue() != 0 );
                        if ( tmp29 ) {
                            { // Invoke: set qchars ...
                                setVarScalar(interp, "qchars", const5, compiledLocals, 5);
                            } // End Invoke: set
                        } else {
                            { // Invoke: set qchars ""
                                setVarScalar(interp, "qchars", const6, compiledLocals, 5);
                            } // End Invoke: set
                        }
                    }
                } // End Invoke: if
                { // Invoke: set unquoted [...]
                    TclObject tmp30;
                    { // Invoke: ... $script $stree "text"
                        TclObject[] objv31 = TJC.grabObjv(interp, 4);
                        TclObject tmp32;
                        try {
                            // Arg 0 constant: ...
                            objv31[0] = const1;
                            // Arg 1 variable: $script
                            tmp32 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp32.preserve();
                            objv31[1] = tmp32;
                            // Arg 2 variable: $stree
                            tmp32 = getVarScalar(interp, "stree", compiledLocals, 1);
                            tmp32.preserve();
                            objv31[2] = tmp32;
                            // Arg 3 constant: "text"
                            objv31[3] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv31, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp32 = objv31[1];
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                            tmp32 = objv31[2];
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                            TJC.releaseObjv(interp, objv31, 4);
                        }
                    } // End Invoke: ...
                    tmp30 = interp.getResult();
                    setVarScalar(interp, "unquoted", tmp30, compiledLocals, 6);
                } // End Invoke: set
            } else {
                { // Invoke: parse_is_word $stree
                    TclObject[] objv33 = TJC.grabObjv(interp, 2);
                    TclObject tmp34;
                    try {
                        // Arg 0 constant: parse_is_word
                        objv33[0] = const8;
                        // Arg 1 variable: $stree
                        tmp34 = getVarScalar(interp, "stree", compiledLocals, 1);
                        tmp34.preserve();
                        objv33[1] = tmp34;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv33, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp34 = objv33[1];
                        if ( tmp34 != null ) {
                            tmp34.release();
                        }
                        TJC.releaseObjv(interp, objv33, 2);
                    }
                } // End Invoke: parse_is_word
                TclObject tmp35 = interp.getResult();
                ExprValue tmp36 = evs0;
                TJC.exprInitValue(interp, tmp36, tmp35);
                boolean tmp37 = tmp36.getBooleanValue(interp);
                if ( tmp37 ) {
                    { // Invoke: set result [...]
                        TclObject tmp38;
                        { // Invoke: parse_word_iterate $script $stree ...
                            TclObject[] objv39 = TJC.grabObjv(interp, 4);
                            TclObject tmp40;
                            try {
                                // Arg 0 constant: parse_word_iterate
                                objv39[0] = const9;
                                // Arg 1 variable: $script
                                tmp40 = getVarScalar(interp, "script", compiledLocals, 0);
                                tmp40.preserve();
                                objv39[1] = tmp40;
                                // Arg 2 variable: $stree
                                tmp40 = getVarScalar(interp, "stree", compiledLocals, 1);
                                tmp40.preserve();
                                objv39[2] = tmp40;
                                // Arg 3 constant: ...
                                objv39[3] = const10;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv39, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp40 = objv39[1];
                                if ( tmp40 != null ) {
                                    tmp40.release();
                                }
                                tmp40 = objv39[2];
                                if ( tmp40 != null ) {
                                    tmp40.release();
                                }
                                TJC.releaseObjv(interp, objv39, 4);
                            }
                        } // End Invoke: parse_word_iterate
                        tmp38 = interp.getResult();
                        setVarScalar(interp, "result", tmp38, compiledLocals, 7);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        // Binary operator: $result == "NONCONSTANT"
                        TclObject tmp41 = getVarScalar(interp, "result", compiledLocals, 7);
                        boolean tmp42 = tmp41.toString().equals("NONCONSTANT");
                        ExprValue tmp43 = evs0;
                        tmp43.setIntValue(tmp42);
                        // End Binary operator: ==
                        boolean tmp44 = ( tmp43.getIntValue() != 0 );
                        if ( tmp44 ) {
                            { // Invoke: error ...
                                TclObject[] objv45 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: error
                                    objv45[0] = const11;
                                    // Arg 1 constant: ...
                                    objv45[1] = const12;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv45, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv45, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set unquoted $result
                        TclObject tmp46;
                        tmp46 = getVarScalar(interp, "result", compiledLocals, 7);
                        setVarScalar(interp, "unquoted", tmp46, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: set word_range [...]
                        TclObject tmp47;
                        { // Invoke: lindex $stree 1
                            TclObject tmp48 = getVarScalar(interp, "stree", compiledLocals, 1);
                            tmp48 = TclList.index(interp, tmp48, 1);
                            if ( tmp48 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp48);
                            }
                        } // End Invoke: lindex
                        tmp47 = interp.getResult();
                        setVarScalar(interp, "word_range", tmp47, compiledLocals, 8);
                    } // End Invoke: set
                    { // Invoke: set str [...]
                        TclObject tmp49;
                        { // Invoke: parse getstring $script $word_range
                            TclObject[] objv50 = TJC.grabObjv(interp, 4);
                            TclObject tmp51;
                            try {
                                // Arg 0 constant: parse
                                objv50[0] = const13;
                                // Arg 1 constant: getstring
                                objv50[1] = const14;
                                // Arg 2 variable: $script
                                tmp51 = getVarScalar(interp, "script", compiledLocals, 0);
                                tmp51.preserve();
                                objv50[2] = tmp51;
                                // Arg 3 variable: $word_range
                                tmp51 = getVarScalar(interp, "word_range", compiledLocals, 8);
                                tmp51.preserve();
                                objv50[3] = tmp51;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv50, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp51 = objv50[2];
                                if ( tmp51 != null ) {
                                    tmp51.release();
                                }
                                tmp51 = objv50[3];
                                if ( tmp51 != null ) {
                                    tmp51.release();
                                }
                                TJC.releaseObjv(interp, objv50, 4);
                            }
                        } // End Invoke: parse
                        tmp49 = interp.getResult();
                        setVarScalar(interp, "str", tmp49, compiledLocals, 9);
                    } // End Invoke: set
                    { // Invoke: set first [...]
                        TclObject tmp52;
                        { // Invoke: string index $str 0
                            TclObject tmp53 = getVarScalar(interp, "str", compiledLocals, 9);
                            String tmp54 = tmp53.toString();
                            TclObject tmp55 = TJC.stringIndex(interp, tmp54, const2);
                            interp.setResult(tmp55);
                        } // End Invoke: string
                        tmp52 = interp.getResult();
                        setVarScalar(interp, "first", tmp52, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: set last [...]
                        TclObject tmp56;
                        { // Invoke: string index $str end
                            TclObject tmp57 = getVarScalar(interp, "str", compiledLocals, 9);
                            String tmp58 = tmp57.toString();
                            TclObject tmp59 = TJC.stringIndex(interp, tmp58, const3);
                            interp.setResult(tmp59);
                        } // End Invoke: string
                        tmp56 = interp.getResult();
                        setVarScalar(interp, "last", tmp56, compiledLocals, 4);
                    } // End Invoke: set
                    { // Invoke: if ... ... elseif ... ... else ...
                        // Binary operator: () && ()
                        // Binary operator: $first == "{"
                        TclObject tmp60 = getVarScalar(interp, "first", compiledLocals, 3);
                        boolean tmp61 = tmp60.toString().equals("{");
                        ExprValue tmp62 = evs0;
                        tmp62.setIntValue(tmp61);
                        // End Binary operator: ==
                        if (tmp62.getBooleanValue(interp)) {
                        // Binary operator: $last == "}"
                        TclObject tmp63 = getVarScalar(interp, "last", compiledLocals, 4);
                        boolean tmp64 = tmp63.toString().equals("}");
                        ExprValue tmp65 = evs1;
                        tmp65.setIntValue(tmp64);
                        // End Binary operator: ==
                        tmp62.setIntValue(tmp65.getBooleanValue(interp));
                        } else {
                        tmp62.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp66 = ( tmp62.getIntValue() != 0 );
                        if ( tmp66 ) {
                            { // Invoke: set qchars ...
                                setVarScalar(interp, "qchars", const4, compiledLocals, 5);
                            } // End Invoke: set
                            { // Invoke: set quoted ...
                                TclObject tmp67;
                                StringBuffer sbtmp68 = new StringBuffer(64);
                                sbtmp68.append("{");
                                tmp67 = getVarScalar(interp, "result", compiledLocals, 7);
                                sbtmp68.append(tmp67.toString());
                                sbtmp68.append("}");
                                tmp67 = TclString.newInstance(sbtmp68);
                                setVarScalar(interp, "quoted", tmp67, compiledLocals, 2);
                            } // End Invoke: set
                        } else {
                            // Binary operator: () && ()
                            // Binary operator: $first == "\""
                            TclObject tmp69 = getVarScalar(interp, "first", compiledLocals, 3);
                            boolean tmp70 = tmp69.toString().equals("\"");
                            ExprValue tmp71 = evs0;
                            tmp71.setIntValue(tmp70);
                            // End Binary operator: ==
                            if (tmp71.getBooleanValue(interp)) {
                            // Binary operator: $last == "\""
                            TclObject tmp72 = getVarScalar(interp, "last", compiledLocals, 4);
                            boolean tmp73 = tmp72.toString().equals("\"");
                            ExprValue tmp74 = evs1;
                            tmp74.setIntValue(tmp73);
                            // End Binary operator: ==
                            tmp71.setIntValue(tmp74.getBooleanValue(interp));
                            } else {
                            tmp71.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp75 = ( tmp71.getIntValue() != 0 );
                            if ( tmp75 ) {
                                { // Invoke: set qchars ...
                                    setVarScalar(interp, "qchars", const5, compiledLocals, 5);
                                } // End Invoke: set
                                { // Invoke: set quoted ...
                                    TclObject tmp76;
                                    StringBuffer sbtmp77 = new StringBuffer(64);
                                    sbtmp77.append("\"");
                                    tmp76 = getVarScalar(interp, "result", compiledLocals, 7);
                                    sbtmp77.append(tmp76.toString());
                                    sbtmp77.append("\"");
                                    tmp76 = TclString.newInstance(sbtmp77);
                                    setVarScalar(interp, "quoted", tmp76, compiledLocals, 2);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set qchars ""
                                    setVarScalar(interp, "qchars", const6, compiledLocals, 5);
                                } // End Invoke: set
                                { // Invoke: set quoted $result
                                    TclObject tmp78;
                                    tmp78 = getVarScalar(interp, "result", compiledLocals, 7);
                                    setVarScalar(interp, "quoted", tmp78, compiledLocals, 2);
                                } // End Invoke: set
                            }
                        }
                    } // End Invoke: if
                } else {
                    { // Invoke: error "..."
                        TclObject[] objv79 = TJC.grabObjv(interp, 2);
                        TclObject tmp80;
                        try {
                            // Arg 0 constant: error
                            objv79[0] = const11;
                            // Arg 1 word: "..."
                            StringBuffer sbtmp81 = new StringBuffer(64);
                            sbtmp81.append("not a word or simple/text type ");
                            sbtmp81.append("{");
                            tmp80 = getVarScalar(interp, "stree", compiledLocals, 1);
                            sbtmp81.append(tmp80.toString());
                            sbtmp81.append("}");
                            tmp80 = TclString.newInstance(sbtmp81);
                            tmp80.preserve();
                            objv79[1] = tmp80;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv79, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp80 = objv79[1];
                            if ( tmp80 != null ) {
                                tmp80.release();
                            }
                            TJC.releaseObjv(interp, objv79, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $quoted $qchars $unquoted
                TclObject tmp82 = TclList.newInstance();
                TclObject tmp83;
                try {
                    tmp83 = getVarScalar(interp, "quoted", compiledLocals, 2);
                    TclList.append(interp, tmp82, tmp83);
                    tmp83 = getVarScalar(interp, "qchars", compiledLocals, 5);
                    TclList.append(interp, tmp82, tmp83);
                    tmp83 = getVarScalar(interp, "unquoted", compiledLocals, 6);
                    TclList.append(interp, tmp82, tmp83);
                } catch (TclException ex) {
                    tmp82.release();
                    throw ex;
                }
                interp.setResult(tmp82);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_get_constant_text");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse_is_simple_text");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("parse_get_simple_text");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("end");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("{}");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("\"\"");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("text");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("parse_is_word");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("parse_word_iterate");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("_parse_is_constant_word_iterate");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("error");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("expected to iterate over a constant word");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("parse");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("getstring");
        const14.preserve(); const14.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 2: {
                cmdName = "parse_get_simple_text";
                break;
            }
            case 3: {
                cmdName = "parse_is_word";
                break;
            }
            case 4: {
                cmdName = "parse_word_iterate";
                break;
            }
            case 5: {
                cmdName = "error";
                break;
            }
            case 6: {
                cmdName = "parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "quoted",
        "first",
        "last",
        "qchars",
        "unquoted",
        "result",
        "word_range",
        "str"
    };
} // end class ParseGetConstantTextCmd

