// TJC implementation of procedure _parse_is_constant_word_iterate
package tjc;
import tcl.lang.*;

public class ParseIsConstantWordIterateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "script stree type values ranges");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "type", objv[3], compiledLocals, 2);
        setVarScalar(interp, "values", objv[4], compiledLocals, 3);
        setVarScalar(interp, "ranges", objv[5], compiledLocals, 4);
        { // Invoke: set word [...]
            TclObject tmp0;
            { // Invoke: ...
                TclObject[] objv1 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv1, 1);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "word", tmp0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $word == "NONCONSTANT"
            TclObject tmp2 = getVarScalar(interp, "word", compiledLocals, 5);
            boolean tmp3 = tmp2.toString().equals("NONCONSTANT");
            ExprValue tmp4 = evs0;
            tmp4.setIntValue(tmp3);
            // End Binary operator: ==
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: switch -exact -- $type {backslash} ... {command} ... {text} ... {variable} ... {word begin} ... {word end} ... {word} ... default ...
            TclObject tmp6 = getVarScalar(interp, "type", compiledLocals, 2);
            String tmp7 = tmp6.toString();
            int tmp7_length = tmp7.length();
            char tmp7_first = '\n';
            if ( tmp7_length > 0 ) {
                tmp7_first = tmp7.charAt(0);
            }
            interp.resetResult();
            if ( tmp7_length == 9 && tmp7_first == 'b'
                    && tmp7.compareTo("backslash") == 0 ) {
                // Pattern {backslash}
                { // Invoke: set elem [...]
                    TclObject tmp8;
                    { // Invoke: lindex $values 0
                        TclObject tmp9 = getVarScalar(interp, "values", compiledLocals, 3);
                        tmp9 = TclList.index(interp, tmp9, 0);
                        if ( tmp9 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp9);
                        }
                    } // End Invoke: lindex
                    tmp8 = interp.getResult();
                    setVarScalar(interp, "elem", tmp8, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: regexp ... $elem whole
                        TclObject[] objv10 = TJC.grabObjv(interp, 4);
                        TclObject tmp11;
                        try {
                            // Arg 0 constant: regexp
                            objv10[0] = const1;
                            // Arg 1 constant: ...
                            objv10[1] = const2;
                            // Arg 2 variable: $elem
                            tmp11 = getVarScalar(interp, "elem", compiledLocals, 6);
                            tmp11.preserve();
                            objv10[2] = tmp11;
                            // Arg 3 constant: whole
                            objv10[3] = const3;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv10, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp11 = objv10[2];
                            if ( tmp11 != null ) {
                                tmp11.release();
                            }
                            TJC.releaseObjv(interp, objv10, 4);
                        }
                    } // End Invoke: regexp
                    TclObject tmp12 = interp.getResult();
                    ExprValue tmp13 = evs0;
                    TJC.exprInitValue(interp, tmp13, tmp12);
                    boolean tmp14 = tmp13.getBooleanValue(interp);
                    if ( tmp14 ) {
                        { // Invoke: set elem " "
                            setVarScalar(interp, "elem", const4, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: set word [...]
                            TclObject tmp15;
                            { // Invoke: ...
                                TclObject[] objv16 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv16[0] = const0;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv16, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv16, 1);
                                }
                            } // End Invoke: ...
                            tmp15 = interp.getResult();
                            setVarScalar(interp, "word", tmp15, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: append word $elem
                            TclObject[] objv17 = TJC.grabObjv(interp, 1);
                            TclObject tmp18;
                            try {
                                // Arg 2 variable: $elem
                                tmp18 = getVarScalar(interp, "elem", compiledLocals, 6);
                                tmp18.preserve();
                                objv17[0] = tmp18;
                                interp.resetResult();
                                appendVarScalar(interp, "word", objv17, compiledLocals, 5);
                            } finally {
                                TJC.releaseObjvElems(interp, objv17, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: ... $word
                            TclObject[] objv19 = TJC.grabObjv(interp, 2);
                            TclObject tmp20;
                            try {
                                // Arg 0 constant: ...
                                objv19[0] = const0;
                                // Arg 1 variable: $word
                                tmp20 = getVarScalar(interp, "word", compiledLocals, 5);
                                tmp20.preserve();
                                objv19[1] = tmp20;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv19, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp20 = objv19[1];
                                if ( tmp20 != null ) {
                                    tmp20.release();
                                }
                                TJC.releaseObjv(interp, objv19, 2);
                            }
                        } // End Invoke: ...
                    } else {
                        { // Invoke: ... "NONCONSTANT"
                            TclObject[] objv21 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: ...
                                objv21[0] = const0;
                                // Arg 1 constant: "NONCONSTANT"
                                objv21[1] = const5;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv21, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv21, 2);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
            } else if ( tmp7_length == 7 && tmp7_first == 'c'
                    && tmp7.compareTo("command") == 0 ) {
                // Pattern {command}
                { // Invoke: ... "NONCONSTANT"
                    TclObject[] objv22 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: ...
                        objv22[0] = const0;
                        // Arg 1 constant: "NONCONSTANT"
                        objv22[1] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv22, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv22, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp7_length == 4 && tmp7_first == 't'
                    && tmp7.compareTo("text") == 0 ) {
                // Pattern {text}
                { // Invoke: set elem [...]
                    TclObject tmp23;
                    { // Invoke: lindex $values 0
                        TclObject tmp24 = getVarScalar(interp, "values", compiledLocals, 3);
                        tmp24 = TclList.index(interp, tmp24, 0);
                        if ( tmp24 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp24);
                        }
                    } // End Invoke: lindex
                    tmp23 = interp.getResult();
                    setVarScalar(interp, "elem", tmp23, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set word [...]
                    TclObject tmp25;
                    { // Invoke: ...
                        TclObject[] objv26 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv26[0] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv26, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv26, 1);
                        }
                    } // End Invoke: ...
                    tmp25 = interp.getResult();
                    setVarScalar(interp, "word", tmp25, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: append word $elem
                    TclObject[] objv27 = TJC.grabObjv(interp, 1);
                    TclObject tmp28;
                    try {
                        // Arg 2 variable: $elem
                        tmp28 = getVarScalar(interp, "elem", compiledLocals, 6);
                        tmp28.preserve();
                        objv27[0] = tmp28;
                        interp.resetResult();
                        appendVarScalar(interp, "word", objv27, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv27, 1);
                    }
                } // End Invoke: append
                { // Invoke: ... $word
                    TclObject[] objv29 = TJC.grabObjv(interp, 2);
                    TclObject tmp30;
                    try {
                        // Arg 0 constant: ...
                        objv29[0] = const0;
                        // Arg 1 variable: $word
                        tmp30 = getVarScalar(interp, "word", compiledLocals, 5);
                        tmp30.preserve();
                        objv29[1] = tmp30;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv29, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp30 = objv29[1];
                        if ( tmp30 != null ) {
                            tmp30.release();
                        }
                        TJC.releaseObjv(interp, objv29, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp7_length == 8 && tmp7_first == 'v'
                    && tmp7.compareTo("variable") == 0 ) {
                // Pattern {variable}
                { // Invoke: ... "NONCONSTANT"
                    TclObject[] objv31 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: ...
                        objv31[0] = const0;
                        // Arg 1 constant: "NONCONSTANT"
                        objv31[1] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv31, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv31, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp7_length == 10 && tmp7_first == 'w'
                    && tmp7.compareTo("word begin") == 0 ) {
                // Pattern {word begin}
            } else if ( tmp7_length == 8 && tmp7_first == 'w'
                    && tmp7.compareTo("word end") == 0 ) {
                // Pattern {word end}
            } else if ( tmp7_length == 4 && tmp7_first == 'w'
                    && tmp7.compareTo("word") == 0 ) {
                // Pattern {word}
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv32 = TJC.grabObjv(interp, 2);
                    TclObject tmp33;
                    try {
                        // Arg 0 constant: error
                        objv32[0] = const6;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp34 = new StringBuffer(64);
                        sbtmp34.append("unknown type ");
                        sbtmp34.append("\"");
                        tmp33 = getVarScalar(interp, "type", compiledLocals, 2);
                        sbtmp34.append(tmp33.toString());
                        sbtmp34.append("\"");
                        tmp33 = TclString.newInstance(sbtmp34);
                        tmp33.preserve();
                        objv32[1] = tmp33;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv32, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp33 = objv32[1];
                        if ( tmp33 != null ) {
                            tmp33.release();
                        }
                        TJC.releaseObjv(interp, objv32, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_parse_is_constant_word_iterate");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse_word_iterate_word_value");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("regexp");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("^\n[ |\t]*$");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("whole");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance(" ");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("NONCONSTANT");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("error");
        const6.preserve(); const6.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_word_iterate_word_value";
                break;
            }
            case 2: {
                cmdName = "regexp";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "type",
        "values",
        "ranges",
        "word",
        "elem"
    };
} // end class ParseIsConstantWordIterateCmd

