// TJC implementation of procedure parse_is_word_command
package tjc;
import tcl.lang.*;

public class ParseIsWordCommandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "stree");
        }
        setVarScalar(interp, "stree", objv[1], compiledLocals, 0);
        { // Invoke: set word [...]
            TclObject tmp0;
            { // Invoke: lindex $stree 0
                TclObject tmp1 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "word", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: string equal "word" $word
                String tmp2 = const0.toString();
                TclObject tmp3 = getVarScalar(interp, "word", compiledLocals, 1);
                String tmp4 = tmp3.toString();
                boolean tmp5 = tmp2.equals(tmp4);
                interp.setResult(tmp5);
            } // End Invoke: string
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs0;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            boolean tmp8 = ( tmp7.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set word_range [...]
            TclObject tmp9;
            { // Invoke: lindex $stree 1
                TclObject tmp10 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp10 = TclList.index(interp, tmp10, 1);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            tmp9 = interp.getResult();
            setVarScalar(interp, "word_range", tmp9, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set subtree [...]
            TclObject tmp11;
            { // Invoke: lindex $stree 2
                TclObject tmp12 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp12 = TclList.index(interp, tmp12, 2);
                if ( tmp12 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp12);
                }
            } // End Invoke: lindex
            tmp11 = interp.getResult();
            setVarScalar(interp, "subtree", tmp11, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != 1
            { // Invoke: llength $subtree
                TclObject tmp13 = getVarScalar(interp, "subtree", compiledLocals, 3);
                int tmp14 = TclList.getLength(interp, tmp13);
                interp.setResult(tmp14);
            } // End Invoke: llength
            TclObject tmp15 = interp.getResult();
            ExprValue tmp16 = evs0;
            TJC.exprInitValue(interp, tmp16, tmp15);
            ExprValue tmp17 = evs1;
            tmp17.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp16, tmp17);
            // End Binary operator: !=
            boolean tmp18 = ( tmp16.getIntValue() != 0 );
            if ( tmp18 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set command_tuple [...]
            TclObject tmp19;
            { // Invoke: lindex $subtree 0
                TclObject tmp20 = getVarScalar(interp, "subtree", compiledLocals, 3);
                tmp20 = TclList.index(interp, tmp20, 0);
                if ( tmp20 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp20);
                }
            } // End Invoke: lindex
            tmp19 = interp.getResult();
            setVarScalar(interp, "command_tuple", tmp19, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set command [...]
            TclObject tmp21;
            { // Invoke: lindex $command_tuple 0
                TclObject tmp22 = getVarScalar(interp, "command_tuple", compiledLocals, 4);
                tmp22 = TclList.index(interp, tmp22, 0);
                if ( tmp22 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp22);
                }
            } // End Invoke: lindex
            tmp21 = interp.getResult();
            setVarScalar(interp, "command", tmp21, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set command_range [...]
            TclObject tmp23;
            { // Invoke: lindex $command_tuple 1
                TclObject tmp24 = getVarScalar(interp, "command_tuple", compiledLocals, 4);
                tmp24 = TclList.index(interp, tmp24, 1);
                if ( tmp24 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp24);
                }
            } // End Invoke: lindex
            tmp23 = interp.getResult();
            setVarScalar(interp, "command_range", tmp23, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set command_subtree [...]
            TclObject tmp25;
            { // Invoke: lindex $command_tuple 2
                TclObject tmp26 = getVarScalar(interp, "command_tuple", compiledLocals, 4);
                tmp26 = TclList.index(interp, tmp26, 2);
                if ( tmp26 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp26);
                }
            } // End Invoke: lindex
            tmp25 = interp.getResult();
            setVarScalar(interp, "command_subtree", tmp25, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: string equal "command" $command
                String tmp27 = const2.toString();
                TclObject tmp28 = getVarScalar(interp, "command", compiledLocals, 5);
                String tmp29 = tmp28.toString();
                boolean tmp30 = tmp27.equals(tmp29);
                interp.setResult(tmp30);
            } // End Invoke: string
            TclObject tmp31 = interp.getResult();
            ExprValue tmp32 = evs0;
            if ( tmp31.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp32, tmp31);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp32, tmp31);
            }
            // End Unary operator: !
            boolean tmp33 = ( tmp32.getIntValue() != 0 );
            if ( tmp33 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: $word_range != $command_range
            TclObject tmp34 = getVarScalar(interp, "word_range", compiledLocals, 2);
            ExprValue tmp35 = evs0;
            TJC.exprInitValue(interp, tmp35, tmp34);
            TclObject tmp36 = getVarScalar(interp, "command_range", compiledLocals, 6);
            ExprValue tmp37 = evs1;
            TJC.exprInitValue(interp, tmp37, tmp36);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp35, tmp37);
            // End Binary operator: !=
            boolean tmp38 = ( tmp35.getIntValue() != 0 );
            if ( tmp38 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] != 0
            { // Invoke: llength $command_subtree
                TclObject tmp39 = getVarScalar(interp, "command_subtree", compiledLocals, 7);
                int tmp40 = TclList.getLength(interp, tmp39);
                interp.setResult(tmp40);
            } // End Invoke: llength
            TclObject tmp41 = interp.getResult();
            ExprValue tmp42 = evs0;
            TJC.exprInitValue(interp, tmp42, tmp41);
            ExprValue tmp43 = evs1;
            tmp43.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp42, tmp43);
            // End Binary operator: !=
            boolean tmp44 = ( tmp42.getIntValue() != 0 );
            if ( tmp44 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const3);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_is_word_command");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("word");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("command");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
    }

    String[] compiledLocalsNames = {
        "stree",
        "word",
        "word_range",
        "subtree",
        "command_tuple",
        "command",
        "command_range",
        "command_subtree"
    };
} // end class ParseIsWordCommandCmd

