// TJC implementation of procedure parseproc_command_callback
package tjc;
import tcl.lang.*;

public class ParseprocCommandCallbackCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp0 = getVarScalar(interp, "debug", compiledLocals, 1);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: puts "..."
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    TclObject tmp3;
                    try {
                        // Arg 0 constant: puts
                        objv2[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp4 = new StringBuffer(64);
                        sbtmp4.append("parseproc_command_callback ");
                        tmp3 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp4.append(tmp3.toString());
                        tmp3 = TclString.newInstance(sbtmp4);
                        tmp3.preserve();
                        objv2[1] = tmp3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp3 = objv2[1];
                        if ( tmp3 != null ) {
                            tmp3.release();
                        }
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set result [...]
            TclObject tmp5;
            { // Invoke: ... $key
                TclObject[] objv6 = TJC.grabObjv(interp, 2);
                TclObject tmp7;
                try {
                    // Arg 0 constant: ...
                    objv6[0] = const2;
                    // Arg 1 variable: $key
                    tmp7 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp7.preserve();
                    objv6[1] = tmp7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv6, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp7 = objv6[1];
                    if ( tmp7 != null ) {
                        tmp7.release();
                    }
                    TJC.releaseObjv(interp, objv6, 2);
                }
            } // End Invoke: ...
            tmp5 = interp.getResult();
            setVarScalar(interp, "result", tmp5, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set undetermined [...]
            TclObject tmp8;
            { // Invoke: ... $key
                TclObject[] objv9 = TJC.grabObjv(interp, 2);
                TclObject tmp10;
                try {
                    // Arg 0 constant: ...
                    objv9[0] = const3;
                    // Arg 1 variable: $key
                    tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp10.preserve();
                    objv9[1] = tmp10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv9, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp10 = objv9[1];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    TJC.releaseObjv(interp, objv9, 2);
                }
            } // End Invoke: ...
            tmp8 = interp.getResult();
            setVarScalar(interp, "undetermined", tmp8, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] && ()
            { // Invoke: lindex $result 0
                TclObject tmp11 = getVarScalar(interp, "result", compiledLocals, 2);
                tmp11 = TclList.index(interp, tmp11, 0);
                if ( tmp11 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp11);
                }
            } // End Invoke: lindex
            TclObject tmp12 = interp.getResult();
            ExprValue tmp13 = evs0;
            TJC.exprInitValue(interp, tmp13, tmp12);
            if (tmp13.getBooleanValue(interp)) {
            // Unary operator: ! $undetermined
            TclObject tmp14 = getVarScalar(interp, "undetermined", compiledLocals, 3);
            ExprValue tmp15 = evs1;
            if ( tmp14.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp15, tmp14);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp15, tmp14);
            }
            // End Unary operator: !
            tmp13.setIntValue(tmp15.getBooleanValue(interp));
            } else {
            tmp13.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp16 = ( tmp13.getIntValue() != 0 );
            if ( tmp16 ) {
                { // Invoke: set cmdname [...]
                    TclObject tmp17;
                    { // Invoke: lindex $result 1
                        TclObject tmp18 = getVarScalar(interp, "result", compiledLocals, 2);
                        tmp18 = TclList.index(interp, tmp18, 1);
                        if ( tmp18 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp18);
                        }
                    } // End Invoke: lindex
                    tmp17 = interp.getResult();
                    setVarScalar(interp, "cmdname", tmp17, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: if {$cmdname == "proc"} ... elseif ... ...
                    // Binary operator: $cmdname == "proc"
                    TclObject tmp19 = getVarScalar(interp, "cmdname", compiledLocals, 4);
                    boolean tmp20 = tmp19.toString().equals("proc");
                    ExprValue tmp21 = evs0;
                    tmp21.setIntValue(tmp20);
                    // End Binary operator: ==
                    boolean tmp22 = ( tmp21.getIntValue() != 0 );
                    if ( tmp22 ) {
                        { // Invoke: ... $key $cmdname
                            TclObject[] objv23 = TJC.grabObjv(interp, 3);
                            TclObject tmp24;
                            try {
                                // Arg 0 constant: ...
                                objv23[0] = const4;
                                // Arg 1 variable: $key
                                tmp24 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp24.preserve();
                                objv23[1] = tmp24;
                                // Arg 2 variable: $cmdname
                                tmp24 = getVarScalar(interp, "cmdname", compiledLocals, 4);
                                tmp24.preserve();
                                objv23[2] = tmp24;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv23, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp24 = objv23[1];
                                if ( tmp24 != null ) {
                                    tmp24.release();
                                }
                                tmp24 = objv23[2];
                                if ( tmp24 != null ) {
                                    tmp24.release();
                                }
                                TJC.releaseObjv(interp, objv23, 3);
                            }
                        } // End Invoke: ...
                    } else {
                        // Binary operator: $cmdname == "switch"
                        TclObject tmp25 = getVarScalar(interp, "cmdname", compiledLocals, 4);
                        boolean tmp26 = tmp25.toString().equals("switch");
                        ExprValue tmp27 = evs0;
                        tmp27.setIntValue(tmp26);
                        // End Binary operator: ==
                        boolean tmp28 = ( tmp27.getIntValue() != 0 );
                        if ( tmp28 ) {
                            { // Invoke: if {$debug} ...
                                TclObject tmp29 = getVarScalar(interp, "debug", compiledLocals, 1);
                                boolean tmp30 = TJC.getBoolean(interp, tmp29);
                                if ( tmp30 ) {
                                    { // Invoke: puts ...
                                        TclObject[] objv31 = TJC.grabObjv(interp, 2);
                                        try {
                                            // Arg 0 constant: puts
                                            objv31[0] = const1;
                                            // Arg 1 constant: ...
                                            objv31[1] = const5;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                ? cmdcache1.cmd : null), objv31, 0);
                                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                updateCmdCache(interp, 1);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv31, 2);
                                        }
                                    } // End Invoke: puts
                                }
                            } // End Invoke: if
                            { // Invoke: set cmd_range [...]
                                TclObject tmp32;
                                { // Invoke: descend_get_data $key command
                                    TclObject[] objv33 = TJC.grabObjv(interp, 3);
                                    TclObject tmp34;
                                    try {
                                        // Arg 0 constant: descend_get_data
                                        objv33[0] = const6;
                                        // Arg 1 variable: $key
                                        tmp34 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp34.preserve();
                                        objv33[1] = tmp34;
                                        // Arg 2 constant: command
                                        objv33[2] = const7;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv33, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp34 = objv33[1];
                                        if ( tmp34 != null ) {
                                            tmp34.release();
                                        }
                                        TJC.releaseObjv(interp, objv33, 3);
                                    }
                                } // End Invoke: descend_get_data
                                tmp32 = interp.getResult();
                                setVarScalar(interp, "cmd_range", tmp32, compiledLocals, 5);
                            } // End Invoke: set
                            { // Invoke: ... $cmd_range
                                TclObject[] objv35 = TJC.grabObjv(interp, 2);
                                TclObject tmp36;
                                try {
                                    // Arg 0 constant: ...
                                    objv35[0] = const8;
                                    // Arg 1 variable: $cmd_range
                                    tmp36 = getVarScalar(interp, "cmd_range", compiledLocals, 5);
                                    tmp36.preserve();
                                    objv35[1] = tmp36;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv35, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    tmp36 = objv35[1];
                                    if ( tmp36 != null ) {
                                        tmp36.release();
                                    }
                                    TJC.releaseObjv(interp, objv35, 2);
                                }
                            } // End Invoke: ...
                            { // Invoke: if {$debug} ...
                                TclObject tmp37 = getVarScalar(interp, "debug", compiledLocals, 1);
                                boolean tmp38 = TJC.getBoolean(interp, tmp37);
                                if ( tmp38 ) {
                                    { // Invoke: puts ...
                                        TclObject[] objv39 = TJC.grabObjv(interp, 2);
                                        try {
                                            // Arg 0 constant: puts
                                            objv39[0] = const1;
                                            // Arg 1 constant: ...
                                            objv39[1] = const9;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                ? cmdcache1.cmd : null), objv39, 0);
                                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                updateCmdCache(interp, 1);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv39, 2);
                                        }
                                    } // End Invoke: puts
                                } else {
                                    interp.resetResult();
                                }
                            } // End Invoke: if
                        } else {
                            interp.resetResult();
                        }
                    }
                } // End Invoke: if
            } else {
                interp.resetResult();
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parseproc_command_callback");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("puts");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_get_command_name");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_arguments_undetermined");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("parseproc_command_proc");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("pre-process switch cmd: appending to outscript");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_get_data");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("command");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("_parseproc_append_outscript_up_to");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("pre-process switch done");
        const9.preserve(); const9.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "descend_get_command_name";
                break;
            }
            case 3: {
                cmdName = "descend_arguments_undetermined";
                break;
            }
            case 4: {
                cmdName = "parseproc_command_proc";
                break;
            }
            case 5: {
                cmdName = "descend_get_data";
                break;
            }
            case 6: {
                cmdName = "_parseproc_append_outscript_up_to";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "debug",
        "result",
        "undetermined",
        "cmdname",
        "cmd_range"
    };
} // end class ParseprocCommandCallbackCmd

