// TJC implementation of procedure process_cmdline
package tjc;
import tcl.lang.*;

public class ProcessCmdlineCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "argv");
        }
        setVarScalar(interp, "argv", objv[1], compiledLocals, 0);
        { // Invoke: global _cmdline
            TJC.makeGlobalLinkVar(interp, "_cmdline", "_cmdline", 1);
        } // End Invoke: global
        { // Invoke: set files [...]
            TclObject tmp0;
            { // Invoke: list
                TclObject tmp1 = TclList.newInstance();
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            setVarScalar(interp, "files", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set options [...]
            TclObject tmp2;
            { // Invoke: list
                TclObject tmp3 = TclList.newInstance();
                interp.setResult(tmp3);
            } // End Invoke: list
            tmp2 = interp.getResult();
            setVarScalar(interp, "options", tmp2, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: foreach arg $argv ...
            TclObject tmp4 = null;
            try {
                tmp4 = getVarScalar(interp, "argv", compiledLocals, 0);
                tmp4.preserve();
                final int tmp4_length = TclList.getLength(interp, tmp4);

                for ( int index5 = 0 ; index5 < tmp4_length ; index5++ ) {
                    TclObject tmp6 = TclList.index(interp, tmp4, index5);
                    try {
                        setVarScalar(interp, "arg", tmp6, compiledLocals, 4);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "arg");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ... else ...
                        { // Invoke: string match *.tjc $arg
                            TclObject[] objv7 = TJC.grabObjv(interp, 4);
                            TclObject tmp8;
                            try {
                                // Arg 0 constant: string
                                objv7[0] = const0;
                                // Arg 1 constant: match
                                objv7[1] = const1;
                                // Arg 2 constant: *.tjc
                                objv7[2] = const2;
                                // Arg 3 variable: $arg
                                tmp8 = getVarScalar(interp, "arg", compiledLocals, 4);
                                tmp8.preserve();
                                objv7[3] = tmp8;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv7, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp8 = objv7[3];
                                if ( tmp8 != null ) {
                                    tmp8.release();
                                }
                                TJC.releaseObjv(interp, objv7, 4);
                            }
                        } // End Invoke: string
                        TclObject tmp9 = interp.getResult();
                        ExprValue tmp10 = evs0;
                        TJC.exprInitValue(interp, tmp10, tmp9);
                        boolean tmp11 = tmp10.getBooleanValue(interp);
                        if ( tmp11 ) {
                            { // Invoke: lappend files $arg
                                TclObject[] objv12 = TJC.grabObjv(interp, 1);
                                TclObject tmp13;
                                try {
                                    // Arg 2 variable: $arg
                                    tmp13 = getVarScalar(interp, "arg", compiledLocals, 4);
                                    tmp13.preserve();
                                    objv12[0] = tmp13;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "files", objv12, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv12, 1);
                                }
                            } // End Invoke: lappend
                        } else {
                            { // Invoke: lappend options $arg
                                TclObject[] objv14 = TJC.grabObjv(interp, 1);
                                TclObject tmp15;
                                try {
                                    // Arg 2 variable: $arg
                                    tmp15 = getVarScalar(interp, "arg", compiledLocals, 4);
                                    tmp15.preserve();
                                    objv14[0] = tmp15;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "options", objv14, compiledLocals, 3);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv14, 1);
                                }
                            } // End Invoke: lappend
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp4 != null ) {
                    tmp4.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set _cmdline(files) $files
            TclObject tmp16;
            tmp16 = getVarScalar(interp, "files", compiledLocals, 2);
            setVarArray(interp, "_cmdline", "files", tmp16, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set _cmdline(options) $options
            TclObject tmp17;
            tmp17 = getVarScalar(interp, "options", compiledLocals, 3);
            setVarArray(interp, "_cmdline", "options", tmp17, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return $options
            TclObject tmp18 = getVarScalar(interp, "options", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp18);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "process_cmdline");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("match");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("*.tjc");
        const2.preserve(); const2.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "argv",
        "_cmdline",
        "files",
        "options",
        "arg"
    };
} // end class ProcessCmdlineCmd

