// TJC implementation of procedure process_module_file
package tjc;
import tcl.lang.*;

public class ProcessModuleFileCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 44, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "filename");
        }
        setVarScalar(interp, "filename", objv[1], compiledLocals, 0);
        { // Invoke: global _tjc
            TJC.makeGlobalLinkVar(interp, "_tjc", "_tjc", 1);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {$_tjc(debug)} ...
            TclObject tmp0 = getVarArray(interp, "_tjc", "debug", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            TJC.exprInitValue(interp, tmp1, tmp0);
            boolean tmp2 = tmp1.getBooleanValue(interp);
            if ( tmp2 ) {
                { // Invoke: set debug 1
                    setVarScalar(interp, "debug", const1, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: $debug || $_tjc(...)
            TclObject tmp3 = getVarScalar(interp, "debug", compiledLocals, 2);
            ExprValue tmp4 = evs0;
            TJC.exprInitValue(interp, tmp4, tmp3);
            if (!tmp4.getBooleanValue(interp)) {
            TclObject tmp5 = getVarArray(interp, "_tjc", "progress", compiledLocals, 1);
            ExprValue tmp6 = evs1;
            TJC.exprInitValue(interp, tmp6, tmp5);
            tmp4.setIntValue(tmp6.getBooleanValue(interp));
            } else {
            tmp4.setIntValue(1);
            } // End if: !$debug
            // End Binary operator: ||
            boolean tmp7 = ( tmp4.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: puts "..."
                    TclObject[] objv8 = TJC.grabObjv(interp, 2);
                    TclObject tmp9;
                    try {
                        // Arg 0 constant: puts
                        objv8[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp10 = new StringBuffer(64);
                        sbtmp10.append("processing module file ");
                        tmp9 = getVarScalar(interp, "filename", compiledLocals, 0);
                        sbtmp10.append(tmp9.toString());
                        tmp9 = TclString.newInstance(sbtmp10);
                        tmp9.preserve();
                        objv8[1] = tmp9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv8, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp9 = objv8[1];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        TJC.releaseObjv(interp, objv8, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: file exists $filename
                TclObject[] objv11 = TJC.grabObjv(interp, 3);
                TclObject tmp12;
                try {
                    // Arg 0 constant: file
                    objv11[0] = const3;
                    // Arg 1 constant: exists
                    objv11[1] = const4;
                    // Arg 2 variable: $filename
                    tmp12 = getVarScalar(interp, "filename", compiledLocals, 0);
                    tmp12.preserve();
                    objv11[2] = tmp12;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv11, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp12 = objv11[2];
                    if ( tmp12 != null ) {
                        tmp12.release();
                    }
                    TJC.releaseObjv(interp, objv11, 3);
                }
            } // End Invoke: file
            TclObject tmp13 = interp.getResult();
            ExprValue tmp14 = evs0;
            if ( tmp13.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp14, tmp13);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp14, tmp13);
            }
            // End Unary operator: !
            boolean tmp15 = ( tmp14.getIntValue() != 0 );
            if ( tmp15 ) {
                { // Invoke: puts stderr "..."
                    TclObject[] objv16 = TJC.grabObjv(interp, 3);
                    TclObject tmp17;
                    try {
                        // Arg 0 constant: puts
                        objv16[0] = const2;
                        // Arg 1 constant: stderr
                        objv16[1] = const5;
                        // Arg 2 word: "..."
                        StringBuffer sbtmp18 = new StringBuffer(64);
                        sbtmp18.append("module file ");
                        sbtmp18.append("\"");
                        tmp17 = getVarScalar(interp, "filename", compiledLocals, 0);
                        sbtmp18.append(tmp17.toString());
                        sbtmp18.append("\"");
                        sbtmp18.append(" does not exists");
                        tmp17 = TclString.newInstance(sbtmp18);
                        tmp17.preserve();
                        objv16[2] = tmp17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv16, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp17 = objv16[2];
                        if ( tmp17 != null ) {
                            tmp17.release();
                        }
                        TJC.releaseObjv(interp, objv16, 3);
                    }
                } // End Invoke: puts
                { // Invoke: return -1
                    interp.resetResult();
                    interp.setResult(const6);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: catch ... err
                int code19 = TCL.OK;
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: module_parse_file $filename
                    TclObject[] objv20 = TJC.grabObjv(interp, 2);
                    TclObject tmp21;
                    try {
                        // Arg 0 constant: module_parse_file
                        objv20[0] = const7;
                        // Arg 1 variable: $filename
                        tmp21 = getVarScalar(interp, "filename", compiledLocals, 0);
                        tmp21.preserve();
                        objv20[1] = tmp21;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv20, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp21 = objv20[1];
                        if ( tmp21 != null ) {
                            tmp21.release();
                        }
                        TJC.releaseObjv(interp, objv20, 2);
                    }
                } // End Invoke: module_parse_file
                } catch (TclException ex) {
                    code19 = ex.getCompletionCode();
                }
                TclObject result = interp.getResult();
                try {
                    setVarScalar(interp, "err", result, compiledLocals, 3);
                } catch (TclException ex) {
                    TJC.catchVarErr(interp);
                }
                interp.resetResult();
                interp.setResult(code19);
            } // End Invoke: catch
            TclObject tmp22 = interp.getResult();
            ExprValue tmp23 = evs0;
            TJC.exprInitValue(interp, tmp23, tmp22);
            boolean tmp24 = tmp23.getBooleanValue(interp);
            if ( tmp24 ) {
                { // Invoke: puts stderr "..."
                    TclObject[] objv25 = TJC.grabObjv(interp, 3);
                    TclObject tmp26;
                    try {
                        // Arg 0 constant: puts
                        objv25[0] = const2;
                        // Arg 1 constant: stderr
                        objv25[1] = const5;
                        // Arg 2 word: "..."
                        StringBuffer sbtmp27 = new StringBuffer(64);
                        sbtmp27.append("module file ");
                        tmp26 = getVarScalar(interp, "filename", compiledLocals, 0);
                        sbtmp27.append(tmp26.toString());
                        sbtmp27.append(" parse failure: ");
                        tmp26 = getVarScalar(interp, "err", compiledLocals, 3);
                        sbtmp27.append(tmp26.toString());
                        tmp26 = TclString.newInstance(sbtmp27);
                        tmp26.preserve();
                        objv25[2] = tmp26;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv25, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp26 = objv25[2];
                        if ( tmp26 != null ) {
                            tmp26.release();
                        }
                        TJC.releaseObjv(interp, objv25, 3);
                    }
                } // End Invoke: puts
                { // Invoke: return -1
                    interp.resetResult();
                    interp.setResult(const6);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: catch ... err
                int code28 = TCL.OK;
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: ...
                    TclObject[] objv29 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv29[0] = const8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv29, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv29, 1);
                    }
                } // End Invoke: ...
                } catch (TclException ex) {
                    code28 = ex.getCompletionCode();
                }
                TclObject result = interp.getResult();
                try {
                    setVarScalar(interp, "err", result, compiledLocals, 3);
                } catch (TclException ex) {
                    TJC.catchVarErr(interp);
                }
                interp.resetResult();
                interp.setResult(code28);
            } // End Invoke: catch
            TclObject tmp30 = interp.getResult();
            ExprValue tmp31 = evs0;
            TJC.exprInitValue(interp, tmp31, tmp30);
            boolean tmp32 = tmp31.getBooleanValue(interp);
            if ( tmp32 ) {
                { // Invoke: puts stderr "..."
                    TclObject[] objv33 = TJC.grabObjv(interp, 3);
                    TclObject tmp34;
                    try {
                        // Arg 0 constant: puts
                        objv33[0] = const2;
                        // Arg 1 constant: stderr
                        objv33[1] = const5;
                        // Arg 2 word: "..."
                        StringBuffer sbtmp35 = new StringBuffer(64);
                        sbtmp35.append("module file ");
                        tmp34 = getVarScalar(interp, "filename", compiledLocals, 0);
                        sbtmp35.append(tmp34.toString());
                        sbtmp35.append(" validation failure: ");
                        tmp34 = getVarScalar(interp, "err", compiledLocals, 3);
                        sbtmp35.append(tmp34.toString());
                        tmp34 = TclString.newInstance(sbtmp35);
                        tmp34.preserve();
                        objv33[2] = tmp34;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv33, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp34 = objv33[2];
                        if ( tmp34 != null ) {
                            tmp34.release();
                        }
                        TJC.releaseObjv(interp, objv33, 3);
                    }
                } // End Invoke: puts
                { // Invoke: return -1
                    interp.resetResult();
                    interp.setResult(const6);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: catch ... err
                int code36 = TCL.OK;
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: ...
                    TclObject[] objv37 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv37[0] = const9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv37, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv37, 1);
                    }
                } // End Invoke: ...
                } catch (TclException ex) {
                    code36 = ex.getCompletionCode();
                }
                TclObject result = interp.getResult();
                try {
                    setVarScalar(interp, "err", result, compiledLocals, 3);
                } catch (TclException ex) {
                    TJC.catchVarErr(interp);
                }
                interp.resetResult();
                interp.setResult(code36);
            } // End Invoke: catch
            TclObject tmp38 = interp.getResult();
            ExprValue tmp39 = evs0;
            TJC.exprInitValue(interp, tmp39, tmp38);
            boolean tmp40 = tmp39.getBooleanValue(interp);
            if ( tmp40 ) {
                { // Invoke: puts stderr "..."
                    TclObject[] objv41 = TJC.grabObjv(interp, 3);
                    TclObject tmp42;
                    try {
                        // Arg 0 constant: puts
                        objv41[0] = const2;
                        // Arg 1 constant: stderr
                        objv41[1] = const5;
                        // Arg 2 word: "..."
                        StringBuffer sbtmp43 = new StringBuffer(64);
                        sbtmp43.append("module file ");
                        tmp42 = getVarScalar(interp, "filename", compiledLocals, 0);
                        sbtmp43.append(tmp42.toString());
                        sbtmp43.append(" options validation failure: ");
                        tmp42 = getVarScalar(interp, "err", compiledLocals, 3);
                        sbtmp43.append(tmp42.toString());
                        tmp42 = TclString.newInstance(sbtmp43);
                        tmp42.preserve();
                        objv41[2] = tmp42;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv41, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp42 = objv41[2];
                        if ( tmp42 != null ) {
                            tmp42.release();
                        }
                        TJC.releaseObjv(interp, objv41, 3);
                    }
                } // End Invoke: puts
                { // Invoke: return -1
                    interp.resetResult();
                    interp.setResult(const6);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set pkg [...]
            TclObject tmp44;
            { // Invoke: module_query PACKAGE
                TclObject[] objv45 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: module_query
                    objv45[0] = const10;
                    // Arg 1 constant: PACKAGE
                    objv45[1] = const11;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv45, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv45, 2);
                }
            } // End Invoke: module_query
            tmp44 = interp.getResult();
            setVarScalar(interp, "pkg", tmp44, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set source_files [...]
            TclObject tmp46;
            { // Invoke: module_expand SOURCE
                TclObject[] objv47 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: module_expand
                    objv47[0] = const12;
                    // Arg 1 constant: SOURCE
                    objv47[1] = const13;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv47, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv47, 2);
                }
            } // End Invoke: module_expand
            tmp46 = interp.getResult();
            setVarScalar(interp, "source_files", tmp46, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set include_source_files [...]
            TclObject tmp48;
            { // Invoke: module_expand INCLUDE_SOURCE
                TclObject[] objv49 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: module_expand
                    objv49[0] = const12;
                    // Arg 1 constant: INCLUDE_SOURCE
                    objv49[1] = const14;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv49, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv49, 2);
                }
            } // End Invoke: module_expand
            tmp48 = interp.getResult();
            setVarScalar(interp, "include_source_files", tmp48, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set source_files [...]
            TclObject tmp50;
            { // Invoke: ... $source_files $...
                TclObject[] objv51 = TJC.grabObjv(interp, 3);
                TclObject tmp52;
                try {
                    // Arg 0 constant: ...
                    objv51[0] = const15;
                    // Arg 1 variable: $source_files
                    tmp52 = getVarScalar(interp, "source_files", compiledLocals, 5);
                    tmp52.preserve();
                    objv51[1] = tmp52;
                    // Arg 2 variable: $...
                    tmp52 = getVarScalar(interp, "include_source_files", compiledLocals, 6);
                    tmp52.preserve();
                    objv51[2] = tmp52;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                        ? cmdcache8.cmd : null), objv51, 0);
                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                        updateCmdCache(interp, 8);
                    }
                } finally {
                    tmp52 = objv51[1];
                    if ( tmp52 != null ) {
                        tmp52.release();
                    }
                    tmp52 = objv51[2];
                    if ( tmp52 != null ) {
                        tmp52.release();
                    }
                    TJC.releaseObjv(interp, objv51, 3);
                }
            } // End Invoke: ...
            tmp50 = interp.getResult();
            setVarScalar(interp, "source_files", tmp50, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set TJC [...]
            TclObject tmp53;
            { // Invoke: file join [...] [...]
                TclObject[] objv54 = TJC.grabObjv(interp, 4);
                TclObject tmp55;
                try {
                    // Arg 0 constant: file
                    objv54[0] = const3;
                    // Arg 1 constant: join
                    objv54[1] = const16;
                    // Arg 2 command: [...]
                    { // Invoke: pwd
                        TclObject[] objv56 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: pwd
                            objv56[0] = const17;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                ? cmdcache9.cmd : null), objv56, 0);
                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                updateCmdCache(interp, 9);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv56, 1);
                        }
                    } // End Invoke: pwd
                    tmp55 = interp.getResult();
                    tmp55.preserve();
                    objv54[2] = tmp55;
                    // Arg 3 command: [...]
                    { // Invoke: jdk_tjc_rootdir
                        TclObject[] objv57 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: jdk_tjc_rootdir
                            objv57[0] = const18;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                ? cmdcache10.cmd : null), objv57, 0);
                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                updateCmdCache(interp, 10);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv57, 1);
                        }
                    } // End Invoke: jdk_tjc_rootdir
                    tmp55 = interp.getResult();
                    tmp55.preserve();
                    objv54[3] = tmp55;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv54, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp55 = objv54[2];
                    if ( tmp55 != null ) {
                        tmp55.release();
                    }
                    tmp55 = objv54[3];
                    if ( tmp55 != null ) {
                        tmp55.release();
                    }
                    TJC.releaseObjv(interp, objv54, 4);
                }
            } // End Invoke: file
            tmp53 = interp.getResult();
            setVarScalar(interp, "TJC", tmp53, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set TJC_BUILD [...]
            TclObject tmp58;
            { // Invoke: file join $TJC build
                TclObject[] objv59 = TJC.grabObjv(interp, 4);
                TclObject tmp60;
                try {
                    // Arg 0 constant: file
                    objv59[0] = const3;
                    // Arg 1 constant: join
                    objv59[1] = const16;
                    // Arg 2 variable: $TJC
                    tmp60 = getVarScalar(interp, "TJC", compiledLocals, 7);
                    tmp60.preserve();
                    objv59[2] = tmp60;
                    // Arg 3 constant: build
                    objv59[3] = const19;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv59, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp60 = objv59[2];
                    if ( tmp60 != null ) {
                        tmp60.release();
                    }
                    TJC.releaseObjv(interp, objv59, 4);
                }
            } // End Invoke: file
            tmp58 = interp.getResult();
            setVarScalar(interp, "TJC_BUILD", tmp58, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp61;
            { // Invoke: file join $TJC_BUILD [...]
                TclObject[] objv62 = TJC.grabObjv(interp, 4);
                TclObject tmp63;
                try {
                    // Arg 0 constant: file
                    objv62[0] = const3;
                    // Arg 1 constant: join
                    objv62[1] = const16;
                    // Arg 2 variable: $TJC_BUILD
                    tmp63 = getVarScalar(interp, "TJC_BUILD", compiledLocals, 8);
                    tmp63.preserve();
                    objv62[2] = tmp63;
                    // Arg 3 command: [...]
                    { // Invoke: jdk_package_library $pkg 0
                        TclObject[] objv64 = TJC.grabObjv(interp, 3);
                        TclObject tmp65;
                        try {
                            // Arg 0 constant: jdk_package_library
                            objv64[0] = const20;
                            // Arg 1 variable: $pkg
                            tmp65 = getVarScalar(interp, "pkg", compiledLocals, 4);
                            tmp65.preserve();
                            objv64[1] = tmp65;
                            // Arg 2 constant: 0
                            objv64[2] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                ? cmdcache11.cmd : null), objv64, 0);
                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                updateCmdCache(interp, 11);
                            }
                        } finally {
                            tmp65 = objv64[1];
                            if ( tmp65 != null ) {
                                tmp65.release();
                            }
                            TJC.releaseObjv(interp, objv64, 3);
                        }
                    } // End Invoke: jdk_package_library
                    tmp63 = interp.getResult();
                    tmp63.preserve();
                    objv62[3] = tmp63;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv62, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp63 = objv62[2];
                    if ( tmp63 != null ) {
                        tmp63.release();
                    }
                    tmp63 = objv62[3];
                    if ( tmp63 != null ) {
                        tmp63.release();
                    }
                    TJC.releaseObjv(interp, objv62, 4);
                }
            } // End Invoke: file
            tmp61 = interp.getResult();
            setVarScalar(interp, "TJC_BUILD_PACKAGE_LIBRARY", tmp61, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: file mkdir $...
            TclObject[] objv66 = TJC.grabObjv(interp, 3);
            TclObject tmp67;
            try {
                // Arg 0 constant: file
                objv66[0] = const3;
                // Arg 1 constant: mkdir
                objv66[1] = const21;
                // Arg 2 variable: $...
                tmp67 = getVarScalar(interp, "TJC_BUILD_PACKAGE_LIBRARY", compiledLocals, 9);
                tmp67.preserve();
                objv66[2] = tmp67;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv66, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                tmp67 = objv66[2];
                if ( tmp67 != null ) {
                    tmp67.release();
                }
                TJC.releaseObjv(interp, objv66, 3);
            }
        } // End Invoke: file
        { // Invoke: set TJC_SOURCE [...]
            TclObject tmp68;
            { // Invoke: file join $TJC source
                TclObject[] objv69 = TJC.grabObjv(interp, 4);
                TclObject tmp70;
                try {
                    // Arg 0 constant: file
                    objv69[0] = const3;
                    // Arg 1 constant: join
                    objv69[1] = const16;
                    // Arg 2 variable: $TJC
                    tmp70 = getVarScalar(interp, "TJC", compiledLocals, 7);
                    tmp70.preserve();
                    objv69[2] = tmp70;
                    // Arg 3 constant: source
                    objv69[3] = const22;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv69, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp70 = objv69[2];
                    if ( tmp70 != null ) {
                        tmp70.release();
                    }
                    TJC.releaseObjv(interp, objv69, 4);
                }
            } // End Invoke: file
            tmp68 = interp.getResult();
            setVarScalar(interp, "TJC_SOURCE", tmp68, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp71;
            { // Invoke: file join $TJC_SOURCE [...]
                TclObject[] objv72 = TJC.grabObjv(interp, 4);
                TclObject tmp73;
                try {
                    // Arg 0 constant: file
                    objv72[0] = const3;
                    // Arg 1 constant: join
                    objv72[1] = const16;
                    // Arg 2 variable: $TJC_SOURCE
                    tmp73 = getVarScalar(interp, "TJC_SOURCE", compiledLocals, 10);
                    tmp73.preserve();
                    objv72[2] = tmp73;
                    // Arg 3 command: [...]
                    { // Invoke: jdk_package_library $pkg 1
                        TclObject[] objv74 = TJC.grabObjv(interp, 3);
                        TclObject tmp75;
                        try {
                            // Arg 0 constant: jdk_package_library
                            objv74[0] = const20;
                            // Arg 1 variable: $pkg
                            tmp75 = getVarScalar(interp, "pkg", compiledLocals, 4);
                            tmp75.preserve();
                            objv74[1] = tmp75;
                            // Arg 2 constant: 1
                            objv74[2] = const1;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                ? cmdcache11.cmd : null), objv74, 0);
                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                updateCmdCache(interp, 11);
                            }
                        } finally {
                            tmp75 = objv74[1];
                            if ( tmp75 != null ) {
                                tmp75.release();
                            }
                            TJC.releaseObjv(interp, objv74, 3);
                        }
                    } // End Invoke: jdk_package_library
                    tmp73 = interp.getResult();
                    tmp73.preserve();
                    objv72[3] = tmp73;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv72, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp73 = objv72[2];
                    if ( tmp73 != null ) {
                        tmp73.release();
                    }
                    tmp73 = objv72[3];
                    if ( tmp73 != null ) {
                        tmp73.release();
                    }
                    TJC.releaseObjv(interp, objv72, 4);
                }
            } // End Invoke: file
            tmp71 = interp.getResult();
            setVarScalar(interp, "TJC_SOURCE_PACKAGE_LIBRARY", tmp71, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: file mkdir $...
            TclObject[] objv76 = TJC.grabObjv(interp, 3);
            TclObject tmp77;
            try {
                // Arg 0 constant: file
                objv76[0] = const3;
                // Arg 1 constant: mkdir
                objv76[1] = const21;
                // Arg 2 variable: $...
                tmp77 = getVarScalar(interp, "TJC_SOURCE_PACKAGE_LIBRARY", compiledLocals, 11);
                tmp77.preserve();
                objv76[2] = tmp77;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv76, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                tmp77 = objv76[2];
                if ( tmp77 != null ) {
                    tmp77.release();
                }
                TJC.releaseObjv(interp, objv76, 3);
            }
        } // End Invoke: file
        { // Invoke: nameproc_init $pkg
            TclObject[] objv78 = TJC.grabObjv(interp, 2);
            TclObject tmp79;
            try {
                // Arg 0 constant: nameproc_init
                objv78[0] = const23;
                // Arg 1 variable: $pkg
                tmp79 = getVarScalar(interp, "pkg", compiledLocals, 4);
                tmp79.preserve();
                objv78[1] = tmp79;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                    ? cmdcache12.cmd : null), objv78, 0);
                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                    updateCmdCache(interp, 12);
                }
            } finally {
                tmp79 = objv78[1];
                if ( tmp79 != null ) {
                    tmp79.release();
                }
                TJC.releaseObjv(interp, objv78, 2);
            }
        } // End Invoke: nameproc_init
        { // Invoke: set file_and_procs [...]
            TclObject tmp80;
            { // Invoke: list
                TclObject tmp81 = TclList.newInstance();
                interp.setResult(tmp81);
            } // End Invoke: list
            tmp80 = interp.getResult();
            setVarScalar(interp, "file_and_procs", tmp80, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: set num_procs_parsed 0
            setVarScalar(interp, "num_procs_parsed", const0, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: foreach source_file $source_files ...
            TclObject tmp82 = null;
            try {
                tmp82 = getVarScalar(interp, "source_files", compiledLocals, 5);
                tmp82.preserve();
                final int tmp82_length = TclList.getLength(interp, tmp82);

                for ( int index83 = 0 ; index83 < tmp82_length ; index83++ ) {
                    TclObject tmp84 = TclList.index(interp, tmp82, index83);
                    try {
                        setVarScalar(interp, "source_file", tmp84, compiledLocals, 14);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "source_file");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ...
                        // Binary operator: $debug || $_tjc(...)
                        TclObject tmp85 = getVarScalar(interp, "debug", compiledLocals, 2);
                        ExprValue tmp86 = evs0;
                        TJC.exprInitValue(interp, tmp86, tmp85);
                        if (!tmp86.getBooleanValue(interp)) {
                        TclObject tmp87 = getVarArray(interp, "_tjc", "progress", compiledLocals, 1);
                        ExprValue tmp88 = evs1;
                        TJC.exprInitValue(interp, tmp88, tmp87);
                        tmp86.setIntValue(tmp88.getBooleanValue(interp));
                        } else {
                        tmp86.setIntValue(1);
                        } // End if: !$debug
                        // End Binary operator: ||
                        boolean tmp89 = ( tmp86.getIntValue() != 0 );
                        if ( tmp89 ) {
                            { // Invoke: puts "..."
                                TclObject[] objv90 = TJC.grabObjv(interp, 2);
                                TclObject tmp91;
                                try {
                                    // Arg 0 constant: puts
                                    objv90[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp92 = new StringBuffer(64);
                                    sbtmp92.append("scanning Tcl procs in ");
                                    tmp91 = getVarScalar(interp, "source_file", compiledLocals, 14);
                                    sbtmp92.append(tmp91.toString());
                                    tmp91 = TclString.newInstance(sbtmp92);
                                    tmp91.preserve();
                                    objv90[1] = tmp91;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv90, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp91 = objv90[1];
                                    if ( tmp91 != null ) {
                                        tmp91.release();
                                    }
                                    TJC.releaseObjv(interp, objv90, 2);
                                }
                            } // End Invoke: puts
                        }
                    } // End Invoke: if
                    { // Invoke: set script [...]
                        TclObject tmp93;
                        { // Invoke: tjc_util_file_read $source_file
                            TclObject[] objv94 = TJC.grabObjv(interp, 2);
                            TclObject tmp95;
                            try {
                                // Arg 0 constant: tjc_util_file_read
                                objv94[0] = const24;
                                // Arg 1 variable: $source_file
                                tmp95 = getVarScalar(interp, "source_file", compiledLocals, 14);
                                tmp95.preserve();
                                objv94[1] = tmp95;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                    ? cmdcache13.cmd : null), objv94, 0);
                                if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                    updateCmdCache(interp, 13);
                                }
                            } finally {
                                tmp95 = objv94[1];
                                if ( tmp95 != null ) {
                                    tmp95.release();
                                }
                                TJC.releaseObjv(interp, objv94, 2);
                            }
                        } // End Invoke: tjc_util_file_read
                        tmp93 = interp.getResult();
                        setVarScalar(interp, "script", tmp93, compiledLocals, 15);
                    } // End Invoke: set
                    { // Invoke: file copy $source_file $...
                        TclObject[] objv96 = TJC.grabObjv(interp, 4);
                        TclObject tmp97;
                        try {
                            // Arg 0 constant: file
                            objv96[0] = const3;
                            // Arg 1 constant: copy
                            objv96[1] = const25;
                            // Arg 2 variable: $source_file
                            tmp97 = getVarScalar(interp, "source_file", compiledLocals, 14);
                            tmp97.preserve();
                            objv96[2] = tmp97;
                            // Arg 3 variable: $...
                            tmp97 = getVarScalar(interp, "TJC_SOURCE_PACKAGE_LIBRARY", compiledLocals, 11);
                            tmp97.preserve();
                            objv96[3] = tmp97;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv96, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp97 = objv96[2];
                            if ( tmp97 != null ) {
                                tmp97.release();
                            }
                            tmp97 = objv96[3];
                            if ( tmp97 != null ) {
                                tmp97.release();
                            }
                            TJC.releaseObjv(interp, objv96, 4);
                        }
                    } // End Invoke: file
                    { // Invoke: parseproc_init
                        TclObject[] objv98 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: parseproc_init
                            objv98[0] = const26;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                ? cmdcache14.cmd : null), objv98, 0);
                            if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                updateCmdCache(interp, 14);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv98, 1);
                        }
                    } // End Invoke: parseproc_init
                    { // Invoke: if ... ...
                        { // Invoke: catch ... err
                            int code99 = TCL.OK;
                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set results [...]
                                TclObject tmp100;
                                { // Invoke: parseproc_start $script $source_file
                                    TclObject[] objv101 = TJC.grabObjv(interp, 3);
                                    TclObject tmp102;
                                    try {
                                        // Arg 0 constant: parseproc_start
                                        objv101[0] = const27;
                                        // Arg 1 variable: $script
                                        tmp102 = getVarScalar(interp, "script", compiledLocals, 15);
                                        tmp102.preserve();
                                        objv101[1] = tmp102;
                                        // Arg 2 variable: $source_file
                                        tmp102 = getVarScalar(interp, "source_file", compiledLocals, 14);
                                        tmp102.preserve();
                                        objv101[2] = tmp102;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                            ? cmdcache15.cmd : null), objv101, 0);
                                        if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                            updateCmdCache(interp, 15);
                                        }
                                    } finally {
                                        tmp102 = objv101[1];
                                        if ( tmp102 != null ) {
                                            tmp102.release();
                                        }
                                        tmp102 = objv101[2];
                                        if ( tmp102 != null ) {
                                            tmp102.release();
                                        }
                                        TJC.releaseObjv(interp, objv101, 3);
                                    }
                                } // End Invoke: parseproc_start
                                tmp100 = interp.getResult();
                                tmp100 = setVarScalar(interp, "results", tmp100, compiledLocals, 16);
                                interp.setResult(tmp100);
                            } // End Invoke: set
                            } catch (TclException ex) {
                                code99 = ex.getCompletionCode();
                            }
                            TclObject result = interp.getResult();
                            try {
                                setVarScalar(interp, "err", result, compiledLocals, 3);
                            } catch (TclException ex) {
                                TJC.catchVarErr(interp);
                            }
                            interp.resetResult();
                            interp.setResult(code99);
                        } // End Invoke: catch
                        TclObject tmp103 = interp.getResult();
                        ExprValue tmp104 = evs0;
                        TJC.exprInitValue(interp, tmp104, tmp103);
                        boolean tmp105 = tmp104.getBooleanValue(interp);
                        if ( tmp105 ) {
                            { // Invoke: puts stderr "..."
                                TclObject[] objv106 = TJC.grabObjv(interp, 3);
                                TclObject tmp107;
                                try {
                                    // Arg 0 constant: puts
                                    objv106[0] = const2;
                                    // Arg 1 constant: stderr
                                    objv106[1] = const5;
                                    // Arg 2 word: "..."
                                    StringBuffer sbtmp108 = new StringBuffer(64);
                                    { // Invoke: module_get_filename
                                        TclObject[] objv109 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: module_get_filename
                                            objv109[0] = const28;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                                                ? cmdcache16.cmd : null), objv109, 0);
                                            if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                                                updateCmdCache(interp, 16);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv109, 1);
                                        }
                                    } // End Invoke: module_get_filename
                                    tmp107 = interp.getResult();
                                    sbtmp108.append(tmp107.toString());
                                    sbtmp108.append(": Internal error while parsing Tcl file ");
                                    tmp107 = getVarScalar(interp, "source_file", compiledLocals, 14);
                                    sbtmp108.append(tmp107.toString());
                                    sbtmp108.append(":");
                                    tmp107 = TclString.newInstance(sbtmp108);
                                    tmp107.preserve();
                                    objv106[2] = tmp107;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv106, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp107 = objv106[2];
                                    if ( tmp107 != null ) {
                                        tmp107.release();
                                    }
                                    TJC.releaseObjv(interp, objv106, 3);
                                }
                            } // End Invoke: puts
                            { // Invoke: puts stderr "$err"
                                TclObject[] objv110 = TJC.grabObjv(interp, 3);
                                TclObject tmp111;
                                try {
                                    // Arg 0 constant: puts
                                    objv110[0] = const2;
                                    // Arg 1 constant: stderr
                                    objv110[1] = const5;
                                    // Arg 2 word: "$err"
                                    tmp111 = getVarScalar(interp, "err", compiledLocals, 3);
                                    tmp111.preserve();
                                    objv110[2] = tmp111;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv110, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp111 = objv110[2];
                                    if ( tmp111 != null ) {
                                        tmp111.release();
                                    }
                                    TJC.releaseObjv(interp, objv110, 3);
                                }
                            } // End Invoke: puts
                            { // Invoke: return -1
                                interp.resetResult();
                                interp.setResult(const6);
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    } // End Invoke: if
                    { // Invoke: set mod_script [...]
                        TclObject tmp112;
                        { // Invoke: lindex $results 0
                            TclObject tmp113 = getVarScalar(interp, "results", compiledLocals, 16);
                            tmp113 = TclList.index(interp, tmp113, 0);
                            if ( tmp113 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp113);
                            }
                        } // End Invoke: lindex
                        tmp112 = interp.getResult();
                        setVarScalar(interp, "mod_script", tmp112, compiledLocals, 17);
                    } // End Invoke: set
                    { // Invoke: set proc_tuples [...]
                        TclObject tmp114;
                        { // Invoke: lindex $results 1
                            TclObject tmp115 = getVarScalar(interp, "results", compiledLocals, 16);
                            tmp115 = TclList.index(interp, tmp115, 1);
                            if ( tmp115 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp115);
                            }
                        } // End Invoke: lindex
                        tmp114 = interp.getResult();
                        setVarScalar(interp, "proc_tuples", tmp114, compiledLocals, 18);
                    } // End Invoke: set
                    { // Invoke: incr num_procs_parsed [...]
                        { // Invoke: llength $proc_tuples
                            TclObject tmp117 = getVarScalar(interp, "proc_tuples", compiledLocals, 18);
                            int tmp118 = TclList.getLength(interp, tmp117);
                            interp.setResult(tmp118);
                        } // End Invoke: llength
                        TclObject tmp116 = interp.getResult();
                        int tmp119 = TclInteger.get(interp, tmp116);
                        interp.resetResult();
                        incrVarScalar(interp, "num_procs_parsed", tmp119, compiledLocals, 13);
                    } // End Invoke: incr
                    { // Invoke: if {0 && $debug} ...
                        // Binary operator: 0 && $debug
                        ExprValue tmp120 = evs0;
                        tmp120.setIntValue(0);
                        if (tmp120.getBooleanValue(interp)) {
                        TclObject tmp121 = getVarScalar(interp, "debug", compiledLocals, 2);
                        ExprValue tmp122 = evs1;
                        TJC.exprInitValue(interp, tmp122, tmp121);
                        tmp120.setIntValue(tmp122.getBooleanValue(interp));
                        } else {
                        tmp120.setIntValue(0);
                        } // End if: 0
                        // End Binary operator: &&
                        boolean tmp123 = ( tmp120.getIntValue() != 0 );
                        if ( tmp123 ) {
                            { // Invoke: puts "..."
                                TclObject[] objv124 = TJC.grabObjv(interp, 2);
                                TclObject tmp125;
                                try {
                                    // Arg 0 constant: puts
                                    objv124[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp126 = new StringBuffer(64);
                                    sbtmp126.append("got mod_script ");
                                    sbtmp126.append("\"");
                                    tmp125 = getVarScalar(interp, "mod_script", compiledLocals, 17);
                                    sbtmp126.append(tmp125.toString());
                                    sbtmp126.append("\"");
                                    tmp125 = TclString.newInstance(sbtmp126);
                                    tmp125.preserve();
                                    objv124[1] = tmp125;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv124, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp125 = objv124[1];
                                    if ( tmp125 != null ) {
                                        tmp125.release();
                                    }
                                    TJC.releaseObjv(interp, objv124, 2);
                                }
                            } // End Invoke: puts
                            { // Invoke: puts "..."
                                TclObject[] objv127 = TJC.grabObjv(interp, 2);
                                TclObject tmp128;
                                try {
                                    // Arg 0 constant: puts
                                    objv127[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp129 = new StringBuffer(64);
                                    sbtmp129.append("got proc_tuples ");
                                    sbtmp129.append("{");
                                    tmp128 = getVarScalar(interp, "proc_tuples", compiledLocals, 18);
                                    sbtmp129.append(tmp128.toString());
                                    sbtmp129.append("}");
                                    tmp128 = TclString.newInstance(sbtmp129);
                                    tmp128.preserve();
                                    objv127[1] = tmp128;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv127, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp128 = objv127[1];
                                    if ( tmp128 != null ) {
                                        tmp128.release();
                                    }
                                    TJC.releaseObjv(interp, objv127, 2);
                                }
                            } // End Invoke: puts
                        }
                    } // End Invoke: if
                    { // Invoke: lappend file_and_procs [...]
                        TclObject[] objv130 = TJC.grabObjv(interp, 1);
                        TclObject tmp131;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: list $source_file $proc_tuples
                                TclObject tmp132 = TclList.newInstance();
                                TclObject tmp133;
                                try {
                                    tmp133 = getVarScalar(interp, "source_file", compiledLocals, 14);
                                    TclList.append(interp, tmp132, tmp133);
                                    tmp133 = getVarScalar(interp, "proc_tuples", compiledLocals, 18);
                                    TclList.append(interp, tmp132, tmp133);
                                } catch (TclException ex) {
                                    tmp132.release();
                                    throw ex;
                                }
                                interp.setResult(tmp132);
                            } // End Invoke: list
                            tmp131 = interp.getResult();
                            tmp131.preserve();
                            objv130[0] = tmp131;
                            interp.resetResult();
                            lappendVarScalar(interp, "file_and_procs", objv130, compiledLocals, 12);
                        } finally {
                            TJC.releaseObjvElems(interp, objv130, 1);
                        }
                    } // End Invoke: lappend
                    { // Invoke: set tail [...]
                        TclObject tmp134;
                        { // Invoke: file tail $source_file
                            TclObject[] objv135 = TJC.grabObjv(interp, 3);
                            TclObject tmp136;
                            try {
                                // Arg 0 constant: file
                                objv135[0] = const3;
                                // Arg 1 constant: tail
                                objv135[1] = const29;
                                // Arg 2 variable: $source_file
                                tmp136 = getVarScalar(interp, "source_file", compiledLocals, 14);
                                tmp136.preserve();
                                objv135[2] = tmp136;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv135, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp136 = objv135[2];
                                if ( tmp136 != null ) {
                                    tmp136.release();
                                }
                                TJC.releaseObjv(interp, objv135, 3);
                            }
                        } // End Invoke: file
                        tmp134 = interp.getResult();
                        setVarScalar(interp, "tail", tmp134, compiledLocals, 19);
                    } // End Invoke: set
                    { // Invoke: set script_out [...]
                        TclObject tmp137;
                        { // Invoke: file join $... $tail
                            TclObject[] objv138 = TJC.grabObjv(interp, 4);
                            TclObject tmp139;
                            try {
                                // Arg 0 constant: file
                                objv138[0] = const3;
                                // Arg 1 constant: join
                                objv138[1] = const16;
                                // Arg 2 variable: $...
                                tmp139 = getVarScalar(interp, "TJC_BUILD_PACKAGE_LIBRARY", compiledLocals, 9);
                                tmp139.preserve();
                                objv138[2] = tmp139;
                                // Arg 3 variable: $tail
                                tmp139 = getVarScalar(interp, "tail", compiledLocals, 19);
                                tmp139.preserve();
                                objv138[3] = tmp139;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv138, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp139 = objv138[2];
                                if ( tmp139 != null ) {
                                    tmp139.release();
                                }
                                tmp139 = objv138[3];
                                if ( tmp139 != null ) {
                                    tmp139.release();
                                }
                                TJC.releaseObjv(interp, objv138, 4);
                            }
                        } // End Invoke: file
                        tmp137 = interp.getResult();
                        setVarScalar(interp, "script_out", tmp137, compiledLocals, 20);
                    } // End Invoke: set
                    { // Invoke: tjc_util_file_saveas $script_out $mod_script
                        TclObject[] objv140 = TJC.grabObjv(interp, 3);
                        TclObject tmp141;
                        try {
                            // Arg 0 constant: tjc_util_file_saveas
                            objv140[0] = const30;
                            // Arg 1 variable: $script_out
                            tmp141 = getVarScalar(interp, "script_out", compiledLocals, 20);
                            tmp141.preserve();
                            objv140[1] = tmp141;
                            // Arg 2 variable: $mod_script
                            tmp141 = getVarScalar(interp, "mod_script", compiledLocals, 17);
                            tmp141.preserve();
                            objv140[2] = tmp141;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                                ? cmdcache17.cmd : null), objv140, 0);
                            if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                                updateCmdCache(interp, 17);
                            }
                        } finally {
                            tmp141 = objv140[1];
                            if ( tmp141 != null ) {
                                tmp141.release();
                            }
                            tmp141 = objv140[2];
                            if ( tmp141 != null ) {
                                tmp141.release();
                            }
                            TJC.releaseObjv(interp, objv140, 3);
                        }
                    } // End Invoke: tjc_util_file_saveas
                    { // Invoke: if {$debug} ...
                        TclObject tmp142 = getVarScalar(interp, "debug", compiledLocals, 2);
                        boolean tmp143 = TJC.getBoolean(interp, tmp142);
                        if ( tmp143 ) {
                            { // Invoke: puts "..."
                                TclObject[] objv144 = TJC.grabObjv(interp, 2);
                                TclObject tmp145;
                                try {
                                    // Arg 0 constant: puts
                                    objv144[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp146 = new StringBuffer(64);
                                    sbtmp146.append("wrote proc parsed script ");
                                    sbtmp146.append("\"");
                                    tmp145 = getVarScalar(interp, "script_out", compiledLocals, 20);
                                    sbtmp146.append(tmp145.toString());
                                    sbtmp146.append("\"");
                                    tmp145 = TclString.newInstance(sbtmp146);
                                    tmp145.preserve();
                                    objv144[1] = tmp145;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv144, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp145 = objv144[1];
                                    if ( tmp145 != null ) {
                                        tmp145.release();
                                    }
                                    TJC.releaseObjv(interp, objv144, 2);
                                }
                            } // End Invoke: puts
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp82 != null ) {
                    tmp82.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: unset script mod_script
            TclObject[] objv147 = TJC.grabObjv(interp, 3);
            try {
                // Arg 0 constant: unset
                objv147[0] = const31;
                // Arg 1 constant: script
                objv147[1] = const32;
                // Arg 2 constant: mod_script
                objv147[2] = const33;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                    ? cmdcache18.cmd : null), objv147, 0);
                if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                    updateCmdCache(interp, 18);
                }
            } finally {
                TJC.releaseObjv(interp, objv147, 3);
            }
        } // End Invoke: unset
        { // Invoke: if ... ...
            // Binary operator: $num_procs_parsed == 0
            TclObject tmp148 = getVarScalar(interp, "num_procs_parsed", compiledLocals, 13);
            ExprValue tmp149 = evs0;
            TJC.exprInitValue(interp, tmp149, tmp148);
            ExprValue tmp150 = evs1;
            tmp150.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp149, tmp150);
            // End Binary operator: ==
            boolean tmp151 = ( tmp149.getIntValue() != 0 );
            if ( tmp151 ) {
                { // Invoke: puts stderr ...
                    TclObject[] objv152 = TJC.grabObjv(interp, 3);
                    try {
                        // Arg 0 constant: puts
                        objv152[0] = const2;
                        // Arg 1 constant: stderr
                        objv152[1] = const5;
                        // Arg 2 constant: ...
                        objv152[2] = const34;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv152, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv152, 3);
                    }
                } // End Invoke: puts
                { // Invoke: return -1
                    interp.resetResult();
                    interp.setResult(const6);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set java_files [...]
            TclObject tmp153;
            { // Invoke: list
                TclObject tmp154 = TclList.newInstance();
                interp.setResult(tmp154);
            } // End Invoke: list
            tmp153 = interp.getResult();
            setVarScalar(interp, "java_files", tmp153, compiledLocals, 21);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp155 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp156 = TJC.getBoolean(interp, tmp155);
            if ( tmp156 ) {
                { // Invoke: puts "..."
                    TclObject[] objv157 = TJC.grabObjv(interp, 2);
                    TclObject tmp158;
                    try {
                        // Arg 0 constant: puts
                        objv157[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp159 = new StringBuffer(64);
                        sbtmp159.append("there are ");
                        { // Invoke: llength $file_and_procs
                            TclObject tmp160 = getVarScalar(interp, "file_and_procs", compiledLocals, 12);
                            int tmp161 = TclList.getLength(interp, tmp160);
                            interp.setResult(tmp161);
                        } // End Invoke: llength
                        tmp158 = interp.getResult();
                        sbtmp159.append(tmp158.toString());
                        sbtmp159.append(" file_and_procs pairs");
                        tmp158 = TclString.newInstance(sbtmp159);
                        tmp158.preserve();
                        objv157[1] = tmp158;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv157, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp158 = objv157[1];
                        if ( tmp158 != null ) {
                            tmp158.release();
                        }
                        TJC.releaseObjv(interp, objv157, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv162 = TJC.grabObjv(interp, 2);
                    TclObject tmp163;
                    try {
                        // Arg 0 constant: puts
                        objv162[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp164 = new StringBuffer(64);
                        sbtmp164.append("parsed a total of ");
                        tmp163 = getVarScalar(interp, "num_procs_parsed", compiledLocals, 13);
                        sbtmp164.append(tmp163.toString());
                        sbtmp164.append(" Tcl procs");
                        tmp163 = TclString.newInstance(sbtmp164);
                        tmp163.preserve();
                        objv162[1] = tmp163;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv162, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp163 = objv162[1];
                        if ( tmp163 != null ) {
                            tmp163.release();
                        }
                        TJC.releaseObjv(interp, objv162, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set nocompile 0
            setVarScalar(interp, "nocompile", const0, compiledLocals, 22);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] && $_tjc(...)
            { // Invoke: info exists _tjc(nocompile)
                TclObject[] objv165 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv165[0] = const35;
                    // Arg 1 constant: exists
                    objv165[1] = const4;
                    // Arg 2 constant: _tjc(nocompile)
                    objv165[2] = const36;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                        ? cmdcache19.cmd : null), objv165, 0);
                    if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                        updateCmdCache(interp, 19);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv165, 3);
                }
            } // End Invoke: info
            TclObject tmp166 = interp.getResult();
            ExprValue tmp167 = evs0;
            TJC.exprInitValue(interp, tmp167, tmp166);
            if (tmp167.getBooleanValue(interp)) {
            TclObject tmp168 = getVarArray(interp, "_tjc", "nocompile", compiledLocals, 1);
            ExprValue tmp169 = evs1;
            TJC.exprInitValue(interp, tmp169, tmp168);
            tmp167.setIntValue(tmp169.getBooleanValue(interp));
            } else {
            tmp167.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp170 = ( tmp167.getIntValue() != 0 );
            if ( tmp170 ) {
                { // Invoke: set nocompile 1
                    setVarScalar(interp, "nocompile", const1, compiledLocals, 22);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: foreach pair $file_and_procs ...
            TclObject tmp171 = null;
            try {
                tmp171 = getVarScalar(interp, "file_and_procs", compiledLocals, 12);
                tmp171.preserve();
                final int tmp171_length = TclList.getLength(interp, tmp171);

                for ( int index172 = 0 ; index172 < tmp171_length ; index172++ ) {
                    TclObject tmp173 = TclList.index(interp, tmp171, index172);
                    try {
                        setVarScalar(interp, "pair", tmp173, compiledLocals, 23);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "pair");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set proc_filename [...]
                        TclObject tmp174;
                        { // Invoke: lindex $pair 0
                            TclObject tmp175 = getVarScalar(interp, "pair", compiledLocals, 23);
                            tmp175 = TclList.index(interp, tmp175, 0);
                            if ( tmp175 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp175);
                            }
                        } // End Invoke: lindex
                        tmp174 = interp.getResult();
                        setVarScalar(interp, "proc_filename", tmp174, compiledLocals, 24);
                    } // End Invoke: set
                    { // Invoke: set proc_tuples [...]
                        TclObject tmp176;
                        { // Invoke: lindex $pair 1
                            TclObject tmp177 = getVarScalar(interp, "pair", compiledLocals, 23);
                            tmp177 = TclList.index(interp, tmp177, 1);
                            if ( tmp177 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp177);
                            }
                        } // End Invoke: lindex
                        tmp176 = interp.getResult();
                        setVarScalar(interp, "proc_tuples", tmp176, compiledLocals, 18);
                    } // End Invoke: set
                    { // Invoke: if {$debug} ...
                        TclObject tmp178 = getVarScalar(interp, "debug", compiledLocals, 2);
                        boolean tmp179 = TJC.getBoolean(interp, tmp178);
                        if ( tmp179 ) {
                            { // Invoke: puts "..."
                                TclObject[] objv180 = TJC.grabObjv(interp, 2);
                                TclObject tmp181;
                                try {
                                    // Arg 0 constant: puts
                                    objv180[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp182 = new StringBuffer(64);
                                    sbtmp182.append("processing proc_tuples for file ");
                                    tmp181 = getVarScalar(interp, "proc_filename", compiledLocals, 24);
                                    sbtmp182.append(tmp181.toString());
                                    tmp181 = TclString.newInstance(sbtmp182);
                                    tmp181.preserve();
                                    objv180[1] = tmp181;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv180, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp181 = objv180[1];
                                    if ( tmp181 != null ) {
                                        tmp181.release();
                                    }
                                    TJC.releaseObjv(interp, objv180, 2);
                                }
                            } // End Invoke: puts
                            { // Invoke: puts "..."
                                TclObject[] objv183 = TJC.grabObjv(interp, 2);
                                TclObject tmp184;
                                try {
                                    // Arg 0 constant: puts
                                    objv183[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp185 = new StringBuffer(64);
                                    sbtmp185.append("there are ");
                                    { // Invoke: llength $proc_tuples
                                        TclObject tmp186 = getVarScalar(interp, "proc_tuples", compiledLocals, 18);
                                        int tmp187 = TclList.getLength(interp, tmp186);
                                        interp.setResult(tmp187);
                                    } // End Invoke: llength
                                    tmp184 = interp.getResult();
                                    sbtmp185.append(tmp184.toString());
                                    sbtmp185.append(" proc_tuples");
                                    tmp184 = TclString.newInstance(sbtmp185);
                                    tmp184.preserve();
                                    objv183[1] = tmp184;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv183, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp184 = objv183[1];
                                    if ( tmp184 != null ) {
                                        tmp184.release();
                                    }
                                    TJC.releaseObjv(interp, objv183, 2);
                                }
                            } // End Invoke: puts
                            { // Invoke: puts "..."
                                TclObject[] objv188 = TJC.grabObjv(interp, 2);
                                TclObject tmp189;
                                try {
                                    // Arg 0 constant: puts
                                    objv188[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp190 = new StringBuffer(64);
                                    sbtmp190.append("proc_tuples is ");
                                    { // Invoke: string length $proc_tuples
                                        TclObject tmp191 = getVarScalar(interp, "proc_tuples", compiledLocals, 18);
                                        int tmp192 = tmp191.toString().length();
                                        interp.setResult(tmp192);
                                    } // End Invoke: string
                                    tmp189 = interp.getResult();
                                    sbtmp190.append(tmp189.toString());
                                    sbtmp190.append(" bytes long");
                                    tmp189 = TclString.newInstance(sbtmp190);
                                    tmp189.preserve();
                                    objv188[1] = tmp189;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv188, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp189 = objv188[1];
                                    if ( tmp189 != null ) {
                                        tmp189.release();
                                    }
                                    TJC.releaseObjv(interp, objv188, 2);
                                }
                            } // End Invoke: puts
                        }
                    } // End Invoke: if
                    { // Invoke: if {$_tjc(progress)} ...
                        TclObject tmp193 = getVarArray(interp, "_tjc", "progress", compiledLocals, 1);
                        ExprValue tmp194 = evs0;
                        TJC.exprInitValue(interp, tmp194, tmp193);
                        boolean tmp195 = tmp194.getBooleanValue(interp);
                        if ( tmp195 ) {
                            { // Invoke: puts "..."
                                TclObject[] objv196 = TJC.grabObjv(interp, 2);
                                TclObject tmp197;
                                try {
                                    // Arg 0 constant: puts
                                    objv196[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp198 = new StringBuffer(64);
                                    sbtmp198.append("found ");
                                    { // Invoke: llength $proc_tuples
                                        TclObject tmp199 = getVarScalar(interp, "proc_tuples", compiledLocals, 18);
                                        int tmp200 = TclList.getLength(interp, tmp199);
                                        interp.setResult(tmp200);
                                    } // End Invoke: llength
                                    tmp197 = interp.getResult();
                                    sbtmp198.append(tmp197.toString());
                                    sbtmp198.append(" Tcl procs in ");
                                    tmp197 = getVarScalar(interp, "proc_filename", compiledLocals, 24);
                                    sbtmp198.append(tmp197.toString());
                                    tmp197 = TclString.newInstance(sbtmp198);
                                    tmp197.preserve();
                                    objv196[1] = tmp197;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv196, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp197 = objv196[1];
                                    if ( tmp197 != null ) {
                                        tmp197.release();
                                    }
                                    TJC.releaseObjv(interp, objv196, 2);
                                }
                            } // End Invoke: puts
                        }
                    } // End Invoke: if
                    { // Invoke: foreach proc_tuple $proc_tuples ...
                        TclObject tmp201 = null;
                        try {
                            tmp201 = getVarScalar(interp, "proc_tuples", compiledLocals, 18);
                            tmp201.preserve();
                            final int tmp201_length = TclList.getLength(interp, tmp201);

                            for ( int index202 = 0 ; index202 < tmp201_length ; index202++ ) {
                                TclObject tmp203 = TclList.index(interp, tmp201, index202);
                                try {
                                    setVarScalar(interp, "proc_tuple", tmp203, compiledLocals, 25);
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "proc_tuple");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: set tuple [...]
                                    TclObject tmp204;
                                    { // Invoke: ... $proc_filename $proc_tuple
                                        TclObject[] objv205 = TJC.grabObjv(interp, 3);
                                        TclObject tmp206;
                                        try {
                                            // Arg 0 constant: ...
                                            objv205[0] = const37;
                                            // Arg 1 variable: $proc_filename
                                            tmp206 = getVarScalar(interp, "proc_filename", compiledLocals, 24);
                                            tmp206.preserve();
                                            objv205[1] = tmp206;
                                            // Arg 2 variable: $proc_tuple
                                            tmp206 = getVarScalar(interp, "proc_tuple", compiledLocals, 25);
                                            tmp206.preserve();
                                            objv205[2] = tmp206;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache20_cmdEpoch == cmdcache20.cmdEpoch)
                                                ? cmdcache20.cmd : null), objv205, 0);
                                            if ( cmdcache20_cmdEpoch != cmdcache20.cmdEpoch ) {
                                                updateCmdCache(interp, 20);
                                            }
                                        } finally {
                                            tmp206 = objv205[1];
                                            if ( tmp206 != null ) {
                                                tmp206.release();
                                            }
                                            tmp206 = objv205[2];
                                            if ( tmp206 != null ) {
                                                tmp206.release();
                                            }
                                            TJC.releaseObjv(interp, objv205, 3);
                                        }
                                    } // End Invoke: ...
                                    tmp204 = interp.getResult();
                                    setVarScalar(interp, "tuple", tmp204, compiledLocals, 26);
                                } // End Invoke: set
                                { // Invoke: if {$tuple == "ERROR"} ...
                                    // Binary operator: $tuple == "ERROR"
                                    TclObject tmp207 = getVarScalar(interp, "tuple", compiledLocals, 26);
                                    boolean tmp208 = tmp207.toString().equals("ERROR");
                                    ExprValue tmp209 = evs0;
                                    tmp209.setIntValue(tmp208);
                                    // End Binary operator: ==
                                    boolean tmp210 = ( tmp209.getIntValue() != 0 );
                                    if ( tmp210 ) {
                                        { // Invoke: return -1
                                            interp.resetResult();
                                            interp.setResult(const6);
                                            if ( true ) { return; }
                                        } // End Invoke: return
                                    }
                                } // End Invoke: if
                                { // Invoke: set tcl_filename [...]
                                    TclObject tmp211;
                                    { // Invoke: lindex $tuple 0
                                        TclObject tmp212 = getVarScalar(interp, "tuple", compiledLocals, 26);
                                        tmp212 = TclList.index(interp, tmp212, 0);
                                        if ( tmp212 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp212);
                                        }
                                    } // End Invoke: lindex
                                    tmp211 = interp.getResult();
                                    setVarScalar(interp, "tcl_filename", tmp211, compiledLocals, 27);
                                } // End Invoke: set
                                { // Invoke: set proc_name [...]
                                    TclObject tmp213;
                                    { // Invoke: lindex $tuple 1
                                        TclObject tmp214 = getVarScalar(interp, "tuple", compiledLocals, 26);
                                        tmp214 = TclList.index(interp, tmp214, 1);
                                        if ( tmp214 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp214);
                                        }
                                    } // End Invoke: lindex
                                    tmp213 = interp.getResult();
                                    setVarScalar(interp, "proc_name", tmp213, compiledLocals, 28);
                                } // End Invoke: set
                                { // Invoke: set java_class [...]
                                    TclObject tmp215;
                                    { // Invoke: lindex $tuple 2
                                        TclObject tmp216 = getVarScalar(interp, "tuple", compiledLocals, 26);
                                        tmp216 = TclList.index(interp, tmp216, 2);
                                        if ( tmp216 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp216);
                                        }
                                    } // End Invoke: lindex
                                    tmp215 = interp.getResult();
                                    setVarScalar(interp, "java_class", tmp215, compiledLocals, 29);
                                } // End Invoke: set
                                { // Invoke: set java_source [...]
                                    TclObject tmp217;
                                    { // Invoke: lindex $tuple 3
                                        TclObject tmp218 = getVarScalar(interp, "tuple", compiledLocals, 26);
                                        tmp218 = TclList.index(interp, tmp218, 3);
                                        if ( tmp218 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp218);
                                        }
                                    } // End Invoke: lindex
                                    tmp217 = interp.getResult();
                                    setVarScalar(interp, "java_source", tmp217, compiledLocals, 30);
                                } // End Invoke: set
                                { // Invoke: if {$nocompile} ... else ...
                                    TclObject tmp219 = getVarScalar(interp, "nocompile", compiledLocals, 22);
                                    boolean tmp220 = TJC.getBoolean(interp, tmp219);
                                    if ( tmp220 ) {
                                        { // Invoke: set java_filename {}
                                            setVarScalar(interp, "java_filename", const38, compiledLocals, 31);
                                        } // End Invoke: set
                                    } else {
                                        { // Invoke: set java_filename [...]
                                            TclObject tmp221;
                                            { // Invoke: jdk_tool_javac_save $java_class $java_source
                                                TclObject[] objv222 = TJC.grabObjv(interp, 3);
                                                TclObject tmp223;
                                                try {
                                                    // Arg 0 constant: jdk_tool_javac_save
                                                    objv222[0] = const39;
                                                    // Arg 1 variable: $java_class
                                                    tmp223 = getVarScalar(interp, "java_class", compiledLocals, 29);
                                                    tmp223.preserve();
                                                    objv222[1] = tmp223;
                                                    // Arg 2 variable: $java_source
                                                    tmp223 = getVarScalar(interp, "java_source", compiledLocals, 30);
                                                    tmp223.preserve();
                                                    objv222[2] = tmp223;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache21_cmdEpoch == cmdcache21.cmdEpoch)
                                                        ? cmdcache21.cmd : null), objv222, 0);
                                                    if ( cmdcache21_cmdEpoch != cmdcache21.cmdEpoch ) {
                                                        updateCmdCache(interp, 21);
                                                    }
                                                } finally {
                                                    tmp223 = objv222[1];
                                                    if ( tmp223 != null ) {
                                                        tmp223.release();
                                                    }
                                                    tmp223 = objv222[2];
                                                    if ( tmp223 != null ) {
                                                        tmp223.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv222, 3);
                                                }
                                            } // End Invoke: jdk_tool_javac_save
                                            tmp221 = interp.getResult();
                                            setVarScalar(interp, "java_filename", tmp221, compiledLocals, 31);
                                        } // End Invoke: set
                                    }
                                } // End Invoke: if
                                { // Invoke: if ... ...
                                    // Binary operator: $debug || $_tjc(...)
                                    TclObject tmp224 = getVarScalar(interp, "debug", compiledLocals, 2);
                                    ExprValue tmp225 = evs0;
                                    TJC.exprInitValue(interp, tmp225, tmp224);
                                    if (!tmp225.getBooleanValue(interp)) {
                                    TclObject tmp226 = getVarArray(interp, "_tjc", "progress", compiledLocals, 1);
                                    ExprValue tmp227 = evs1;
                                    TJC.exprInitValue(interp, tmp227, tmp226);
                                    tmp225.setIntValue(tmp227.getBooleanValue(interp));
                                    } else {
                                    tmp225.setIntValue(1);
                                    } // End if: !$debug
                                    // End Binary operator: ||
                                    boolean tmp228 = ( tmp225.getIntValue() != 0 );
                                    if ( tmp228 ) {
                                        { // Invoke: puts "..."
                                            TclObject[] objv229 = TJC.grabObjv(interp, 2);
                                            TclObject tmp230;
                                            try {
                                                // Arg 0 constant: puts
                                                objv229[0] = const2;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp231 = new StringBuffer(64);
                                                sbtmp231.append("Tcl proc ");
                                                sbtmp231.append("\"");
                                                tmp230 = getVarScalar(interp, "proc_name", compiledLocals, 28);
                                                sbtmp231.append(tmp230.toString());
                                                sbtmp231.append("\"");
                                                sbtmp231.append(" defined in ");
                                                { // Invoke: file tail $tcl_filename
                                                    TclObject[] objv232 = TJC.grabObjv(interp, 3);
                                                    TclObject tmp233;
                                                    try {
                                                        // Arg 0 constant: file
                                                        objv232[0] = const3;
                                                        // Arg 1 constant: tail
                                                        objv232[1] = const29;
                                                        // Arg 2 variable: $tcl_filename
                                                        tmp233 = getVarScalar(interp, "tcl_filename", compiledLocals, 27);
                                                        tmp233.preserve();
                                                        objv232[2] = tmp233;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                            ? cmdcache2.cmd : null), objv232, 0);
                                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                            updateCmdCache(interp, 2);
                                                        }
                                                    } finally {
                                                        tmp233 = objv232[2];
                                                        if ( tmp233 != null ) {
                                                            tmp233.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv232, 3);
                                                    }
                                                } // End Invoke: file
                                                tmp230 = interp.getResult();
                                                sbtmp231.append(tmp230.toString());
                                                sbtmp231.append(" generated ");
                                                { // Invoke: string length $java_source
                                                    TclObject tmp234 = getVarScalar(interp, "java_source", compiledLocals, 30);
                                                    int tmp235 = tmp234.toString().length();
                                                    interp.setResult(tmp235);
                                                } // End Invoke: string
                                                tmp230 = interp.getResult();
                                                sbtmp231.append(tmp230.toString());
                                                sbtmp231.append(" bytes of Java source");
                                                tmp230 = TclString.newInstance(sbtmp231);
                                                tmp230.preserve();
                                                objv229[1] = tmp230;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv229, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp230 = objv229[1];
                                                if ( tmp230 != null ) {
                                                    tmp230.release();
                                                }
                                                TJC.releaseObjv(interp, objv229, 2);
                                            }
                                        } // End Invoke: puts
                                    }
                                } // End Invoke: if
                                { // Invoke: lappend java_files $java_filename
                                    TclObject[] objv236 = TJC.grabObjv(interp, 1);
                                    TclObject tmp237;
                                    try {
                                        // Arg 2 variable: $java_filename
                                        tmp237 = getVarScalar(interp, "java_filename", compiledLocals, 31);
                                        tmp237.preserve();
                                        objv236[0] = tmp237;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "java_files", objv236, compiledLocals, 21);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv236, 1);
                                    }
                                } // End Invoke: lappend
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp201 != null ) {
                                tmp201.release();
                            }
                        }
                    } // End Invoke: foreach
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp171 != null ) {
                    tmp171.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: unset file_and_procs pair proc_tuples proc_tuple
            TclObject[] objv238 = TJC.grabObjv(interp, 5);
            try {
                // Arg 0 constant: unset
                objv238[0] = const31;
                // Arg 1 constant: file_and_procs
                objv238[1] = const40;
                // Arg 2 constant: pair
                objv238[2] = const41;
                // Arg 3 constant: proc_tuples
                objv238[3] = const42;
                // Arg 4 constant: proc_tuple
                objv238[4] = const43;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                    ? cmdcache18.cmd : null), objv238, 0);
                if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                    updateCmdCache(interp, 18);
                }
            } finally {
                TJC.releaseObjv(interp, objv238, 5);
            }
        } // End Invoke: unset
        { // Invoke: unset tuple java_source
            TclObject[] objv239 = TJC.grabObjv(interp, 3);
            try {
                // Arg 0 constant: unset
                objv239[0] = const31;
                // Arg 1 constant: tuple
                objv239[1] = const44;
                // Arg 2 constant: java_source
                objv239[2] = const45;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                    ? cmdcache18.cmd : null), objv239, 0);
                if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                    updateCmdCache(interp, 18);
                }
            } finally {
                TJC.releaseObjv(interp, objv239, 3);
            }
        } // End Invoke: unset
        { // Invoke: set init_source [...]
            TclObject tmp240;
            { // Invoke: module_query INIT_SOURCE
                TclObject[] objv241 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: module_query
                    objv241[0] = const10;
                    // Arg 1 constant: INIT_SOURCE
                    objv241[1] = const46;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv241, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv241, 2);
                }
            } // End Invoke: module_query
            tmp240 = interp.getResult();
            setVarScalar(interp, "init_source", tmp240, compiledLocals, 32);
        } // End Invoke: set
        { // Invoke: set init_source [...]
            TclObject tmp242;
            { // Invoke: file tail $init_source
                TclObject[] objv243 = TJC.grabObjv(interp, 3);
                TclObject tmp244;
                try {
                    // Arg 0 constant: file
                    objv243[0] = const3;
                    // Arg 1 constant: tail
                    objv243[1] = const29;
                    // Arg 2 variable: $init_source
                    tmp244 = getVarScalar(interp, "init_source", compiledLocals, 32);
                    tmp244.preserve();
                    objv243[2] = tmp244;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv243, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp244 = objv243[2];
                    if ( tmp244 != null ) {
                        tmp244.release();
                    }
                    TJC.releaseObjv(interp, objv243, 3);
                }
            } // End Invoke: file
            tmp242 = interp.getResult();
            setVarScalar(interp, "init_source", tmp242, compiledLocals, 32);
        } // End Invoke: set
        { // Invoke: set source_tails [...]
            TclObject tmp245;
            { // Invoke: list
                TclObject tmp246 = TclList.newInstance();
                interp.setResult(tmp246);
            } // End Invoke: list
            tmp245 = interp.getResult();
            setVarScalar(interp, "source_tails", tmp245, compiledLocals, 33);
        } // End Invoke: set
        { // Invoke: foreach file [...] ...
            TclObject tmp247 = null;
            try {
                { // Invoke: concat $source_files $...
                    TclObject[] objv248 = TJC.grabObjv(interp, 3);
                    TclObject tmp249;
                    try {
                        // Arg 0 constant: concat
                        objv248[0] = const47;
                        // Arg 1 variable: $source_files
                        tmp249 = getVarScalar(interp, "source_files", compiledLocals, 5);
                        tmp249.preserve();
                        objv248[1] = tmp249;
                        // Arg 2 variable: $...
                        tmp249 = getVarScalar(interp, "include_source_files", compiledLocals, 6);
                        tmp249.preserve();
                        objv248[2] = tmp249;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache22_cmdEpoch == cmdcache22.cmdEpoch)
                            ? cmdcache22.cmd : null), objv248, 0);
                        if ( cmdcache22_cmdEpoch != cmdcache22.cmdEpoch ) {
                            updateCmdCache(interp, 22);
                        }
                    } finally {
                        tmp249 = objv248[1];
                        if ( tmp249 != null ) {
                            tmp249.release();
                        }
                        tmp249 = objv248[2];
                        if ( tmp249 != null ) {
                            tmp249.release();
                        }
                        TJC.releaseObjv(interp, objv248, 3);
                    }
                } // End Invoke: concat
                tmp247 = interp.getResult();
                tmp247.preserve();
                final int tmp247_length = TclList.getLength(interp, tmp247);

                for ( int index250 = 0 ; index250 < tmp247_length ; index250++ ) {
                    TclObject tmp251 = TclList.index(interp, tmp247, index250);
                    try {
                        setVarScalar(interp, "file", tmp251, compiledLocals, 34);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "file");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set tail [...]
                        TclObject tmp252;
                        { // Invoke: file tail $file
                            TclObject[] objv253 = TJC.grabObjv(interp, 3);
                            TclObject tmp254;
                            try {
                                // Arg 0 constant: file
                                objv253[0] = const3;
                                // Arg 1 constant: tail
                                objv253[1] = const29;
                                // Arg 2 variable: $file
                                tmp254 = getVarScalar(interp, "file", compiledLocals, 34);
                                tmp254.preserve();
                                objv253[2] = tmp254;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv253, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp254 = objv253[2];
                                if ( tmp254 != null ) {
                                    tmp254.release();
                                }
                                TJC.releaseObjv(interp, objv253, 3);
                            }
                        } // End Invoke: file
                        tmp252 = interp.getResult();
                        setVarScalar(interp, "tail", tmp252, compiledLocals, 19);
                    } // End Invoke: set
                    { // Invoke: lappend source_tails $tail
                        TclObject[] objv255 = TJC.grabObjv(interp, 1);
                        TclObject tmp256;
                        try {
                            // Arg 2 variable: $tail
                            tmp256 = getVarScalar(interp, "tail", compiledLocals, 19);
                            tmp256.preserve();
                            objv255[0] = tmp256;
                            interp.resetResult();
                            lappendVarScalar(interp, "source_tails", objv255, compiledLocals, 33);
                        } finally {
                            TJC.releaseObjvElems(interp, objv255, 1);
                        }
                    } // End Invoke: lappend
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp247 != null ) {
                    tmp247.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set tuple [...]
            TclObject tmp257;
            { // Invoke: ... $pkg $source_tails $init_source
                TclObject[] objv258 = TJC.grabObjv(interp, 4);
                TclObject tmp259;
                try {
                    // Arg 0 constant: ...
                    objv258[0] = const48;
                    // Arg 1 variable: $pkg
                    tmp259 = getVarScalar(interp, "pkg", compiledLocals, 4);
                    tmp259.preserve();
                    objv258[1] = tmp259;
                    // Arg 2 variable: $source_tails
                    tmp259 = getVarScalar(interp, "source_tails", compiledLocals, 33);
                    tmp259.preserve();
                    objv258[2] = tmp259;
                    // Arg 3 variable: $init_source
                    tmp259 = getVarScalar(interp, "init_source", compiledLocals, 32);
                    tmp259.preserve();
                    objv258[3] = tmp259;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache23_cmdEpoch == cmdcache23.cmdEpoch)
                        ? cmdcache23.cmd : null), objv258, 0);
                    if ( cmdcache23_cmdEpoch != cmdcache23.cmdEpoch ) {
                        updateCmdCache(interp, 23);
                    }
                } finally {
                    tmp259 = objv258[1];
                    if ( tmp259 != null ) {
                        tmp259.release();
                    }
                    tmp259 = objv258[2];
                    if ( tmp259 != null ) {
                        tmp259.release();
                    }
                    tmp259 = objv258[3];
                    if ( tmp259 != null ) {
                        tmp259.release();
                    }
                    TJC.releaseObjv(interp, objv258, 4);
                }
            } // End Invoke: ...
            tmp257 = interp.getResult();
            setVarScalar(interp, "tuple", tmp257, compiledLocals, 26);
        } // End Invoke: set
        { // Invoke: set java_class [...]
            TclObject tmp260;
            { // Invoke: lindex $tuple 0
                TclObject tmp261 = getVarScalar(interp, "tuple", compiledLocals, 26);
                tmp261 = TclList.index(interp, tmp261, 0);
                if ( tmp261 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp261);
                }
            } // End Invoke: lindex
            tmp260 = interp.getResult();
            setVarScalar(interp, "java_class", tmp260, compiledLocals, 29);
        } // End Invoke: set
        { // Invoke: set java_source [...]
            TclObject tmp262;
            { // Invoke: lindex $tuple 1
                TclObject tmp263 = getVarScalar(interp, "tuple", compiledLocals, 26);
                tmp263 = TclList.index(interp, tmp263, 1);
                if ( tmp263 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp263);
                }
            } // End Invoke: lindex
            tmp262 = interp.getResult();
            setVarScalar(interp, "java_source", tmp262, compiledLocals, 30);
        } // End Invoke: set
        { // Invoke: set java_filename [...]
            TclObject tmp264;
            { // Invoke: jdk_tool_javac_save $java_class $java_source
                TclObject[] objv265 = TJC.grabObjv(interp, 3);
                TclObject tmp266;
                try {
                    // Arg 0 constant: jdk_tool_javac_save
                    objv265[0] = const39;
                    // Arg 1 variable: $java_class
                    tmp266 = getVarScalar(interp, "java_class", compiledLocals, 29);
                    tmp266.preserve();
                    objv265[1] = tmp266;
                    // Arg 2 variable: $java_source
                    tmp266 = getVarScalar(interp, "java_source", compiledLocals, 30);
                    tmp266.preserve();
                    objv265[2] = tmp266;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache21_cmdEpoch == cmdcache21.cmdEpoch)
                        ? cmdcache21.cmd : null), objv265, 0);
                    if ( cmdcache21_cmdEpoch != cmdcache21.cmdEpoch ) {
                        updateCmdCache(interp, 21);
                    }
                } finally {
                    tmp266 = objv265[1];
                    if ( tmp266 != null ) {
                        tmp266.release();
                    }
                    tmp266 = objv265[2];
                    if ( tmp266 != null ) {
                        tmp266.release();
                    }
                    TJC.releaseObjv(interp, objv265, 3);
                }
            } // End Invoke: jdk_tool_javac_save
            tmp264 = interp.getResult();
            setVarScalar(interp, "java_filename", tmp264, compiledLocals, 31);
        } // End Invoke: set
        { // Invoke: lappend java_files $java_filename
            TclObject[] objv267 = TJC.grabObjv(interp, 1);
            TclObject tmp268;
            try {
                // Arg 2 variable: $java_filename
                tmp268 = getVarScalar(interp, "java_filename", compiledLocals, 31);
                tmp268.preserve();
                objv267[0] = tmp268;
                interp.resetResult();
                lappendVarScalar(interp, "java_files", objv267, compiledLocals, 21);
            } finally {
                TJC.releaseObjvElems(interp, objv267, 1);
            }
        } // End Invoke: lappend
        { // Invoke: if ... ...
            // Binary operator: [...] && $_tjc(...)
            { // Invoke: info exists _tjc(nocompile)
                TclObject[] objv269 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv269[0] = const35;
                    // Arg 1 constant: exists
                    objv269[1] = const4;
                    // Arg 2 constant: _tjc(nocompile)
                    objv269[2] = const36;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                        ? cmdcache19.cmd : null), objv269, 0);
                    if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                        updateCmdCache(interp, 19);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv269, 3);
                }
            } // End Invoke: info
            TclObject tmp270 = interp.getResult();
            ExprValue tmp271 = evs0;
            TJC.exprInitValue(interp, tmp271, tmp270);
            if (tmp271.getBooleanValue(interp)) {
            TclObject tmp272 = getVarArray(interp, "_tjc", "nocompile", compiledLocals, 1);
            ExprValue tmp273 = evs1;
            TJC.exprInitValue(interp, tmp273, tmp272);
            tmp271.setIntValue(tmp273.getBooleanValue(interp));
            } else {
            tmp271.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp274 = ( tmp271.getIntValue() != 0 );
            if ( tmp274 ) {
                { // Invoke: puts ...
                    TclObject[] objv275 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: puts
                        objv275[0] = const2;
                        // Arg 1 constant: ...
                        objv275[1] = const49;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv275, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv275, 2);
                    }
                } // End Invoke: puts
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: $debug || $_tjc(...)
            TclObject tmp276 = getVarScalar(interp, "debug", compiledLocals, 2);
            ExprValue tmp277 = evs0;
            TJC.exprInitValue(interp, tmp277, tmp276);
            if (!tmp277.getBooleanValue(interp)) {
            TclObject tmp278 = getVarArray(interp, "_tjc", "progress", compiledLocals, 1);
            ExprValue tmp279 = evs1;
            TJC.exprInitValue(interp, tmp279, tmp278);
            tmp277.setIntValue(tmp279.getBooleanValue(interp));
            } else {
            tmp277.setIntValue(1);
            } // End if: !$debug
            // End Binary operator: ||
            boolean tmp280 = ( tmp277.getIntValue() != 0 );
            if ( tmp280 ) {
                { // Invoke: puts "..."
                    TclObject[] objv281 = TJC.grabObjv(interp, 2);
                    TclObject tmp282;
                    try {
                        // Arg 0 constant: puts
                        objv281[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp283 = new StringBuffer(64);
                        sbtmp283.append("Compiling ");
                        { // Invoke: llength $java_files
                            TclObject tmp284 = getVarScalar(interp, "java_files", compiledLocals, 21);
                            int tmp285 = TclList.getLength(interp, tmp284);
                            interp.setResult(tmp285);
                        } // End Invoke: llength
                        tmp282 = interp.getResult();
                        sbtmp283.append(tmp282.toString());
                        sbtmp283.append(" files with javac");
                        tmp282 = TclString.newInstance(sbtmp283);
                        tmp282.preserve();
                        objv281[1] = tmp282;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv281, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp282 = objv281[1];
                        if ( tmp282 != null ) {
                            tmp282.release();
                        }
                        TJC.releaseObjv(interp, objv281, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set result [...]
            TclObject tmp286;
            { // Invoke: jdk_tool_javac $java_files
                TclObject[] objv287 = TJC.grabObjv(interp, 2);
                TclObject tmp288;
                try {
                    // Arg 0 constant: jdk_tool_javac
                    objv287[0] = const50;
                    // Arg 1 variable: $java_files
                    tmp288 = getVarScalar(interp, "java_files", compiledLocals, 21);
                    tmp288.preserve();
                    objv287[1] = tmp288;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache24_cmdEpoch == cmdcache24.cmdEpoch)
                        ? cmdcache24.cmd : null), objv287, 0);
                    if ( cmdcache24_cmdEpoch != cmdcache24.cmdEpoch ) {
                        updateCmdCache(interp, 24);
                    }
                } finally {
                    tmp288 = objv287[1];
                    if ( tmp288 != null ) {
                        tmp288.release();
                    }
                    TJC.releaseObjv(interp, objv287, 2);
                }
            } // End Invoke: jdk_tool_javac
            tmp286 = interp.getResult();
            setVarScalar(interp, "result", tmp286, compiledLocals, 35);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == "ERROR"
            { // Invoke: lindex $result 0
                TclObject tmp289 = getVarScalar(interp, "result", compiledLocals, 35);
                tmp289 = TclList.index(interp, tmp289, 0);
                if ( tmp289 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp289);
                }
            } // End Invoke: lindex
            TclObject tmp290 = interp.getResult();
            boolean tmp291 = tmp290.toString().equals("ERROR");
            ExprValue tmp292 = evs0;
            tmp292.setIntValue(tmp291);
            // End Binary operator: ==
            boolean tmp293 = ( tmp292.getIntValue() != 0 );
            if ( tmp293 ) {
                { // Invoke: return -1
                    interp.resetResult();
                    interp.setResult(const6);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set include_source_files
            TclObject tmp294 = getVarScalar(interp, "include_source_files", compiledLocals, 6);
            interp.setResult(tmp294);
        } // End Invoke: set
        { // Invoke: foreach include_source_file $... ...
            TclObject tmp295 = null;
            try {
                tmp295 = getVarScalar(interp, "include_source_files", compiledLocals, 6);
                tmp295.preserve();
                final int tmp295_length = TclList.getLength(interp, tmp295);

                for ( int index296 = 0 ; index296 < tmp295_length ; index296++ ) {
                    TclObject tmp297 = TclList.index(interp, tmp295, index296);
                    try {
                        setVarScalar(interp, "include_source_file", tmp297, compiledLocals, 36);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "include_source_file");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: file copy $include_source_file $...
                        TclObject[] objv298 = TJC.grabObjv(interp, 4);
                        TclObject tmp299;
                        try {
                            // Arg 0 constant: file
                            objv298[0] = const3;
                            // Arg 1 constant: copy
                            objv298[1] = const25;
                            // Arg 2 variable: $include_source_file
                            tmp299 = getVarScalar(interp, "include_source_file", compiledLocals, 36);
                            tmp299.preserve();
                            objv298[2] = tmp299;
                            // Arg 3 variable: $...
                            tmp299 = getVarScalar(interp, "TJC_SOURCE_PACKAGE_LIBRARY", compiledLocals, 11);
                            tmp299.preserve();
                            objv298[3] = tmp299;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv298, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp299 = objv298[2];
                            if ( tmp299 != null ) {
                                tmp299.release();
                            }
                            tmp299 = objv298[3];
                            if ( tmp299 != null ) {
                                tmp299.release();
                            }
                            TJC.releaseObjv(interp, objv298, 4);
                        }
                    } // End Invoke: file
                    { // Invoke: file copy $include_source_file $...
                        TclObject[] objv300 = TJC.grabObjv(interp, 4);
                        TclObject tmp301;
                        try {
                            // Arg 0 constant: file
                            objv300[0] = const3;
                            // Arg 1 constant: copy
                            objv300[1] = const25;
                            // Arg 2 variable: $include_source_file
                            tmp301 = getVarScalar(interp, "include_source_file", compiledLocals, 36);
                            tmp301.preserve();
                            objv300[2] = tmp301;
                            // Arg 3 variable: $...
                            tmp301 = getVarScalar(interp, "TJC_BUILD_PACKAGE_LIBRARY", compiledLocals, 9);
                            tmp301.preserve();
                            objv300[3] = tmp301;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv300, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp301 = objv300[2];
                            if ( tmp301 != null ) {
                                tmp301.release();
                            }
                            tmp301 = objv300[3];
                            if ( tmp301 != null ) {
                                tmp301.release();
                            }
                            TJC.releaseObjv(interp, objv300, 4);
                        }
                    } // End Invoke: file
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp295 != null ) {
                    tmp295.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set tail [...]
            TclObject tmp302;
            { // Invoke: file tail $filename
                TclObject[] objv303 = TJC.grabObjv(interp, 3);
                TclObject tmp304;
                try {
                    // Arg 0 constant: file
                    objv303[0] = const3;
                    // Arg 1 constant: tail
                    objv303[1] = const29;
                    // Arg 2 variable: $filename
                    tmp304 = getVarScalar(interp, "filename", compiledLocals, 0);
                    tmp304.preserve();
                    objv303[2] = tmp304;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv303, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp304 = objv303[2];
                    if ( tmp304 != null ) {
                        tmp304.release();
                    }
                    TJC.releaseObjv(interp, objv303, 3);
                }
            } // End Invoke: file
            tmp302 = interp.getResult();
            setVarScalar(interp, "tail", tmp302, compiledLocals, 19);
        } // End Invoke: set
        { // Invoke: set tailr [...]
            TclObject tmp305;
            { // Invoke: file rootname $tail
                TclObject[] objv306 = TJC.grabObjv(interp, 3);
                TclObject tmp307;
                try {
                    // Arg 0 constant: file
                    objv306[0] = const3;
                    // Arg 1 constant: rootname
                    objv306[1] = const51;
                    // Arg 2 variable: $tail
                    tmp307 = getVarScalar(interp, "tail", compiledLocals, 19);
                    tmp307.preserve();
                    objv306[2] = tmp307;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv306, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp307 = objv306[2];
                    if ( tmp307 != null ) {
                        tmp307.release();
                    }
                    TJC.releaseObjv(interp, objv306, 3);
                }
            } // End Invoke: file
            tmp305 = interp.getResult();
            setVarScalar(interp, "tailr", tmp305, compiledLocals, 37);
        } // End Invoke: set
        { // Invoke: set jar_name "${tailr}.jar"
            TclObject tmp308;
            StringBuffer sbtmp309 = new StringBuffer(64);
            tmp308 = getVarScalar(interp, "tailr", compiledLocals, 37);
            sbtmp309.append(tmp308.toString());
            sbtmp309.append(".jar");
            tmp308 = TclString.newInstance(sbtmp309);
            setVarScalar(interp, "jar_name", tmp308, compiledLocals, 38);
        } // End Invoke: set
        { // Invoke: set jar_location [...]
            TclObject tmp310;
            { // Invoke: jdk_tool_jar $jar_name
                TclObject[] objv311 = TJC.grabObjv(interp, 2);
                TclObject tmp312;
                try {
                    // Arg 0 constant: jdk_tool_jar
                    objv311[0] = const52;
                    // Arg 1 variable: $jar_name
                    tmp312 = getVarScalar(interp, "jar_name", compiledLocals, 38);
                    tmp312.preserve();
                    objv311[1] = tmp312;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache25_cmdEpoch == cmdcache25.cmdEpoch)
                        ? cmdcache25.cmd : null), objv311, 0);
                    if ( cmdcache25_cmdEpoch != cmdcache25.cmdEpoch ) {
                        updateCmdCache(interp, 25);
                    }
                } finally {
                    tmp312 = objv311[1];
                    if ( tmp312 != null ) {
                        tmp312.release();
                    }
                    TJC.releaseObjv(interp, objv311, 2);
                }
            } // End Invoke: jdk_tool_jar
            tmp310 = interp.getResult();
            setVarScalar(interp, "jar_location", tmp310, compiledLocals, 39);
        } // End Invoke: set
        { // Invoke: set src_jar_name "${tailr}src.jar"
            TclObject tmp313;
            StringBuffer sbtmp314 = new StringBuffer(64);
            tmp313 = getVarScalar(interp, "tailr", compiledLocals, 37);
            sbtmp314.append(tmp313.toString());
            sbtmp314.append("src.jar");
            tmp313 = TclString.newInstance(sbtmp314);
            setVarScalar(interp, "src_jar_name", tmp313, compiledLocals, 40);
        } // End Invoke: set
        { // Invoke: set src_jar_location [...]
            TclObject tmp315;
            { // Invoke: jdk_tool_jar $src_jar_name SOURCE
                TclObject[] objv316 = TJC.grabObjv(interp, 3);
                TclObject tmp317;
                try {
                    // Arg 0 constant: jdk_tool_jar
                    objv316[0] = const52;
                    // Arg 1 variable: $src_jar_name
                    tmp317 = getVarScalar(interp, "src_jar_name", compiledLocals, 40);
                    tmp317.preserve();
                    objv316[1] = tmp317;
                    // Arg 2 constant: SOURCE
                    objv316[2] = const13;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache25_cmdEpoch == cmdcache25.cmdEpoch)
                        ? cmdcache25.cmd : null), objv316, 0);
                    if ( cmdcache25_cmdEpoch != cmdcache25.cmdEpoch ) {
                        updateCmdCache(interp, 25);
                    }
                } finally {
                    tmp317 = objv316[1];
                    if ( tmp317 != null ) {
                        tmp317.release();
                    }
                    TJC.releaseObjv(interp, objv316, 3);
                }
            } // End Invoke: jdk_tool_jar
            tmp315 = interp.getResult();
            setVarScalar(interp, "src_jar_location", tmp315, compiledLocals, 41);
        } // End Invoke: set
        { // Invoke: set jar_filename [...]
            TclObject tmp318;
            { // Invoke: file join [...] $jar_name
                TclObject[] objv319 = TJC.grabObjv(interp, 4);
                TclObject tmp320;
                try {
                    // Arg 0 constant: file
                    objv319[0] = const3;
                    // Arg 1 constant: join
                    objv319[1] = const16;
                    // Arg 2 command: [...]
                    { // Invoke: pwd
                        TclObject[] objv321 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: pwd
                            objv321[0] = const17;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                ? cmdcache9.cmd : null), objv321, 0);
                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                updateCmdCache(interp, 9);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv321, 1);
                        }
                    } // End Invoke: pwd
                    tmp320 = interp.getResult();
                    tmp320.preserve();
                    objv319[2] = tmp320;
                    // Arg 3 variable: $jar_name
                    tmp320 = getVarScalar(interp, "jar_name", compiledLocals, 38);
                    tmp320.preserve();
                    objv319[3] = tmp320;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv319, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp320 = objv319[2];
                    if ( tmp320 != null ) {
                        tmp320.release();
                    }
                    tmp320 = objv319[3];
                    if ( tmp320 != null ) {
                        tmp320.release();
                    }
                    TJC.releaseObjv(interp, objv319, 4);
                }
            } // End Invoke: file
            tmp318 = interp.getResult();
            setVarScalar(interp, "jar_filename", tmp318, compiledLocals, 42);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp322 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp323 = TJC.getBoolean(interp, tmp322);
            if ( tmp323 ) {
                { // Invoke: puts "..."
                    TclObject[] objv324 = TJC.grabObjv(interp, 2);
                    TclObject tmp325;
                    try {
                        // Arg 0 constant: puts
                        objv324[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp326 = new StringBuffer(64);
                        sbtmp326.append("now to rename ");
                        sbtmp326.append("\"");
                        tmp325 = getVarScalar(interp, "jar_location", compiledLocals, 39);
                        sbtmp326.append(tmp325.toString());
                        sbtmp326.append("\"");
                        sbtmp326.append(" to ");
                        sbtmp326.append("\"");
                        tmp325 = getVarScalar(interp, "jar_filename", compiledLocals, 42);
                        sbtmp326.append(tmp325.toString());
                        sbtmp326.append("\"");
                        tmp325 = TclString.newInstance(sbtmp326);
                        tmp325.preserve();
                        objv324[1] = tmp325;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv324, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp325 = objv324[1];
                        if ( tmp325 != null ) {
                            tmp325.release();
                        }
                        TJC.releaseObjv(interp, objv324, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: file exists $jar_filename
                TclObject[] objv327 = TJC.grabObjv(interp, 3);
                TclObject tmp328;
                try {
                    // Arg 0 constant: file
                    objv327[0] = const3;
                    // Arg 1 constant: exists
                    objv327[1] = const4;
                    // Arg 2 variable: $jar_filename
                    tmp328 = getVarScalar(interp, "jar_filename", compiledLocals, 42);
                    tmp328.preserve();
                    objv327[2] = tmp328;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv327, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp328 = objv327[2];
                    if ( tmp328 != null ) {
                        tmp328.release();
                    }
                    TJC.releaseObjv(interp, objv327, 3);
                }
            } // End Invoke: file
            TclObject tmp329 = interp.getResult();
            ExprValue tmp330 = evs0;
            TJC.exprInitValue(interp, tmp330, tmp329);
            boolean tmp331 = tmp330.getBooleanValue(interp);
            if ( tmp331 ) {
                { // Invoke: file delete $jar_filename
                    TclObject[] objv332 = TJC.grabObjv(interp, 3);
                    TclObject tmp333;
                    try {
                        // Arg 0 constant: file
                        objv332[0] = const3;
                        // Arg 1 constant: delete
                        objv332[1] = const53;
                        // Arg 2 variable: $jar_filename
                        tmp333 = getVarScalar(interp, "jar_filename", compiledLocals, 42);
                        tmp333.preserve();
                        objv332[2] = tmp333;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv332, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp333 = objv332[2];
                        if ( tmp333 != null ) {
                            tmp333.release();
                        }
                        TJC.releaseObjv(interp, objv332, 3);
                    }
                } // End Invoke: file
            }
        } // End Invoke: if
        { // Invoke: file rename $jar_location $jar_filename
            TclObject[] objv334 = TJC.grabObjv(interp, 4);
            TclObject tmp335;
            try {
                // Arg 0 constant: file
                objv334[0] = const3;
                // Arg 1 constant: rename
                objv334[1] = const54;
                // Arg 2 variable: $jar_location
                tmp335 = getVarScalar(interp, "jar_location", compiledLocals, 39);
                tmp335.preserve();
                objv334[2] = tmp335;
                // Arg 3 variable: $jar_filename
                tmp335 = getVarScalar(interp, "jar_filename", compiledLocals, 42);
                tmp335.preserve();
                objv334[3] = tmp335;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv334, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                tmp335 = objv334[2];
                if ( tmp335 != null ) {
                    tmp335.release();
                }
                tmp335 = objv334[3];
                if ( tmp335 != null ) {
                    tmp335.release();
                }
                TJC.releaseObjv(interp, objv334, 4);
            }
        } // End Invoke: file
        { // Invoke: set src_jar_filename [...]
            TclObject tmp336;
            { // Invoke: file join [...] $src_jar_name
                TclObject[] objv337 = TJC.grabObjv(interp, 4);
                TclObject tmp338;
                try {
                    // Arg 0 constant: file
                    objv337[0] = const3;
                    // Arg 1 constant: join
                    objv337[1] = const16;
                    // Arg 2 command: [...]
                    { // Invoke: pwd
                        TclObject[] objv339 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: pwd
                            objv339[0] = const17;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                ? cmdcache9.cmd : null), objv339, 0);
                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                updateCmdCache(interp, 9);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv339, 1);
                        }
                    } // End Invoke: pwd
                    tmp338 = interp.getResult();
                    tmp338.preserve();
                    objv337[2] = tmp338;
                    // Arg 3 variable: $src_jar_name
                    tmp338 = getVarScalar(interp, "src_jar_name", compiledLocals, 40);
                    tmp338.preserve();
                    objv337[3] = tmp338;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv337, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp338 = objv337[2];
                    if ( tmp338 != null ) {
                        tmp338.release();
                    }
                    tmp338 = objv337[3];
                    if ( tmp338 != null ) {
                        tmp338.release();
                    }
                    TJC.releaseObjv(interp, objv337, 4);
                }
            } // End Invoke: file
            tmp336 = interp.getResult();
            setVarScalar(interp, "src_jar_filename", tmp336, compiledLocals, 43);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp340 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp341 = TJC.getBoolean(interp, tmp340);
            if ( tmp341 ) {
                { // Invoke: puts "..."
                    TclObject[] objv342 = TJC.grabObjv(interp, 2);
                    TclObject tmp343;
                    try {
                        // Arg 0 constant: puts
                        objv342[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp344 = new StringBuffer(64);
                        sbtmp344.append("now to rename ");
                        sbtmp344.append("\"");
                        tmp343 = getVarScalar(interp, "src_jar_location", compiledLocals, 41);
                        sbtmp344.append(tmp343.toString());
                        sbtmp344.append("\"");
                        sbtmp344.append(" to ");
                        sbtmp344.append("\"");
                        tmp343 = getVarScalar(interp, "src_jar_filename", compiledLocals, 43);
                        sbtmp344.append(tmp343.toString());
                        sbtmp344.append("\"");
                        tmp343 = TclString.newInstance(sbtmp344);
                        tmp343.preserve();
                        objv342[1] = tmp343;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv342, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp343 = objv342[1];
                        if ( tmp343 != null ) {
                            tmp343.release();
                        }
                        TJC.releaseObjv(interp, objv342, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: file exists $src_jar_filename
                TclObject[] objv345 = TJC.grabObjv(interp, 3);
                TclObject tmp346;
                try {
                    // Arg 0 constant: file
                    objv345[0] = const3;
                    // Arg 1 constant: exists
                    objv345[1] = const4;
                    // Arg 2 variable: $src_jar_filename
                    tmp346 = getVarScalar(interp, "src_jar_filename", compiledLocals, 43);
                    tmp346.preserve();
                    objv345[2] = tmp346;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv345, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp346 = objv345[2];
                    if ( tmp346 != null ) {
                        tmp346.release();
                    }
                    TJC.releaseObjv(interp, objv345, 3);
                }
            } // End Invoke: file
            TclObject tmp347 = interp.getResult();
            ExprValue tmp348 = evs0;
            TJC.exprInitValue(interp, tmp348, tmp347);
            boolean tmp349 = tmp348.getBooleanValue(interp);
            if ( tmp349 ) {
                { // Invoke: file delete $src_jar_filename
                    TclObject[] objv350 = TJC.grabObjv(interp, 3);
                    TclObject tmp351;
                    try {
                        // Arg 0 constant: file
                        objv350[0] = const3;
                        // Arg 1 constant: delete
                        objv350[1] = const53;
                        // Arg 2 variable: $src_jar_filename
                        tmp351 = getVarScalar(interp, "src_jar_filename", compiledLocals, 43);
                        tmp351.preserve();
                        objv350[2] = tmp351;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv350, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp351 = objv350[2];
                        if ( tmp351 != null ) {
                            tmp351.release();
                        }
                        TJC.releaseObjv(interp, objv350, 3);
                    }
                } // End Invoke: file
            }
        } // End Invoke: if
        { // Invoke: file rename $src_jar_location $src_jar_filename
            TclObject[] objv352 = TJC.grabObjv(interp, 4);
            TclObject tmp353;
            try {
                // Arg 0 constant: file
                objv352[0] = const3;
                // Arg 1 constant: rename
                objv352[1] = const54;
                // Arg 2 variable: $src_jar_location
                tmp353 = getVarScalar(interp, "src_jar_location", compiledLocals, 41);
                tmp353.preserve();
                objv352[2] = tmp353;
                // Arg 3 variable: $src_jar_filename
                tmp353 = getVarScalar(interp, "src_jar_filename", compiledLocals, 43);
                tmp353.preserve();
                objv352[3] = tmp353;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv352, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                tmp353 = objv352[2];
                if ( tmp353 != null ) {
                    tmp353.release();
                }
                tmp353 = objv352[3];
                if ( tmp353 != null ) {
                    tmp353.release();
                }
                TJC.releaseObjv(interp, objv352, 4);
            }
        } // End Invoke: file
        { // Invoke: if ... ...
            // Binary operator: $debug || $_tjc(...)
            TclObject tmp354 = getVarScalar(interp, "debug", compiledLocals, 2);
            ExprValue tmp355 = evs0;
            TJC.exprInitValue(interp, tmp355, tmp354);
            if (!tmp355.getBooleanValue(interp)) {
            TclObject tmp356 = getVarArray(interp, "_tjc", "progress", compiledLocals, 1);
            ExprValue tmp357 = evs1;
            TJC.exprInitValue(interp, tmp357, tmp356);
            tmp355.setIntValue(tmp357.getBooleanValue(interp));
            } else {
            tmp355.setIntValue(1);
            } // End if: !$debug
            // End Binary operator: ||
            boolean tmp358 = ( tmp355.getIntValue() != 0 );
            if ( tmp358 ) {
                { // Invoke: puts "..."
                    TclObject[] objv359 = TJC.grabObjv(interp, 2);
                    TclObject tmp360;
                    try {
                        // Arg 0 constant: puts
                        objv359[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp361 = new StringBuffer(64);
                        sbtmp361.append("Created ");
                        { // Invoke: file tail $jar_filename
                            TclObject[] objv362 = TJC.grabObjv(interp, 3);
                            TclObject tmp363;
                            try {
                                // Arg 0 constant: file
                                objv362[0] = const3;
                                // Arg 1 constant: tail
                                objv362[1] = const29;
                                // Arg 2 variable: $jar_filename
                                tmp363 = getVarScalar(interp, "jar_filename", compiledLocals, 42);
                                tmp363.preserve();
                                objv362[2] = tmp363;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv362, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp363 = objv362[2];
                                if ( tmp363 != null ) {
                                    tmp363.release();
                                }
                                TJC.releaseObjv(interp, objv362, 3);
                            }
                        } // End Invoke: file
                        tmp360 = interp.getResult();
                        sbtmp361.append(tmp360.toString());
                        tmp360 = TclString.newInstance(sbtmp361);
                        tmp360.preserve();
                        objv359[1] = tmp360;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv359, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp360 = objv359[1];
                        if ( tmp360 != null ) {
                            tmp360.release();
                        }
                        TJC.releaseObjv(interp, objv359, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv364 = TJC.grabObjv(interp, 2);
                    TclObject tmp365;
                    try {
                        // Arg 0 constant: puts
                        objv364[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp366 = new StringBuffer(64);
                        sbtmp366.append("Created ");
                        { // Invoke: file tail $src_jar_filename
                            TclObject[] objv367 = TJC.grabObjv(interp, 3);
                            TclObject tmp368;
                            try {
                                // Arg 0 constant: file
                                objv367[0] = const3;
                                // Arg 1 constant: tail
                                objv367[1] = const29;
                                // Arg 2 variable: $src_jar_filename
                                tmp368 = getVarScalar(interp, "src_jar_filename", compiledLocals, 43);
                                tmp368.preserve();
                                objv367[2] = tmp368;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv367, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp368 = objv367[2];
                                if ( tmp368 != null ) {
                                    tmp368.release();
                                }
                                TJC.releaseObjv(interp, objv367, 3);
                            }
                        } // End Invoke: file
                        tmp365 = interp.getResult();
                        sbtmp366.append(tmp365.toString());
                        tmp365 = TclString.newInstance(sbtmp366);
                        tmp365.preserve();
                        objv364[1] = tmp365;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv364, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp365 = objv364[1];
                        if ( tmp365 != null ) {
                            tmp365.release();
                        }
                        TJC.releaseObjv(interp, objv364, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: jdk_tool_cleanup
            TclObject[] objv369 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: jdk_tool_cleanup
                objv369[0] = const55;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache26_cmdEpoch == cmdcache26.cmdEpoch)
                    ? cmdcache26.cmd : null), objv369, 0);
                if ( cmdcache26_cmdEpoch != cmdcache26.cmdEpoch ) {
                    updateCmdCache(interp, 26);
                }
            } finally {
                TJC.releaseObjv(interp, objv369, 1);
            }
        } // End Invoke: jdk_tool_cleanup
        { // Invoke: return 0
            interp.resetResult();
            interp.setResult(const0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "process_module_file");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;
    TclObject const38;
    TclObject const39;
    TclObject const40;
    TclObject const41;
    TclObject const42;
    TclObject const43;
    TclObject const44;
    TclObject const45;
    TclObject const46;
    TclObject const47;
    TclObject const48;
    TclObject const49;
    TclObject const50;
    TclObject const51;
    TclObject const52;
    TclObject const53;
    TclObject const54;
    TclObject const55;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("puts");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("file");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("exists");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("stderr");
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(-1);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("module_parse_file");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("module_parse_validate");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("module_options_validate");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("module_query");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("PACKAGE");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("module_expand");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("SOURCE");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("INCLUDE_SOURCE");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("module_filter_include_source");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("join");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("pwd");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("jdk_tjc_rootdir");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("build");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("jdk_package_library");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("mkdir");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("source");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("nameproc_init");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("tjc_util_file_read");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("copy");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("parseproc_init");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("parseproc_start");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("module_get_filename");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("tail");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("tjc_util_file_saveas");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("unset");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("script");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("mod_script");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance("no compilable procs found in SOURCE files");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance("info");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance("_tjc(nocompile)");
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance("compileproc_entry_point");
        const37.preserve(); const37.preserve();
        const38 = TclString.newInstance("");
        const38.preserve(); const38.preserve();
        const39 = TclString.newInstance("jdk_tool_javac_save");
        const39.preserve(); const39.preserve();
        const40 = TclString.newInstance("file_and_procs");
        const40.preserve(); const40.preserve();
        const41 = TclString.newInstance("pair");
        const41.preserve(); const41.preserve();
        const42 = TclString.newInstance("proc_tuples");
        const42.preserve(); const42.preserve();
        const43 = TclString.newInstance("proc_tuple");
        const43.preserve(); const43.preserve();
        const44 = TclString.newInstance("tuple");
        const44.preserve(); const44.preserve();
        const45 = TclString.newInstance("java_source");
        const45.preserve(); const45.preserve();
        const46 = TclString.newInstance("INIT_SOURCE");
        const46.preserve(); const46.preserve();
        const47 = TclString.newInstance("concat");
        const47.preserve(); const47.preserve();
        const48 = TclString.newInstance("compileproc_tjcextension");
        const48.preserve(); const48.preserve();
        const49 = TclString.newInstance("Skipped JAVAC compile step since -nocompile flags was passed");
        const49.preserve(); const49.preserve();
        const50 = TclString.newInstance("jdk_tool_javac");
        const50.preserve(); const50.preserve();
        const51 = TclString.newInstance("rootname");
        const51.preserve(); const51.preserve();
        const52 = TclString.newInstance("jdk_tool_jar");
        const52.preserve(); const52.preserve();
        const53 = TclString.newInstance("delete");
        const53.preserve(); const53.preserve();
        const54 = TclString.newInstance("rename");
        const54.preserve(); const54.preserve();
        const55 = TclString.newInstance("jdk_tool_cleanup");
        const55.preserve(); const55.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;
    WrappedCommand cmdcache18;
    int cmdcache18_cmdEpoch;
    WrappedCommand cmdcache19;
    int cmdcache19_cmdEpoch;
    WrappedCommand cmdcache20;
    int cmdcache20_cmdEpoch;
    WrappedCommand cmdcache21;
    int cmdcache21_cmdEpoch;
    WrappedCommand cmdcache22;
    int cmdcache22_cmdEpoch;
    WrappedCommand cmdcache23;
    int cmdcache23_cmdEpoch;
    WrappedCommand cmdcache24;
    int cmdcache24_cmdEpoch;
    WrappedCommand cmdcache25;
    int cmdcache25_cmdEpoch;
    WrappedCommand cmdcache26;
    int cmdcache26_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                cmdcache18 = TJC.INVALID_COMMAND_CACHE;
                cmdcache18_cmdEpoch = 0;
                cmdcache19 = TJC.INVALID_COMMAND_CACHE;
                cmdcache19_cmdEpoch = 0;
                cmdcache20 = TJC.INVALID_COMMAND_CACHE;
                cmdcache20_cmdEpoch = 0;
                cmdcache21 = TJC.INVALID_COMMAND_CACHE;
                cmdcache21_cmdEpoch = 0;
                cmdcache22 = TJC.INVALID_COMMAND_CACHE;
                cmdcache22_cmdEpoch = 0;
                cmdcache23 = TJC.INVALID_COMMAND_CACHE;
                cmdcache23_cmdEpoch = 0;
                cmdcache24 = TJC.INVALID_COMMAND_CACHE;
                cmdcache24_cmdEpoch = 0;
                cmdcache25 = TJC.INVALID_COMMAND_CACHE;
                cmdcache25_cmdEpoch = 0;
                cmdcache26 = TJC.INVALID_COMMAND_CACHE;
                cmdcache26_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "file";
                break;
            }
            case 3: {
                cmdName = "module_parse_file";
                break;
            }
            case 4: {
                cmdName = "module_parse_validate";
                break;
            }
            case 5: {
                cmdName = "module_options_validate";
                break;
            }
            case 6: {
                cmdName = "module_query";
                break;
            }
            case 7: {
                cmdName = "module_expand";
                break;
            }
            case 8: {
                cmdName = "module_filter_include_source";
                break;
            }
            case 9: {
                cmdName = "pwd";
                break;
            }
            case 10: {
                cmdName = "jdk_tjc_rootdir";
                break;
            }
            case 11: {
                cmdName = "jdk_package_library";
                break;
            }
            case 12: {
                cmdName = "nameproc_init";
                break;
            }
            case 13: {
                cmdName = "tjc_util_file_read";
                break;
            }
            case 14: {
                cmdName = "parseproc_init";
                break;
            }
            case 15: {
                cmdName = "parseproc_start";
                break;
            }
            case 16: {
                cmdName = "module_get_filename";
                break;
            }
            case 17: {
                cmdName = "tjc_util_file_saveas";
                break;
            }
            case 18: {
                cmdName = "unset";
                break;
            }
            case 19: {
                cmdName = "info";
                break;
            }
            case 20: {
                cmdName = "compileproc_entry_point";
                break;
            }
            case 21: {
                cmdName = "jdk_tool_javac_save";
                break;
            }
            case 22: {
                cmdName = "concat";
                break;
            }
            case 23: {
                cmdName = "compileproc_tjcextension";
                break;
            }
            case 24: {
                cmdName = "jdk_tool_javac";
                break;
            }
            case 25: {
                cmdName = "jdk_tool_jar";
                break;
            }
            case 26: {
                cmdName = "jdk_tool_cleanup";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
            case 18: {
                cmdcache18 = lwcmd;
                cmdcache18_cmdEpoch = cmdEpoch;
                break;
            }
            case 19: {
                cmdcache19 = lwcmd;
                cmdcache19_cmdEpoch = cmdEpoch;
                break;
            }
            case 20: {
                cmdcache20 = lwcmd;
                cmdcache20_cmdEpoch = cmdEpoch;
                break;
            }
            case 21: {
                cmdcache21 = lwcmd;
                cmdcache21_cmdEpoch = cmdEpoch;
                break;
            }
            case 22: {
                cmdcache22 = lwcmd;
                cmdcache22_cmdEpoch = cmdEpoch;
                break;
            }
            case 23: {
                cmdcache23 = lwcmd;
                cmdcache23_cmdEpoch = cmdEpoch;
                break;
            }
            case 24: {
                cmdcache24 = lwcmd;
                cmdcache24_cmdEpoch = cmdEpoch;
                break;
            }
            case 25: {
                cmdcache25 = lwcmd;
                cmdcache25_cmdEpoch = cmdEpoch;
                break;
            }
            case 26: {
                cmdcache26 = lwcmd;
                cmdcache26_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "filename",
        "_tjc",
        "debug",
        "err",
        "pkg",
        "source_files",
        "include_source_files",
        "TJC",
        "TJC_BUILD",
        "TJC_BUILD_PACKAGE_LIBRARY",
        "TJC_SOURCE",
        "TJC_SOURCE_PACKAGE_LIBRARY",
        "file_and_procs",
        "num_procs_parsed",
        "source_file",
        "script",
        "results",
        "mod_script",
        "proc_tuples",
        "tail",
        "script_out",
        "java_files",
        "nocompile",
        "pair",
        "proc_filename",
        "proc_tuple",
        "tuple",
        "tcl_filename",
        "proc_name",
        "java_class",
        "java_source",
        "java_filename",
        "init_source",
        "source_tails",
        "file",
        "result",
        "include_source_file",
        "tailr",
        "jar_name",
        "jar_location",
        "src_jar_name",
        "src_jar_location",
        "jar_filename",
        "src_jar_filename"
    };
} // end class ProcessModuleFileCmd

